#include <exec/types.h>
#include <exec/memory.h>

#include <intuition/intuitionbase.h>
#include <libraries/dos.h>

#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/dos_protos.h>

#include <pragma/all_lib.h>

#include <string.h>
#include <math.h>
#include <stdlib.h>

#include </WaveTracer/ModIncl.h>
#include </WaveTracer/EffIncl.c>
#include </WaveTracer/WTIncl.h>

extern struct DOSBase *DOSBase;
struct IntuitionBase  *IntuitionBase;
struct GfxBase        *GfxBase;



BYTE       ChBit,ChID;



void SENDERROR(char *Fehler)

{
MyWTStdMsg->Flags=0;
MyWTStdMsg->WTMsgPrc->PRC_Flags=WTM_TASKREQ;
strcpy(MyWTStdMsg->WTMsgPrc->PRC_Str1,Fehler);
strcpy(MyWTStdMsg->WTMsgPrc->PRC_Str2,"Operation cancelled!");
strcpy(MyWTStdMsg->WTMsgPrc->PRC_Str3,"");
strcpy(MyWTStdMsg->WTMsgPrc->PRC_Str4,"OK");
strcpy(MyWTStdMsg->WTMsgPrc->PRC_Str5,"");
MESSAGEHANDLE();
}



void MAKEWAVE(LONG SAddr)

{
// Create the defined waveform
}



void DEFINEWAVE(void)

{
Window   *DWindow;


if ((MyWTStdMsg->ActWaveOp->Operator[4]<1) ||
    (MyWTStdMsg->ActWaveOp->Operator[4]>MyWTStdMsg->ActWaveOp->Operator[5]))
   {
   MyWTStdMsg->ActWaveOp->Operator[4]=16;
   MyWTStdMsg->ActWaveOp->Operator[3]=0;
   }
// if Operator[4]<1 then you have to set default-values for your module

MyWTStdMsg->Flags=0;
MyWTStdMsg->WTMsgPrc->PRC_Flags=WTM_OPENDWIN;              // Open a definitionwindow
strcpy(MyWTStdMsg->WTMsgPrc->PRC_Str1,"Definitionwindow"); // Windowtitle
MyWTStdMsg->WTMsgPrc->PRC_Long1=123;                       // Windowheight
MyWTStdMsg->WTMsgPrc->PRC_Long2=0;                         // y-Offset, put window to bottom if =0
MyWTStdMsg->WTMsgPrc->PRC_Long3=0;                         // Predefine some gadgets, forbidden for
                                                           // Loaders and Softmodules so set it to 0
MESSAGEHANDLE();                                           // Open the window
if ((MyWTStdMsg->WTMsgPrc->PRC_Long1==-1) || (!MyWTStdMsg->WTMsgPrc->PRC_NewPtr))
   {
   SENDERROR("Can't open definitionwindow!");
   MyWTStdMsg->Flags=MDE_ERROR;
   return;
   }
DWindow=(Window*)MyWTStdMsg->WTMsgPrc->PRC_NewPtr;         // Get the window-pointer

// Here you have to create and open your gadgets

repeat

   // Handle the inputs and put the defined values to Operator[3],Operator[4],Operator[5]
   // of the WTStdMsg->ActWaveOp-structure

while ((GadCode!=1) && (RawCode!=68));
if (RawCode==68)
   {
   // select the OK-Button, if the return-key was pressed
   DKnopf[0].Flags=DKnopf[0].Flags | SELECTED;
   RefreshGadgets(DWindow->FirstGadget,DWindow,NULL);
   Delay(5);
   }
CloseWindow(DWindow);
// Close and leave
};



void main (void)

{
DOSBase=(struct DOSBase*)OpenLibrary("dos.library",39);
GfxBase=(struct GfxBase*)OpenLibrary("graphics.library",39);
IntuitionBase=(struct IntuitionBase*)OpenLibrary("intuition.library",39);
if ((DOSBase) && (IntuitionBase) && (GfxBase))
   {
   if (CREATEPORTS(PORT_LOADER))
      {
      if (MyWTStdMsg->Version==VERSION_LOADER)
         {
         if (MyWTStdMsg->Flags==MDC_ASKREADY)
            {
            // Asks if the softmodule is ready, here you can ask the user for different
            // values using DEFINEWAVE()
            DEFINEWAVE();
            MyWTStdMsg->Flags=MDE_NICE_SOFTMOD;
               // Attention! If everything was done without errors, you have to leave
               // a softmodule with MDE_NICE_SOFTMOD instead of MDE_READY!
            }
         else if (MyWTStdMsg->Flags==MDC_DEFINEIT) MyWTStdMsg->Flags=MDE_NICE_SOFTMOD
               // The user made an mistake - he tried to load a sample using a softmodule
               // use the MDE_NICE_SOFTMOD-returnflag and the WT gives out an errormessage
         else if (MyWTStdMsg->Flags==MDC_DOIT)
            {
            ChBit=1;
            for (ChID=0; ChID<6; ChID++)
               {
               if ((MyWTStdMsg->ActiveChannels & ChBit)==ChBit) MAKEWAVE(MyWTStdMsg->MemA24[ChID]);
                  // Create the waveform only in the channels wich were defined in WT's Waveformgenerator
               ChBit=ChBit*2;
               }
            MyWTStdMsg->Flags=MDE_READY;
               // All done without errors
            }
         else (MyWTStdMsg->Flags=MDE_ERROR); // A illegal MDC_-command was given
         }
      else MyWTStdMsg->Flags=MDE_WRONG_MODULEVERSION; // WT and softmodule won't fit together
      MESSAGEHANDLE();
      RemPort(MyPort);
      DeleteMsgPort(MyPort)
      }
   }
if (DOSBase) CloseLibrary((Library*)DOSBase);
if (GfxBase) CloseLibrary((Library*)GfxBase);
if (IntuitionBase) CloseLibrary((Library*)IntuitionBase);
}
