program WaveTracer_DS;

{*****  Delta2-Kompression
        HISX
        Buffer-VMem

        Szenen-Auswahl fr UNIVERSAL_IFF
        Info-Window mit Infos ber Special-Datas
        Szenen-Auswahl-Effektmodul}

USES Intuition,ExecIO,Graphics;

{$incl "libraries/dosextens.h","libraries/dos.h","exec/memory.h",
       "libraries/diskfont.h","soundplay.mod","reqtools.h","AGA.lib",
       "RexxSys.lib"}

{$path "WaveTracer/"; incl "WTIncl.mod"}

const MODE_COPYNEW=1;      {MemA-Speicher auf VDevice kopieren}
const MODE_EXCHANGE=2;     {MemA- und UNDO-Speicher tauschen}
const MODE_MOVETODISK=3;   {UNDO-Speicher auf VDevice kopieren}
const MODE_NAMEEXCHANGE=4; {Namen zwischen0 und MemID swappen}

const WINMASK=%00010;

const CHANNELNAMES='L    R    C   SL   SR  Sub';
const PORT_REXX='WTRexx';
const IMAGE1=6436;
const IMAGE2=3425;
const IMAGE3=4177;
const SAMPLE=3001;
const PLAYPRIORITY=10;

const SCRDIFF=103;
const MAXOPS=250;
const FUNCTS=18;
const TEXTS=400;
const WTA_FILEID_OLD='WaveTracer WTA-File4';
const WTA_FILEID_NEW='WaveTracer WTA-File5';
const PREFFILE='ENVARC:WaveTracer.config';
const PREFVERSION=2;
const WTVer='WaveTracer DS Mark V `020 ';
const NEGATIVE=3;
const POSITIVE=0;

const FLAG_8=1;
const FLAG_16=2;
const FLAG_24=4;
const FLAG_REMOVE=8;

const SETPREFSWINDOW=269;

type VoiceHeader=Record
        OneShotHiSamples,RepeatHiSamples,SamplesPerHiCycle      :long;
        SamplesPerSec                                           :word;
        CtOctave1,SCompression1,FixedVolume1                    :byte;
        CtOctave2,SCompression2,FixedVolume2                    :byte
     end;
type SXHeader=Record
        SampleDepth,FixedVolume                 :byte;
        SoundLength,PlayRate,Flags              :long;
        UsedChannels,UsedMode                   :byte;
        PlayFreq                                :long;
        Loop                                    :word;
     end;
type ADSRHeader=record
        Attack,Decay,Sustain,Release    :long;
     end;
type IntArr5=array[1..5] of integer;
type BArr5=array[1..5] of boolean;
type r_Prefs=Record
        Confirm,UseVMem,Raster,Cache,
        ImmediatRender,EffReq,ShowData,
        AutoPlay                        :boolean;
        ActiveChannels                  :byte;
        UNDOVMem,BufferVMem,FunctVMem,
        FrameCache                      :boolean;
        VMemStr,SampleStr,PlayListStr   :string[200];
        ResStr1,ResStr2                 :string[200];
        PlayCh1,PlayCh2                 :long;
        SRate                           :word;
        LoaderString                    :string[100];
        LocaleString                    :string[70];
        CopyrightStr                    :string[25];
        ScrID,ScrWidth,ScrHeight        :long;
        SUnit,Pegel,PlayMethod,
        PlayType1,PlayType2,pad1,
        SubCFreq                        :byte;
        WinXOffset,WinYOffset           :IntArr5;
        WinActive                       :BArr5;
        WinXSize,WinYSize               :word;
     end;
type WTBitMap=record
        BytesPerRow,Rows                :word;
        Flags,Depth                     :byte;
        pad                             :word;
        Plane0,Plane1,Plane2,Plane3,
        Plane4,Plane5,Plane6,Plane7     :PLANEPTR;
        MemA,MemL                       :long;
     end;
type r_Key=record
        Time                    :long;
        Name                    :string[50];
        ID                      :long;
        Street                  :string[50];
        Number                  :long;
        City                    :string[50];
     end;

type FTagArr=array [1..6] of long;
type TagArr=array [1..12] of long;
type PenArr=array [1..13] of word;
type KeyArr=array [2..58] of word;
type BArr32=array [0..31] of byte;

var MyKey               :r_Key;

var Tags                :TagArr;
var Pens                :PenArr;

var AnimPicPos,CachePicPos      :long;

var MySDHeader                  :array [0..5] of ^SDHeader;
var MyFReq                      :^rtFileRequester;
var FTags                       :FTagArr;
var MyBitMap                    :WTBitMap;
Var NeuWindow                   :NewWindow;
var MyWindow,DWindow,InfoWindow,
    IntuiWindow1,IntuiWindow2,
    IntuiWindow3,IntuiWindow4   :^Window;
var NeuScreen                   :NewScreen;
var MyScreen                    :^Screen;
var CustomTA                    :TextAttr;
var CustomFont                  :^TextFont;
var PlayModPort,WTPort,RexxPort :^MsgPort;
var MyWTStdMsg                  :WTStdMsg;
var MyMsg                       :Message;
var MyWTImg                     :WTImages;
var EmptyMsgPrc                 :MsgPrc;
var MTBase                      :ptr;
var WTVersion                   :string[200];
var RxMsg                       :^RexxMsg;
var RxArg                       :RexxArg;
var RxStr                       :string;

var TPKnopf                     :array [1..15] of Gadget;
var TPKnopfTx                   :array [1..4] of IntuiText;
var TPTextGad                   :array [1..7] of Gadget;
var TPTextInfo                  :array [1..7] of StringInfo;
var TPBuffer,TPUndoBuffer       :array [1..7] of string[30];
var TBTextGad                   :array [1..3] of Gadget;
var TBTextInfo                  :array [1..3] of StringInfo;
var TBBuffer,TBUndoBuffer       :array [1..3] of string[15];
var TBKnopf                     :array [1..12] of Gadget;
var TBKnopfTx                   :array [1..8] of IntuiText;
var SData                       :array [1..7] of integer;
var TPSchieber                  :Gadget;
var TPSchieberInfo              :PropInfo;

var Knopf               :Array [1..33] of Gadget;
var KnopfTx             :array [1..13] of IntuiText;
var MSchieber,E3Knopf   :Gadget;
var MSchieberInfo       :PropInfo;
var ShitData            :array [1..6] of integer;

var DKnopf              :array [1..40] of Gadget;
var DKnopfTx            :array [1..40] of IntuiText;
var EKnopf              :array [1..100] of Gadget;
var EKnopfTx            :array [1..4] of IntuiText;
var CKnopfTx,OKKnopfTx  :IntuiText;
var Schieber,Textgad    :array [1..7] of Gadget;
var SImage              :array [1..7] of Image;
var SchieberInfo        :array [1..7] of PropInfo;
var TextInfo            :array [1..7] of StringInfo;
var Buffer,UndoBuffer   :array [1..7] of string[15];
var XGadget             :^Gadget;

var MenuX       :array [1..3] of Menu;
var Mi1         :array [1..6] of MenuItem;
var Mi2,Mi3     :array [1..9] of MenuItem;
var SMi2        :array [1..31] of MenuItem;
var MiT         :array [1..55] of IntuiText;
var SubMit      :IntuiText;
var MenuName    :array[1..24] of string[30];
var PText       :array[1..TEXTS] of str;

var IMsg,IMsg1,IMsg2,IMsg3,IMsg4,IMsg0          :^IntuiMessage;
var UsedWindow                                  :byte;
var process_ptr                                 :p_Process;
var oldwindow_ptr                               :ptr;
var GadCode                                     :long;
var GadHit,RawCode,Men,MenItem,SItem,FCode,
    Octave,SEdMode,UsedChans                    :byte;
var Img                                         :Image;
var IMem,OPos,OEnd,TextMemA,TextMemL            :long;

var FHandle,AnimHandle                          :BPTR;

var Addr1,Addr2,Addr8,Addr16                    :long;
var Data1,Data2                                 :^long;
var Data16                                      :^integer;
var DataW                                       :^word;
var Data8                                       :^short;

var MemA24,MemA16,MemA8,MemAAlpha,MemAUNDO,
    AlphaUNDO                                   :array [0..5,1..6] of long;
var PlayRate                                    :array [0..5] of word;
var ActiveChannels,ActiveMode                   :array [0..5] of byte;
var PlayL24,MemL24,DrawOffset,Zoom,AreaA,AreaE,
    SAttack,SDecay,SSustain,SRelease            :array [0..5] of long;
var PlayMemA                                    :array [1..4] of long;
var SInfo                                       :array [0..5] of string;
var MemLF,MemAEff,MemLEff,MemAMod,MemLMod,
    ModMemInhalt,PlayLUNDO,l,m,PlayMemL,
    UndoAttack,UndoDecay,UndoSustain,UndoRelease:long;
var SFreq,WaveMaxAmp                            :long;
var i,j                                         :integer;
var scr,b,SharePayed,WTAChanged,ProcessOff,
    SampleEd,PlayEd,PlayDataValid,DoDoubleSize,
    TDeviceValid,Debug                          :boolean;
var _WaveOp                                     :array[0..MAXOPS] of WaveOp;
var LastSetup                                   :array[1..FUNCTS] of WaveOp;
var VHDR                                        :VoiceHeader;
var SXHD                                        :SXHeader;
var ADSR                                        :ADSRHeader;
var Prefs                                       :r_Prefs;

var LData                                       :^byte;
var FirstUNDO,ActBuffer                         :byte;
var s                                           :string;
var FName                                       :array[1..70] of string[80];
var KeyRates                                    :KeyArr;
var ChSurround,ChQuadro,ChAC3                   :ChCoords;
var MyChCoords                                  :^ChCoords;
var MaxZoom,UndoAreaA,UndoAreaE                 :long;
var RealYPos                                    :word;
var DspX1,DspX2,DspY1,DspY2,PosX,PosY           :integer;
var AAddr                                       :array [1..5] of long;
var AnimPath,AnimErrorTxt                       :string;

var PatternPos,SelPattern,EntryPos,SelEntry     :long;
var Patterns,Entries                            :long;
var FirstPattern                                :PlayListPattern;
var FirstEntry                                  :PlayListEntry;

type Plane =Array[1..128] of long;
type Plane2=Array[1..84] of long;
type ButtonPlane=Array[1..24] of long;
type CalcPlane=Array[1..26] of long;
type KnobPlane=Array[1..22] of long;

var KnobImg,CalcImg                             :Image;
var GImg                                        :array[1..6] of Image;
var ButtonImg                                   :array[1..6] of Image;
var KnobMem,CalcMem                             :long;
var GMem                                        :array[1..6] of long;
var ButtonMem                                   :array[1..6] of long;
var IDt                                         :^Plane;
var ButtonIDt                                   :^ButtonPlane;
var CalcIDt                                     :^CalcPlane;
var KnobIDt                                     :^KnobPlane;
var Notes                                       :BlueNote;
var FRTit,PathFR,FRShow,DirFR,FileFR            :string[90];
var NewColorR,NewColorG,NewColorB               :BArr32;



function XAllocMem(l1,l2 :long):long;

begin
   XAllocMem:=AllocMem(l1,l2);
end;



function XAllocVec(l1,l2 :long):long;

begin
   XAllocVec:=AllocVec(l1,l2);
end;



procedure XFreeMem(l1,l2 :long);

begin
   FreeMem(l1,l2);
end;



procedure XFreeVec(l1 :long);

begin
   FreeVec(l1);
end;



procedure IMPORTSAMPLE;

var MemID               :byte;
var Addr1,Addr16        :long;
var Data1               :^long;
var Data16              :^integer;

begin
   if (ActiveMode[0]=MD_STEREO) and (MemA24[0,1]<>0) and (MemA24[0,2]<>0)
    then CopyMem(MemA24[0,1]+(PlayL24[0] div 2),MemA24[0,2],PlayL24[0] div 2);
   if ActiveMode[0]=MD_MONO then MemID:=3 else MemID:=1;
   repeat
      if MemA24[0,MemID]<>0 then begin
         Addr1:=MemA24[0,MemID]+PlayL24[0];
         Addr16:=MemA24[0,MemID]+(PlayL24[0] div 2);
         repeat
            Data1:=ptr(Addr1);   Addr1:=Addr1-4;
            Data16:=ptr(Addr16); Addr16:=Addr16-2;
            Data1^:=Data16^*255;
         until Addr16<=MemA24[0,MemID];
         Data1:=ptr(MemA24[0,MemID]);
         Data1^:=0;
      end;
      if MemID=2 then exit;
      MemID:=2;
   until (ActiveMode[0]=MD_MONO);
end;



procedure REXXSHREDDER;

var ArgCtr      :short;
var i,j         :integer;

begin
   with RxMsg^ do begin
      RxStr:=rm_Args[0];
      ArgCtr:=1;
      j:=length(RxStr);
      for i:=1 to j do if (RxStr[i]=' ') and (ArgCtr<15) then begin
         RxStr[i]:=chr(0);
         rm_Args[ArgCtr]:=str(addr(RxStr[i+1]));
         ArgCtr:=ArgCtr+1;
      end;
      rm_Args[0]:=str(addr(RxStr[1]));
      for i:=1 to 15 do if rm_Args[i]='NIL' then rm_Args[i]:=NIL;
   end;
end;



procedure ERRORMSG(Tx1,Tx2 :str);

var f           :Text;

begin
   DisplayBeep(NIL);
   reset(f,'CON:0/20/640/100/WaveTracer DS');
   if IOResult<>0 then exit;
   writeln(f,Tx1);
   writeln(f,Tx2);
   delay(300);
   close(f);
end;



function GETSOUNDMODE(Channels :byte):byte;

begin
   if Channels in [CH_LEFT,CH_RIGHT,CH_CENTER] then GETSOUNDMODE:=MD_MONO
   else if Channels<=CH_LEFT+CH_RIGHT then GETSOUNDMODE:=MD_STEREO
   else if Channels<=CH_LEFT+CH_RIGHT+CH_CENTER then GETSOUNDMODE:=MD_3CH
   else if Channels=CH_LEFT+CH_RIGHT+CH_SLEFT+CH_SRIGHT then GETSOUNDMODE:=MD_QUADRO
   else if Channels=CH_LEFT+CH_CENTER+CH_RIGHT+CH_SLEFT then GETSOUNDMODE:=MD_SURROUND;
   if not (Channels and CH_SRIGHT=0) then GETSOUNDMODE:=MD_AC3_SUB;
   if not (Channels and CH_SUB=0) then GETSOUNDMODE:=MD_AC3;
end;



function INITIMG:boolean;


begin;
   INITIMG:=false;
   for i:=1 to 6 do begin
      GMem[i]:=XAllocMem(sizeof(Plane),MEMF_CHIP+MEMF_CLEAR);
      if GMem[i]=0 then exit;
   end;

   IDt:=ptr(GMem[1]);
   IDt^:=Plane(%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %01111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,

               %11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %10000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000);
   GImg[1]:=Image(0,0,128,16,2,IDt,3,1,NIL);
   IDt:=ptr(GMem[2]);
   IDt^:=Plane(%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000011111111111110011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000001100000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000110000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000011000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000001100000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000110000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000010000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000011111111111100011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000010000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %01111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,

               %11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000001100000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000011000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000110000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000001100000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000001000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000010000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000001111111111110000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %10000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000);
   GImg[2]:=Image(0,0,128,16,2,IDt,3,1,NIL);
   IDt:=ptr(GMem[3]);
   IDt^:=Plane2(%00000000000000000000000000000000,%00000000000000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %00000011111111111111111111111111,%11100000011000000000000000000000,
                %00000011111111111111111111111111,%11110000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000011110000000000000000000000,%01111000011000000000000000000000,
                %00000011110000000000000111100000,%01111000011000000000000000000000,
                %00000011110000000000011000011000,%01111000011000000000000000000000,
                %00000011110000111111100000011000,%01111000011000000000000000000000,
                %00000011110000111000011111111000,%01111000011000000000000000000000,
                %00000011110000111000000000011000,%01111000011000000000000000000000,
                %00000011110000111111111111111000,%01111000011000000000000000000000,
                %00000011110000000000000000000000,%01111000011000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %01111111111111111111111111111111,%11111111111000000000000000000000,

                %11111111111111111111111111111111,%11111111111000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000011111111000000000000000001,%11100000000000000000000000000000,
                %11000011111111000000000001111001,%11110000000000000000000000000000,
                %11000011111111000000000001111001,%11111000000000000000000000000000,
                %11000011111111000000000001111001,%11111000000000000000000000000000,
                %11000011111111000000000001111001,%11111000000000000000000000000000,
                %11000011111111000000000000000001,%11111000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000011111111111111111000011111,%11111000000000000000000000000000,
                %11000011111111111111100111100111,%11111000000000000000000000000000,
                %11000011111111000000011111100111,%11111000000000000000000000000000,
                %11000011111111000111100000000111,%11111000000000000000000000000000,
                %11000010011111000111111111100111,%11001000000000000000000000000000,
                %11000010011111000000000000000111,%11001000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %10000000000000000000000000000000,%00000000000000000000000000000000);
   GImg[3]:=Image(0,0,64,21,2,IDt,3,1,NIL);
   IDt:=ptr(GMem[4]);
   IDt^:=Plane2(%11111111111111111111111111111111,%11111111111000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000011111111111111111111111111,%11100000000000000000000000000000,
                %11000011111111111111111111111111,%11110000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000011111111111111111111111111,%11111000000000000000000000000000,
                %11000011110000000000000000000000,%01111000000000000000000000000000,
                %11000011110000000000000111100000,%01111000000000000000000000000000,
                %11000011110000000000011000011000,%01111000000000000000000000000000,
                %11000011110000111111100000011000,%01111000000000000000000000000000,
                %11000011110000111000011111111000,%01111000000000000000000000000000,
                %11000011110000111000000000011000,%01111000000000000000000000000000,
                %11000011110000111111111111111000,%01111000000000000000000000000000,
                %11000011110000000000000000000000,%01111000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %10000000000000000000000000000000,%00000000000000000000000000000000,

                %00000000000000000000000000000000,%00000000000000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %00000011110000000000000000011111,%11100000011000000000000000000000,
                %00000011110000000000011110011111,%11110000011000000000000000000000,
                %00000011110000000000011110011111,%11111000011000000000000000000000,
                %00000011110000000000011110011111,%11111000011000000000000000000000,
                %00000011110000000000011110011111,%11111000011000000000000000000000,
                %00000011110000000000000000011111,%11111000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000011111111111111111000011111,%11111000011000000000000000000000,
                %00000011111111111111100111100111,%11111000011000000000000000000000,
                %00000011111111000000011111100111,%11111000011000000000000000000000,
                %00000011111111000111100000000111,%11111000011000000000000000000000,
                %00000010011111000111111111100111,%11001000011000000000000000000000,
                %00000010011111000000000000000111,%11001000011000000000000000000000,
                %00000011111111111111111111111111,%11111000011000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %00000000000000000000000000000000,%00000000011000000000000000000000,
                %01111111111111111111111111111111,%11111111111000000000000000000000);
   GImg[4]:=Image(0,0,64,21,2,IDt,3,1,NIL);
   IDt:=ptr(GMem[5]);
   IDt^:=Plane(%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000100000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000001100000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000011111111111110000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000110000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000001100000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000110000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000011000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000001100000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000100000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000011,
               %01111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,

               %11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,%11111111111111111111111111111111,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000001000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000011000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000011000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000011000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000111111111111000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %11000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,
               %10000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000,%00000000000000000000000000000000);
   GImg[5]:=Image(0,0,128,16,2,IDt,3,1,NIL);
   IDt:=ptr(GMem[6]);
   IDt^:=Plane2(%00000000000000000000000000000000,%00000000000000000000000000000000,
                %00110000000000000000000000000000,%00000000000000000000000000000000,
                %00110000000001010100000000000000,%00000000000000000000000000000000,
                %00110000000101010101000000000000,%00000000000000000000000000000000,
                %00110000010101010101010000000000,%00000000000000000000000000000000,
                %00110000010101010101010000000000,%00000000000000000000000000000000,
                %00110001010101010101010100000000,%00000000000000000101010000000000,
                %00110001010101010101010100000000,%00000000000000010101010100000000,
                %00110101010101010101010101000000,%00000000000000010101010100000000,
                %00110101010101010101010101000000,%00000000000001010101010101000000,
                %00111111111111111111111111111111,%11111111111111111111111111111111,
                %00110000000000000000000000010101,%01010101010100000000000000000000,
                %00110000000000000000000000010101,%01010101010100000000000000000000,
                %00110000000000000000000000010101,%01010101010100000000000000000000,
                %00110000000000000000000000000101,%01010101010000000000000000000000,
                %00110000000000000000000000000101,%01010101010000000000000000000000,
                %00110000000000000000000000000001,%01010101000000000000000000000000,
                %00110000000000000000000000000000,%01010100000000000000000000000000,
                %00110000000000000000000000000000,%00000000000000000000000000000000,
                %00110000000000000000000000000000,%00000000000000000000000000000000,
                %11110000000000000000000000000000,%00000000000000000000000000000000,

                %11110000000000000000000000000000,%00000000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000000000001010100000000000000,%00000000000000000000000000000000,
                %11000000000101010101000000000000,%00000000000000000000000000000000,
                %11000000010101010101010000000000,%00000000000000000000000000000000,
                %11000000010101010101010000000000,%00000000000000000000000000000000,
                %11000001010101010101010100000000,%00000000000000000101010000000000,
                %11000001010101010101010100000000,%00000000000000010101010100000000,
                %11000101010101010101010101000000,%00000000000000010101010100000000,
                %11000101010101010101010101000000,%00000000000001010101010101000000,
                %11000101010101010101010101000000,%00000000000001010101010101000000,
                %11001111111111111111111111111111,%11111111111111111111111111111111,
                %11000000000000000000000000010101,%01010101010100000000000000000000,
                %11000000000000000000000000010101,%01010101010100000000000000000000,
                %11000000000000000000000000000101,%01010101010000000000000000000000,
                %11000000000000000000000000000101,%01010101010000000000000000000000,
                %11000000000000000000000000000001,%01010101000000000000000000000000,
                %11000000000000000000000000000000,%01010100000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %11000000000000000000000000000000,%00000000000000000000000000000000,
                %00000000000000000000000000000000,%00000000000000000000000000000000);
   GImg[6]:=Image(0,0,64,21,2,IDt,3,1,NIL);
   for i:=1 to 6 do begin
      ButtonMem[i]:=XAllocMem(sizeof(ButtonPlane),MEMF_CHIP+MEMF_CLEAR);
      if ButtonMem[i]=0 then exit;
   end;
   ButtonIDt:=ptr(ButtonMem[1]);
   ButtonIDt^:=ButtonPlane(%00000000000000000000000000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %01111111111111111111100000000000,

                           %11111111111111111111100000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %10000000000000000000000000000000);
   ButtonImg[1]:=Image(0,0,21,12,2,ButtonIDt,3,1,NIL);
   ButtonIDt:=ptr(ButtonMem[2]);
   ButtonIDt^:=ButtonPlane(%00000000000000000000000000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000010001100000000000,
                           %00000000000000100001100000000000,
                           %00000000000001000001100000000000,
                           %00000001000010000001100000000000,
                           %00000000100100000001100000000000,
                           %00000000001000000001100000000000,
                           %00000000010000000001100000000000,
                           %00000000000000000001100000000000,
                           %01111111111111111111100000000000,

                           %11111111111111111111100000000000,
                           %11000000000000000000000000000000,
                           %11000000000000110000000000000000,
                           %11000000000001100000000000000000,
                           %11000000000011000000000000000000,
                           %11000000000110000000000000000000,
                           %11001100001100000000000000000000,
                           %11000110011000000000000000000000,
                           %11000011110000000000000000000000,
                           %11000001100000000000000000000000,
                           %11000000000000000000000000000000,
                           %10000000000000000000000000000000);
   ButtonImg[2]:=Image(0,0,21,12,2,ButtonIDt,3,1,NIL);
   ButtonIDt:=ptr(ButtonMem[3]);
   ButtonIDt^:=ButtonPlane(%00000000000000000000000000000000,
                           %00000000000000000001100000000000,
                           %00000000000100000001100000000000,
                           %00000000000111000001100000000000,
                           %00000000000110110001100000000000,
                           %00000000000110011001100000000000,
                           %00000000000110001101100000000000,
                           %00000011111110001101100000000000,
                           %00000111111110000001100000000000,
                           %00000011111100000001100000000000,
                           %00000000000000000001100000000000,
                           %01111111111111111111100000000000,

                           %11111111111111111111100000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11011000000001100000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %10000000000000000000000000000000);
   ButtonImg[3]:=Image(0,0,21,12,2,ButtonIDt,3,1,NIL);
   ButtonIDt:=ptr(ButtonMem[4]);
   ButtonIDt^:=ButtonPlane(%11111111111111111111100000000000,
                           %11000000000000000000000000000000,
                           %11000001111111000000000000000000,
                           %11000111111111000000000000000000,
                           %11001111111111110000000000000000,
                           %11001111111111110000000000000000,
                           %11001111111111110000000000000000,
                           %11001111111111110000000000000000,
                           %11000111111111000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %10000000000000000000000000000000,

                           %00000000000000000000000000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00000001111111110001100000000000,
                           %00000011111111111001100000000000,
                           %00000011111111111001100000000000,
                           %00000011111111111001100000000000,
                           %00000011111111111001100000000000,
                           %00000001111111110001100000000000,
                           %00000001111111000001100000000000,
                           %00000000000000000001100000000000,
                           %01111111111111111111100000000000);
   ButtonImg[4]:=Image(0,0,21,12,2,ButtonIDt,3,1,NIL);
   ButtonIDt:=ptr(ButtonMem[5]);
   ButtonIDt^:=ButtonPlane(%00000000000000000000000000000000,
                           %00000000000000000001100000000000,
                           %00000000001000000001100000000000,
                           %00000000011100000001100000000000,
                           %00000000111110000001100000000000,
                           %00000001110111000001100000000000,
                           %00000011100011100001100000000000,
                           %00000111000001110001100000000000,
                           %00001110000000111001100000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %01111111111111111111100000000000,

                           %11111111111111111111100000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %10000000000000000000000000000000);
   ButtonImg[5]:=Image(0,0,21,12,2,ButtonIDt,3,1,NIL);
   ButtonIDt:=ptr(ButtonMem[6]);
   ButtonIDt^:=ButtonPlane(%00000000000000000000000000000000,
                           %00000000000000000001100000000000,
                           %00000000000000000001100000000000,
                           %00001110000000111001100000000000,
                           %00000111000001110001100000000000,
                           %00000011100011100001100000000000,
                           %00000001110111000001100000000000,
                           %00000000111110000001100000000000,
                           %00000000011100000001100000000000,
                           %00000000001000000001100000000000,
                           %00000000000000000001100000000000,
                           %01111111111111111111100000000000,

                           %11111111111111111111100000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %11000000000000000000000000000000,
                           %10000000000000000000000000000000);
   ButtonImg[6]:=Image(0,0,21,12,2,ButtonIDt,3,1,NIL);

   KnobMem:=XAllocMem(sizeof(KnobPlane),MEMF_CHIP+MEMF_CLEAR);
   if KnobMem=0 then exit;
   KnobIDt:=ptr(KnobMem);
   KnobIDt^:=KnobPlane(%00000000000000000000000000000001,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %00000000000000001000000000000111,
                       %01111111111111111111111111111111,

                       %11111111111111111111111111111111,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11100000000000010000000000000000,
                       %11000000000000010000000000000000);
   KnobImg:=Image(0,0,32,11,2,KnobIDt,3,0,NIL);
   CalcMem:=XAllocMem(sizeof(CalcPlane),MEMF_CHIP+MEMF_CLEAR);
   if CalcMem=0 then exit;
   CalcIDt:=ptr(CalcMem);
   CalcIDt^:=CalcPlane(%00000000000000000000000000000000,
                       %00000000000000000000000000000011,
                       %00000000001110001000000001110011,
                       %00000000000001001000000000001011,
                       %00000100000001001010001000001011,
                       %00000000000001001001010000001011,
                       %00011111001110001000100001110011,
                       %00000000010000001001010010000011,
                       %00000100010000001010001010000011,
                       %00000000010000001000000010000011,
                       %00000000001110001000000001110011,
                       %00000000000000000000000000000011,
                       %01111111111111111111111111111111,

                       %11111111111111111111111111111111,
                       %11000000000000000000000000000000,
                       %11000000001110010000000001110000,
                       %11000000000001010000000000001000,
                       %11000100000001010010001000001000,
                       %11000000000001010001010000001000,
                       %11011111001110010000100001110000,
                       %11000000010000010001010010000000,
                       %11000100010000010010001010000000,
                       %11000000010000010000000010000000,
                       %11000000001110010000000001110000,
                       %11000000000000000000000000000000,
                       %10000000000000000000000000000000);
   CalcImg:=Image(0,0,32,13,2,CalcIDt,3,0,NIL);

   MyWTImg:=WTImages(true,SharePayed,NIL,^KnobImg,^CalcImg,^GImg[1],^GImg[2],^GImg[3],^GImg[4],
                     ^GImg[5],NIL,^ButtonImg[1],^ButtonImg[2],^ButtonImg[3],NIL,NIL,NIL,^Notes,
                     ^OKKnopfTx,^CKnopfTx,^ButtonImg[4],^ButtonImg[5],^ButtonImg[6]);

   INITIMG:=true;
end;



procedure DRAWLINE(Wind :Window; Left,Top,Right,Bottom,Color :word);

begin
   SetAPen(Wind.RPort,Color);
   Move(Wind.RPort,Left,Top);
   Draw(Wind.RPort,Right,Bottom);
end;



procedure WRITE(LEdge,TEdge :word; StPen :byte; DMode :word; Wind :Window; tx :str);

var IT1 :IntuiText;
var txt :string[200];

begin
   txt:=tx;
   IT1:=IntuiText(StPen  ,0,0,LEdge  ,TEdge  ,^CustomTA,txt,NIL);
   if DMode>5 then begin
      while IntuiTextLength(^IT1)>DMode do txt:=copy(txt,2,length(txt)-1);
      DMode:=3;
   end;
   if DMode=3 then begin
      IT1.LeftEdge:=LEdge-IntuiTextLength(^IT1) div 2;
   end else if DMode=4 then begin
      IT1.LeftEdge:=LEdge-IntuiTextLength(^IT1);
   end;
   if DMode=5 then IT1.DrawMode:=1;
   PrintIText(Wind.RPort,^IT1,0,0);
end;



procedure FREEOLDANIM;

var i           :long;

begin
   DosClose(AnimHandle);
   AnimHandle:=0;
   AnimPath:='';
   TDeviceValid:=true;
   i:=0;
   if Prefs.UseVMem and Prefs.FrameCache then repeat
      i:=i+1;
      s:=intstr(i); while length(s)<5 do s:='0'+s;
      s:=Prefs.VMemStr+s;
      l:=DeleteFile(s);
   until l=0;
end;



procedure MAKEBORDER(Wind :Window; LEdge,TEdge,REdge,BEdge :word; Color :byte);

begin
   SetAPen(Wind.RPort,abs(Color-2));
   Move(Wind.RPort,LEdge+1,TEdge); Draw(Wind.RPort,LEdge+1,BEdge-1);
   Draw(Wind.RPort,LEdge,BEdge);   Draw(Wind.RPort,LEdge,TEdge);
   Draw(Wind.RPort,REdge,TEdge);
   SetAPen(Wind.RPort,abs(Color-1));
   Move(Wind.RPort,LEdge+1,BEdge); Draw(Wind.RPort,REdge,BEdge);
   Draw(Wind.RPort,REdge,TEdge+1); Draw(Wind.RPort,REdge-1,TEdge+1);
   Draw(Wind.RPort,REdge-1,BEdge);
end;



function TASKREQUEST(Text1,Text2 :str; Gad1,Gad2,Gad3 :str):byte;

type TagArr=array [1..4] of long;

var ReqText                     :string[300];
var GadText                     :string[100];
var ReqTags                     :TagArr;

begin
   TASKREQUEST:=3;
   ReqText:=Text1+chr(10)+Text2;
   GadText:=Gad1;
   if (GadText<>'') and (Gad2<>'') then GadText:=GadText+'|'+Gad2;
   if GadText='' then GadText:=Gad2;
   if (GadText<>'') and (Gad3<>'') then GadText:=GadText+'|'+Gad3;
   if GadText='' then GadText:=Gad3;
   ReqTags:=TagArr(RTEZ_Flags,EZREQF_LAMIGAQUAL+EZREQF_CENTERTEXT,
                   0,0);
   l:=rtEZRequestA(ReqText,GadText,NIL,NIL,^ReqTags);
   if (Gad1='') and (Gad2='') then TASKREQUEST:=2
   else if l=0 then TASKREQUEST:=3 else TASKREQUEST:=l;
   GadCode:=0;
end;



procedure AnimPlay(ShowPic :long);

const PORT_ANIM='WTAnimPort';

type p_AnimMsg=^AnimMsg;
type AnimMsg=Record
        wt_Node                                :Message;
        an_ShowPic,an_StartFrame,an_EndFrame   :long;
        an_Window                              :^Window;
        an_AnimHandle                          :^BPTR;
        an_AnimPicPos                          :long
        an_CachePicPos                         :^long;
        an_NewColorR,an_NewColorG,an_NewColorB :BArr32;
        an_MyScreen                            :^Screen;
        an_E3Knopf                             :^Gadget;
        an_GImg                                :^Image;
        an_TDeviceVaild                        :^boolean;
        an_UseVMem,an_FrameCache               :boolean;
        an_AnimErrorTxt,an_VMemStr,an_AnimPath :string[200];
     end;

var AnimSDHeader        :^SDHeader;
var AnimSDBodyScene     :^SDBodyScene;

var MyANode             :Node;
var MyAMsg              :Message;
var MyAnimMsg           :AnimMsg;
var AnimPort            :^MsgPort;
var StartFrame,EndFrame :long;

begin
   if (ShowPic<>-10) then begin
      if (IntuiWindow3=NIL) or (AnimPath='') or
      ((ShowPic=AnimPicPos) and ((not Prefs.UseVMem) or (not Prefs.FrameCache))) or
      ((ShowPic=CachePicPos) and (Prefs.UseVMem and Prefs.FrameCache)) then exit;
   end;
   AnimPort:=FindPort(PORT_ANIM);
   if (AnimPort=NIL) then begin
      if (Debug) then i:=Execute('run WTAnimPlay',0,0) else i:=Execute('run >NIL: WTAnimPlay >NIL:',0,0);
      delay(5);
   end;
   repeat
      AnimPort:=FindPort(PORT_ANIM);
      i:=i+1;
      delay(1);
   until (AnimPort<>NIL) or (i>=400);
   if (AnimPort<>NIL) then begin
      if (ShowPic<>-10) then begin
         StartFrame:=1; EndFrame:=2000000000;
         if MySDHeader[0]<>NIL then begin
            AnimSDHeader:=MySDHeader[0];
            repeat
               if AnimSDHeader^.sdh_Type=SD_SCENE then begin
                  AnimSDBodyScene:=r_SDBodyScene(AnimSDHeader);
                  with AnimSDBodyScene^ do begin
                     StartFrame:=sdb_StartFrame;
                     EndFrame:=sdb_EndFrame;
                  end;
                  if ShowPic=1 then ShowPic:=StartFrame;
               end;
               AnimSDHeader:=AnimSDHeader^.NextSpecialData;
            until AnimSDHeader=NIL;
         end;
      end;
      {// -10 = IntuiWindow3 schlieen }
      MyAMsg:=Message(MyANode,NIL,sizeof(AnimMsg)+100);
      MyANode:=Node(NIL,NIL,0,0,NIL);
      MyAnimMsg:=AnimMsg(MyAMsg,ShowPic,StartFrame,EndFrame,
                         IntuiWindow3,^AnimHandle,AnimPicPos,^CachePicPos,
                         NewColorR,NewColorG,NewColorB,
                         MyScreen,^E3Knopf,^GImg[1],
                         ^TDeviceValid,Prefs.UseVMem,Prefs.FrameCache,
                         AnimErrorTxt,Prefs.VMemStr,AnimPath);
      PutMsg(AnimPort,^MyAnimMsg.wt_Node);
   end else begin
      { Fehlermeldung }
   end;
end;



procedure GETWINPOSITIONS;

var i           :byte;

begin
   Prefs.WinXOffset[1]:=IntuiWindow1^.LeftEdge;    Prefs.WinYOffset[1]:=IntuiWindow1^.TopEdge;
   if IntuiWindow2<>NIL then begin
      Prefs.WinXOffset[2]:=IntuiWindow2^.LeftEdge; Prefs.WinYOffset[2]:=IntuiWindow2^.TopEdge;
      Prefs.WinActive[2]:=true;
   end else Prefs.WinActive[2]:=false;
   if IntuiWindow3<>NIL then begin
      Prefs.WinXOffset[3]:=IntuiWindow3^.LeftEdge; Prefs.WinYOffset[3]:=IntuiWindow3^.TopEdge;
      Prefs.WinActive[3]:=true;
      Prefs.WinXSize:=IntuiWindow3^.Width;         Prefs.WinYSize:=IntuiWindow3^.Height;
   end else Prefs.WinActive[3]:=false;
   if IntuiWindow4<>NIL then begin
      Prefs.WinXOffset[4]:=IntuiWindow4^.LeftEdge; Prefs.WinYOffset[4]:=IntuiWindow4^.TopEdge;
      Prefs.WinActive[4]:=true;
   end else Prefs.WinActive[4]:=false;
   if DWindow<>NIL then begin
      Prefs.WinXOffset[5]:=IntuiWindow1^.LeftEdge; Prefs.WinYOffset[5]:=IntuiWindow1^.TopEdge;
   end;
end;



procedure TASKMESSAGE(TXT :str);

begin
   SetAPen(MyWindow^.RPort,3); RectFill(MyWindow^.RPort,MyScreen^.Width div 2-100,40,MyScreen^.Width div 2+100,58);
   MAKEBORDER(MyWindow^,MyScreen^.Width div 2-100,40,MyScreen^.Width div 2+100,58,POSITIVE);
   WRITE(MyScreen^.Width div 2,43,1,3,MyWindow^,Txt);
end;



procedure USERINFO;

var s1,s2       :string;

begin
   if SharePayed then begin
      s1:='VOLLVERSION, registered to '+MyKey.Name;
      s2:=MyKey.Street+', '+MyKey.City;
   end else begin
      s1:='DEMOVERSION';
      s2:='Not registered!';
   end;
   l:=TASKREQUEST(s1,s2,'','OK','');
end;



function LONGREQUEST(Text1 :str; Gad1,Gad2,Gad3 :str; Default,Smallest,Highest :long; var Return :long):byte;

type TagArr=array [1..12] of long;

var GadText                     :string[100];
var ReqTags                     :TagArr;

begin
   LONGREQUEST:=3;
   GadText:=Gad1;
   if (GadText<>'') and (Gad2<>'') then GadText:=GadText+'|'+Gad2;
   if GadText='' then GadText:=Gad2;
   if (GadText<>'') and (Gad3<>'') then GadText:=GadText+'|'+Gad3;
   if GadText='' then GadText:=Gad3;
   Return:=Default;
   ReqTags:=TagArr(RTGL_Flags,GLREQF_CENTERTEXT,
                   RTGL_Min,Smallest,
                   RTGL_Max,Highest,
                   RTGL_GadFmt,addr(GadText),
                   RTGL_Width,320,0,0);
   l:=rtGetLongA(^Return,Text1,NIL,^ReqTags);
   if (Gad1='') and (Gad2='') then LONGREQUEST:=2
   else if l=0 then LONGREQUEST:=3 else LONGREQUEST:=l;
end;



procedure READKEYFILE;

var AddrX,l     :long;
var Data1,Data2 :^byte;
var FHandle     :BPTR;
var i           :integer;


procedure DECODE;

begin
   with MyKey do begin
      for i:=1 to 16 do begin
         AddrX:=addr(MyKey)+sizeof(r_Key);
         Data1:=ptr(AddrX); AddrX:=AddrX-1;
         Data2:=ptr(AddrX);
         repeat
            Data1:=ptr(AddrX); AddrX:=AddrX-1;
            Data2:=ptr(AddrX);
            Data1^:=Data1^-Data2^
         until AddrX<=addr(MyKey)+1;

         AddrX:=addr(MyKey);
         repeat
            Data1:=ptr(AddrX); AddrX:=AddrX+1;
            Data1^:=Data1^ XOR 139;
         until AddrX>=sizeof(r_Key)+addr(MyKey);
      end;
   end;
end;


begin
   SharePayed:=false;
   FHandle:=DosOpen('Key.WT',MODE_OLDFILE);
   if FHandle=0 then FHandle:=DosOpen('S:Key.WT',MODE_OLDFILE);
   if FHandle<>0 then begin
      l:=DosRead(FHandle,^MyKey,sizeof(r_Key));
      DosClose(FHandle);
      DECODE;
      if MyKey.ID=17031973 then SharePayed:=true;
   end;
end;



function OPENDWIN(Height,TopEdge :integer; var DWindow :p_Window; WTitle :str; WinMode,ChGadOffset :byte):boolean;

var i   :byte;

begin
   if TopEdge=0 then TopEdge:=MyScreen^.Height-Height;
   NeuWindow:=NewWindow(MyScreen^.Width div 2-320,TopEdge,640,Height,3,1,RAWKEY or GADGETDOWN or GADGETUP
                        or MOUSEMOVE or MOUSEBUTTONS,SMART_REFRESH or ACTIVATE or WINDOWDRAG
                        or _REPORTMOUSE or WINDOWDEPTH,
                        Nil,NIL,WTVer,MyScreen,Nil,640,Height,640,Height,CUSTOMSCREEN);
   DWindow:=OpenWindow(^NeuWindow);
   If DWindow=Nil Then begin
      OPENDWIN:=false;
      DisplayBeep(NIL);
      exit;
   end else OPENDWIN:=true;
   WRITE(320,19,2,3,DWindow^,WTitle);
   if WinMode and 1=1 then begin
      DKnopf[1]:=Gadget(NIL,500,40,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^OKKnopfTx,0,NIL,1,0);
      DKnopf[2]:=Gadget(NIL,500,58,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^CKnopfTx,0,NIL,2,0);
      for i:=1 to 2 do AddGadget(DWindow,^DKnopf[i],NIL);
   end;
   if WinMode and 2=2 then begin
      for i:=3 to 8 do DKnopf[i]:=Gadget(NIL,21*i-52,ChGadOffset*18+40,21,12,GADGHIMAGE+GADGIMAGE,
                                         RELVERIFY+TOGGLESELECT,BOOLGADGET,^ButtonImg[1],
                                         ^ButtonImg[2],NIL,0,NIL,i,0);
      WRITE(19,ChGadOffset*16+56,2,0,DWindow^,CHANNELNAMES);
      for i:=3 to 8 do AddGadget(DWindow,^DKnopf[i],NIL);
   end;
   RefreshWindowFrame(DWindow);
end;



function LEAVEDEF(RawCode,GadCode,OKGad,EscGad :byte; XWindow :p_Window):boolean;

begin
   LEAVEDEF:=true;
   if RawCode=69 then begin
      DKnopf[EscGad].flags:=DKnopf[EscGad].flags+SELECTED;
      if OPos>1 then Opos:=OPos-1;
      LEAVEDEF:=false;
   end else if RawCode=68 then DKnopf[OKGad].flags:=DKnopf[OKGad].flags+SELECTED;
   RefreshGadgets(XWindow^.FirstGadget,XWindow,NIL);
   while RawCode in [68,69] do begin
      delay(1);
      IMsg:=Get_Msg(XWindow^.UserPort);
      if IMsg<>NIL then begin
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      end;
   end;
   while XWindow^.FirstGadget<>NIL do RemoveGadgets(XWindow,XWindow^.FirstGadget);
   CloseWindow(XWindow);
   if GadCode=EscGad then LEAVEDEF:=False;
end;



function DOSELECTLIST(MySList :r_SelectListGad):byte;

var i,Gads,TEdge,LEdge  :integer;
var CWindow             :^Window;
var CKnopf              :array [1..15] of Gadget;

begin
   with MySList^ do begin
      Gads:=0; i:=0;
      repeat
         Gads:=Gads+1; i:=i+1;
      until ITextTag[i]=NIL;
      Gads:=Gads-1;
      DOSELECTLIST:=SelectedGad;

      TEdge:=GadWindow^.TopEdge+SGad^.TopEdge-pred(SelectedGad)*SGad^.Height;
      if SelectedGad>Gads then TEdge:=GadWindow^.TopEdge+SGad^.TopEdge;
      LEdge:=GadWindow^.LeftEdge+SGad^.LeftEdge+SGad^.Width;
      if TEdge+(SGad^.Height*Gads)>MyScreen^.Height then TEdge:=MyScreen^.Height-(SGad^.Height*Gads)-1;
      if TEdge<1 then TEdge:=1;
      if LEdge+SGad^.Width>MyScreen^.Width then LEdge:=MyScreen^.Width-SGad^.Width-1;
      NeuWindow:=NewWindow(LEdge,TEdge,SGad^.Width,SGad^.Height*Gads,3,1,GADGETUP,
                           SMART_REFRESH or ACTIVATE or BORDERLESS,Nil,Nil,'',
                           MyScreen,Nil,SGad^.Width,SGad^.Height*Gads,SGad^.Width,SGad^.Height*Gads,CUSTOMSCREEN);
      CWindow:=OpenWindow(^Neuwindow);
      If CWindow=Nil Then begin
         DisplayBeep(NIL);
         exit;
      end;
      for i:=1 to Gads do begin
         if i<>SelectedGad then ITextTag[i]^.FrontPen:=2 else ITextTag[i]^.FrontPen:=3;
         CKnopf[i]:=Gadget(NIL,0,pred(i)*16,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,
                           ^GImg[1],NIL,ITextTag[i],0,Nil,i,0);
         AddGadget(CWindow,^CKnopf[i],NIL);
      end;
      RefreshGadgets(CWindow^.FirstGadget,CWindow,NIL);
      IMsg:=Wait_Port(CWindow^.UserPort);
      if IMsg<>NIL then begin
         IMsg:=Get_Msg(CWindow^.UserPort);
         if IMsg^.class=GADGETUP then begin
            XGadget:=IMsg^.IAddress;
            DOSELECTLIST:=XGadget^.GadgetID;
            SelectedGad:=XGadget^.GadgetID;
            ITextTag[XGadget^.GadgetID]^.FrontPen:=2;
            SGad^.GadgetText:=ITextTag[XGadget^.GadgetID];
            RefreshGadgets(GadWindow^.FirstGadget,GadWindow,NIL);
         end;
         Reply_Msg(IMsg)
      End;
      CloseWindow(CWindow);
   end;
end;



procedure FREEUNDO(MemID :byte);

var j   :byte;

begin
   if (Prefs.UseVMem) and (Prefs.UNDOVMem) then begin
      for j:=1 to 6 do begin
         s:=Prefs.VMemStr+'WT.UNDO.'+intstr(MemID)+'.'+intstr(j);
         l:=DeleteFile(s);
         s:=Prefs.VMemStr+'WT.AlphaUNDO.'+intstr(MemID)+'.'+intstr(j);
         l:=DeleteFile(s);
         s:=Prefs.VMemStr+'WT.UNDO.x,'+intstr(j);
         l:=DeleteFile(s);
         s:=Prefs.VMemStr+'WT.AlphaUNDO.x.'+intstr(j);
         l:=DeleteFile(s);
      end;
   end;
   for j:=1 to 6 do begin
      if MemAUNDO[MemID,j]<>0  then XFreeMem(MemAUNDO[MemID,j]-16,MemL24[MemID]+32);
      MemAUNDO[MemID,j]:=0;
      if AlphaUNDO[MemID,j]<>0 then XFreeMem(AlphaUNDO[MemID,j],round(MemL24[MemID]/80+5));
      AlphaUNDO[MemID,j]:=0;
   end;
end;



procedure WORKINFO(WText :str; Step :byte);

begin
   if (InfoWindow=NIL) and (Step<8) then begin
      NeuWindow:=NewWindow(MyScreen^.Width div 2-175,35,351,80,1,0,RAWKEY or GADGETUP,
                           SMART_REFRESH or WINDOWDRAG,NIL,NIL,WTVer,MyScreen,Nil,
                           350,80,350,80,CUSTOMSCREEN);
      InfoWindow:=OpenWindow(^Neuwindow);
      If InfoWindow=Nil Then begin
         DisplayBeep(NIL);
         exit;
      end;
      MAKEBORDER(InfoWindow^,9,39,341,60,POSITIVE);
      WRITE(9,63,3,0,InfoWindow^,'0 %');
      WRITE(311,63,3,0,InfoWindow^,'100 %');
   end else if (InfoWindow=NIL) and (Step=8) then exit;
   if WText<>'' then begin
      SetAPen(InfoWindow^.RPort,0); RectFill(InfoWindow^.RPort,5,20,340,34);
      WRITE(175,20,2,3,InfoWindow^,WText);
   end;
   SetAPen(InfoWindow^.RPort,3);
   RectFill(InfoWindow^.RPort,11,40,11+Step*41,59);
   if Step<8 then begin
      SetAPen(InfoWindow^.RPort,0);
      RectFill(InfoWindow^.RPort,12+Step*41,40,338,59);
   end else if Step=8 then begin
      WaitBlit;
      delay(4);
      CloseWindow(InfoWindow);
      InfoWindow:=NIL;
   end;
end;



procedure HANDLEUNDO(Mode,MemID :byte);

var l           :long;
var i           :byte;
var FHandle     :BPTR;
var s,s2,s3,sa  :string;
var UseVMem     :boolean;


function SAVEMEMA24(s :str; i :byte):boolean;

begin
   SAVEMEMA24:=false;

   FHandle:=DosOpen(s,MODE_NEWFILE);
   if FHandle=0 then begin
      FREEUNDO(MemID);
      exit;
   end;
   l:=DosWrite(FHandle,ptr(MemA24[MemID,i]),PlayL24[MemID]);
   DosClose(FHandle);
   if l<PlayL24[MemID] then begin
      FREEUNDO(MemID);
      exit;
   end;
   SAVEMEMA24:=true;
end;



function SAVEMEMAALPHA(sa :str; i :byte):boolean;

begin
   SAVEMEMAALPHA:=false;
   FHandle:=DosOpen(sa,MODE_NEWFILE);
   if FHandle=0 then begin
      FREEUNDO(MemID);
      exit;
   end;
   l:=DosWrite(FHandle,ptr(MemAAlpha[MemID,i]),round(MemL24[MemID]/80+0.5));
   DosClose(FHandle);
   if l<round(MemL24[MemID]/80+0.5) then begin
      FREEUNDO(MemID);
      exit;
   end;
   SAVEMEMAALPHA:=true;
end;


begin
   for i:=1 to 6 do if MemA24[MemID,i]<>0 then begin
      s:= Prefs.VMemStr+'WT.UNDO.'+intstr(MemID)+'.'+intstr(i);
      sa:=Prefs.VMemStr+'WT.AlphaUNDO.'+intstr(MemID)+'.'+intstr(i);
      if (MemAUNDO[MemID,i]=0) and Prefs.UseVMem and (Prefs.UNDOVMem)
       then UseVMem:=true else UseVMem:=false;
      if Mode=MODE_COPYNEW then begin
         if UseVMem then begin
            if not SAVEMEMA24(s,i) then exit;
            if MemAAlpha[MemID,i]<>0 then if not SAVEMEMAALPHA(sa,i) then exit;
         end else begin
            if MemAUNDO[MemID,i]<>0 then CopyMemQuick(MemA24[MemID,i],MemAUNDO[MemID,i],PlayL24[MemID]);
            if (AlphaUNDO[MemID,i]<>0) and (MemAAlpha[MemID,i]<>0) then CopyMem(MemAAlpha[MemID,i],AlphaUNDO[MemID,i],round(MemL24[MemID]/80+0.5));
         end;
      end else if (Mode=MODE_MOVETODISK) then begin
         if MemAUNDO[MemID,i]<>0 then begin
            exchange(MemA24[MemID,i],MemAUNDO[MemID,i]);
            if not SAVEMEMA24(s,i) then exit;
            exchange(MemA24[MemID,i],MemAUNDO[MemID,i]);
            XFreeMem(MemAUNDO[MemID,i]-16,MemL24[MemID]+32);
            MemAUNDO[MemID,i]:=0;
         end;
         if AlphaUNDO[MemID,i]<>0 then begin
            exchange(MemAAlpha[MemID,i],AlphaUNDO[MemID,i]);
            if not SAVEMEMAALPHA(sa,i) then exit;
            exchange(MemAAlpha[MemID,i],AlphaUNDO[MemID,i]);
            if AlphaUNDO[MemID,i]<>0 then XFreeMem(AlphaUNDO[MemID,i],round(MemL24[MemID]/80+5));
            AlphaUNDO[MemID,i]:=0;
         end;
      end else if Mode=MODE_NAMEEXCHANGE then begin
         s2:=Prefs.VMemStr+'WT.UNDO.x.'+intstr(i);
         s3:=Prefs.VMemStr+'WT.UNDO.0.'+intstr(i);
         l:=Rename(s,s2); l:=Rename(s3,s); l:=Rename(s2,s3);
         exchange(MemAUNDO[0,i],MemAUNDO[MemID,i]);
         exchange(AlphaUNDO[0,i],AlphaUNDO[MemID,i]);
      end else if Mode=MODE_EXCHANGE then begin
         WORKINFO('UNDO',i);
         if UseVMem then begin
            s2:=Prefs.VMemStr+'WT.UNDO.x.'+intstr(i);
            l:=Rename(s,s2);
            if not SAVEMEMA24(s,i) then exit;
            FHandle:=DosOpen(s2,MODE_OLDFILE);
            if FHandle=0 then begin
               FREEUNDO(MemID);
               exit;
            end;
            l:=DosRead(FHandle,ptr(MemA24[MemID,i]),PlayLUNDO);
            DosClose(FHandle);
            l:=DeleteFile(s2);
            if MemAAlpha[MemID,i]<>0 then begin
               s2:=Prefs.VMemStr+'WT.AlphaUNDO.x.'+intstr(i);
               l:=Rename(sa,s2);
               if not SAVEMEMAALPHA(sa,i) then exit;
               FHandle:=DosOpen(s2,MODE_OLDFILE);
               if FHandle=0 then begin
                  FREEUNDO(MemID);
                  exit;
               end;
               l:=DosRead(FHandle,ptr(MemAAlpha[MemID,i]),round(MemL24[MemID]/80+0.5));
               DosClose(FHandle);
               l:=DeleteFile(s2);
            end;
         end else begin
            if MemAUNDO[MemID,i]<>0 then exchange(MemAUNDO[MemID,i],MemA24[MemID,i]);
            if AlphaUNDO[MemID,i]<>0 then exchange(AlphaUNDO[MemID,i],MemAAlpha[MemID,i]);
         end;
      end;
   end;
end;



procedure CLEARPORT(PortName :str);

var BadPort     :^MsgPort;
var BadMsg      :^Message;

begin
   BadPort:=FindPort(PortName);
   Forbid;
   while BadPort<>NIL do begin
      BadMsg:=Get_Msg(BadPort);
      while BadMsg<>NIL do begin
         Reply_Msg(BadMsg);
         BadMsg:=Get_Msg(BadPort);
      end;
      RemPort(BadPort);
      BadPort:=FindPort(PortName);
   end;
   Permit;
end;



function PORTACTIVE(PortName :str):boolean;

var BadPort     :^MsgPort;

begin
   BadPort:=FindPort(PortName);
   if BadPort=NIL then PORTACTIVE:=false else PORTACTIVE:=true;
end;



function FILEREQ:boolean;

var l   :long;
var i   :byte;

begin
   if FRShow='' then FRShow:='~(#?.p|#?.backup|#?.data|#?.s|#?.o|#?.c|#?.mdbi|#?.mdbg|#?.bak)';

   if PathFR<>'' then begin
      DirFR:=PathFR; FileFR:='';
      for i:=1 to length(PathFR) do if PathFR[i] in ['/',':'] then begin
         FileFR:=copy(PathFR,succ(i),length(PathFR)-i);
         DirFR:=copy(PathFR,1,i);
      end;
   end;
   FTags:=FTagArr(RTFI_MatchPat,addr(FRShow),
                  RTFI_Dir,addr(DirFR),
                  0,0);
   l:=rtChangeReqAttrA(MyFReq,^FTags);
   l:=rtFileRequestA(MyFReq,FileFR,FRTit,^FTags);
   if l=1 then FILEREQ:=true else begin
      FILEREQ:=false;
      PathFR:='';
      exit;
   end;
   DirFR:=MyFReq^.Dir;
   if length(DirFR)>0 then begin
      if not (DirFR[length(DirFR)] in ['/',':']) then PathFR:=DirFR+'/'+FileFR else PathFR:=DirFR+FileFR;
   end else PathFR:=FileFR;
end;



function GETNOTEFREQ(XWindow :p_Window):word;

var NWindow     :^Window;
var NKnopf      :array[0..6,1..12] of Gadget;
var NKnopfTx    :array[0..6,1..12] of IntuiText;
var TEdge,LEdge :integer;
var i,j         :byte;

begin
   GETNOTEFREQ:=0;
   TEdge:=MyScreen^.MouseY-50;
   if TEdge+105>MyScreen^.Height then TEdge:=MyScreen^.Height-105;
   if TEdge<1 then TEdge:=1;
   LEdge:=MyScreen^.MouseX-160;
   if LEdge+330>MyScreen^.Width-5 then LEdge:=MyScreen^.Width-335;
   if LEdge<1 then LEdge:=1;
   NeuWindow:=NewWindow(LEdge,TEdge,327,100,0,0,GADGETUP,SMART_REFRESH or ACTIVATE
                        or BORDERLESS,NIL,NIL,'',MyScreen,NIL,1,1,640,256,CUSTOMSCREEN);
   NWindow:=OpenWindow(^NeuWindow);
   if NWindow=NIL then begin
      DisplayBeep(NIL); exit;
   end;
   NWindow^.BorderTop:=0;
   SetAPen(NWindow^.RPort,0); RectFill(NWindow^.RPort,0,0,327,101);
   MAKEBORDER(NWindow^,0,0,326,99,POSITIVE);
   for j:=0 to 6 do for i:=1 to 12 do begin
      NKnopf[j,i]:=Gadget(NIL,pred(i)*27+2,j*14+1,26,14,GADGHCOMP,$1,BOOLGADGET,NIL,NIL,
                          ^NKnopfTx[j,i],0,NIL,pred(i)+12*j,0);
      NKnopfTx[j,i]:=IntuiText(2,0,0,2,2,^CustomTA,Notes.bn_NoteName[j,i],NIL);
      if Notes.bn_NoteName[j,i][3] in ['b','#'] then NKnopfTx[j,i].FrontPen:=1;
      AddGadget(NWindow,^NKnopf[j,i],NIL);
   end;
   RefreshGadgets(NWindow^.FirstGadget,NWindow,NIL);
   repeat
      GadCode:=100;
      IMsg:=Wait_Port(NWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(NWindow^.UserPort);
         if IMsg^.Class=GADGETUP then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      End;
   until Gadcode<>100;
   GETNOTEFREQ:=round(Notes.bn_SampleFreq[GadCode div 12,succ(GadCode)-(GadCode div 12 * 12)]);
   Notes.bn_PosX:=GadCode div 12; Notes.bn_PosY:=succ(GadCode)-(GadCode div 12 * 12);
   while NWindow^.FirstGadget<>NIL do RemoveGadgets(NWindow,NWindow^.FirstGadget);
   CloseWindow(NWindow);
end;



procedure UNPACK(UnPackedD,PackedD,Laenge :long);

var Anfang              :long;
var Anz,Inh,Dest        :^byte;
var i                   :integer;

begin
   Anfang:=UnPackedD;
   repeat
      Anz:=ptr(PackedD);   PackedD:=PackedD+1;
      if Anz^>127 then begin
         Anz^:=Anz^-127;
         CopyMem(PackedD,UnPackedD,Anz^);
         PackedD:=PackedD+Anz^;
         UnPackedD:=UnPackedD+Anz^;
      end else begin
         Inh:=ptr(PackedD);   PackedD:=PackedD+1;
         for i:=1 to Anz^ do begin
            Dest:=Ptr(UnPackedD); UnPackedD:=UnPackedD+1;
            Dest^:=Inh^;
         end;
      end;
   until (UnPackedD>=PackedD) or (UnPackedD>=Anfang+Laenge);
end;



procedure CHECKSUFFIX(Sfx :str);

var PfadFR,Suffix       :string;
var i                   :byte;

begin
   PfadFR:=PathFR;
   Suffix:=sfx;
   delete(PfadFR,1,(length(PfadFR)-length(Suffix)));
   for i:=1 to length(PfadFR) do PfadFR[i]:=upcase(PfadFR[i]);
   if PfadFR<>Suffix then PathFR:=PathFR+Suffix;
end;



procedure CREATEPROPGAD(LEdge,TEdge,XSet,XJump,GadNum,IDOffset :word; XWindow :Window);

begin
   SImage[GadNum]:=KnobImg;
   Schieber[GadNum]:=Gadget(NIL,LEdge,TEdge,320,15,GADGHCOMP+GADGIMAGE,$83,PROPGADGET,
                           ^SImage[GadNum],NIL,NIL,0,^Schieberinfo[GadNum],IDOffset+GadNum*2-1,0);
   SchieberInfo[GadNum]:=Propinfo(FREEHORIZ,XSet,0,XJump,0,0,0,0,0,0,0);
   TextGad[GadNum]:=Gadget(NIL,LEdge+332,TEdge+1,60,15,GADGHCOMP,_LONGINT+STRINGCENTER+$1,
                           STRGADGET,NIL,Nil,Nil,0,^TextInfo[GadNum],IDOffset+GadNum*2,0);
   TextInfo[GadNum]:=StringInfo(^Buffer[GadNum],^Undobuffer[GadNum],0,14,0,0,14,0,
                           0,0,Nil,0,Nil);
   UndoBuffer[GadNum]:='';
   MAKEBORDER(XWindow,LEdge+330,TEdge,LEdge+394,TEdge+14,NEGATIVE);
end;



procedure ACTIVECHANNELGADS(Mode,Channels :integer);

var i,ChBit     :byte;

begin
   ChBit:=1;
   for i:=3 to 8 do begin
      DKnopf[i].Flags:=DKnopf[i].Flags and not GADGDISABLED;
      if not (Channels and ChBit=0) then
       DKnopf[i].Flags:=DKnopf[i].Flags or SELECTED
      else
       DKnopf[i].Flags:=DKnopf[i].Flags and not SELECTED;
      ChBit:=ChBit*2;
   end;
   if Mode<7 then DKnopf[8].Flags:=DKnopf[8].Flags or GADGDISABLED;
   if Mode<6 then DKnopf[7].Flags:=DKnopf[7].Flags or GADGDISABLED;
   if Mode<4 then DKnopf[6].Flags:=DKnopf[6].Flags or GADGDISABLED;
   if Mode<3 then DKnopf[5].Flags:=DKnopf[5].Flags or GADGDISABLED;
   if Mode<2 then begin
      DKnopf[4].Flags:=DKnopf[4].Flags or GADGDISABLED;
      DKnopf[3].Flags:=DKnopf[3].Flags or GADGDISABLED;
      DKnopf[5].Flags:=DKnopf[5].Flags and not GADGDISABLED;
   end;
   if Mode=4 then begin
      DKnopf[5].Flags:=DKnopf[5].Flags or GADGDISABLED;
      DKnopf[7].Flags:=DKnopf[7].Flags and not GADGDISABLED;
   end;
end;



function GETCHANNELBITS(Mode :byte):byte;

var ChB :byte;

begin
   GETCHANNELBITS:=0;
   if Mode=MD_MONO then ChB:=CH_CENTER;
   if Mode>=MD_STEREO then ChB:=CH_LEFT+CH_RIGHT;
   if Mode>=MD_3CH then ChB:=ChB+CH_CENTER;
   if Mode>=MD_SURROUND then ChB:=ChB+CH_SLEFT;
   if Mode>=MD_AC3_Sub then ChB:=ChB+CH_SRIGHT;
   if Mode>=MD_AC3 then ChB:=ChB+CH_SUB;
   if Mode=MD_QUADRO then ChB:=CH_LEFT+CH_RIGHT+CH_SLEFT+CH_SRIGHT;
   GETCHANNELBITS:=ChB
end;



function GETACTIVECHANNELS(Mode :integer):byte;

var i,Chan,Active       :byte;
var ChBit               :byte;

begin
   Chan:=0;
   ChBit:=1;
   for i:=3 to 8 do begin
      if not (DKnopf[i].Flags and SELECTED=0) then Chan:=Chan+ChBit;
      ChBit:=ChBit*2;
   end;
   Active:=GETCHANNELBITS(Mode);
   Chan:=Active and Chan;
   ChBit:=1;
   for i:=19 to 24 do begin
      if not (Active and ChBit=0) then
       Knopf[i].Flags:=(Knopf[i].Flags or SELECTED) and not GADGDISABLED
      else Knopf[i].Flags:=(Knopf[i].Flags or GADGDISABLED) and not SELECTED;
      ChBit:=ChBit*2;
   end;
   RefreshGadgets(IntuiWindow1^.FirstGadget,IntuiWindow1,NIL);
   GETACTIVECHANNELS:=Chan;
end;



procedure CREATEGADS(ChNames,SLists,DGads :integer);

var GadCtr,i      :byte;

begin
   GadCtr:=8;
   if SLists>0 then for i:=9 to GadCtr+SLists do
    DKnopf[i]:= Gadget(NIL,10,i*18-122,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,NIL,0,NIL,i,0);
   GadCtr:=GadCtr+SLists;
      { SELECTLIST }
   if DGads>0 then for i:=GadCtr+1 to GadCtr+DGads do
    DKnopf[i]:=Gadget(NIL,(i-GadCtr)*76+109,40,43,21,GADGHIMAGE+GADGIMAGE,$1,BOOLGADGET,^GImg[3],^GImg[4],NIL,0,Nil,i,0);
   GadCtr:=GadCtr+DGads;
      { DISKGADGET  }
end;



function CHANNELREQUEST(Channels,ActiveGads,Compression :byte; CReqText :Str; var Result :long):byte;

var ChBit,GadCode,RawCode,ChCnt,i       :byte;
var CcWindow                            :^Window;
var DKnopf                              :array [1..12] of Gadget;
var TextGad                             :Gadget;
var TextInfo                            :StringInfo;
var Buffer,UndoBuffer                   :string[25];

begin
   if not OPENDWIN(80,0,CcWindow,CReqText,0,0) then exit;
   DKnopf[1]:=Gadget(NIL,500,40,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^OKKnopfTx,0,Nil,1,0);
      { OK / CANCEL }
   for i:=3 to 8  do DKnopf[i]:=Gadget(NIL,21*i-52,40,21,12,GADGHIMAGE+GADGIMAGE+GADGDISABLED,
                                            RELVERIFY+TOGGLESELECT,BOOLGADGET,^ButtonImg[1],
                                            ^ButtonImg[2],NIL,0,Nil,i,0);
   WRITE(19,56,2,0,CcWindow^,CHANNELNAMES);

   if not (Compression and $80=0) then begin
      DKnopf[10]:=Gadget(NIL,157,40,21,12,GADGHIMAGE+GADGIMAGE,RELVERIFY+TOGGLESELECT,
                        BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,10,0);
      TextGad:=Gadget(Nil,182,40,100,14,GADGHCOMP+GADGDISABLED,STRINGCENTER,STRGADGET,NIL,Nil,Nil,0,^TextInfo,0,0);
      TextInfo:=StringInfo(^Buffer,^Buffer,0,21,0,0,0,0,0,0,Nil,0,Nil);
      MAKEBORDER(CcWindow^,180,39,282,54,NEGATIVE);
      Buffer:=Prefs.CopyrightStr;
      WRITE(288,40,2,0,CcWindow^,'Sample-Copyright');
      AddGadget(CcWindow,^DKnopf[10],NIL);
      AddGadget(CcWindow,^TextGad,NIL);
   end;
   ChBit:=1; ChCnt:=0;
   for i:=3 to 8 do begin
      if not (Channels and ChBit=0) then begin
         DKnopf[i].Flags:=DKnopf[i].Flags and not GADGDISABLED;
         ChCnt:=ChCnt+1;
      end;
      if not (ActiveGads and ChBit=0) then DKnopf[i].Flags:=DKnopf[i].Flags or SELECTED;
      ChBit:=ChBit*2;
   end;
   if not (Compression and COMPRESSION_FIBONACCI_DELTA=0) then begin
      DKnopf[11]:=Gadget(NIL,157,56,21,12,GADGHIMAGE+GADGIMAGE,RELVERIFY+TOGGLESELECT,
                        BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,11,0);
      WRITE(184,56,2,0,CcWindow^,PText[256]);
      AddGadget(CcWindow,^DKnopf[11],NIL);
   end;
   if not (Compression and COMPRESSION_DELTA=0) then begin
      DKnopf[9]:=Gadget(NIL,157,56,21,12,GADGHIMAGE+GADGIMAGE,TOGGLESELECT+$3,
                        BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,9,0);
      if ChCnt=1 then DKnopf[9].Flags:=DKnopf[9].Flags or GADGDISABLED;
      WRITE(184,56,2,0,CcWindow^,PText[254]);
      AddGadget(CcWindow,^DKnopf[9],NIL);
   end;
   AddGadget(CcWindow,^DKnopf[1],NIL);
   for i:=3 to 8 do AddGadget(CcWindow,^DKnopf[i],NIL);
   RefreshGadgets(CcWindow^.FirstGadget,CcWindow,NIL);
   repeat
      RawCode:=0; GadCode:=0; b:=false;
      IMsg:=Wait_Port(CcWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(CcWindow^.UserPort);
         if IMsg^.class=GADGETUP then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      End;

      if GadCode=10 then begin
         if not (DKnopf[10].Flags and SELECTED=0) then TextGad.Flags:=TextGad.Flags and not GADGDISABLED
         else TextGad.Flags:=TextGad.Flags or GADGDISABLED;
      end;

      if (GadCode=11) and not (Compression and COMPRESSION_FIBONACCI_DELTA=0) then begin
         if not (DKnopf[11].Flags and SELECTED=0) then begin
            DKnopf[10].Flags:=DKnopf[10].Flags or GADGDISABLED;
            TextGad.Flags:=TextGad.Flags or GADGDISABLED;
         end else begin
            DKnopf[10].Flags:=DKnopf[10].Flags and not GADGDISABLED;
            if not (DKnopf[10].Flags and SELECTED=0) then TextGad.Flags:=TextGad.Flags and not GADGDISABLED;
         end;
      end;

      if GadCode in [9..12] then RefreshGadgets(CcWindow^.FirstGadget,CcWindow,NIL);

   Until (GadCode=1) or (RawCode=68);
   Channels:=0;
   ChBit:=1;
   for i:=3 to 8 do begin
      if not (DKnopf[i].Flags and SELECTED=0) and (DKnopf[i].Flags and GADGDISABLED=0) then
       Channels:=Channels+ChBit;
      ChBit:=ChBit*2;
   end;
   CHANNELREQUEST:=Channels;
   Result:=0;
   if not (Compression and COMPRESSION_DELTA=0) and not (DKnopf[9].Flags and SELECTED=0) then
    Result:=COMPRESSION_DELTA;
   if not (Compression and COMPRESSION_FIBONACCI_DELTA=0) and not (DKnopf[11].Flags and SELECTED=0) then
    Result:=Result or COMPRESSION_FIBONACCI_DELTA;
   if not (Compression and $80=0) and not (DKnopf[10].Flags and SELECTED=0)
   and (DKnopf[10].Flags and GADGDISABLED=0) then begin
      Result:=Result or $80;
      Prefs.CopyrightStr:=Buffer;
   end;
   while CcWindow^.FirstGadget<>NIL do RemoveGadgets(Ccwindow,CcWindow^.FirstGadget);
   CloseWindow(CcWindow);
end;



procedure GETNOTEPOS;

begin
   Notes.bn_PosX:=-1; Notes.bn_PosY:=-1;
   SFreq:=round(10000000/(Prefs.SRate*2.79365));
   with Notes do for i:=1 to 12 do for j:=0 to 6 do
    if (bn_PlayRate[j,i]=Prefs.SRate) or (round(bn_SampleFreq[j,i])=SFreq) then begin
      Notes.bn_PosX:=j; Notes.bn_PosY:=i;
   end;
end;



procedure SETNEWWTSTATE;

var ChBit,i     :byte;

begin
   MemA24[0]:=MyWTStdMsg.MemA24;
   MemA16[0]:=MyWTStdMsg.MemA16;
   MemAUNDO[0]:=MyWTStdMsg.MemAUNDO;
   MemAAlpha[0]:=MyWTStdMsg.MemAAlpha;
   AlphaUNDO[0]:=MyWTStdMsg.AlphaUNDO;
   if MyWTStdMsg.UNDOPossible then FirstUNDO:=1 else begin
      FirstUNDO:=0; PlayLUNDO:=PlayL24[0];
   end;
   if ActiveMode[0]<>MyWTStdMsg.ActiveMode then begin
      ActiveMode[0]:=MyWTStdMsg.ActiveMode;
      ActiveChannels[0]:=GETCHANNELBITS(ActiveMode[0]);
      ChBit:=1;
      for i:=19 to 24 do begin
         if not (ActiveChannels[0] and ChBit=0) then Knopf[i].Flags:=(Knopf[i].Flags or SELECTED) and not GADGDISABLED
          else Knopf[i].Flags:=(Knopf[i].Flags or GADGDISABLED) and not SELECTED;
         ChBit:=ChBit*2;
      end;
   end;

   SAttack[0]:=MyWtStdMsg.Attack;       SDecay[0]:=MyWtStdMsg.Decay;
   SSustain[0]:=MyWtStdMsg.Sustain;     SRelease[0]:=MyWtStdMsg.Release;
   PlayL24[0]:=MyWTStdMsg.PlayL24;
   AreaA[0]:=MyWTStdMsg.AreaA;          AreaE[0]:=MyWTStdMsg.AreaE;
   MemA8[0,1]:=MemA16[0,1]; MemA8[0,2]:=MemA16[0,1]+MemL24[0] div 4;
   MemA8[0,3]:=MemA16[0,2]; MemA8[0,4]:=MemA16[0,2]+MemL24[0] div 4;
   if SSustain[0]>=PlayL24[0] then begin
      SSustain[0]:=0; SRelease[0]:=0;
   end else if SRelease[0]>PlayL24[0] then SRelease[0]:=PlayL24[0];
   Prefs.SRate:=MyWTStdMsg.SRate;
   if Prefs.SRate=0 then Prefs.SRate:=90;
   OPos:=MyWTStdMsg.OPos;        OEnd:=MyWTStdMsg.OEnd;
   GETNOTEPOS;
end;



function PORTCOMMUNICATION(PName,MName :str; CommWTStdMsg :p_WTStdMsg):long;
forward;



function INITLANG:boolean;

var WordSet     :boolean;
var c           :^char;
var Addr1       :long;

begin
   INITLANG:=false;
   s:='WTLocale/'+Prefs.LocaleString;
   FHandle:=DosOpen(s,MODE_OLDFILE);
   if FHandle=0 then begin
      FHandle:=DosOpen('WTLocale/deutsch',MODE_OLDFILE);
      if FHandle=0 then begin
         ERRORMSG('Kann WTLocale-Dateien nicht finden!','Can`t find WTLocale-Files!');
         exit;
      end;
   end;
   TextMemL:=DosSeek(FHandle,0,OFFSET_END);
   TextMemL:=DosSeek(FHandle,0,OFFSET_BEGINNING);
   TextMemA:=XAllocMem(TextMemL,MEMF_CLEAR);
   if TextMemA=0 then begin
      ERRORMSG('Nicht genug Speicher vorhanden!','Not enough Memory!');
      DosClose(FHandle);
      exit;
   end;
   l:=DosRead(FHandle,ptr(TextMemA),TextMemL);
   DosClose(FHandle);
   Addr1:=TextMemA; i:=1; WordSet:=false;
   repeat
      c:=ptr(Addr1); Addr1:=Addr1+1;
      if (ord(c^) in [33..58,60..255]) and not WordSet then begin
         PText[i]:=ptr(Addr1-1);
         i:=i+1;
         WordSet:=true;
      end else if ord(c^)=59 then WordSet:=true
      else if (ord(c^)=10) and WordSet then begin
         c^:=chr(0);
         WordSet:=false;
      end;
   until (Addr1>=TextMemA+TextMemL) or (i>TEXTS);
   OKKnopfTx:=IntuiText(3,0,0,8,2,^CustomTA,PText[220],NIL);
   CKnopfTx:= IntuiText(3,0,0,8,2,^CustomTA,PText[221],NIL);
   OKKnopfTx.LeftEdge:=56-IntuiTextLength(^OKKnopfTx) div 2;
   CKnopfTx.LeftEdge:= 56-IntuiTextLength(^CKnopfTx)  div 2;
   INITLANG:=true;
end;



procedure WRITETBWINDOW;

var IT1 :IntuiText;
var i   :byte;
var b   :boolean;

begin
   SetAPen(^MyScreen^.RastPort,0);
   RectFill(^MyScreen^.RastPort,MyScreen^.Width-213,1,MyScreen^.Width-24,14);
   if (AreaE[0]>0) then begin
      if Prefs.SUnit=1 then s:=intstr(AreaA[0] div 4)+' - '+intstr(AreaE[0] div 4)
      else s:=realstr((AreaA[0] div 4)/SFreq,4)+' - '+realstr((AreaE[0] div 4)/SFreq,4);
   end else s:=' - ';
   if Prefs.SUnit=1 then s:=s+' / '+intstr(PlayL24[0] div 4)
   else s:=s+' / '+realstr((PlayL24[0] div 4)/SFreq,4);

   IT1:=IntuiText(2,0,0,0,2,^CustomTA,s,NIL);
   IT1.LeftEdge:=MyScreen^.Width-118-IntuiTextLength(^IT1) div 2;
   PrintIText(^MyScreen^.RastPort,^IT1,0,0);

   if IntuiWindow4<>NIL then begin
      SetAPen(IntuiWindow4^.RPort,0);
      RectFill(IntuiWindow4^.RPort,10,20,150,35);
      s:=intstr(PlayL24[0] div 4)+' ('+intstr(MemL24[0] div 4)+')';
      WRITE(80,20,2,3,IntuiWindow4^,s);
      TBBuffer[1]:=intstr(AreaA[0] div 4);
      TBBuffer[2]:=intstr(AreaE[0] div 4);
      TBBuffer[3]:=intstr((AreaE[0]-AreaA[0]) div 4);
      b:=false;
      if (AreaE[0]=0) and (TBKnopf[1].Flags and GADGDISABLED=0) then begin
         b:=true;
         for i:=1 to 10 do TBKnopf[i].Flags:=TBKnopf[i].Flags or GADGDISABLED;
      end else if (AreaE[0]<>0) and not (TBKnopf[1].Flags and GADGDISABLED=0) then begin
         b:=true;
         for i:=1 to 10 do TBKnopf[i].Flags:=TBKnopf[i].Flags and not GADGDISABLED;
      end;
      if b then RefreshGadgets(IntuiWindow4^.FirstGadget,IntuiWindow4,NIL)
      else RefreshGadgets(^TBTextGad[3],IntuiWindow4,NIL);
   end;
end;



procedure DRAWMARK(BeginOffset,EndOffset :long; Mode :byte);

var x,x2        :long;

begin
   AreaA[0]:=BeginOffset;
   AreaE[0]:=EndOffset;
   if (AreaE[0]<4) or (AreaE[0]>PlayL24[0]) then exit;
   if (AreaA[0]<0) or (AreaA[0]>AreaE[0]) then exit;
   x:=(AreaA[0]-DrawOffset[0]) div Zoom[0];  if x<0 then x:=0;
   x2:=(AreaE[0]-DrawOffset[0]) div Zoom[0]; if x2>pred(MyScreen^.Width) then x2:=pred(MyScreen^.Width);
   if (x2<0) or (x>pred(MyScreen^.Width)) then exit;
   MyWindow^.RPort^.Mask:=WINMASK;
   if Mode=0 then begin
      SetAPen(MyWindow^.RPort,0);
      if x>0 then RectFill(MyWindow^.RPort,0,MyScreen^.BarHeight,pred(x),RealYPos);
      if x2<pred(MyScreen^.Width) then RectFill(MyWindow^.RPort,succ(x2),MyScreen^.BarHeight,pred(MyScreen^.Width),RealYPos);
      if (AreaA[0]=0) and (AreaE[0]=0) then RectFill(MyWindow^.RPort,0,MyScreen^.BarHeight,pred(MyScreen^.Width),RealYPos);
   end;
   SetAPen(MyWindow^.RPort,31);
   RectFill(MyWindow^.RPort,x,MyScreen^.BarHeight,x2,RealYPos);
   MyWindow^.RPort^.Mask:=$FF;
end;



procedure FREEPLAYLIST;

var MyPattern   :PlayListPattern;
var MyEntry     :PlayListEntry;
var Next        :ptr;
var i           :byte;

begin
   Patterns:=0; Entries:=0; AnimPath:='';
   for i:=1 to 2 do begin
{      if AnimBMemA[i]<>0 then XFreeMem(AnimBMemA[i],AnimBMemL);
      AnimBMemA[i]:=0;                                          }
   end;
   if AnimHandle<>0 then FREEOLDANIM;
   if FirstPattern<>NIL then begin
      MyPattern:=FirstPattern^.NextPattern;
      while MyPattern<>NIL do begin
         Next:=MyPattern^.NextPattern;
         XFreeMem(long(MyPattern),sizeof(r_PlayListPattern));
         MyPattern:=Next;
      end;
      FirstPattern^.NextPattern:=NIL;
   end;
   if FirstEntry<>NIL then begin
      MyEntry:=FirstEntry^.NextEntry;
      while MyEntry<>NIL do begin
         Next:=MyEntry^.NextEntry;
         XFreeMem(long(MyEntry),sizeof(r_PlayListEntry));
         MyEntry:=Next;
      end;
      FirstEntry^.NextEntry:=NIL;
   end;
end;



function ADDPATTERN:PlayListPattern;

var ActPattern  :PlayListPattern;

begin
   ADDPATTERN:=NIL;
   m:=XAllocMem(sizeof(r_PlayListPattern),MEMF_CLEAR);
   if m=0 then begin
      m:=TASKREQUEST(PText[183],PText[231],NIL,PText[220],NIL);
      exit;
   end;
   ActPattern:=ptr(m);
   ActPattern^:=r_PlayListPattern(0,0,'',NIL,NIL);
   ActPattern:=FirstPattern;
   while ActPattern^.NextPattern<>NIL do ActPattern:=ActPattern^.NextPattern;
   ActPattern^.NextPattern:=ptr(m);
   ActPattern^.NextPattern^.BeforePattern:=ActPattern;
   ActPattern:=ptr(m);
   Patterns:=Patterns+1;
   ADDPATTERN:=ActPattern;
end;



procedure INSERTNEWPATTERN;

var MyPattern   :PlayListPattern;

begin
   if (AreaE[0]=0) or (SelEntry<>0) then DisplayBeep(NIL) else begin
      MyPattern:=ADDPATTERN;
      if MyPattern<>NIL then with MyPattern^ do begin
         BeginOffset:=AreaA[0];
         EndOffset:=AreaE[0];
         Name:=intstr(AreaA[0] div 4)+' - '+intstr(AreaE[0] div 4);
      end;
      if Patterns>4 then PatternPos:=Patterns-4;
   end;
end;



procedure REMOVEOLDPATTERN;

var MyPattern   :PlayListPattern;

begin
   if SelPattern=0 then DisplayBeep(NIL) else begin
      MyPattern:=FirstPattern;
      for i:=0 to pred(SelPattern) do MyPattern:=MyPattern^.NextPattern;
      MyPattern^.BeforePattern^.NextPattern:=MyPattern^.NextPattern;
      if MyPattern^.NextPattern<>NIL then MyPattern^.NextPattern^.BeforePattern:=MyPattern^.BeforePattern;
      SelPattern:=0;
      XFreeMem(long(MyPattern),sizeof(r_PlayListPattern));
      Patterns:=Patterns-1;
      if PatternPos>Patterns then PatternPos:=Patterns;
   end;
end;



function ADDENTRY(Pos :long):PlayListEntry;

var ActEntry,OldNextEntry       :PlayListEntry;

begin
   ADDENTRY:=NIL;
   m:=XAllocMem(sizeof(r_PlayListEntry),MEMF_CLEAR);
   if m=0 then begin
      l:=TASKREQUEST(PText[183],PText[231],NIL,PText[220],NIL);
      exit;
   end;
   ActEntry:=FirstEntry;
   while (Pos>0) and (ActEntry^.NextEntry<>NIL) do begin
      ActEntry:=ActEntry^.NextEntry;
      Pos:=Pos-1;
   end;
   OldNextEntry:=ActEntry^.NextEntry;
   ActEntry^.NextEntry:=ptr(m);
   ActEntry^.NextEntry^.BeforeEntry:=ActEntry;
   ActEntry:=ptr(m);
   ActEntry^.NextEntry:=OldNextEntry;
   if OldNextEntry<>NIL then OldNextEntry^.BeforeEntry:=ActEntry;
   Entries:=Entries+1;
   ADDENTRY:=ActEntry;
end;



procedure LOADPLL;

var s,t         :string[9];
var i,j         :long;
var BadPLL      :boolean;
var LoadPad     :byte;
var ActPattern  :PlayListPattern;
var ActEntry    :PlayListEntry;

begin
   FREEPLAYLIST;
   BadPLL:=false;
   PatternPos:=1; Patterns:=0;
   EntryPos:=1;   Entries:=0;
   FHandle:=DosOpen(PathFR,MODE_OLDFILE);
   if FHandle=0 then begin
      l:=TASKREQUEST(PathFR,PText[185],NIL,PText[220],NIL);
      exit;
   end;
   l:=DosRead(FHandle,^s,8); s[5]:=chr(0);
   l:=DosRead(FHandle,^t,4); t[5]:=chr(0);
   if (s<>'FORM') or (t<>'WTPL') then begin
      l:=TASKREQUEST(PText[186],PText[225],NIL,PText[220],NIL);
      DosClose(FHandle);
      exit;
   end;
   repeat
      l:=DosRead(FHandle,^s,4); s[5]:=chr(0);
      l:=l+DosRead(FHandle,^m,4);
      if l=8 then begin
         if s='PATT' then begin
            ActPattern:=FirstPattern;
            j:=m div (sizeof(r_PlayListPattern)-8);
            LoadPad:=m mod (sizeof(r_PlayListPattern)-8);
            for i:=1 to j do begin
               ActPattern:=ADDPATTERN;
               if ActPattern=NIL then begin
                  DosClose(FHandle);
                  exit;
               end;
               l:=DosRead(FHandle,ActPattern,sizeof(r_PlayListPattern)-8);
               if l=0 then begin
                  DosClose(FHandle);
                  exit;
               end;
               with ActPattern^ do if (BeginOffset>=PlayL24[0]) or (EndOffset>PlayL24[0]) then BadPLL:=true;
            end;
            l:=DosSeek(FHandle,LoadPad,OFFSET_CURRENT);
         end else if s='ENTR' then begin
            ActEntry:=FirstEntry;
            j:=m div (sizeof(r_PlayListEntry)-8);
            LoadPad:=m mod (sizeof(r_PlayListEntry)-8);
            for i:=1 to j do begin
               ActEntry:=ADDENTRY($0FFFFFFF);
               if ActEntry=NIL then begin
                  DosClose(FHandle);
                  exit;
               end;
               l:=DosRead(FHandle,ActEntry,sizeof(r_PlayListEntry)-8);
               if l=0 then begin
                  DosClose(FHandle);
                  exit;
               end;
               with ActEntry^ do if (BeginOffset>=PlayL24[0]) or (EndOffset>PlayL24[0]) then BadPLL:=true;
            end;
            l:=DosSeek(FHandle,LoadPad,OFFSET_CURRENT);
         end else if s='ANIM' then begin
            l:=DosRead(FHandle,^AnimPath,m);
            ANIMPLAY(1)
         end else m:=DosSeek(FHandle,m,OFFSET_CURRENT);
      end;
   until l<8;
   DosClose(FHandle);
   if BadPLL then l:=TASKREQUEST(PText[270],NIL,NIL,PText[220],NIL);
end;



procedure DISKFULL;

begin
   l:=TASKREQUEST(PText[191],PText[192],PText[253],NIL,PText[218]);
   DosClose(FHandle);
   if l=1 then l:=DeleteFile(PathFR);
end;



procedure SAVEPLL;

var s           :string;
var SavePad     :byte;
var ActPattern  :PlayListPattern;
var ActEntry    :PlayListEntry;
var i,l,m       :long;

begin
   FHandle:=DosOpen(PathFR,MODE_OLDFILE);
   if FHandle<>0 then begin
      DosClose(FHandle);
      if Prefs.Confirm then begin
         l:=TASKREQUEST(PathFR,PText[194],PText[217],NIL,PText[218]);
         if l=3 then exit;
      end;
   end;
   FHandle:=DosOpen(PathFR,MODE_NEWFILE);
   if FHandle=0 then begin
      l:=TASKREQUEST(PathFR,PText[190],NIL,PText[220],NIL);
      exit;
   end;
   s:='FORM    WTPLPATT';                     l:=DosWrite(FHandle,^s,16);
   m:=(sizeof(r_PlayListPattern)-8)*Patterns;
   SavePad:=0;
   if m mod 4<>0 then SavePad:=4-(m mod 4);   m:=m+SavePad;
                                              l:=DosWrite(FHandle,^m,4);
   ActPattern:=FirstPattern^.NextPattern;
   if Patterns>0 then begin
      for i:=1 to Patterns do begin
         l:=DosWrite(FHandle,ActPattern,sizeof(r_PlayListPattern)-8);
         if l<sizeof(r_PlayListPattern)-8 then begin
            DISKFULL;
            exit;
         end;
         ActPattern:=ActPattern^.NextPattern;
      end;
      if SavePad>0 then begin
         m:=0; l:=DosWrite(FHandle,^m,SavePad);
      end;
   end else l:=DosSeek(FHandle,-4,OFFSET_CURRENT);
   if Entries>0 then begin
      s:='ENTR';                                 l:=DosWrite(FHandle,^s,4);
      m:=(sizeof(r_PlayListEntry)-8)*Entries;
      SavePad:=0;
      if m mod 4<>0 then SavePad:=4-(m mod 4);   m:=m+SavePad;
                                                 l:=DosWrite(FHandle,^m,4);
      ActEntry:=FirstEntry^.NextEntry;
      for i:=1 to Entries do begin
         l:=DosWrite(FHandle,ActEntry,sizeof(r_PlayListEntry)-8);
         if l<sizeof(r_PlayListEntry)-8 then begin
            DISKFULL;
            exit;
         end;
         ActEntry:=ActEntry^.NextEntry;
      end;
      if SavePad>0 then begin
         m:=0; l:=DosWrite(FHandle,^m,SavePad);
      end;
   end;
   if AnimPath<>'' then begin
      s:='ANIM'; l:=DosWrite(FHandle,^s,4);
      m:=200;    l:=DosWrite(FHandle,^m,4);
      l:=DosWrite(FHandle,^AnimPath,200);
   end;
   m:=DosSeek(FHandle,4,OFFSET_BEGINNING)-8;
   l:=DosWrite(FHandle,^m,4);
   DosClose(FHandle);
end;



procedure PROCESSWAVE(Action :word; Close :boolean);
forward;



procedure DRAWTIMEPATTERNLIST(KnopfUsed :boolean);

var j                           :integer;
var i                           :long;
var MyPattern,ActPattern        :PlayListPattern;
var PCtr                        :long;
var s                           :string[5];

begin
   if IntuiWindow2=NIL then exit;
   if PatternPos>Patterns then PatternPos:=Patterns;
   if PatternPos<1 then PatternPos:=1;
   MyPattern:=FirstPattern;
   ActPattern:=FirstPattern;
   for i:=1 to PatternPos do MyPattern:=MyPattern^.NextPattern;
   PCtr:=PatternPos;
   if Patterns>0 then begin
      repeat
         if PCtr in [PatternPos..PatternPos+6] then begin
            TPBuffer[PCtr-PatternPos+1]:=MyPattern^.Name;
            if PCtr=SelPattern then SetAPen(IntuiWindow2^.RPort,3) else SetAPen(IntuiWindow2^.RPort,0);
            RectFill(IntuiWindow2^.RPort,153,succ(PCtr-PatternPos)*15+23,181,succ(PCtr-PatternPos)*15+36);
            s:=intstr(PCtr); while length(s)<4 do s:='0'+s;
            WRITE(179,succ(PCtr-PatternPos)*15+24,2,4,IntuiWindow2^,s);
         end;
         if PCtr=SelPattern then ActPattern:=MyPattern;
         MyPattern:=MyPattern^.NextPattern;
         PCtr:=PCtr+1;
      until (MyPattern=NIL) or (PCtr>Patterns);
   end;
   while PCtr<=PatternPos+6 do begin
      TPBuffer[PCtr-PatternPos+1]:='';
      SetAPen(IntuiWindow2^.RPort,0);
      RectFill(IntuiWindow2^.RPort,153,succ(PCtr-PatternPos)*15+23,181,succ(PCtr-PatternPos)*15+36);
      PCtr:=PCtr+1;
   end;
   if Patterns=0 then begin
      TPSchieberInfo.VertBody:=$FFFF;
      TPSchieberInfo.VertPot:=$FFFF;
   end else begin
      l:=round(65535*6/(Patterns+6));            if l<1 then l:=1; if l>65535 then l:=65535;
      TPSchieberInfo.VertBody:=l;
      l:=round(65535/Patterns*pred(PatternPos)); if l<1 then l:=1; if l>65535 then l:=65535;
      TPSchieberInfo.VertPot:=l;
   end;
   if SelPattern>Patterns then SelPattern:=Patterns;
   if ActPattern<>FirstPattern then begin
      if KnopfUsed then begin
         if (TPKnopf[12].Flags and SELECTED=SELECTED) and (AreaE[0]<>0) then begin
            TPKnopf[12].Flags:=TPKnopf[12].Flags and not SELECTED;
            if ActPattern^.BeginOffset<AreaA[0] then AreaA[0]:=ActPattern^.BeginOffset;
            if ActPattern^.EndOffset>AreaE[0] then AreaE[0]:=ActPattern^.EndOffset;
         end else begin
            AreaA[0]:=ActPattern^.BeginOffset;
            AreaE[0]:=ActPattern^.EndOffset;
         end;
      end;
      if (AreaA[0]>0) and (AreaA[0]<PlayL24[0]) and (AreaE[0]>PlayL24[0])
       then AreaE[0]:=PlayL24[0];
      if Zoom[0]>0 then DRAWMARK(AreaA[0],AreaE[0],0);
      if (AnimPath<>'') and (length(ActPattern^.Name)=4) then begin
         val(ActPattern^.Name,i,j);
         if i>0 then begin
            RefreshGadgets(IntuiWindow2^.FirstGadget,IntuiWindow2,NIL);
            ANIMPLAY(i)
         end;
      end;
   end else if (FirstPattern^.NextPattern<>NIL) and (AreaE[0]<>0)
   and (SelPattern=0) then begin
      AreaA[0]:=0;
      AreaE[0]:=0;
      if Zoom[0]>0 then PROCESSWAVE($8,false);
   end;
   WRITETBWINDOW;
   RefreshGadgets(^TPTextGad[7],IntuiWindow2,NIL);
   RefreshGadgets(IntuiWindow2^.FirstGadget,IntuiWindow2,NIL);
end;



procedure CALCCHANNELS(BeginOffset,Length :long; UsedChans :byte);

var SideDiv,CentDiv,SurrDiv,SubDiv,
    ABDiv,CDDiv                         :long;
var Addr1,Addr2,Addr3,Addr4,MemE,
    IntData1,IntData2                   :long;
var Data3,Data4                         :^long;
var DataW1,DataW2                       :^integer;
var DataS1,DataS2                       :^short;
var DataL,DataH                         :^byte;
var i,j,ChBit,ChNum,Factor              :byte;
var SpectraMemA                         :array [1..2] of long;
var AddrA,TimeOffset1,TimeOffset2,
    SpectraLength,SpectraMaxAmp,
    SpectraNewAmp                       :long;
var DataA                               :^byte;
var ACtr                                :byte;
var SpectraFactor                       :real;



procedure GETTIMEOFFSETS(Base :byte);

var BaseHeight          :real;
var Time1,Time2         :real;

{Base - Stereobasisbreite [m]}

begin
   BaseHeight:=SQRT(SQR(Base)-SQR(Base/2));
   Time1:=(SQRT(SQR(BaseHeight)+SQR(((Base/2)-0.1))))/333.7;
   Time2:=(SQRT(SQR(BaseHeight)+SQR(((Base/2)+0.1))))/333.7;
   TimeOffset1:=round((10000000/(Prefs.SRate*2.79365))*Time1)*4;
   TimeOffset2:=round((10000000/(Prefs.SRate*2.79365))*Time2)*4;
end;



begin
   { MAX24=8388600 }
   PlayDataValid:=true;
   if ActiveMode[0]=MD_AC3 then UsedChans:=UsedChans or CH_SUB;
   if (Prefs.PlayType1=1) or (Prefs.PlayType2=1) then begin
      { //Amiga 2 x 16 Bit }
      l:=0;
      if Prefs.PlayType1=1 then l:=Prefs.PlayCh1;
      if Prefs.PlayType2=1 then l:=l or Prefs.PlayCh2;
      UsedChans:=UsedChans and l;
      Factor:=0;
      ChBit:=1; ChNum:=0;
      for i:=1 to 6 do begin
         if not (UsedChans and ChBit=0) then begin
            Factor:=Factor+1;
            ChNum:=ChNum+1;
         end;
         ChBit:=ChBit*2;
      end;

      SpectraMemA[1]:=0; SpectraMemA[2]:=0;
      TimeOffset1:=0; TimeOffset2:=0;
      if Prefs.PlayMethod in [2..4] then GETTIMEOFFSETS(1)
      else if Prefs.PlayMethod in [5..7] then GETTIMEOFFSETS(2)
      else if Prefs.PlayMethod in [8..10] then GETTIMEOFFSETS(3);

      if (UsedChans and (CH_LEFT+CH_RIGHT)=(CH_LEFT+CH_RIGHT)) then Factor:=Factor-1;
      SideDiv:=round((MAX24/16386)*Factor/2);
      CentDiv:=round((MAX24/16386)*Factor);
      SurrDiv:=round((MAX24/16386)*Factor);
      SubDiv:=round((MAX24/16386)*Factor);
      if ActiveMode[0] in [MD_STEREO,MD_QUADRO] then SideDiv:=round((MAX24/16386)*Factor);

      AddrA:=MemAAlpha[0,1] or MemAAlpha[0,3];
      { LEFT & RIGHT }
      for i:=1 to 2 do if not (UsedChans and i=0)
      and (MemA24[0,i]<>0) then begin
         Addr1:=MemA8[0,i*2-1]+(BeginOffset div 4);
         Addr3:=MemA24[0,i]+BeginOffset+4;
         if AddrA<>0 then AddrA:=MemAAlpha[0,i]+(BeginOffset+4) div 80;
         for j:=1 to 2 do begin
            ACtr:=10;
            repeat
               DataW1:=ptr(Addr1); Addr1:=Addr1+2;
               Data3:=ptr(Addr3);  Addr3:=Addr3+8;
               if AddrA=0 then DataW1^:=Data3^ div SideDiv else begin
                  if ACtr=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  DataW1^:=Data3^ div SideDiv div 255 * DataA^;
               end;
            until Addr3>=MemA24[0,i]+Length;
            Addr1:=MemA8[0,i*2]+(BeginOffset div 4);
            Addr3:=MemA24[0,i]+BeginOffset;
            if AddrA<>0 then AddrA:=MemAAlpha[0,i]+BeginOffset div 80;
         end;
      end else begin
         Addr1:=MemA8[0,i*2-1]+(BeginOffset div 4);
         Addr2:=MemA8[0,i*2]+  (BeginOffset div 4);
         MemE:=MemA8[0,i*2-1]+ (Length div 4);
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data1^:=0;
            Data2:=ptr(Addr2); Addr2:=Addr2+4;
            Data2^:=0;
         until Addr1>=MemE;
      end;

      { CENTER }
      if not (UsedChans and CH_CENTER=0) then begin
         Addr1:=MemA8[0,1]+(BeginOffset div 4);
         Addr2:=MemA8[0,3]+(BeginOffset div 4);
         Addr3:=MemA24[0,3]+BeginOffset+4;
         if AddrA<>0 then AddrA:=MemAAlpha[0,3]+(BeginOffset+4) div 80;
         for j:=1 to 2 do if MemA24[0,3]<>0 then begin
            ACtr:=10;
            repeat
               DataW1:=ptr(Addr1); Addr1:=Addr1+2;
               DataW2:=ptr(Addr2); Addr2:=Addr2+2;
               Data3:=ptr(Addr3);  Addr3:=Addr3+8;
               if ActiveMode[0]=MD_MONO then begin
                  if AddrA=0 then begin
                     DataW1^:=Data3^ div CentDiv;
                     DataW2^:=Data3^ div CentDiv;
                  end else begin
                     if ACtr>=10 then begin
                        ACtr:=0;
                        DataA:=ptr(AddrA); AddrA:=AddrA+1;
                     end;
                     ACtr:=ACtr+1;
                     DataW1^:=Data3^ div CentDiv div 255 * DataA^;
                     DataW2^:=Data3^ div CentDiv div 255 * DataA^
                  end;
               end else begin
                  if AddrA=0 then begin
                     DataW1^:=DataW1^+ Data3^ div CentDiv;
                     DataW2^:=DataW2^+ Data3^ div CentDiv;
                  end else begin
                     if ACtr>=10 then begin
                        ACtr:=0;
                        DataA:=ptr(AddrA); AddrA:=AddrA+1;
                     end;
                     ACtr:=ACtr+1;
                     DataW1^:=DataW1^+(Data3^ div CentDiv div 255 * DataA^);
                     DataW2^:=DataW2^+(Data3^ div CentDiv div 255 * DataA^);
                  end;
               end;
            until Addr3>=MemA24[0,i]+Length;
            Addr1:=MemA8[0,2]+(BeginOffset div 4);
            Addr2:=MemA8[0,4]+(BeginOffset div 4);
            Addr3:=MemA24[0,3]+BeginOffset;
            if AddrA<>0 then AddrA:=MemAAlpha[0,3]+BeginOffset div 80;
         end;
      end;

      if (Prefs.PlayMethod=2) and not (UsedChans and (CH_SLEFT+CH_SRIGHT)=0)
      then begin
         SpectraLength:=Length-BeginOffset+TimeOffset1;
         for i:=1 to 2 do SpectraMemA[i]:=XAllocMem(SpectraLength,MEMF_CLEAR);
         if (SpectraMemA[1]=0) or (SpectraMemA[2]=0) then begin
            for i:=1 to 2 do if SpectraMemA[i]<>0 then begin
               XFreeMem(SpectraMemA[i],SpectraLength);
               SpectraMemA[i]:=0;
            end;
            l:=TASKREQUEST('SpectraFX:',PText[183],NIL,PText[220],NIL);
         end;
      end;

      if (Prefs.PlayMethod=1) or (SpectraMemA[1]=0) then begin {*** Dolby-Surround ***}
         { SURROUND LEFT/RIGHT }
         for i:=1 to 2 do if not (UsedChans and (i*8)=0)
         and (MemA24[0,i+3]<>0) then begin
            Addr1:=MemA8[0,1]+(BeginOffset div 4);
            Addr2:=MemA8[0,3]+(BeginOffset div 4);
            Addr3:=MemA24[0,i+3]+BeginOffset+804;
            if AddrA<>0 then AddrA:=MemAAlpha[0,i+3]+(BeginOffset+804) div 80;
            for j:=1 to 2 do begin
               ACtr:=10;
               if Addr3<MemA24[0,i+3]+Length then repeat
                  DataW1:=ptr(Addr1); Addr1:=Addr1+2;
                  DataW2:=ptr(Addr2); Addr2:=Addr2+2;
                  Data3:=ptr(Addr3);  Addr3:=Addr3+8;
                  if AddrA=0 then begin
                     DataW1^:=DataW1^- (Data3^ div SurrDiv);
                     DataW2^:=DataW2^+ (Data3^ div SurrDiv)
                  end else begin
                     if ACtr=10 then begin
                        ACtr:=0;
                        DataA:=ptr(AddrA); AddrA:=AddrA+1;
                     end;
                     ACtr:=ACtr+1;
                     DataW1^:=DataW1^- (Data3^ div SurrDiv div 255 * DataA^);
                     DataW2^:=DataW2^+ (Data3^ div SurrDiv div 255 * DataA^)
                  end;
               until Addr3>=MemA24[0,i+3]+Length;
               Addr1:=MemA8[0,2]+(BeginOffset div 4);
               Addr2:=MemA8[0,4]+(BeginOffset div 4);
               Addr3:=MemA24[0,i+3]+BeginOffset+800;
               if AddrA<>0 then AddrA:=MemAAlpha[0,i+3]+(BeginOffset+800) div 80;
            end;
         end;
      end else if (MemA24[0,4]<>0) and not (UsedChans and (CH_SLEFT+CH_SRIGHT)=0)
      then begin   {*** SpectraFX ***}
         Addr1:=SpectraMemA[1];
         Addr2:=SpectraMemA[2];
         Addr3:=MemA24[0,4]+BeginOffset+400;
         if MemA24[0,5]=0 then Addr4:=Addr3-400 else Addr4:=MemA24[0,5]+BeginOffset;
         CopyMemQuick(Addr3,Addr1,(Length-BeginOffset));
         CopyMemQuick(Addr4,Addr2,(Length-BeginOffset));
         Addr1:=Addr1+TimeOffset1;
         Addr2:=Addr2+TimeOffset1;
         IntData1:=0; IntData2:=0;
         SpectraMaxAmp:=0; SpectraNewAmp:=0;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data2:=ptr(Addr2); Addr2:=Addr2+4;
            Data3:=ptr(Addr3); Addr3:=Addr3+4;
            Data4:=ptr(Addr4); Addr4:=Addr4+4;
            if abs(Data3^)>SpectraMaxAmp then SpectraMaxAmp:=abs(Data3^);
            if abs(Data4^)>SpectraMaxAmp then SpectraMaxAmp:=abs(Data4^);
            if Prefs.PlayMethod in [2,5,8] then begin
               Data2^:=Data2^+(Data3^+IntData1+IntData1) div 4;
               Data1^:=Data1^+(Data4^+IntData2+IntData2) div 4;
               IntData1:=(Data3^+IntData1+IntData1) div 3;
               IntData2:=(Data4^+IntData2+IntData2) div 3;
            end else if Prefs.PlayMethod in [3,6,9] then begin
               Data2^:=Data2^+(Data3^+IntData1+IntData1+IntData1) div 5;
               Data1^:=Data1^+(Data4^+IntData2+IntData2+IntData2) div 5;
               IntData1:=(Data3^+IntData1+IntData1+IntData1) div 4;
               IntData2:=(Data4^+IntData2+IntData2+IntData2) div 4;
            end else if Prefs.PlayMethod in [4,7,10] then begin
               Data2^:=Data2^+(Data3^+IntData1+IntData1+IntData1+IntData1) div 6;
               Data1^:=Data1^+(Data4^+IntData2+IntData2+IntData2+IntData2) div 6;
               IntData1:=(Data3^+IntData1+IntData1+IntData1) div 5;
               IntData2:=(Data4^+IntData2+IntData2+IntData1) div 5;
            end else
         until (Addr3>=MemA24[0,4]+Length) or
         (Addr1>=SpectraMemA[1]+SpectraLength);

         Addr1:=SpectraMemA[1]+SpectraLength-TimeOffset1;
         Addr2:=SpectraMemA[2]+SpectraLength-TimeOffset1;
         Addr3:=SpectraMemA[1]+SpectraLength-TimeOffset2;
         Addr4:=SpectraMemA[2]+SpectraLength-TimeOffset2;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1-4;
            Data2:=ptr(Addr2); Addr2:=Addr2-4;
            Data3:=ptr(Addr3); Addr3:=Addr3-4;
            Data4:=ptr(Addr4); Addr4:=Addr4-4;
            Data1^:=Data1^-Data4^;
            Data2^:=Data2^-Data3^;
            if abs(Data1^)>SpectraNewAmp then SpectraNewAmp:=abs(Data1^);
            if abs(Data2^)>SpectraNewAmp then SpectraNewAmp:=abs(Data2^);
         until Addr3<SpectraMemA[1];
         SpectraFactor:=SpectraMaxAmp/SpectraNewAmp;
         SpectraNewAmp:=round(SpectraNewAmp*SpectraFactor);
         if SpectraNewAmp>MAX24 then SpectraFactor:=SpectraFactor*(MAX24/SpectraNewAmp);
         if ActiveMode[0]=MD_SURROUND then SurrDiv:=SurrDiv*2;
         if SpectraFactor>1.01 then begin
            Addr1:=SpectraMemA[1];
            Addr2:=SpectraMemA[2];
            repeat
               Data1:=ptr(Addr1); Addr1:=Addr1+4;
               Data2:=ptr(Addr2); Addr2:=Addr2+4;
               Data1^:=round(Data1^*SpectraFactor);
               Data2^:=round(Data2^*SpectraFactor)
            until Addr1>=SpectraMemA[1]+SpectraLength;
         end;


         { SURROUND LEFT/RIGHT }
         if MemA24[0,1]<>0 then begin
            Addr1:=MemA8[0,1]+(BeginOffset div 4);
            Addr2:=Addr1+(Length-BeginOffset) div 4;
            Addr3:=SpectraMemA[1]+4;
            if AddrA<>0 then AddrA:=MemAAlpha[0,4]+(BeginOffset+4) div 80;
            for j:=1 to 2 do begin
               ACtr:=10;
               if Addr1<Addr2 then repeat
                  DataW1:=ptr(Addr1); Addr1:=Addr1+2;
                  Data3:=ptr(Addr3);  Addr3:=Addr3+8;
                  if AddrA=0 then begin
                     l:=DataW1^+ (Data3^ div SurrDiv);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW1^:=l;
                  end else begin
                     if ACtr=10 then begin
                        ACtr:=0;
                        DataA:=ptr(AddrA); AddrA:=AddrA+1;
                     end;
                     ACtr:=ACtr+1;
                     l:=DataW1^+ (Data3^ div SurrDiv div 255 * DataA^);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW1^:=l;
                  end;
               until Addr1>=Addr2;
               Addr1:=MemA8[0,2]+(BeginOffset div 4);
               Addr2:=Addr1+(Length-BeginOffset) div 4;
               Addr3:=SpectraMemA[1];
               if AddrA<>0 then AddrA:=MemAAlpha[0,4]+(BeginOffset) div 80;
            end;
         end;
         if MemA24[0,2]<>0 then begin
            Addr1:=MemA8[0,3]+(BeginOffset div 4);
            Addr2:=Addr1+(Length-BeginOffset) div 4;
            Addr3:=SpectraMemA[2]+4;
            if AddrA<>0 then AddrA:=MemAAlpha[0,5]+(BeginOffset+4) div 80;
            for j:=1 to 2 do begin
               ACtr:=10;
               if Addr1<Addr2 then repeat
                  DataW1:=ptr(Addr1); Addr1:=Addr1+2;
                  Data3:=ptr(Addr3);  Addr3:=Addr3+8;
                  if AddrA=0 then begin
                     l:=DataW1^+ (Data3^ div SurrDiv);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW1^:=l;
                  end else begin
                     if ACtr=10 then begin
                        ACtr:=0;
                        DataA:=ptr(AddrA); AddrA:=AddrA+1;
                     end;
                     ACtr:=ACtr+1;
                     l:=DataW1^+ (Data3^ div SurrDiv div 255 * DataA^);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW1^:=l;
                  end;
               until Addr1>=Addr2;
               Addr1:=MemA8[0,4]+(BeginOffset div 4);
               Addr2:=Addr1+(Length-BeginOffset) div 4;
               Addr3:=SpectraMemA[2];
               if AddrA<>0 then AddrA:=MemAAlpha[0,5]+(BeginOffset) div 80;
            end;
         end;
      end;
      for i:=1 to 2 do if SpectraMemA[i]<>0 then begin
         XFreeMem(SpectraMemA[i],SpectraLength);
         SpectraMemA[i]:=0;
      end;

      { SUBWOOFER }
      if MemA24[0,6]<>0 then begin
         Addr1:=MemA8[0,1]+(BeginOffset div 4);
         Addr2:=MemA8[0,3]+(BeginOffset div 4);
         Addr3:=MemA24[0,6]+BeginOffset+4;
         if AddrA<>0 then AddrA:=MemAAlpha[0,6]+(BeginOffset+4) div 80;
         for j:=1 to 2 do begin
            ACtr:=10;
            repeat
               DataW1:=ptr(Addr1); Addr1:=Addr1+2;
               DataW2:=ptr(Addr2); Addr2:=Addr2+2;
               Data3:=ptr(Addr3);  Addr3:=Addr3+8;
               if AddrA=0 then begin
                  if Prefs.PlayMethod=1 then begin
                     DataW1^:=DataW1^+ (Data3^ div SubDiv);
                     DataW2^:=DataW2^+ (Data3^ div SubDiv)
                  end else begin
                     l:=DataW1^+ (Data3^ div SubDiv);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW1^:=l;
                     l:=DataW2^+ (Data3^ div SubDiv);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW2^:=l;
                  end;
               end else begin
                  if ACtr=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  if Prefs.PlayMethod=1 then begin
                     DataW1^:=DataW1^+ (Data3^ div SubDiv div 255 * DataA^);
                     DataW2^:=DataW2^+ (Data3^ div SubDiv div 255 * DataA^);
                  end else begin
                     l:=DataW1^+ (Data3^ div SubDiv div 255 * DataA^);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW1^:=l;
                     l:=DataW2^+ (Data3^ div SubDiv div 255 * DataA^);
                     if l>32767 then l:=32767 else if l<-32767 then l:=-32767;
                     DataW2^:=l;
                  end;
               end;
            until Addr3>=MemA24[0,6]+Length;
            Addr1:=MemA8[0,2]+(BeginOffset div 4);
            Addr2:=MemA8[0,4]+(BeginOffset div 4);
            Addr3:=MemA24[0,6]+BeginOffset;
            if AddrA<>0 then AddrA:=MemAAlpha[0,6]+BeginOffset div 80;
         end;
      end;
      for i:=1 to 2 do begin
         Addr1:=MemA8[0,2*i-1]+(BeginOffset div 4);
         Addr2:=MemA8[0,2*i]+1+(BeginOffset div 4);
         MemE:=MemA8[0,2*i]+(Length div 4);
         if MemE>MemA16[0,i]+MemL24[0] div 2
          then MemE:=MemA16[0,i]+MemL24[0] div 2;
         repeat
            DataL:=ptr(Addr1); Addr1:=Addr1+2;
            DataH:=ptr(Addr2); Addr2:=Addr2+2;
            exchange(DataH^,DataL^);
         until Addr2>=MemE;
      end;
   end else if (Prefs.PlayType1=2) or (Prefs.PlayType2=2) then begin
      { //Amiga 4 x 8 Bit }
      l:=0;
      if Prefs.PlayType1=2 then l:=Prefs.PlayCh1;
      if Prefs.PlayType2=2 then l:=l or Prefs.PlayCh2;
      UsedChans:=UsedChans and l;
      Factor:=0; ABDiv:=0; CDDiv:=0;
      ChBit:=1; ChNum:=0;
      for i:=1 to 6 do begin
         if not (UsedChans and ChBit=0) then begin
            Factor:=Factor+1;
            ChNum:=ChNum+1;
         end;
         if not (Prefs.PlayCh1 and CHBit=0) then ABDiv:=ABDiv+1;
         if not (Prefs.PlayCh2 and CHBit=0) then CDDiv:=CDDiv+1;
         ChBit:=ChBit*2;
      end;

      SpectraMemA[1]:=0; SpectraMemA[2]:=0;
      TimeOffset1:=0; TimeOffset2:=0;
      if Prefs.PlayMethod in [2..4] then GETTIMEOFFSETS(1)
      else if Prefs.PlayMethod in [5..7] then GETTIMEOFFSETS(2)
      else if Prefs.PlayMethod in [8..10] then GETTIMEOFFSETS(3);

      if (Prefs.PlayCh1 and CH_LEFT=CH_LEFT)
       then SideDiv:=round((MAX24/65)*ABDiv/2)
       else SideDiv:=round((MAX24/65)*CDDiv/2);
      if (Prefs.PlayCh1 and CH_CENTER=CH_CENTER)
       then CentDiv:=round((MAX24/65)*ABDiv)
       else CentDiv:=round((MAX24/65)*CDDiv);
      if (Prefs.PlayCh1 and CH_SLEFT=CH_SLEFT)
       then SurrDiv:=round((MAX24/65)*ABDiv)
       else SurrDiv:=round((MAX24/65)*CDDiv);
      if (Prefs.PlayCh1 and CH_SUB=CH_SUB)
       then SubDiv:=round((MAX24/65)*ABDiv)
       else SubDiv:=round((MAX24/65)*CDDiv);
      if ActiveMode[0] in [MD_STEREO,MD_QUADRO] then begin
         if (Prefs.PlayCh1 and CH_LEFT=CH_LEFT)
         then SideDiv:=round((MAX24/65)*ABDiv)
         else SideDiv:=round((MAX24/65)*CDDiv);
      end;

      AddrA:=MemAAlpha[0,1] or MemAAlpha[0,3];
      { LEFT & RIGHT }
      for i:=1 to 4 do begin
         case i of
            1: if (Prefs.PlayCh1 and UsedChans and CH_LEFT=0) then begin
                  Addr1:=MemA8[0,1]+(BeginOffset div 4);
                  MemE :=MemA8[0,1]+(Length div 4);
               end else Addr1:=0;
            2: if (Prefs.PlayCh1 and UsedChans and CH_RIGHT=0) then begin
                  Addr1:=MemA8[0,2]+(BeginOffset div 4);
                  MemE :=MemA8[0,2]+(Length div 4);
               end else Addr1:=0;
            3: if (Prefs.PlayCh2 and UsedChans and CH_RIGHT=0) then begin
                  Addr1:=MemA8[0,3]+(BeginOffset div 4);
                  MemE :=MemA8[0,3]+(Length div 4);
               end else Addr1:=0;
            4: if (Prefs.PlayCh2 and UsedChans and CH_LEFT=0) then begin
                  Addr1:=MemA8[0,4]+(BeginOffset div 4);
                  MemE :=MemA8[0,4]+(Length div 4);
               end else Addr1:=0;
         end;
         if Addr1<>0 then repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data1^:=0;
         until Addr1>=MemE;
      end;

      for i:=1 to 2 do begin
         if not (UsedChans and i=0) and (MemA24[0,i]<>0) then begin
            if (Prefs.PlayCh1 and CH_LEFT=CH_LEFT) and (i=1) then Addr1:=MemA8[0,1]+(BeginOffset div 4)
            else if (Prefs.PlayCh1 and CH_LEFT=CH_LEFT) and (i=2) then Addr1:=MemA8[0,2]+(BeginOffset div 4);
            if (Prefs.PlayCh2 and CH_LEFT=CH_LEFT) and (i=2) then Addr1:=MemA8[0,3]+(BeginOffset div 4);
            if (Prefs.PlayCh2 and CH_LEFT=CH_LEFT) and (i=1) then Addr1:=MemA8[0,4]+(BeginOffset div 4);
            Addr3:=MemA24[0,i]+BeginOffset+4;
            if AddrA<>0 then AddrA:=MemAAlpha[0,i]+(BeginOffset+4) div 80;
            ACtr:=10;
            repeat
               DataS1:=ptr(Addr1); Addr1:=Addr1+1;
               Data3:=ptr(Addr3);  Addr3:=Addr3+4;
               if AddrA=0 then DataS1^:=Data3^ div SideDiv else begin
                  if ACtr=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  DataS1^:=Data3^ div SideDiv div 255 * DataA^;
               end;
            until Addr3>=MemA24[0,i]+Length;
         end;
      end;

      { CENTER }
      if not (UsedChans and CH_CENTER=0) then begin
         if (Prefs.PlayCh1 and CH_CENTER=CH_CENTER) then begin
            Addr1:=MemA8[0,1]+(BeginOffset div 4);       
            Addr2:=MemA8[0,2]+(BeginOffset div 4);       
         end else begin
            Addr1:=MemA8[0,4]+(BeginOffset div 4);       
            Addr2:=MemA8[0,3]+(BeginOffset div 4);
         end;
         Addr3:=MemA24[0,3]+BeginOffset+4;
         if AddrA<>0 then AddrA:=MemAAlpha[0,3]+(BeginOffset+4) div 80;
         ACtr:=10;
         repeat
            DataS1:=ptr(Addr1); Addr1:=Addr1+1;
            DataS2:=ptr(Addr2); Addr2:=Addr2+1;
            Data3:=ptr(Addr3);  Addr3:=Addr3+4;
            if ActiveMode[0]=MD_MONO then begin
               if AddrA=0 then begin
                  DataS1^:=Data3^ div CentDiv;
                  DataS2^:=Data3^ div CentDiv;
               end else begin
                  if ACtr>=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  DataS1^:=Data3^ div CentDiv div 255 * DataA^;
                  DataS2^:=Data3^ div CentDiv div 255 * DataA^
               end;
            end else begin
               if AddrA=0 then begin
                  DataS1^:=DataS1^+ Data3^ div CentDiv;
                  DataS2^:=DataS2^+ Data3^ div CentDiv;
               end else begin
                  if ACtr>=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  DataS1^:=DataS1^+(Data3^ div CentDiv div 255 * DataA^);
                  DataS2^:=DataS2^+(Data3^ div CentDiv div 255 * DataA^);
               end;
            end;
         until Addr3>=MemA24[0,3]+Length;
      end;

      if (Prefs.PlayMethod=2) and not (UsedChans and (CH_SLEFT+CH_SRIGHT)=0)
      then begin
         SpectraLength:=Length-BeginOffset+TimeOffset1;
         for i:=1 to 2 do SpectraMemA[i]:=XAllocMem(SpectraLength,MEMF_CLEAR);
         if (SpectraMemA[1]=0) or (SpectraMemA[2]=0) then begin
            for i:=1 to 2 do if SpectraMemA[i]<>0 then begin
               XFreeMem(SpectraMemA[i],SpectraLength);
               SpectraMemA[i]:=0;
            end;
            l:=TASKREQUEST('SpectraFX:',PText[183],NIL,PText[220],NIL);
         end;
      end;

      if (Prefs.PlayMethod=1) or (SpectraMemA[1]=0) then begin {*** Surround ***}
         { SURROUND LEFT/RIGHT }
         for i:=1 to 2 do if not (UsedChans and (i*8)=0)
         and (MemA24[0,i+3]<>0) then begin
            if (Prefs.PlayCh1 and CH_SLEFT=CH_SLEFT) then begin
               Addr1:=MemA8[0,1]+(BeginOffset div 4);
               Addr2:=MemA8[0,2]+(BeginOffset div 4);
            end else begin
               Addr1:=MemA8[0,4]+(BeginOffset div 4);
               Addr2:=MemA8[0,3]+(BeginOffset div 4);
            end;
            Addr3:=MemA24[0,i+3]+BeginOffset+800;
            if AddrA<>0 then AddrA:=MemAAlpha[0,i+3]+(BeginOffset+804) div 80;
            ACtr:=10;
            if Addr3<MemA24[0,i+3]+Length then repeat
               DataS1:=ptr(Addr1); Addr1:=Addr1+1;
               DataS2:=ptr(Addr2); Addr2:=Addr2+1;
               Data3:=ptr(Addr3);  Addr3:=Addr3+4;
               if AddrA=0 then begin
                  DataS1^:=DataS1^- (Data3^ div SurrDiv);
                  DataS2^:=DataS2^+ (Data3^ div SurrDiv)
               end else begin
                  if ACtr=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  DataS1^:=DataS1^- (Data3^ div SurrDiv div 255 * DataA^);
                  DataS2^:=DataS2^+ (Data3^ div SurrDiv div 255 * DataA^)
               end;
            until Addr3>=MemA24[0,i+3]+Length;
         end;
      end else if (MemA24[0,4]<>0) and not (UsedChans and (CH_SLEFT+CH_SRIGHT)=0)
      then begin   {*** SpectraFX ***}
         Addr1:=SpectraMemA[1];
         Addr2:=SpectraMemA[2];
         Addr3:=MemA24[0,4]+BeginOffset+400;
         if MemA24[0,5]=0 then Addr4:=Addr3-400 else Addr4:=MemA24[0,5]+BeginOffset;
         CopyMemQuick(Addr3,Addr1,(Length-BeginOffset));
         CopyMemQuick(Addr4,Addr2,(Length-BeginOffset));
         Addr1:=Addr1+TimeOffset1;
         Addr2:=Addr2+TimeOffset1;
         IntData1:=0; IntData2:=0;
         SpectraMaxAmp:=0; SpectraNewAmp:=0;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data2:=ptr(Addr2); Addr2:=Addr2+4;
            Data3:=ptr(Addr3); Addr3:=Addr3+4;
            Data4:=ptr(Addr4); Addr4:=Addr4+4;
            if abs(Data3^)>SpectraMaxAmp then SpectraMaxAmp:=abs(Data3^);
            if abs(Data4^)>SpectraMaxAmp then SpectraMaxAmp:=abs(Data4^);
            if Prefs.PlayMethod in [2,5,8] then begin
               Data2^:=Data2^+(Data3^+IntData1+IntData1) div 4;
               Data1^:=Data1^+(Data4^+IntData2+IntData2) div 4;
               IntData1:=(Data3^+IntData1+IntData1) div 3;
               IntData2:=(Data4^+IntData2+IntData2) div 3;
            end else if Prefs.PlayMethod in [3,6,9] then begin
               Data2^:=Data2^+(Data3^+IntData1+IntData1+IntData1) div 5;
               Data1^:=Data1^+(Data4^+IntData2+IntData2+IntData2) div 5;
               IntData1:=(Data3^+IntData1+IntData1+IntData1) div 4;
               IntData2:=(Data4^+IntData2+IntData2+IntData2) div 4;
            end else if Prefs.PlayMethod in [4,7,10] then begin
               Data2^:=Data2^+(Data3^+IntData1+IntData1+IntData1+IntData1) div 6;
               Data1^:=Data1^+(Data4^+IntData2+IntData2+IntData2+IntData2) div 6;
               IntData1:=(Data3^+IntData1+IntData1+IntData1) div 5;
               IntData2:=(Data4^+IntData2+IntData2+IntData1) div 5;
            end else
         until (Addr3>=MemA24[0,4]+Length) or
         (Addr1>=SpectraMemA[1]+SpectraLength);

         Addr1:=SpectraMemA[1]+SpectraLength-TimeOffset1;
         Addr2:=SpectraMemA[2]+SpectraLength-TimeOffset1;
         Addr3:=SpectraMemA[1]+SpectraLength-TimeOffset2;
         Addr4:=SpectraMemA[2]+SpectraLength-TimeOffset2;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1-4;
            Data2:=ptr(Addr2); Addr2:=Addr2-4;
            Data3:=ptr(Addr3); Addr3:=Addr3-4;
            Data4:=ptr(Addr4); Addr4:=Addr4-4;
            Data1^:=Data1^-Data4^;
            Data2^:=Data2^-Data3^;
            if abs(Data1^)>SpectraNewAmp then SpectraNewAmp:=abs(Data1^);
            if abs(Data2^)>SpectraNewAmp then SpectraNewAmp:=abs(Data2^);
         until Addr3<SpectraMemA[1];
         SpectraFactor:=SpectraMaxAmp/SpectraNewAmp;
         SpectraNewAmp:=round(SpectraNewAmp*SpectraFactor);
         if SpectraNewAmp>MAX24 then SpectraFactor:=SpectraFactor*(MAX24/SpectraNewAmp);
         if ActiveMode[0]=MD_SURROUND then SurrDiv:=SurrDiv*2;
         if SpectraFactor>1.01 then begin
            Addr1:=SpectraMemA[1];
            Addr2:=SpectraMemA[2];
            repeat
               Data1:=ptr(Addr1); Addr1:=Addr1+4;
               Data2:=ptr(Addr2); Addr2:=Addr2+4;
               Data1^:=round(Data1^*SpectraFactor);
               Data2^:=round(Data2^*SpectraFactor)
            until Addr1>=SpectraMemA[1]+SpectraLength;
         end;


         { SURROUND LEFT/RIGHT }
         if MemA24[0,1]<>0 then begin
            if (Prefs.PlayCh1 and CH_SLEFT=CH_SLEFT)
             then Addr1:=MemA8[0,1]+(BeginOffset div 4)
             else Addr1:=MemA8[0,4]+(BeginOffset div 4);
            Addr2:=Addr1+(Length-BeginOffset) div 4;
            Addr3:=SpectraMemA[1]+4;
            if AddrA<>0 then AddrA:=MemAAlpha[0,4]+(BeginOffset+4) div 80;
            ACtr:=10;
            if Addr1<Addr2 then repeat
               DataS1:=ptr(Addr1); Addr1:=Addr1+1;
               Data3:=ptr(Addr3);  Addr3:=Addr3+4;
               if AddrA=0 then begin
                  l:=DataS1^+ (Data3^ div SurrDiv);
                  if l>127 then l:=127 else if l<-127 then l:=-127;
                  DataS1^:=l;
               end else begin
                  if ACtr=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  l:=DataS1^+ (Data3^ div SurrDiv div 255 * DataA^);
                  if l>127 then l:=127 else if l<-127 then l:=-127;
                  DataS1^:=l;
               end;
            until Addr1>=Addr2;
         end;
         if MemA24[0,2]<>0 then begin
            if (Prefs.PlayCh1 and CH_SLEFT=CH_SLEFT)
             then Addr1:=MemA8[0,2]+(BeginOffset div 4)
             else Addr1:=MemA8[0,3]+(BeginOffset div 4);             
            Addr2:=Addr1+(Length-BeginOffset) div 4;
            Addr3:=SpectraMemA[2]+4;
            if AddrA<>0 then AddrA:=MemAAlpha[0,5]+(BeginOffset+4) div 80;
            ACtr:=10;
            if Addr1<Addr2 then repeat
               DataS1:=ptr(Addr1); Addr1:=Addr1+1;
               Data3:=ptr(Addr3);  Addr3:=Addr3+4;
               if AddrA=0 then begin
                  l:=DataS1^+ (Data3^ div SurrDiv);
                  if l>127 then l:=127 else if l<-127 then l:=-127;
                  DataS1^:=l;
               end else begin
                  if ACtr=10 then begin
                     ACtr:=0;
                     DataA:=ptr(AddrA); AddrA:=AddrA+1;
                  end;
                  ACtr:=ACtr+1;
                  l:=DataS1^+ (Data3^ div SurrDiv div 255 * DataA^);
                  if l>127 then l:=127 else if l<-127 then l:=-127;
                  DataS1^:=l;
               end;
            until Addr1>=Addr2;
         end;
      end;
      for i:=1 to 2 do if SpectraMemA[i]<>0 then begin
         XFreeMem(SpectraMemA[i],SpectraLength);
         SpectraMemA[i]:=0;
      end;

      { SUBWOOFER }
      if MemA24[0,6]<>0 then begin
         if (Prefs.PlayCh1 and CH_SUB=CH_SUB) then begin
            Addr1:=MemA8[0,1]+(BeginOffset div 4);
            Addr2:=MemA8[0,2]+(BeginOffset div 4);
         end else begin
            Addr1:=MemA8[0,4]+(BeginOffset div 4);
            Addr2:=MemA8[0,3]+(BeginOffset div 4);
         end;
         Addr3:=MemA24[0,6]+BeginOffset+4;
         if AddrA<>0 then AddrA:=MemAAlpha[0,6]+(BeginOffset+4) div 80;
         ACtr:=10;
         repeat
            DataS1:=ptr(Addr1); Addr1:=Addr1+1;
            DataS2:=ptr(Addr2); Addr2:=Addr2+1;
            Data3:=ptr(Addr3);  Addr3:=Addr3+4;
            if AddrA=0 then begin
               if Prefs.PlayMethod=1 then begin
                  DataS1^:=DataS1^+ (Data3^ div SubDiv);
                  DataS2^:=DataS2^+ (Data3^ div SubDiv)
               end else begin
                  l:=DataS1^+ (Data3^ div SubDiv);
                  if l>128 then l:=128 else if l<-127 then l:=-127;
                  DataS1^:=l;
                  l:=DataS2^+ (Data3^ div SubDiv);
                  if l>128 then l:=128 else if l<-127 then l:=-127;
                  DataS2^:=l;
               end;
            end else begin
               if ACtr=10 then begin
                  ACtr:=0;
                  DataA:=ptr(AddrA); AddrA:=AddrA+1;
               end;
               ACtr:=ACtr+1;
               if Prefs.PlayMethod=1 then begin
                  DataS1^:=DataS1^+ (Data3^ div SubDiv div 255 * DataA^);
                  DataS2^:=DataS2^+ (Data3^ div SubDiv div 255 * DataA^);
               end else begin
                  l:=DataS1^+ (Data3^ div SubDiv div 255 * DataA^);
                  if l>128 then l:=128 else if l<-127 then l:=-127;
                  DataS1^:=l;
                  l:=DataS2^+ (Data3^ div SubDiv div 255 * DataA^);
                  if l>128 then l:=128 else if l<-127 then l:=-127;
                  DataS2^:=l;
               end;
            end;
         until Addr3>=MemA24[0,6]+Length;
      end;
   end;
end;



procedure DRAWWAVE(SAddr24,AlphaAddr24 :long; ActualChan,Mode :byte);

var Chan,AChan,i        :byte;
var x                   :word;
var Offset,Size,Divider,
    ADivider            :real;
var s                   :string[4];
var Addr1,AddrA,l       :long;
var Data1               :^long;
var DataA               :^byte;


procedure DRAWDATA;

var Divider16           :real;
var Zoom8,MemE          :long;
var Data16              :integer;
var DataL,DataH         :^byte;
var DataAB,DataCD       :^short;

begin
   if not Prefs.ShowData then exit;
   if (Prefs.PlayType1=1) then begin
      for i:=1 to 2 do begin
         if DrawOffset[0]<0 then DrawOffset[0]:=0;
         Zoom8:=Zoom[0] div 4;
         Addr1:=MemA8[0,i*2-1]+DrawOffset[0] div 4;
         Addr2:=MemA8[0,i*2]  +DrawOffset[0] div 4;
         MemE:=MemA8[0,i*2-1]+PlayL24[0] div 4;
         Offset:=pred(Chan)*Size+16+(Size / 2);
         DRAWLINE(MyWindow^,0,round(Offset),pred(MyScreen^.Width),round(Offset),1);
         if not PlayDataValid then exit;
         SetAPen(MyWindow^.RPort,i+23);
         Move(MyWindow^.RPort,0,round(Offset));
         Divider16:=Divider / 256;
         x:=1;
         repeat
            DataL:=ptr(Addr1); Addr1:=Addr1+Zoom8;
            DataH:=ptr(Addr2); Addr2:=Addr2+Zoom8;
            Data16:=(DataH^ * 256) + DataL^;
            Draw(MyWindow^.RPort,x,round(Data16/Divider16+Offset));
            x:=x+1;
         until (x>=pred(MyScreen^.Width)) or (Addr1>=MemE);
      end;
   end else if (Prefs.PlayType1=2) then begin
      for i:=1 to 2 do begin
         if DrawOffset[0]<0 then DrawOffset[0]:=0;
         Zoom8:=Zoom[0] div 4;
         if i=1 then begin
            Addr1:=MemA8[0,1]+DrawOffset[0] div 4;
            Addr2:=MemA8[0,4]+DrawOffset[0] div 4;
            MemE:=MemA8[0,1]+PlayL24[0] div 4;
         end else begin
            Addr1:=MemA8[0,2]+DrawOffset[0] div 4;
            Addr2:=MemA8[0,3]+DrawOffset[0] div 4;
            MemE:=MemA8[0,2]+PlayL24[0] div 4;
         end;
         Offset:=pred(Chan)*Size+16+(Size / 2);
         DRAWLINE(MyWindow^,0,round(Offset),pred(MyScreen^.Width),round(Offset),1);
         if not PlayDataValid then exit;
         SetAPen(MyWindow^.RPort,i+23);
         Move(MyWindow^.RPort,0,round(Offset));
         Divider16:=Divider / 256;
         x:=1;
         repeat
            DataAB:=ptr(Addr1); Addr1:=Addr1+Zoom8;
            DataCD:=ptr(Addr2); Addr2:=Addr2+Zoom8;
            Data16:=(DataAB^+DataCD^) * 128;
            Draw(MyWindow^.RPort,x,round(Data16/Divider16+Offset));
            x:=x+1;
         until (x>=pred(MyScreen^.Width)) or (Addr1>=MemE);
      end;
   end;
end;



procedure DRAWRASTER;

var Step,Pos,x  :long;
var s           :string[20];

begin
   if Zoom[0]=0 then Zoom[0]:=1;
   Step:=(MyScreen^.Width*Zoom[0] div 6 div 100) * 100;
   if Prefs.SUnit=2 then begin
      x:=32000;
      repeat
         x:=x div 2;
      until (x/250*SFreq)/Zoom[0]<=130;
      Step:=round(x/250*SFreq);
   end;
   Pos:=0;
   SetAPen(MyWindow^.RPort,30);
   repeat
      x:=(Pos-DrawOffset[0]) div Zoom[0];
      if x in [10..pred(MyScreen^.Width)] then begin
         Move(MyWindow^.RPort,x,MyScreen^.BarHeight);
         Draw(MyWindow^.RPort,x,RealYPos);
         if x in [0..MyScreen^.Width-30] then begin
            if Prefs.SUnit=1 then s:=intstr(Pos div 4)
            else s:=realstr((Pos div 4)/SFreq,4);
            WRITE(x+2,RealYPos-10,30,0,MyWindow^,s);
         end;
      end;
      Pos:=Pos+Step;
   until Pos>=PlayL24[0];
end;



begin
   if ActualChan>0 then if (Knopf[ActualChan+18].Flags and SELECTED=0) then exit;
   Chan:=0;  AChan:=ActualChan;
   for i:=19 to 25 do if not (Knopf[i].Flags and SELECTED=0) then begin
      Chan:=Chan+1;
      if i-18=ActualChan then ActualChan:=Chan;
   end;
   if Prefs.ShowData then Chan:=Chan+1;
   if Chan=0 then exit;
   Size:=round((MyScreen^.Height-SCRDIFF-10) / Chan);
   Divider:=18400000 / Size;
   Offset:=pred(ActualChan)*Size+MyScreen^.BarHeight+(Size/2);
   if ActualChan=0 then begin
      DRAWDATA;
      DRAWRASTER;
      exit;
   end;

   if (AlphaAddr24<>0) and (Mode=0) then begin
      SetAPen(MyWindow^.RPort,25);
      x:=0;  ADivider:=Divider/32780;
      repeat
         AddrA:=AlphaAddr24+(DrawOffset[0] div 80)+(Zoom[0]*x div 80);
         DataA:=ptr(AddrA);
         RectFill(MyWindow^.RPort,x,round(Offset-DataA^/ADivider),x,round(Offset+DataA^/ADivider));
         x:=x+1;
      until (x>=MyScreen^.Width) or (AddrA>=AlphaAddr24+PlayL24[0] div 80);
   end;
   DRAWLINE(MyWindow^,0,round(Offset),pred(MyScreen^.Width),round(Offset),1);
   Size:=Size/4.35;
   if Prefs.Pegel=2 then begin
      DRAWLINE(MyWindow^,0,round(Offset-Size*1.4141414),pred(MyScreen^.Width),round(Offset-Size*1.4141414),30);
      DRAWLINE(MyWindow^,0,round(Offset+Size*1.4141414),pred(MyScreen^.Width),round(Offset+Size*1.4141414),30);
   end else if Prefs.Pegel=3 then begin
      DRAWLINE(MyWindow^,0,round(Offset-Size),pred(MyScreen^.Width),round(Offset-Size),30);
      DRAWLINE(MyWindow^,0,round(Offset+Size),pred(MyScreen^.Width),round(Offset+Size),30);
   end;
   if SAddr24=0 then exit;

   SetAPen(MyWindow^.RPort,4);
   if DrawOffset[0]<0 then DrawOffset[0]:=0;
   Addr1:=SAddr24+DrawOffset[0];  x:=0;
   if Mode=2 then begin
      x:=618; Addr1:=Addr1+x*Zoom[0];
   end;
   Data1:=ptr(Addr1); Addr1:=Addr1+Zoom[0];
   if Addr1>=SAddr24+PlayL24[0] then exit;
   Move(MyWindow^.RPort,x,round(Data1^/Divider+Offset));
   x:=x+1;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+Zoom[0];
      Draw(MyWindow^.RPort,x,round((Data1^/Divider)+Offset));
      x:=x+1;
   until (x>=MyScreen^.Width) or (Addr1>=SAddr24+PlayL24[0]) or ((Mode=1) and (x>=22));
   if Mode=0 then begin
      case AChan of
         1: s:='L'
         2: s:='R'
         3: s:='C'
         4: s:='SL'
         5: s:='SR'
         6: s:='Sub'
      end;
      WRITE(1,round(Offset-11),1,0,MyWindow^,s);
   end;
end;



procedure REALTIMEMIXER(Mode :byte);
forward;



function STARTSOUND(SpecialRate :word, PlayTime :long, XWindow :p_Window; Mode,VolumeR,VolumeL :byte):byte;

var PlayPos,PlayL8,CopySize,PlayBytes   :long;
var i,j,PlayChannels,ABVol,CDVol,ChBit  :byte;
var PlayMemPos                          :word;
var Leave,DoLoop                        :boolean;

begin
   if not PlayDataValid then begin
      WORKINFO(NIL,1);
      WORKINFO(PText[179],7);
      CALCCHANNELS(0,PlayL24[0],UsedChans);
      DRAWWAVE(1,0,0,0);
   end;
   WORKINFO('',8);
   if (Prefs.PlayType1=1) and (Prefs.PlayType2=1) then begin
      STARTSOUND:=0;
      ADKCON_WRITE^:=$000F;
      DMACON_WRITE^:=$000F;
      if (MemA16[0,1] or MemA16[0,2])=0 then exit;
      LData:=ptr($BFE001);
      LData^:=LData^ or 2;
      Leave:=false;
      if (SSustain[0] or SRelease[0]<>0) and (Mode=0) then DoLoop:=true else DoLoop:=false;
      PlayPos:=0;            PlayMemPos:=0;
      PlayL8:=PlayL24[0] div 4;
      if SRelease[0]<>0 then PlayL8:=SRelease[0] div 4;

      if SpecialRate=0 then SpecialRate:=Prefs.SRate;
      PlayBytes:=round((PlayTime/1000)*(10000000/(SpecialRate*2.79365)));
      if PlayBytes=0 then PlayBytes:=PlayL8;
      if (Mode=2) and (AreaE[0]<>0) then begin
         PlayL8:=AreaE[0] div 4;
         PlayPos:=AreaA[0] div 4;
         PlayBytes:=(AreaE[0]-AreaA[0]) div 4;
      end;

      SPFreqA^:=SpecialRate; SPFreqB^:=SpecialRate; SPFreqC^:=SpecialRate; SPFreqD^:=SpecialRate;
      SPVolA^:=VolumeL;      SPVolB^:=VolumeL;      SPVolC^:=VolumeR;      SPVolD^:=VolumeR;
      repeat
         repeat
            if PlayL8-PlayPos>PlayMemL div 2 then
             CopySize:=PlayMemL div 4 else CopySize:=PlayMemL div 2;
            if CopySize>PlayL8-PlayPos then CopySize:=PlayL8-PlayPos;

            if CopySize>PlayBytes then CopySize:=PlayBytes;
            for i:=1 to 4 do CopyMemQuick(MemA8[0,i]+PlayPos,PlayMemA[i]+PlayMemPos,CopySize);
            PlayPos:=PlayPos+CopySize;
            PlayBytes:=PlayBytes-CopySize;
            CopySize:=CopySize div 2;
            SPAddrA^:=PlayMemA[3]+PlayMemPos;  SPAddrD^:=PlayMemA[2]+PlayMemPos;
            SPAddrB^:=PlayMemA[4]+PlayMemPos;  SPAddrC^:=PlayMemA[1]+PlayMemPos;
            SPLengthA^:=CopySize;             SPLengthB^:=CopySize;
            SPLengthC^:=CopySize;             SPLengthD^:=CopySize;

            PlayMemPos:=(PlayMemL div 2) - PlayMemPos;

            DMACON_WRITE^:=$800A;
            {B & D}
            ADKCON_WRITE^:=$8005;
            {A & C}
            if Mode=1 then REALTIMEMIXER(1);
            NTREQ_WRITE^:=$0500;
            repeat
               IMsg:=Get_Msg(XWindow^.UserPort);
               if IMsg<>NIL then begin
                  if IMsg^.Class=RAWKEY then begin
                     if IMsg^.Code=68 then begin
                        if not (PlayPos*4 in [SSustain[0]..SRelease[0]]) then DoLoop:=false;
                        if DoLoop then begin
                           PlayL8:=PlayL24[0] div 4;
                           PlayBytes:=PlayL8-PlayPos;
                           DoLoop:=false;
                        end else PlayPos:=PlayL8;
                        Leave:=true;
                     end else if (IMsg^.Code and 128=0) then begin
                        ADKCON_WRITE^:=$000F;
                        DMACON_WRITE^:=$000F;
                        STARTSOUND:=IMsg^.Code;
                        Reply_Msg(IMsg);
                        exit;
                     end;
                  end;
                  Reply_Msg(IMsg);
               end;
            until NTREQ_READ^ and $0500 <> 0;
         until (PlayPos>=PlayL8) or (PlayBytes<=0);
         PlayPos:=SSustain[0] div 4;
         if DoLoop then PlayBytes:=(PlayL24[0]-SSustain[0]) div 4;
      until not DoLoop or (PlayBytes<=0) or Leave;

      SPVolA^:=0;     SPVolB^:=0;     SPVolC^:=0;     SPVolD^:=0;
      while not Leave and (PlayBytes>0) do begin
         CopySize:=PlayMemL div 2;
         if CopySize>PlayBytes then CopySize:=PlayBytes;
         PlayBytes:=PlayBytes-CopySize;
         CopySize:=CopySize div 2;
         SPLengthA^:=CopySize; SPLengthB^:=CopySize; SPLengthC^:=CopySize; SPLengthD^:=CopySize;
         NTREQ_WRITE^:=$0500;
         repeat
         until NTREQ_READ^ and $0500 <> 0;
      end;

      NTREQ_WRITE^:=$0500;
      repeat
      until NTREQ_READ^ and $0500 <> 0;

      ADKCON_WRITE^:=$000F;
      DMACON_WRITE^:=$000F;
   end else if (Prefs.PlayType1=2) and (Prefs.PlayType2=2) then begin
      ABVol:=0; CDVol:=0;
      ChBit:=1;
      for i:=1 to 6 do begin
         if not (Prefs.PlayCh1 and ChBit=0) then ABVol:=ABVol+1;
         if not (Prefs.PlayCh2 and ChBit=0) then CDVol:=CDVol+1;
         ChBit:=ChBit*2;
      end;
      if ABVol>CDVol then begin
         CDVol:=round(64*(CDVol/ABVol));
         ABVol:=64;
      end else if CDVol>ABVol then begin
         ABVol:=round(64*(ABVol/CDVol));
         CDVol:=64;
      end else begin
         ABVol:=64;
         CDVol:=64;
      end;
      
      STARTSOUND:=0;
      DMACON_WRITE^:=$000F;
      if (MemA16[0,1] or MemA16[0,2])=0 then exit;
      LData:=ptr($BFE001);
      LData^:=LData^ or 2;
      Leave:=false;
      if (SSustain[0] or SRelease[0]<>0) and (Mode=0) then DoLoop:=true else DoLoop:=false;
      PlayPos:=0;            PlayMemPos:=0;
      PlayL8:=PlayL24[0] div 4;
      if SRelease[0]<>0 then PlayL8:=SRelease[0] div 4;

      if SpecialRate=0 then SpecialRate:=Prefs.SRate;
      PlayBytes:=round((PlayTime/1000)*(10000000/(SpecialRate*2.79365)));
      if PlayBytes=0 then PlayBytes:=PlayL8;
      if (Mode=2) and (AreaE[0]<>0) then begin
         PlayL8:=AreaE[0] div 4;
         PlayPos:=AreaA[0] div 4;
         PlayBytes:=(AreaE[0]-AreaA[0]) div 4;
      end;

      SPFreqA^:=SpecialRate; SPFreqB^:=SpecialRate; SPFreqC^:=SpecialRate; SPFreqD^:=SpecialRate;
      SPVolA^:=ABVol;        SPVolB^:=ABVol;        SPVolC^:=CDVol;        SPVolD^:=CDVol;
      repeat
         repeat
            if PlayL8-PlayPos>PlayMemL div 2 then
             CopySize:=PlayMemL div 4 else CopySize:=PlayMemL div 2;
            if CopySize>PlayL8-PlayPos then CopySize:=PlayL8-PlayPos;

            if CopySize>PlayBytes then CopySize:=PlayBytes;
            for i:=1 to 4 do CopyMemQuick(MemA8[0,i]+PlayPos,PlayMemA[i]+PlayMemPos,CopySize);
            PlayPos:=PlayPos+CopySize;
            PlayBytes:=PlayBytes-CopySize;
            CopySize:=CopySize div 2;
            SPAddrA^:=PlayMemA[1]+PlayMemPos;  SPAddrB^:=PlayMemA[2]+PlayMemPos;
            SPAddrC^:=PlayMemA[3]+PlayMemPos;  SPAddrD^:=PlayMemA[4]+PlayMemPos;
            SPLengthA^:=CopySize;              SPLengthB^:=CopySize;
            SPLengthC^:=CopySize;              SPLengthD^:=CopySize;

            PlayMemPos:=(PlayMemL div 2) - PlayMemPos;

            DMACON_WRITE^:=$800F;
            if Mode=1 then REALTIMEMIXER(1);
            NTREQ_WRITE^:=$0780;
            repeat
               IMsg:=Get_Msg(XWindow^.UserPort);
               if IMsg<>NIL then begin
                  if IMsg^.Class=RAWKEY then begin
                     if IMsg^.Code=68 then begin
                        if not (PlayPos*4 in [SSustain[0]..SRelease[0]]) then DoLoop:=false;
                        if DoLoop then begin
                           PlayL8:=PlayL24[0] div 4;
                           PlayBytes:=PlayL8-PlayPos;
                           DoLoop:=false;
                        end else PlayPos:=PlayL8;
                        Leave:=true;
                     end else if (IMsg^.Code and 128=0) then begin
                        DMACON_WRITE^:=$000F;
                        STARTSOUND:=IMsg^.Code;
                        Reply_Msg(IMsg);
                        exit;
                     end;
                  end;
                  Reply_Msg(IMsg);
               end;
            until NTREQ_READ^ and $0780 <> 0;
         until (PlayPos>=PlayL8) or (PlayBytes<=0);
         PlayPos:=SSustain[0] div 4;
         if DoLoop then PlayBytes:=(PlayL24[0]-SSustain[0]) div 4;
      until not DoLoop or (PlayBytes<=0) or Leave;

      SPVolA^:=0;     SPVolB^:=0;     SPVolC^:=0;     SPVolD^:=0;
      while not Leave and (PlayBytes>0) do begin
         CopySize:=PlayMemL div 2;
         if CopySize>PlayBytes then CopySize:=PlayBytes;
         PlayBytes:=PlayBytes-CopySize;
         CopySize:=CopySize div 2;
         SPLengthA^:=CopySize; SPLengthB^:=CopySize;
         SPLengthC^:=CopySize; SPLengthD^:=CopySize;
         NTREQ_WRITE^:=$0780;
         repeat
         until NTREQ_READ^ and $0780 <> 0;
      end;

      NTREQ_WRITE^:=$0780;
      repeat
      until NTREQ_READ^ and $0780 <> 0;
      DMACON_WRITE^:=$000F;      
   end;
end;



procedure ALLOCUNDO(MemID :byte);

var b   :boolean;
var i   :byte;

begin
   b:=true;
   for i:=1 to 6 do if (MemA24[MemID,i]>0) and b then begin
      if MemAUNDO[MemID,i]=0 then begin
         MemAUNDO[MemID,i]:=XAllocMem(MemL24[MemID]+32,MEMF_CLEAR)+16;
         if MemAUNDO[MemID,i]=16 then begin
            FREEUNDO(MemID);
            b:=false
         end;
      end;
      if (AlphaUNDO[MemID,i]=0) and (MemAAlpha[MemID,i]<>0) and b then begin
         AlphaUNDO[MemID,i]:=XAllocMem(round(MemL24[MemID]/80+5),MEMF_CLEAR);
         if AlphaUNDO[MemID,i]=0 then begin
            FREEUNDO(MemID);
            b:=false
         end;
      end;
   end;
end;



procedure FREEALPHA(MemID :byte);

var i   :byte;

begin
   for i:=1 to 6  do if MemAAlpha[MemID,i]>0  then begin
      XFreeMem(MemAAlpha[MemID,i],round(MemL24[MemID]/80+5));
      MemAAlpha[MemID,i]:=0;
   end;
end;



function ALLOCALPHA(MemID :byte):boolean;

var i           :byte;
var AddrA       :long;
var DataA       :^byte;

begin
   ALLOCALPHA:=false;
   for i:=1 to 6 do if MemA24[MemID,i]<>0 then begin
      MemAAlpha[MemID,i]:=XAllocMem(round(MemL24[MemID]/80+5),MEMF_CLEAR);
      if MemAAlpha[MemID,i]=0 then begin
         FREEALPHA(MemID);
         exit;
      end else begin
         AddrA:=MemAAlpha[MemID,i]+round(MemL24[MemID]/80+4);
         repeat
            AddrA:=AddrA-1; DataA:=ptr(AddrA);
            DataA^:=255;
         until AddrA<=MemAAlpha[MemID,i];
      end;
   end;
   if (MemAUNDO[MemID,1] or MemAUNDO[MemID,3])=0 then ALLOCUNDO(MemID);
   ALLOCALPHA:=true;
end;



procedure FREESOUNDMEM(MemID :byte; Say :boolean);

var i   :byte;

begin
   if (Prefs.UseVMem) and (Prefs.BufferVMem) then begin
      for j:=1 to 6 do begin
         s:=Prefs.VMemStr+'WT.Buffer.'+intstr(MemID)+'.'+intstr(j);
         l:=DeleteFile(s);
         s:=Prefs.VMemStr+'WT.AlphaBuffer.'+intstr(MemID)+'.'+intstr(j);
         l:=DeleteFile(s);
         s:=Prefs.VMemStr+'WT.Buffer.x,'+intstr(j);
         l:=DeleteFile(s);
         s:=Prefs.VMemStr+'WT.AlphaBuffer.x.'+intstr(j);
         l:=DeleteFile(s);
      end;
   end;
   for i:=1 to 6 do begin
      if MemA24[MemID,i]>0 then XFreeMem(MemA24[MemID,i]-16,MemL24[MemID]+32);
      if MemA16[MemID,i]>0 then XFreeMem(MemA16[MemID,i],MemL24[MemID] div 2);
      MemA24[MemID,i]:=0; MemA16[MemID,i]:=0;
   end;
   DrawOffset[MemID]:=0; Zoom[MemID]:=0;
   if Say then l:=TASKREQUEST(PText[183],NIL,NIL,PText[220],NIL) else FREEUNDO(MemID);
end;



function ALLOCSOUNDMEM(MemID,ActiveChannels :byte; Say,PlayMem :boolean):boolean;

var ChBit       :byte;

begin
   ALLOCSOUNDMEM:=false;
   ChBit:=1;
   for i:=1 to 6 do begin
      if not (ActiveChannels and ChBit=0) then begin
         MemA24[MemID,i]:=XAllocMem(MemL24[MemID]+32,MEMF_CLEAR)+16;
         if MemA24[MemID,i]=16 then begin
            FREESOUNDMEM(MemID,Say); exit;
         end;
      end;
      ChBit:=ChBit*2;
   end;
   if PlayMem then begin
      for i:=1 to 2 do begin
         MemA16[MemID,i]:=XAllocMem(MemL24[MemID] div 2,MEMF_CLEAR);
         if MemA16[MemID,i]=0 then begin
            FREESOUNDMEM(MemID,Say); exit;
         end;
      end;
      MemA8[MemID,1]:=MemA16[MemID,1]; MemA8[MemID,2]:=MemA16[MemID,1]+MemL24[MemID] div 4;
      MemA8[MemID,3]:=MemA16[MemID,2]; MemA8[MemID,4]:=MemA16[MemID,2]+MemL24[MemID] div 4;
   end;
   ALLOCSOUNDMEM:=true;
end;



function DEFINESCALE(UsePreset :boolean):boolean;

var GCnt       :byte;
var i          :integer;
var MySList1   :SelectListGad;

begin
   DEFINESCALE:=false;
   with _WaveOp[Opos] do begin
      Operation:=18;
      WAreaA:=0; WAreaE:=0; MemAData:=0; MemLData:=0;
      if not OPENDWIN(170,0,DWindow,PText[347],1,0) then exit;
      if not UsePreset then Operator[1]:=PlayL24[0] div 4;
      Operator[2]:=round(Prefs.SRate/(Operator[1]/(PlayL24[0]/4)));
      Operator[3]:=round(10000000/(Operator[2]*2.79365));
      for i:=1 to 3 do begin
         s:=intstr(Operator[i]); Buffer[i]:=s; if i=3 then s:=s+' Hz';
         WRITE(40,87+i*20,2,3,DWindow^,s);
         CREATEPROPGAD(80,85+i*20,1,1,i,2,DWindow^);
         if Operator[i]<=65535 then SchieberInfo[i].HorizPot:=Operator[i]
          else SchieberInfo[i].HorizPot:=65535;
         WRITE(485,87+i*20,2,0,DWindow^,PText[i+347]);
         AddGadget(DWindow,^TextGad[i],NIL);
         AddGadget(DWindow,^Schieber[i],NIL);
      end;
      for i:=1 to 5 do begin
         DKnopf[i+2]:=Gadget(NIL,21*i-11,62,21,12,GADGHCOMP+GADGIMAGE,$3,BOOLGADGET,
                             ^ButtonImg[1],NIL,NIL,0,NIL,i+9,0);
         if (MemA24[i,1]=0) and (MemA24[i,3]=0) then DKnopf[i+2].Flags:=DKnopf[i+2].Flags or GADGDISABLED;
         AddGadget(DWindow,^DKnopf[i+2],NIL);
      end;
      WRITE(18,77,2,0,DWindow^,'1     2     3    4     5');
      WRITE(122,62,2,0,DWindow^,PText[351]);

      CREATEGADS(0,1,0);
      if OpType<1 then OpType:=1 else if OpType>2 then OpType:=2;
      DKnopfTx[1]:=IntuiText(2,0,0,4,2,^CustomTA,PText[354],NIL); {Schnell}
      DKnopfTx[2]:=IntuiText(2,0,0,4,2,^CustomTA,PText[355],NIL); {lineare Interpolation}
      DKnopf[9].GadgetText:=^DKnopfTx[OpType];
      MySList1:=SelectListGad(DWindow,^DKnopf[9],OpType,0,0,0,ITTArr(^DKnopfTx[1],
                              ^DKnopfTx[2],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));
      AddGadget(DWindow,^DKnopf[9],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if GadCode=9 then begin
            OpType:=DOSELECTLIST(^MySList1);
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
         end;

         if GadCode in [10..14] then begin
            Buffer[2]:=intstr(PlayRate[GadCode-9]);
            GadCode:=6;
         end;

         if GadCode in [3..8] then begin
            GCnt:=0;
            repeat
               if (GadCode in [3,4]) and (GCnt<3) then begin
                  while (GadCode=3) or not (Schieber[1].flags and SELECTED=0) do begin
                     Operator[1]:=SchieberInfo[1].HorizPot*2;
                     if Operator[1]<2 then Operator[1]:=2;
                     if Operator[1]>MAXSIZE then Operator[1]:=MAXSIZE;
                     Buffer[1]:=intstr(Operator[1]);
                     RefreshGadgets(^TextGad[1],DWindow,NIL);
                     GadCode:=6;
                  end;
                  if Gadcode=4 then begin
                     val(Buffer[1],Operator[1],i);
                     if Operator[1]<2 then Operator[1]:=2;
                     if Operator[1]>MAXSIZE then Operator[1]:=MAXSIZE;
                     Buffer[1]:=intstr(Operator[1]);
                     if Operator[1]<=131070 then SchieberInfo[1].HorizPot:=Operator[1] div 2
                      else SchieberInfo[1].HorizPot:=65535;
                     RefreshGadgets(^Schieber[1],DWindow,NIL);
                  end;
                  GCnt:=GCnt+1;
                  if GCnt<3 then begin
                     Buffer[2]:=intstr(round(Prefs.SRate/(Operator[1]/(PlayL24[0]/4))));
                     GadCode:=6;
                  end;
               end;

               if (GadCode in [5,6]) and (GCnt<3) then begin
                  while (GadCode=5) or not (Schieber[2].flags and SELECTED=0) do begin
                     Operator[2]:=SchieberInfo[2].HorizPot;
                     if Operator[2]<1 then Operator[2]:=1;
                     if Operator[2]>65535 then Operator[2]:=65535;
                     Buffer[2]:=intstr(Operator[2]);
                     RefreshGadgets(^TextGad[2],DWindow,NIL);
                     GadCode:=8;
                  end;
                  if Gadcode=6 then begin
                     val(Buffer[2],Operator[2],i);
                     if Operator[2]<1 then Operator[2]:=1;
                     if Operator[2]>65535 then Operator[2]:=65535;
                     Buffer[2]:=intstr(Operator[2]);
                     SchieberInfo[2].HorizPot:=Operator[2];
                     RefreshGadgets(^Schieber[2],DWindow,NIL);
                  end;
                  GCnt:=GCnt+1;
                  if GCnt<3 then begin
                     Buffer[3]:=intstr(round(10000000/(Operator[2]*2.79365)));
                     GadCode:=8;
                  end;
               end;

               if (GadCode in [7,8]) and (GCnt<3) then begin
                  while (GadCode=7) or not (Schieber[3].flags and SELECTED=0) do begin
                     Operator[3]:=SchieberInfo[3].HorizPot;
                     if Operator[3]<1 then Operator[3]:=1;
                     if Operator[3]>65535 then Operator[3]:=65535;
                     Buffer[3]:=intstr(Operator[3]);
                     RefreshGadgets(^TextGad[3],DWindow,NIL);
                     GadCode:=4;
                  end;
                  if Gadcode=8 then begin
                     val(Buffer[3],Operator[3],i);
                     if Operator[3]<1 then Operator[3]:=1;
                     if Operator[3]>65535 then Operator[3]:=65535;
                     Buffer[3]:=intstr(Operator[3]);
                     SchieberInfo[3].HorizPot:=Operator[3];
                     RefreshGadgets(^Schieber[3],DWindow,NIL);
                  end;
                  GCnt:=GCnt+1;
                  if GCnt<3 then begin
                     Buffer[1]:=intstr(round((PlayL24[0] div 4)*(Operator[3]/round(10000000/(Prefs.SRate*2.79365)))));
                     GadCode:=4;
                  end;
               end;

            until GCnt>=3
         end;

      Until (GadCode in [1..2]) or (RawCode in [68,69]);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINESCALE:=true;
   end;
end;



function DOSCALE:boolean;

var DataA1,DataA2                       :^byte;
var SMemL24,SPlayL24,OldPlayL24,AddrX   :long;
var DataX                               :^long;
var SMemA24,SMemA16,SMemA8,SMemAAlpha   :array [1..6] of long;
var SFactor,SStep,SmoothStep            :real;
var GCnt,ChCnt                          :byte;
var UseAlpha,UseVirtual                 :boolean;
var VFHandle                            :BPTR;


procedure SWAPVALUES;

begin
   for i:=1 to 6 do begin
      exchange(SMemA24[i],MemA24[0,i]);
      exchange(SMemA16[i],MemA16[0,i]);
      exchange(SMemA8[i],MemA8[0,i]);
      exchange(SMemAAlpha[i],MemAAlpha[0,i]);
   end;
   exchange(SPlayL24,PlayL24[0]);
   exchange(SMemL24,MemL24[0]);
end;


procedure CLOSEVMEM;

begin
   for i:=1 to 6 do begin
      s:=Prefs.VMemStr+intstr(i);
      l:=DeleteFile(s);
   end;
end;


procedure LOADVMEM;

begin
   for i:=1 to 6 do if MemA24[0,i]<>0 then begin
      s:=Prefs.VMemStr+intstr(i);
      VFHandle:=DosOpen(s,MODE_OLDFILE);
      if VFHandle<>0 then begin
         l:=DosRead(VFHandle,ptr(MemA24[0,i]+MemL24[0]-OldPlayL24),OldPlayL24);
         if UseAlpha and (MemAAlpha[0,i]<>0) then
          l:=DosRead(VFHandle,ptr(MemAAlpha[0,i]+((MemL24[0]-OldPlayL24) div 80)),OldPlayL24 div 80);
         DosClose(VFHandle);
      end;
   end;
end;


begin
   DOSCALE:=false;
   UseAlpha:=false; UseVirtual:=false;
   ChCnt:=0;
   for i:=1 to 6 do begin
      if MemA24[0,i]<>0 then ChCnt:=ChCnt+1;
      if MemAAlpha[0,i]<>0 then UseAlpha:=true;
   end;
   with _WaveOp[OPos] do begin
      if Operator[1]*4=PlayL24[0] then exit;
      WORKINFO(PText[119],1);
      SFactor:=PlayL24[0]/(Operator[1]*4);
      OldPlayL24:=PlayL24[0];
      GCnt:=0;
      if (Operator[1]*4)>MemL24[0] then begin
         {*** Vergrerung auf >MemL24 ***}
         GCnt:=1;
         FREEUNDO(0);
         if Prefs.UseVMem and Prefs.FunctVMem then begin
            for i:=1 to 6 do if MemA24[0,i]<>0 then begin
               s:=Prefs.VMemStr+intstr(i);
               VFHandle:=DosOpen(s,MODE_NEWFILE);
               if VFHandle<>0 then begin
                  l:=DosWrite(VFHandle,ptr(MemA24[0,i]),PlayL24[0]);
                  if l<PlayL24[0] then begin
                     l:=TASKREQUEST(PText[191],PText[197],NIL,PText[220],NIL);
                     CLOSEVMEM;
                     DosClose(VFHandle);
                     exit;
                  end;
                  if UseAlpha then l:=DosWrite(VFHandle,ptr(MemAAlpha[0,i]),PlayL24[0] div 80);
                  DosClose(VFHandle);
               end else begin
                  l:=TASKREQUEST(PText[190],PText[197],NIL,PText[220],NIL);
                  CLOSEVMEM;
                  exit;
               end;
            end;
            FREESOUNDMEM(0,false); FREEALPHA(0);
            MemL24[0]:=16+(Operator[1]*4);
            PlayL24[0]:=MemL24[0];
            PlayLUNDO:=MemL24[0];
            if not ALLOCSOUNDMEM(0,ActiveChannels[0],true,true) or (UseAlpha and not ALLOCALPHA(0))
             then begin
               FREESOUNDMEM(0,false);
               FREEALPHA(0);
               MemL24[0]:=OldPlayL24;
               PlayL24[0]:=MemL24[0];
               PlayLUNDO:=MemL24[0];
               if not ALLOCSOUNDMEM(0,ActiveChannels[0],true,true) then begin
                  l:=TASKREQUEST(PText[260],PText[262],NIL,PText[220],NIL);
                  CLOSEVMEM;
                  exit;
               end;
               if UseAlpha then if not ALLOCALPHA(0) then begin end;
               l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
               LOADVMEM;
               CLOSEVMEM;
               exit;
            end;
            LOADVMEM;
            CLOSEVMEM;
         end else begin
            for i:=1 to 6 do begin
               SMemA24[i]:=0;
               SMemA16[i]:=0;
               SMemA8[i]:=0;
               SMemAAlpha[i]:=0;
            end;
            SWAPVALUES;
            MemL24[0]:=16+(Operator[1]*4);
            PlayL24[0]:=MemL24[0];
            PlayLUNDO:=MemL24[0];
            if not ALLOCSOUNDMEM(0,ActiveChannels[0],true,true) then begin
               SWAPVALUES;
               l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
               WORKINFO('',8);
               exit;
            end;
            if UseAlpha and not UseVirtual then begin
               if not ALLOCALPHA(0) then begin
                  SWAPVALUES;
                  l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
                  WORKINFO('',8);
                  exit;
               end;
            end;
            for i:=1 to 6 do if (SMemA24[i]<>0) and (MemA24[0,i]<>0) then
             CopyMemQuick(SMemA24[i],MemA24[0,i]+MemL24[0]-SPlayL24,SPlayL24);
            if UseAlpha then for i:=1 to 6 do if (SMemAAlpha[i]<>0) and (MemAAlpha[0,i]<>0) then
             CopyMemQuick(SMemAAlpha[i],MemAAlpha[0,i]+((MemL24[0]-SPlayL24) div 80),SPlayL24 div 80);

            SWAPVALUES;
            FREESOUNDMEM(0,false);
            FREEALPHA(0);
            SWAPVALUES;
         end;
         ALLOCUNDO(0);
      end else if (Operator[1]*4)>PlayL24[0] then begin
         {*** Vergrerung auf >PlayL24 <=MemL24 ***}
         GCnt:=2;
         for i:=1 to 6 do if MemA24[0,i]<>0 then begin
            Addr1:=MemA24[0,i]+MemL24[0];
            Addr2:=MemA24[0,i]+PlayL24[0];
            repeat
               Addr1:=Addr1-4; Data1:=ptr(Addr1);
               Addr2:=Addr2-4; Data2:=ptr(Addr2);
               Data1^:=Data2^;
            until Addr2<=MemA24[0,i];
         end;

         if UseAlpha then for i:=1 to 6 do if MemAAlpha[0,i]<>0 then begin
            Addr1:=MemAAlpha[0,i]+(MemL24[0] div 80);
            Addr2:=MemAAlpha[0,i]+(PlayL24[0] div 80);
            repeat
               Addr1:=Addr1-1; DataA1:=ptr(Addr1);
               Addr2:=Addr2-1; DataA2:=ptr(Addr2);
               DataA1^:=DataA2^;
            until Addr2<=MemAAlpha[0,i];
         end;

         PlayL24[0]:=Operator[1]*4;
         PlayLUNDO:=PlayL24[0];
      end;

      for i:=1 to 6 do if MemA24[0,i]<>0 then begin
         if GCnt=0 then Addr1:=MemA24[0,i]
          else Addr1:=MemA24[0,i]+MemL24[0]-OldPlayL24;
         Addr2:=MemA24[0,i];
         SStep:=0;
         if OpType=1 then begin {*** Schnell ***}
            repeat
               Data1:=ptr(Addr1+round(SStep)*4); SStep:=SStep+SFactor;
               Data2:=ptr(Addr2); Addr2:=Addr2+4;
               Data2^:=Data1^;
            until (Addr2>=MemA24[0,i]+PlayL24[0]) or (round(SStep)*4>=OldPlayL24);
         end else if (OpType=2) then begin         {*** linear Interpoliert ***}
            repeat
               AddrX:=Addr1+round(SStep)*4;
               SmoothStep:=SStep-round(SStep);
               SStep:=SStep+SFactor;
               Data1:=ptr(AddrX);
               Data2:=ptr(Addr2); Addr2:=Addr2+4;
               if SmoothStep<0 then begin
                  DataX:=ptr(AddrX-4);
                  Data2^:=round((DataX^*(-SmoothStep))+(Data1^*(1+SmoothStep)));
               end else if SmoothStep>0 then begin
                  DataX:=ptr(AddrX+4);
                  Data2^:=round((Data1^*(1-SmoothStep))+(DataX^*SmoothStep));
               end else Data2^:=Data1^;
            until (Addr2>=MemA24[0,i]+PlayL24[0]) or (round(SStep)*4>=OldPlayL24);
         end;
         if Addr2<MemA24[0,i]+MemL24[0] then repeat
            Data2:=ptr(Addr2); Addr2:=Addr2+4;
            Data2^:=0;
         until Addr2>=MemA24[0,i]+MemL24[0];
      end;

      if UseAlpha then for i:=1 to 6 do if MemAAlpha[0,i]<>0 then begin
         if GCnt=0 then Addr1:=MemAAlpha[0,i]
          else Addr1:=MemAAlpha[0,i]+((MemL24[0]-OldPlayL24) div 80);
         Addr2:=MemAAlpha[0,i];
         SStep:=0;
         repeat
            DataA1:=ptr(Addr1+round(SStep)); SStep:=SStep+SFactor;
            DataA2:=ptr(Addr2); Addr2:=Addr2+1;
            DataA2^:=DataA1^;
         until (Addr2>=MemAAlpha[0,i]+(PlayL24[0] div 80))
         or (round(SStep)>=(OldPlayL24 div 80));
         if Addr2<MemAAlpha[0,i]+(MemL24[0] div 80) then repeat
            DataA2:=ptr(Addr2); Addr2:=Addr2+1;
            DataA2^:=0;
         until Addr2>=MemAAlpha[0,i]+(MemL24[0] div 80);
      end;

      AreaA[0]:=round(AreaA[0]/SFactor);       AreaE[0]:=round(AreaE[0]/SFactor);
      SAttack[0]:=round(SAttack[0]/SFactor);   SDecay[0]:=round(SDecay[0]/SFactor);
      SSustain[0]:=round(SSustain[0]/SFactor); SRelease[0]:=round(SRelease[0]/SFactor);
      MaxZoom:=succ(MemL24[0] div (MyScreen^.Width*4)) * 4;
      Zoom[0]:=MaxZoom;
      if Zoom[0]=0 then Zoom[0]:=1;
      PlayDataValid:=false;
   end;
   DOSCALE:=true;
end;



procedure SCANWAVE(SAddr,AlphaSAddr :long; var WaveMaxAmp :long; var AlphaMaxAmp :byte);

var Addr1       :long;
var Data1       :^long;
var DataA       :^byte;

begin
   WaveMaxAmp:=1; AlphaMaxAmp:=1;
   if SAddr=0 then exit;
   Addr1:=SAddr+PlayL24[0];
   repeat
      Addr1:=Addr1-4; Data1:=ptr(Addr1);
      if abs(Data1^)>WaveMaxAmp then WaveMaxAmp:=abs(Data1^);
   until Addr1<=SAddr;
   if AlphaSAddr<>0 then begin
      Addr1:=AlphaSAddr+round(PlayL24[0]/80+0.5);
      repeat
         Addr1:=Addr1-1; DataA:=ptr(Addr1);
         if DataA^>AlphaMaxAmp then AlphaMaxAmp:=DataA^;
         if DataA^=0 then DataA^:=1;
      until Addr1<=AlphaSAddr;
   end;
end;



procedure PUSHWAVE(SAddr,WaveMaxAmp :long);

var WaveAmpFactor       :real;

begin
   if SAddr=0 then exit;
   WaveAmpFactor:=MAX24 / WaveMaxAmp;
   Addr1:=SAddr+PlayL24[0];
   repeat
      Addr1:=Addr1-4; Data1:=ptr(Addr1);
      Data1^:=round(WaveAmpFactor*Data1^);
      if Data1^>MAX24 then Data1^:=MAX24 else if Data1^<-MAX24 then Data1^:=-MAX24;
   until Addr1<=SAddr;
end;



procedure PUSHALPHA(AlphaSAddr,AlphaMaxAmp :long);

var AmpFactor   :real;
var DataA       :^byte;

begin
   if AlphaSAddr=0 then exit;
   AmpFactor:=255 / AlphaMaxAmp;
   Addr1:=AlphaSAddr+round(PlayL24[0]/80+0.5);
   repeat
      Addr1:=Addr1-1; DataA:=ptr(Addr1);
      DataA^:=round(AmpFactor*DataA^);
   until Addr1<=AlphaSAddr;
end;



procedure SETSAMPLEGADS;

var x,l         :long;

begin
   MaxZoom:=succ(MemL24[0] div (MyScreen^.Width*4)) * 4;
   if Zoom[0]>MaxZoom then Zoom[0]:=MaxZoom;
   if Zoom[0]<4 then Zoom[0]:=4;

   x:=PlayL24[0]-MyScreen^.Width*Zoom[0]; if x=0  then x:=1;
   l:=round(DrawOffset[0]/x*65535);
   if l<0 then l:=0;   if l>65535 then l:=65535;
   MSchieberInfo.HorizPot:=l;
   if Zoom[0]=MaxZoom then l:=65535
   else l:=round(65534/(PlayL24[0]/(MyScreen^.Width*Zoom[0])));
   if l<1 then l:=1;   if l>65535 then l:=65535;
   MSchieberInfo.HorizBody:=l;
   RefreshGadgets(^MSchieber,IntuiWindow1,NIL);
end;



procedure CHECKMARK(OPos :long);

begin
   if AreaA[0]>AreaE[0] then exchange(AreaA[0],AreaE[0]);
   if (AreaA[0]<0) or (AreaA[0]>AreaE[0]-4) then AreaA[0]:=0;
   if (AreaE[0]<AreaA[0]) or (AreaE[0]>PlayL24[0]) then AreaE[0]:=PLayL24[0];
   if (AreaA[0]=0) and (AreaE[0]>PlayL24[0]) then AreaE[0]:=0;
   if OPos>0 then with _WaveOp[OPos] do begin
      WAreaA:=AreaA[0];
      WAreaE:=AreaE[0];
   end;
end;



procedure PROCESSWAVE;

var Factor,DataH,l,x,x2                 :long;
var ChBit,b,AlphaMaxAmp,i               :byte;



procedure CREATESUBWOOFER(UsedChans :byte);

var Addr1,Addr2,IntData,Check,TFreq,
    OldTFreq                            :long;
var Data1,Data2                         :^long;
var DataA1,DataA2                       :^Byte;
var i,ChBit                             :byte;
var SampleFreq                          :real;
var First                               :boolean;

begin
   ChBit:=1; First:=true;
   for i:=1 to 5 do begin
      if not (UsedChans and ChBit=0) then begin
         Addr1:=MemA24[0,i]+PlayL24[0];
         Addr2:=MemA24[0,6]+PlayL24[0];
         repeat
            Addr1:=Addr1-4; Data1:=ptr(Addr1);
            Addr2:=Addr2-4; Data2:=ptr(Addr2);
            Data2^:=Data2^+(Data1^ div 20)
         until Addr1<=MemA24[0,i];

         if MemAAlpha[0,i]<>0 then begin
            Addr1:=MemAAlpha[0,i]+round(MemL24[0]/80+0.5);
            Addr2:=MemAAlpha[0,6]+round(MemL24[0]/80+0.5);
            repeat
               Addr1:=Addr1-1; DataA1:=ptr(Addr1);
               Addr2:=Addr2-1; DataA2:=ptr(Addr2);
               Check:=DataA2^+(DataA1^ div 20);
               if Check>255 then Check:=255; DataA2^:=Check;
            until Addr1<=MemAAlpha[0,i];
         end;
         First:=False;
      end;
      ChBit:=ChBit*2;
   end;
   Addr1:=MemA24[0,6];
   SampleFreq:=10000000/(Prefs.SRate*2.79365);
   TFreq:=round(((MAX24*2)/SampleFreq)*(Prefs.SubCFreq));
   IntData:=0;
   WaveMaxAmp:=1;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      if ((IntData>0) and (Data1^<=0))
      or ((IntData<0) and (Data1^>=0)) then begin
         if abs(Data1^-IntData)>TFreq then begin
            if OldTFreq*5>TFreq then TFreq:=round(TFreq*1.1)
         end else TFreq:=OldTFreq;
      end;
      if abs(Data1^-IntData)>TFreq then begin
         l:=(IntData+Data1^) div 80;
         if Data1^<IntData then Data1^:=round((l+IntData-TFreq)/1.025)
         else Data1^:=round((l+IntData+TFreq)/1.025);
      end;
      IntData:=Data1^;
      if abs(Data1^)>WaveMaxAmp then WaveMaxAmp:=abs(Data1^);
   until Addr1>=MemA24[0,6]+PlayL24[0];
   Data2^:=0;
   if WaveMaxAmp>MAX24 then PUSHWAVE(MemA24[0,6],WaveMaxAmp);
end;



procedure DOUBLESIZE(SAddr,AlphaSAddr :long;);

var Addr1,Addr2         :long;
var Data1,Data2         :^long;
var DataA1,DataA2       :^byte;
var DataAH              :byte;

begin
   if SAddr=0 then exit;
   Addr1:=SAddr+PlayL24[0]; Addr2:=SAddr+(PlayL24[0]*2);
   Data1:=ptr(Addr1);
   repeat
      Addr2:=Addr2-4;    Data2:=ptr(Addr2);
      Data2^:=Data1^;    DataH:=Data1^;
      Addr2:=Addr2-4;    Data2:=ptr(Addr2);
      Addr1:=Addr1-4;    Data1:=ptr(Addr1);
      Data2^:=(Data1^+DataH) div 2;
   until (Addr2<=SAddr+4) or (Addr1<=SAddr);
   if AlphaSAddr<>0 then begin
      Addr1:=AlphaSAddr+PlayL24[0] div 80;
      Addr2:=AlphaSAddr+PlayL24[0] div 40;
      DataA1:=ptr(Addr1);
      repeat
         Addr2:=Addr2-1;    DataA2:=ptr(Addr2);
         DataA2^:=DataA1^;  DataAH:=DataA1^;
         if Addr2>AlphaSAddr then begin
            Addr2:=Addr2-1;    DataA2:=ptr(Addr2);
            Addr1:=Addr1-1;    DataA1:=ptr(Addr1);
            DataA2^:=round(DataA1^/2+DataAH/2);
         end;
      until (Addr2<=AlphaSAddr) or (Addr1<=AlphaSAddr);
   end;
end;



procedure OPTIMIZE;

var i,DataB             :byte;
var Addr1,l,PlayLH      :long;
var Data1               :^long;
var DataA1              :^byte;


function FINDZERO(SAddr :long):long;

begin
   FINDZERO:=0;
   if SAddr=0 then exit;
   Addr1:=SAddr+PlayL24[0];
   repeat
      Addr1:=Addr1-4; Data1:=ptr(Addr1);
   until (Addr1<SAddr) or (Data1^<>0);
   FINDZERO:=Addr1-SAddr+4;
end;


begin
   WORKINFO(PText[175],2);
   if PlayL24[0]<MemL24[0] then begin
      for i:=1 to 6 do if MemA24[0,i]<>0 then begin
         Addr1:=MemA24[0,i]+PlayL24[0];
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data1^:=0;
         until Addr1>=MemA24[0,i]+MemL24[0];
      end;
   end;
   PlayLH:=4;
   for i:=1 to 6 do begin
      l:=FINDZERO(MemA24[0,i]);
      if l>PlayLH then PlayLH:=l;
   end;
   if PlayLH>4 then PlayL24[0]:=PlayLH div 8 * 8;
   if AreaA[0]>=PlayL24[0] then begin
      AreaA[0]:=0;
      AreaE[0]:=0;
   end;
   if PlayL24[0]<MemL24[0] then for i:=1 to 6 do if MemAAlpha[0,i]<>0 then begin
      Addr1:=MemAAlpha[0,i]+(PlayL24[0] div 80)-1;
      DataA1:=ptr(Addr1); Addr1:=Addr1+1;
      DataB:=DataA1^;
      while Addr1<MemAAlpha[0,i]+round(MemL24[0]/80+0.5) do begin
         DataA1:=ptr(Addr1); Addr1:=Addr1+1;
         DataA1^:=DataB
      end;
   end;
   if AreaE[0]>0 then CHECKMARK(0);
   SETSAMPLEGADS;
end;



begin  { PROCESSWAVE }
   if (MemA24[0,1] or MemA24[0,3])=0 then exit;
   if Prefs.SRate=0 then Prefs.SRate:=1;
   SFreq:=round(10000000/(Prefs.SRate*2.79365));
   if not (Action and 1=0) and not ProcessOff then begin
      PlayDataValid:=false;
      OPTIMIZE;
      WaveMaxAmp:=1;
      AlphaMaxAmp:=1;

      if DoDoubleSize then while (PlayLUNDO>=PlayL24[0]*2) and (PlayL24[0]<>0)
      and (AreaA[0]=0) and (AreaE[0]=0) and not SampleEd do begin
         ChBit:=1;   UsedChans:=0;
         for i:=1 to 5 do begin
            DOUBLESIZE(MemA24[0,i],MemAAlpha[0,i]);
            if l>1 then UsedChans:=UsedChans or ChBit;
            ChBit:=ChBit*2;
         end;
         DOUBLESIZE(MemA24[0,6],MemAAlpha[0,6]);
         SAttack[0]:=SAttack[0]*2;   SDecay[0]:=SDecay[0]*2;
         SSustain[0]:=SSustain[0]*2; SRelease[0]:=SRelease[0]*2;
         PlayL24[0]:=PlayL24[0]*2;
      end;
      DoDoubleSize:=false;

      WORKINFO(PText[177],4);

      ChBit:=1;   UsedChans:=0;
      for i:=1 to 5 do begin
         SCANWAVE(MemA24[0,i],MemAAlpha[0,i],l,b);
         if l>1 then UsedChans:=UsedChans or ChBit;
         if l>WaveMaxAmp then WaveMaxAmp:=l;
         if b>AlphaMaxAmp then AlphaMaxAmp:=b;
         ChBit:=ChBit*2;
      end;
      if (not (WaveMaxAmp in [MAX24-256..MAX24])) and (WaveMaxAmp>10) then begin
         WORKINFO(PText[178],5);
         for i:=1 to 5 do PUSHWAVE(MemA24[0,i],WaveMaxAmp);
      end;
      if AlphaMaxAmp<255 then begin
         WORKINFO(PText[178],5);
         for i:=1 to 5 do PUSHALPHA(MemAAlpha[0,i],AlphaMaxAmp);
      end;
      if ActiveMode[0]=MD_AC3 then begin
         WORKINFO(PText[174],6);
         CREATESUBWOOFER(UsedChans);
      end;
   end;
   if not (Action and 8=0) then begin
      SetAPen(MyWindow^.RPort,0); RectFill(MyWindow^.RPort,0,MyScreen^.BarHeight,pred(MyScreen^.Width),RealYPos);
      for i:=1 to 6 do DRAWWAVE(MemA24[0,i],MemAAlpha[0,i],i,0);
      if (Action=8) or not Prefs.ImmediatRender then DRAWWAVE(1,0,0,0);
      DRAWMARK(AreaA[0],AreaE[0],1);
      SETSAMPLEGADS;
   end;
   WRITETBWINDOW;
   if not (Action and 2=0) and not ProcessOff and Prefs.ImmediatRender then begin
      WORKINFO(PText[179],7);
      CALCCHANNELS(0,PlayL24[0],UsedChans);
      DRAWWAVE(1,0,0,0);
   end;
   if not (Action and $10=0) and Prefs.AutoPlay then begin
      i:=SetTaskPri(FindTask(NIL),PLAYPRIORITY);
      i:=STARTSOUND(Prefs.SRate,0,MyWindow,0,64,64);
      i:=SetTaskPri(FindTask(NIL),0);
   end;
   ProcessOff:=false;
   if Close then WORKINFO('',8);
end;



procedure RESTOREALPHA(UseChannels :byte; StartOffset,EndOffset :long);

var ChCnt,ChBit,ACtr    :byte;
var Addr1,AddrA         :long;
var Data1               :^long;
var DataA               :^byte;

begin
   ChBit:=1;
   for ChCnt:=1 to 6 do begin
      if not (UseChannels and ChBit=0) and (MemAAlpha[0,ChCnt]<>0)
      and (MemA24[0,ChCnt]<>0) then begin
         Addr1:=MemA24[0,ChCnt]+StartOffset;
         AddrA:=MemAAlpha[0,ChCnt]+(StartOffset div 80);
         ACtr:=(StartOffset mod 80)+20;
         repeat
            Data1:=ptr(Addr1);   Addr1:=Addr1+4;
            if ACtr>=20 then begin
               ACtr:=ACtr-20;
               DataA:=ptr(AddrA); AddrA:=AddrA+1;
               if DataA^=0 then DataA^:=1;
            end;
            ACtr:=ACtr+1;
            Data1^:=round(Data1^/255*DataA^);
         until Addr1>=MemA24[0,ChCnt]+EndOffset;
         AddrA:=MemAAlpha[0,ChCnt]+(StartOffset div 80);
         while AddrA<MemAAlpha[0,ChCnt]+round(EndOffset/80+0.5) do begin
            DataA:=ptr(AddrA); AddrA:=AddrA+1;
            DataA^:=255;
         end;
      end;
      ChBit:=ChBit*2;
   end;
end;



procedure REALTIMEMIXER;


var i           :byte;
var DataA       :^byte;
var FunctUsed   :boolean;


procedure GETPOSITION;

var Volume      :^byte;
var SetX,SetY   :real;
var l           :long;

begin
   PosX:=DWindow^.MouseX;   PosY:=DWindow^.MouseY;
   if PosX<DspX1 then PosX:=DspX1 else if PosX>DspX2 then PosX:=DspX2;
   if PosY<DspY1 then PosY:=DspY1 else if PosY>DspY2 then PosY:=DspY2;
   SetX:=(PosX-190)/16; SetY:=(PosY-25)/16;
   with MyChCoords^ do for i:=1 to 5 do if MemAAlpha[0,i]<>0 then begin
      if AAddr[i]<=MemAAlpha[0,i]+round(MemL24[0]/80+0.5) then begin
         Volume:=ptr(AAddr[i]);
         l:=round((20-SQRT(SQR(SetX-ChX[i])+SQR(SetY-ChY[i])))*12.5);
         if l<1 then l:=1;
         Volume^:=l;
         AAddr[i]:=AAddr[i]+25;
      end;
   end;
   Draw(DWindow^.RPort,PosX,PosY);
end;



procedure INTERPOLATE;

var FromByte,ToByte     :byte;
var MyByte              :^byte;
var Step,Stepsize       :real;

begin
   for i:=1 to 5 do if MemAAlpha[0,i]<>0 then begin
      AAddr[1]:=MemAAlpha[0,i]; AAddr[2]:=MemAAlpha[0,i]+1;
      MyByte:=ptr(AAddr[1]);
      FromByte:=MyByte^;
      repeat
         ToByte:=FromByte;
          AAddr[1]:=AAddr[1]+25; MyByte:=ptr(AAddr[1]);
         FromByte:=MyByte^;
         Stepsize:=(FromByte-ToByte)/25;
         Step:=FromByte;
         while (AAddr[2]<=AAddr[1])
         and (AAddr[1]<MemAAlpha[0,i]+round(PlayL24[0]/80+0.5)) do begin
            MyByte:=ptr(AAddr[2]); AAddr[2]:=AAddr[2]+1;
            MyByte^:=round(Step);  Step:=Step+Stepsize;
            if Step<1 then begin
               Step:=1; Stepsize:=0;
            end else if Step>255 then Step:=255;
         end;
      until (AAddr[1]>=MemAAlpha[0,i]+round(PlayL24[0]/80+0.5));
      while AAddr[2]<MemAAlpha[0,i]+round(MemL24[0]/80+0.5) do begin
         MyByte:=ptr(AAddr[2]); AAddr[2]:=AAddr[2]+1;
         MyByte^:=ToByte;
      end;
   end;
end;



procedure MAKEBOARD;

begin
   SetAPen(DWindow^.RPort,1); RectFill(DWindow^.RPort,DspX1-1,DspY1-1,DspX2-2,DspY2-2);
   if ActiveChannels[0] and CH_LEFT=CH_LEFT then     WRITE(DspX1+1,DspY1+1,2,0,DWindow^,'L');
   if ActiveChannels[0] and CH_RIGHT=CH_RIGHT then   WRITE(DspX2-1,DspY1+1,2,4,DWindow^,'R');
   if ActiveChannels[0] and CH_CENTER=CH_CENTER then WRITE((DspX1+DspX2) div 2,DspY1+1,2,2,DWindow^,'C');
   if ActiveChannels[0] and CH_SLEFT=CH_SLEFT then   WRITE(MyChCoords^.ChX[4]*16+191,DspY2-15,2,0,DWindow^,'SL');
   if ActiveChannels[0] and CH_SRIGHT=CH_SRIGHT then WRITE(DspX2-1,DspY2-15,2,4,DWindow^,'SR');
   Move(DWindow^.RPort,DspX1,DspY2);
end;



begin
   if Mode=0 then begin
      if (MemAAlpha[0,1] or MemAAlpha[0,3])=0 then begin
         if not ALLOCALPHA(0) then begin
            l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
            exit;
         end;
         ALLOCUNDO(0);
      end else begin
         l:=TASKREQUEST(PText[263],PText[264],PText[266],PText[265],PText[218]);
         if l=3 then exit
         else if l=1 then RESTOREALPHA(CH_LEFT+CH_RIGHT+CH_CENTER+CH_SLEFT+CH_SRIGHT,0,PlayL24[0]);
      end;
      if not PlayDataValid then begin
         WORKINFO(NIL,1);
         WORKINFO(PText[179],7);
         CALCCHANNELS(0,PlayL24[0],UsedChans);
         SetAPen(MyWindow^.RPort,0); RectFill(MyWindow^.RPort,0,MyScreen^.BarHeight,pred(MyScreen^.Width),RealYPos);
         for i:=1 to 6 do DRAWWAVE(MemA24[0,i],MemAAlpha[0,i],i,0);
         DRAWWAVE(1,0,0,0);
      end;
      if ActiveMode[0]=MD_QUADRO then MyChCoords:=^ChQuadro
      else if ActiveMode[0] in [MD_AC3_Sub,MD_AC3] then MyChCoords:=^ChAC3
      else MyChCoords:=^ChSurround;
      DspX1:=0; DspX2:=0;
      DspY1:=0; DspY2:=0;
      with MyChCoords^ do for i:=1 to 5 do begin
         if ChX[i]<DspX1 then DspX1:=ChX[i];
         if ChY[i]<DspY1 then DspY1:=ChY[i];
         if ChX[i]>DspX2 then DspX2:=ChX[i];
         if ChY[i]>DspY2 then DspY2:=ChY[i];
      end;
      DspX1:=DspX1*16+190; DspX2:=DspX2*16+190;
      DspY1:=DspY1*16+25;  DspY2:=DspY2*16+25;

      if not OPENDWIN(DspY2+10,0,DWindow,NIL,1,0) then exit;
      MAKEBORDER(DWindow^,DspX1-4,DspY1-3,DspX2+2,DspY2+1,NEGATIVE);
      MAKEBOARD;
      DKnopf[3]:=Gadget(NIL,DspX1,DspY1,DspX2-DspX1,DspY2-DspY1,GADGHNONE,$2,BOOLGADGET,NIL,Nil,NIL,0,Nil,3,0);
      AddGadget(DWindow,^DKnopf[3],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      FunctUsed:=true;
      repeat
         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if GadCode=3 then begin
            FunctUsed:=false;
            MAKEBOARD;
            for i:=1 to 5 do AAddr[i]:=MemAAlpha[0,i];
            GETPOSITION;
            Move(DWindow^.RPort,PosX,PosY);
            SetAPen(DWindow^.RPort,2);
            i:=SetTaskPri(FindTask(NIL),PLAYPRIORITY);
            RawCode:=STARTSOUND(Prefs.SRate,0,DWindow,1,64,64);
            i:=SetTaskPri(FindTask(NIL),0);
            INTERPOLATE;
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      PlayDataValid:=FunctUsed;
      if not LEAVEDEF(RawCode,GadCode,1,2,DWindow) and not PlayDataValid then
       for i:=1 to 5 do if MemAAlpha[0,i]<>0 then begin
         AAddr[1]:=MemAAlpha[0,i];
         repeat
            DataA:=ptr(AAddr[1]); AAddr[1]:=AAddr[1]+1;
            DataA^:=255;
         until AAddr[1]>=MemAAlpha[0,i]+round(MemL24[0]/80+0.5);
      end;
      if not PlayDataValid then begin
         WORKINFO('',1);
         PROCESSWAVE($1A,true);
      end;
   end else GETPOSITION;
end;



procedure FREEWTAFILE(FromPos,ToPos :byte);

begin
   if FromPos>ToPos then exit;
   for i:=FromPos to ToPos do with _WaveOp[i] do begin
      if (ChunkSize>=WOP_BIG) and (MemAData<>0) and (MemLData>0)
       then XFreeMem(MemAData,MemLData);
      MemAData:=0; MemLData:=0;
   end;
   OPos:=1; OEnd:=1;
end;



procedure FREESDMEMORY(MemID :byte);

var MyNextSDHeader        :^SDHeader;

begin
   while MySDHeader[MemID]<>NIL do begin
      MyNextSDHeader:=MySDHeader[MemID]^.NextSpecialData;
      XFreeMem(long(MySDHeader[MemID]),MySDHeader[MemID]^.sdh_Size);
      MySDHeader[MemID]:=MyNextSDHeader;
   end;
   MySDHeader[MemID]:=ptr(0);
end;



procedure GAMEEXIT;

begin
   DMACON_WRITE^:=$000F;
   ADKCON_WRITE^:=$000F;
   for i:=0 to 5 do FREESDMEMORY(i);
   FREEPLAYLIST;
   if FirstPattern<>NIL then XFreeMem(long(FirstPattern),sizeof(r_PlayListPattern));
   if FirstEntry<>NIL then XFreeMem(long(FirstEntry),sizeof(r_PlayListEntry));
   FREEWTAFILE(1,OEnd);
   for i:=0 to 5 do FREESOUNDMEM(i,false);
   for i:=0 to 5 do FREEUNDO(i);
   for i:=0 to 5 do FREEALPHA(i);
   CLEARPORT(PORT_WT);
   CLEARPORT(PORT_REXX);
   for i:=1 to 4 do if PlayMemA[i]<>0 then XFreeMem(PlayMemA[i],PlayMemL);
   for i:=1 to 6 do if GMem[i]<>0 then XFreeMem(GMem[i],sizeof(Plane));
   for i:=1 to 6 do if ButtonMem[i]<>0 then XFreeMem(ButtonMem[i],sizeof(ButtonPlane));
   if KnobMem<>0  then XFreeMem(KnobMem,sizeof(KnobPlane));
   if CalcMem<>0  then XFreeMem(CalcMem,sizeof(CalcPlane));
   if TextMemA<>0 then XFreeMem(TextMemA,TextMemL);
   if MemAMod>0 then   XFreeMem(MemAMod,MemLMod);
   if MemAEff<>0 then  XFreeMem(MemAEff,MemLEff);
   if scr then begin
      if MyScreen^.FirstWindow<>NIL then process_ptr^.pr_WindowPtr:=OldWindow_Ptr;
      while MyScreen^.FirstWindow<>NIL do begin
         while MyScreen^.FirstWindow^.FirstGadget<>NIL do
          RemoveGadgets(MyScreen^.FirstWindow,MyScreen^.FirstWindow^.FirstGadget);
          CloseWindow(MyScreen^.FirstWindow);
      end;
      CloseScreen(MyScreen);
   end;
end;



procedure CREATEPUBLICGADS(Offs :byte);

var ChBit,i     :byte;

begin
   Knopf[19]:=Gadget(NIL,571,IntuiWindow1^.BorderTop+41-Offs*26,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,TOGGLESELECT+$1,BOOLGADGET,^ButtonImg[1],Nil,^KnopfTx[1],0,Nil,19,0);
   Knopf[20]:=Gadget(NIL,617,IntuiWindow1^.BorderTop+41-Offs*26,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,TOGGLESELECT+$1,BOOLGADGET,^ButtonImg[1],Nil,^KnopfTx[2],0,Nil,20,0);
   Knopf[21]:=Gadget(NIL,594,IntuiWindow1^.BorderTop+41-Offs*26,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,TOGGLESELECT+$1,BOOLGADGET,^ButtonImg[1],Nil,^KnopfTx[3],0,Nil,21,0);
   Knopf[22]:=Gadget(NIL,571,IntuiWindow1^.BorderTop+54-Offs*26,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,TOGGLESELECT+$1,BOOLGADGET,^ButtonImg[1],Nil,^KnopfTx[4],0,Nil,22,0);
   Knopf[23]:=Gadget(NIL,617,IntuiWindow1^.BorderTop+54-Offs*26,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,TOGGLESELECT+$1,BOOLGADGET,^ButtonImg[1],Nil,^KnopfTx[5],0,Nil,23,0);
   Knopf[24]:=Gadget(NIL,594,IntuiWindow1^.BorderTop+54-Offs*26,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,TOGGLESELECT+$1,BOOLGADGET,^ButtonImg[1],Nil,^KnopfTx[6],0,Nil,24,0);
   for i:=1 to 7 do Knopf[i+24]:=Gadget(NIL,479+pred(i)*23,IntuiWindow1^.BorderTop+2,21,12,GADGHCOMP+GADGIMAGE,
                                        $1,BOOLGADGET,^ButtonImg[1],Nil,^KnopfTx[i+6],0,Nil,i+24,0);
   KnopfTx[1]:=IntuiText(3,1,0,7,1,^CustomTA,'L',NIL);
   KnopfTx[2]:=IntuiText(3,1,0,6,1,^CustomTA,'R',NIL);
   KnopfTx[3]:=IntuiText(3,1,0,6,1,^CustomTA,'C',NIL);
   KnopfTx[4]:=IntuiText(3,1,0,4,1,^CustomTA,'SL',NIL);
   KnopfTx[5]:=IntuiText(3,1,0,3,1,^CustomTA,'SR',NIL);
   KnopfTx[6]:=IntuiText(3,1,0,1,1,^CustomTA,'Sub',NIL);
   KnopfTx[7]:=IntuiText(3,1,0,5,0,^CustomTA,'I<',NIL);
   KnopfTx[8]:=IntuiText(3,1,0,4,0,^CustomTA,'I  I',NIL);
   KnopfTx[9]:=IntuiText(3,1,0,5,0,^CustomTA,'>I',NIL);
   KnopfTx[10]:=IntuiText(3,1,0,7,0,^CustomTA,'+',NIL);
   KnopfTx[11]:=IntuiText(3,1,0,6,1,^CustomTA,'-',NIL);
   KnopfTx[12]:=IntuiText(3,1,0,3,1,^CustomTA,'1:1',NIL);
   KnopfTx[13]:=IntuiText(3,1,0,4,1,^CustomTA,'=1',NIL);

   Knopf[32]:=Gadget(NIL,0,MyScreen^.BarHeight,MyScreen^.Width,MyScreen^.Height-SCRDIFF,GADGHNONE,$3,BOOLGADGET,NIL,Nil,NIL,0,Nil,32,0);
   MSchieber:=Gadget(NIL,2,IntuiWindow1^.BorderTop+1,476,13,GADGHCOMP,$82,PROPGADGET,
                     ^ShitData,NIL,Nil,0,^MSchieberinfo,50,0);
   MSchieberInfo:=Propinfo(FREEHORIZ+AUTOKNOB,1,0,$FFFF,0,0,0,0,0,0,0);
   ChBit:=1;
   for i:=19 to 24 do begin
      if not (ActiveChannels[0] and ChBit=0) then Knopf[i].Flags:=(Knopf[i].Flags or SELECTED) and not GADGDISABLED;
      ChBit:=ChBit*2;
   end;
end;



procedure INITSTDCOLORS;

begin
   NewColorR:=BArr32(115,  0,255,  0,255,217,178,140,
                     213,  0, 27, 37, 51,178,164, 66,
                      88,  0,104,232,121,150,195,133,
                       0,250, 45,110,  0, 10,210, 85);
   NewColorG:=BArr32(115,  0,255,200,255,217,178,140,
                     213,  0, 27, 37, 51,178,164, 66,
                      88,  0,104,232,121,150,195,133,
                     240,  0, 45,  0,150, 10,210, 85);
   NewColorB:=BArr32(170,  0,255,255,  0,  0,  0,  0,
                     251, 54, 41, 56, 70,214,202, 88,
                     109,198,133,255,150,188,235,170,
                      50, 50,100, 15,200, 10,210,160);
   for i:=0 to 31 do SetRGB32(^MyScreen^.ViewPort,i,NewColorR[i]*$1000000,NewColorG[i]*$1000000,NewColorB[i]*$1000000);
end;



function OPENINTUIWINDOW1(WHeight :word):boolean;

var LEdge,TEdge :integer;

begin
   OPENINTUIWINDOW1:=false;
   LEdge:=Prefs.WinXOffset[1]; if LEdge>MyScreen^.Width-640 then LEdge:=MyScreen^.Width-640;
   TEdge:=Prefs.WinYOffset[1]; if TEdge>MyScreen^.Height-WHeight then TEdge:=MyScreen^.Height-WHeight;
   NeuWindow:=NewWindow(LEdge,TEdge,640,WHeight,2,1,RAWKEY or GADGETDOWN or GADGETUP
                        or MENUPICK or MOUSEBUTTONS,SMART_REFRESH or WINDOWDEPTH
                        or WINDOWDRAG or ACTIVATE,NIL,NIL,PText[317],MyScreen,NIL,640,WHeight,640,WHeight,CUSTOMSCREEN);
   IntuiWindow1:=OpenWindow(^Neuwindow);
   If IntuiWindow1=Nil Then exit;
   IntuiWindow1^.BorderLeft:=2;
   IntuiWindow1^.BorderRight:=2;
   SetMenuStrip(IntuiWindow1,^MenuX[1]);
   OPENINTUIWINDOW1:=true;
end;



function OPENINTUIWINDOW2:boolean;

var LEdge,TEdge :integer;

begin
   OPENINTUIWINDOW2:=false;
   LEdge:=Prefs.WinXOffset[2]; if LEdge>MyScreen^.Width-333 then LEdge:=MyScreen^.Width-333;
   TEdge:=Prefs.WinYOffset[2]; if TEdge>MyScreen^.Height-148 then TEdge:=MyScreen^.Height-148;
   NeuWindow:=NewWindow(LEdge,TEdge,333,148,2,1,RAWKEY or GADGETDOWN or GADGETUP
                        or MENUPICK or _CLOSEWINDOW,SMART_REFRESH or WINDOWDRAG
                        or WINDOWDEPTH or WINDOWCLOSE or ACTIVATE,NIL,NIL,PText[318],MyScreen,
                        NIL,333,148,333,148,CUSTOMSCREEN);
   IntuiWindow2:=OpenWindow(^NeuWindow);
   If IntuiWindow2=Nil then exit;
   SetMenuStrip(IntuiWindow2,^MenuX[1]);

   MAKEBORDER(IntuiWindow2^,148,35,298,142,POSITIVE);
   for i:=1 to 7 do begin
      TPKnopf[i]:=Gadget(NIL,153,i*15+24,29,12,GADGHNONE,$1,BOOLGADGET,NIL,NIL,NIL,0,NIL,i,0);
      TPTextGad[i]:=Gadget(NIL,183,i*15+24,113,15,GADGHCOMP,STRINGCENTER+$1,STRGADGET,NIL,Nil,Nil,0,^TPTextInfo[i],7+i,0);
      TPTextInfo[i]:=StringInfo(^TPBuffer[i],^TPUndobuffer[i],0,30,0,0,30,0,0,0,Nil,0,Nil);
      TPBuffer[i]:=''; TPUndoBuffer[i]:=TPBuffer[i];
   end;
   WRITE(167,19,2,3,IntuiWindow2^,PText[301]);
   WRITE(238,19,2,3,IntuiWindow2^,PText[305]);

   TPSchieber:=Gadget(NIL,302,48,21,81,GADGHCOMP,$82,PROPGADGET,^SData,NIL,NIL,0,^TPSchieberInfo,100,0);
   TPSchieberInfo:=Propinfo(FREEVERT+AUTOKNOB,0,$FFFF,0,$FFFF,0,0,0,0,0,0);
   TPKnopf[8]:=Gadget(NIL,302,35,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^ButtonImg[5],NIL,NIL,0,Nil,108,0);
   TPKnopf[9]:=Gadget(NIL,302,131,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^ButtonImg[6],NIL,NIL,0,Nil,109,0);

   TPKnopf[10]:=Gadget(NIL,10,19,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[1],NIL,^TPKnopfTx[1],0,NIL,110,0);
   TPKnopfTx[1]:=IntuiText(2,1,0,1,2,^CustomTA,PText[312],NIL);
   TPKnopfTx[1].LeftEdge:=64-IntuiTextLength(^TPKnopfTx[1]) div 2;

   TPKnopf[11]:=Gadget(NIL,10,37,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[1],NIL,^TPKnopfTx[2],0,NIL,111,0);
   TPKnopfTx[2]:=IntuiText(2,1,0,1,2,^CustomTA,PText[313],NIL);
   TPKnopfTx[2].LeftEdge:=64-IntuiTextLength(^TPKnopfTx[2]) div 2;

   TPKnopf[12]:=Gadget(NIL,10,56,128,16,GADGHCOMP+GADGIMAGE,RELVERIFY+TOGGLESELECT,BOOLGADGET,^GImg[1],NIL,^TPKnopfTx[3],0,NIL,112,0);
   TPKnopfTx[3]:=IntuiText(2,1,0,1,2,^CustomTA,PText[314],NIL);
   TPKnopfTx[3].LeftEdge:=64-IntuiTextLength(^TPKnopfTx[3]) div 2;

   TPKnopf[13]:=Gadget(NIL,10,75,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[1],NIL,^TPKnopfTx[4],0,NIL,113,0);
   TPKnopfTx[4]:=IntuiText(2,1,0,1,2,^CustomTA,PText[311],NIL);
   TPKnopfTx[4].LeftEdge:=64-IntuiTextLength(^TPKnopfTx[4]) div 2;

   TPKnopf[14]:=Gadget(NIL,18,94,43,21,GADGHIMAGE+GADGIMAGE,$1,BOOLGADGET,^GImg[3],^GImg[4],NIL,0,Nil,114,0);
   TPKnopf[15]:=Gadget(NIL,82,94,43,21,GADGHIMAGE+GADGIMAGE,$1,BOOLGADGET,^GImg[3],^GImg[4],NIL,0,Nil,115,0);
   WRITE(40,116,2,3,IntuiWindow2^,PText[308]);
   WRITE(103,116,2,3,IntuiWindow2^,PText[309]);

   for i:=1 to 7 do AddGadget(IntuiWindow2,^TPTextGad[i],NIL);
   for i:=1 to 15 do AddGadget(IntuiWindow2,^TPKnopf[i],NIL);
   AddGadget(IntuiWindow2,^TPSchieber,NIL);
   RefreshGadgets(IntuiWindow2^.FirstGadget,IntuiWindow2,NIL);
   DRAWTIMEPATTERNLIST(false);
   OPENINTUIWINDOW2:=true;
end;



function OPENINTUIWINDOW4:boolean;

var LEdge,TEdge :integer;

begin
   OPENINTUIWINDOW4:=false;
   LEdge:=Prefs.WinXOffset[4]; if LEdge>MyScreen^.Width-160 then LEdge:=MyScreen^.Width-160;
   TEdge:=Prefs.WinYOffset[4]; if TEdge>MyScreen^.Height-125 then TEdge:=MyScreen^.Height-125;
   NeuWindow:=NewWindow(LEdge,TEdge,160,125,2,1,RAWKEY or GADGETDOWN or GADGETUP
                        or MENUPICK or _CLOSEWINDOW,WINDOWCLOSE or SMART_REFRESH
                        or WINDOWDRAG or WINDOWDEPTH or ACTIVATE,NIl,NIL,PText[320],MyScreen,
                        NIL,160,125,160,125,CUSTOMSCREEN);
   IntuiWindow4:=OpenWindow(^NeuWindow);
   If IntuiWindow4=Nil then exit;
   SetMenuStrip(IntuiWindow4,^MenuX[1]);
   for i:=1 to 2 do begin
      TBTextGad[i]:=Gadget(NIL,pred(i)*80+10,40,60,15,GADGHCOMP,_LONGINT+STRINGCENTER+$1,
                           STRGADGET,NIL,Nil,Nil,0,^TBTextInfo[i],i,0);
      TBTextInfo[i]:=StringInfo(^TBBuffer[i],^TBUndobuffer[i],0,14,0,0,14,0,
                           0,0,Nil,0,Nil);
      TBBuffer[i]:='0';
      UndoBuffer[i]:='0';
      MAKEBORDER(IntuiWindow4^,pred(i)*80+8,38,pred(i)*80+71,54,NEGATIVE);
      AddGadget(IntuiWindow4,^TBTextGad[i],NIL);
   end;
   TBTextGad[3]:=Gadget(NIL,50,62,60,15,GADGHCOMP,_LONGINT+STRINGCENTER+$1,
                        STRGADGET,NIL,Nil,Nil,0,^TBTextInfo[i],3,0);
   TBTextInfo[3]:=StringInfo(^TBBuffer[3],^TBUndobuffer[3],0,14,0,0,14,0,
                             0,0,Nil,0,Nil);
   TBBuffer[3]:='0'; UndoBuffer[3]:='0';
   MAKEBORDER(IntuiWindow4^,48,60,111,76,NEGATIVE);
   AddGadget(IntuiWindow4,^TBTextGad[3],NIL);
   TBKnopfTx[1]:=IntuiText(3,1,0,5,0,^CustomTA,'I<',NIL);
   TBKnopfTx[2]:=IntuiText(3,1,0,7,0,^CustomTA,'<',NIL);
   TBKnopfTx[3]:=IntuiText(3,1,0,7,0,^CustomTA,'>',NIL);
   TBKnopfTx[4]:=IntuiText(3,1,0,4,0,^CustomTA,'<0',NIL);
   TBKnopfTx[5]:=IntuiText(3,1,0,4,0,^CustomTA,'0>',NIL);
   TBKnopfTx[6]:=IntuiText(3,1,0,5,0,^CustomTA,'>I',NIL);
   for i:=1 to 5 do begin
      TBKnopf[i]:=Gadget(NIL,pred(i)*23+8,87,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,
                         $1,BOOLGADGET,^ButtonImg[1],Nil,^TBKnopfTx[i],0,Nil,i+3,0);
      AddGadget(IntuiWindow4,^TBKnopf[i],NIL);
      TBKnopf[i+5]:=Gadget(NIL,pred(i)*23+39,102,21,12,GADGHCOMP+GADGIMAGE+GADGDISABLED,
                           $1,BOOLGADGET,^ButtonImg[1],Nil,^TBKnopfTx[i+1],0,Nil,i+8,0);
      AddGadget(IntuiWindow4,^TBKnopf[i+5],NIL);
   end;

   TBKnopfTx[7]:=IntuiText(3,1,0,2,0,^CustomTA,'<-',NIL);
   TBKnopfTx[8]:=IntuiText(3,1,0,2,0,^CustomTA,'->',NIL);
   TBKnopf[11]:=Gadget(NIL,23,62,21,12,GADGHCOMP+GADGIMAGE,RELVERIFY+TOGGLESELECT
                       +$2,BOOLGADGET,^ButtonImg[1],Nil,^TBKnopfTx[7],0,Nil,14,0);
   TBKnopf[12]:=Gadget(NIL,116,62,21,12,GADGHCOMP+GADGIMAGE+SELECTED,RELVERIFY+
                       TOGGLESELECT+$2,BOOLGADGET,^ButtonImg[1],Nil,^TBKnopfTx[8],0,Nil,15,0);
   for i:=11 to 12 do AddGadget(IntuiWindow4,^TBKnopf[i],NIL);

   SetAPen(IntuiWindow4^.RPort,30); RectFill(IntuiWindow4^.RPort,21,82,138,118);
   RefreshGadgets(IntuiWindow4^.FirstGadget,IntuiWindow4,NIL);
   OPENINTUIWINDOW4:=true;
   WRITETBWINDOW;
end;



function OPENINTUIWINDOW3:boolean;

var LEdge,TEdge :integer;

begin
   OPENINTUIWINDOW3:=false;
   AnimPicPos:=-1;  CachePicPos:=-1;
   LEdge:=Prefs.WinXOffset[3]; if LEdge>MyScreen^.Width-Prefs.WinXSize then LEdge:=MyScreen^.Width-Prefs.WinXSize;
   TEdge:=Prefs.WinYOffset[3]; if TEdge>MyScreen^.Height-Prefs.WinYSize then TEdge:=MyScreen^.Height-Prefs.WinYSize;
   NeuWindow:=NewWindow(LEdge,TEdge,Prefs.WinXSize,Prefs.WinYSize,2,1,NEWSIZE
                        or _CLOSEWINDOW or GADGETUP,WINDOWCLOSE or SMART_REFRESH
                        or WINDOWDRAG or WINDOWDEPTH or WINDOWSIZING or ACTIVATE,NIl,NIL,
                        PText[319],MyScreen,NIL,184,148,400,300,CUSTOMSCREEN);
   IntuiWindow3:=OpenWindow(^NeuWindow);
   If IntuiWindow3=Nil then exit;
   if AnimPath<>'' then begin
      if SelPattern=0 then ANIMPLAY(1) else ANIMPLAY(SelPattern);
   end else begin
      INITSTDCOLORS;
      IMem:=XAllocMem(13000,MEMF_CHIP+MEMF_CLEAR);
      if IMem=0 then exit;
      FHandle:=DosOpen('WT.data',MODE_OLDFILE);
      l:=DosSeek(FHandle,IMAGE1+IMAGE2,OFFSET_BEGINNING);
      if FHandle=0 then begin
         XFreeMem(IMem,13000); exit;
      end;
      l:=DosRead(FHandle,ptr(IMem+13000-IMAGE3),IMAGE3);
      DosClose(FHandle);
      UNPACK(IMem,IMem+13000-IMAGE3,12800);
      Img:=Image(0,0,160,128,5,ptr(IMem),31,1,NIL);
      LEdge:=((Prefs.WinXSize-24) div 2)-75;
      TEdge:=((Prefs.WinYSize-20) div 2)-47;
      DrawImage(IntuiWindow3^.RPort,^Img,LEdge,TEdge);
      XFreeMem(IMem,13000); IMem:=0;
   end;
   OPENINTUIWINDOW3:=true;
end;



function MAKESAMPLEEDSCREEN:boolean;

var i   :byte;

begin
   MAKESAMPLEEDSCREEN:=false;
   if IntuiWindow1<>NIL then CloseWindow(IntuiWindow1);
   if not OPENINTUIWINDOW1(74) then exit;
   MenuX[1].Flags:=0; MenuX[2].flags:=MENUENABLED;
   IMem:=XAllocMem(12000,MEMF_CHIP+MEMF_CLEAR);
   if IMem=0 then exit;
   FHandle:=DosOpen('WT.data',MODE_OLDFILE);
   l:=DosSeek(FHandle,IMAGE1,OFFSET_BEGINNING);
   if FHandle=0 then begin
      XFreeMem(IMem,12000); exit;
   end;
   l:=DosRead(FHandle,ptr(IMem+12000-IMAGE2),IMAGE2);
   DosClose(FHandle);
   UNPACK(IMem,IMem+12000-IMAGE2,9600);
   Img:=Image(0,0,640,40,3,ptr(IMem),7,1,NIL);
   DrawImage(IntuiWindow1^.RPort,^Img,0,IntuiWindow1^.BorderTop+15);
   RefreshWindowFrame(IntuiWindow1);
   XFreeMem(IMem,12000); IMem:=0;
   for i:=1 to 3 do Knopf[i]:=Gadget(NIL,i*53-51,IntuiWindow1^.BorderTop+15,53,24,GADGHCOMP,
                                     $1,BOOLGADGET,NIL,Nil,NIL,0,Nil,i,0);
   Knopf[1].Flags:=Knopf[1].Flags or SELECTED;
   SEdMode:=1; ActBuffer:=1;
   for i:=4 to 8 do Knopf[i]:=Gadget(NIL,75+i*23,IntuiWindow1^.BorderTop+17,21,12,GADGHIMAGE+GADGIMAGE,
                                     $1,BOOLGADGET,^ButtonImg[1],^ButtonImg[4],
                                     NIL,0,Nil,i,0);
   Knopf[4].Flags:=Knopf[4].Flags or SELECTED;
   Knopf[9]:=Gadget(NIL,374,IntuiWindow1^.BorderTop+17,21,12,GADGHIMAGE+GADGIMAGE+GADGDISABLED,
                    $1,BOOLGADGET,^ButtonImg[1],^ButtonImg[4],NIL,0,Nil,9,0);

   Knopf[10]:=Gadget(NIL,283,IntuiWindow1^.BorderTop+17,40,20,GADGHCOMP,$1,BOOLGADGET,
                    NIL,NIL,NIL,0,Nil,10,0);
   Knopf[11]:=Gadget(NIL,326,IntuiWindow1^.BorderTop+17,40,20,GADGHCOMP,$1,BOOLGADGET,
                    NIL,NIL,NIL,0,Nil,11,0);
   Knopf[14]:=Gadget(NIL,407,IntuiWindow1^.BorderTop+15,53,24,GADGHCOMP,$1,BOOLGADGET,
                    NIL,NIL,NIL,0,NIL,14,0);
   Knopf[13]:=Gadget(NIL,462,IntuiWindow1^.BorderTop+15,53,24,GADGHCOMP,$1,BOOLGADGET,
                    NIL,NIL,NIL,0,NIL,13,0);
   Knopf[12]:=Gadget(NIL,517,IntuiWindow1^.BorderTop+15,53,24,GADGHCOMP,$1,BOOLGADGET,
                    NIL,NIL,NIL,0,NIL,12,0);
   CREATEPUBLICGADS(1);
   for i:=1 to 14 do AddGadget(IntuiWindow1,^Knopf[i],NIL);
   for i:=19 to 31 do AddGadget(IntuiWindow1,^Knopf[i],NIL);
   AddGadget(IntuiWindow1,^MSchieber,NIL);
   RefreshGadgets(IntuiWindow1^.FirstGadget,IntuiWindow1,NIL);
   Knopf[1].Flags:=Knopf[1].Flags and not SELECTED;
   MAKESAMPLEEDSCREEN:=true;
end;



function MAKEMAINSCREEN:boolean;

var l                   :byte;
var i                   :long;

begin
   MAKEMAINSCREEN:=false;
   if IntuiWindow1<>NIL then CloseWindow(IntuiWindow1);
   if not OPENINTUIWINDOW1(85) then exit;
   MenuX[1].Flags:=MENUENABLED; MenuX[2].flags:=0;
   IMem:=XAllocMem(12000,MEMF_CHIP+MEMF_CLEAR);
   if IMem=0 then exit;
   FHandle:=DosOpen('WT.data',MODE_OLDFILE);
   if FHandle=0 then begin
      XFreeMem(IMem,12000); exit;
   end;
   l:=DosRead(FHandle,ptr(IMem+12000-IMAGE1),IMAGE1);
   DosClose(FHandle);
   UNPACK(IMem,IMem+12000-IMAGE1,12000);
   Img:=Image(0,0,640,50,3,ptr(IMem),7,1,NIL);
   DrawImage(IntuiWindow1^.RPort,^Img,0,IntuiWindow1^.BorderTop+15);
   RefreshWindowFrame(IntuiWindow1);
   XFreeMem(IMem,12000); IMem:=0;
   for i:=1 to 12 do Knopf[i]:=Gadget(NIL,i*53-51,IntuiWindow1^.BorderTop+15,53,24,GADGHCOMP,
                                      $1,BOOLGADGET,NIL,Nil,NIL,0,Nil,i,0);
   for i:=13 to 18 do Knopf[i]:=Gadget(NIL,2+(i-13)*53,IntuiWindow1^.BorderTop+40,53,24,GADGHCOMP,
                                      $1,BOOLGADGET,NIL,Nil,NIL,0,Nil,i,0);
   Knopf[33]:=Gadget(NIL,2+(19-13)*53,IntuiWindow1^.BorderTop+40,53,24,GADGHCOMP,
                                      $1,BOOLGADGET,NIL,Nil,NIL,0,Nil,99,0);
   CREATEPUBLICGADS(0);
   for i:=1 to 31 do AddGadget(IntuiWindow1,^Knopf[i],NIL);
   AddGadget(IntuiWindow1,^Knopf[33],NIL);
   AddGadget(IntuiWindow1,^MSchieber,NIL);
   RefreshGadgets(IntuiWindow1^.FirstGadget,IntuiWindow1,NIL);
   if MyWindow^.FirstGadget=NIL then AddGadget(MyWindow,^Knopf[32],NIL);
   MAKEMAINSCREEN:=true;
end;



function OPENWTSCREEN:boolean;

type STagArr=array [1..4] of long;

var STags       :STagArr;
var MySReq      :^rtScreenModeRequester;
var inf         :p_FileInfoBlock;
var MyLock      :BPTR;
var l           :long;
var i           :byte;
var Ledge,TEdge :integer;


begin
   MenuX[1]:=Menu(^MenuX[2],10,0,150,10,0,PText[121],^Mi1[1],0,0,0,0);
      Mi1[1]:=MenuItem(^Mi1[2],0,0,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[1],NIL,'2',NIL,0);
         if MemAMod=0 then Mi1[1].flags:=Mi1[1].flags-ITEMENABLED;
      Mi1[2]:=MenuItem(^Mi1[3],0,15,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[2],NIL,'L',NIL,0);
      Mi1[3]:=MenuItem(^Mi1[4],0,30,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[3],NIL,chr(0),^SMi2[1],0);
      Mi1[4]:=MenuItem(^Mi1[5],0,45,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[4],NIL,'E',NIL,0);
      Mi1[5]:=MenuItem(^Mi1[6],0,60,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[5],NIL,'R',NIL,0);
      Mi1[6]:=MenuItem(NIL,0,75,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[6],NIL,'Q',NIL,0);

   MenuX[2]:=Menu(^MenuX[3],160,0,150,10,0,PText[128],^Mi2[1],0,0,0,0);
      Mi2[1]:=MenuItem(^Mi2[2],0,0,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[7],NIL,'1',NIL,0);
      Mi2[2]:=MenuItem(^Mi2[3],0,15,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[8],NIL,'X',NIL,0);
      Mi2[3]:=MenuItem(^Mi2[4],0,30,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[9],NIL,'C',NIL,0);
      Mi2[4]:=MenuItem(^Mi2[5],0,45,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[10],NIL,'P',NIL,0);
      Mi2[5]:=MenuItem(^Mi2[6],0,60,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[11],NIL,'M',NIL,0);
      Mi2[6]:=MenuItem(^Mi2[7],0,75,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[12],NIL,'Y',NIL,0);
      Mi2[7]:=MenuItem(^Mi2[8],0,90,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[13],NIL,'H',NIL,0);
      Mi2[8]:=MenuItem(^Mi2[9],0,105,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[14],NIL,'S',NIL,0);
      Mi2[9]:=MenuItem(NIL,0,120,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[15],NIL,chr(0),NIL,0);

   MenuX[3]:=Menu(NIL,310,0,150,10,MENUENABLED,PText[138],^Mi3[1],0,0,0,0);
      Mi3[1]:=MenuItem(^Mi3[2],0,0,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+COMMSEQ,0,^MiT[16],NIL,'?',NIL,0);
      Mi3[2]:=MenuItem(^Mi3[3],0,15,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[17],NIL,chr(0),NIL,0);
      Mi3[3]:=MenuItem(^Mi3[4],0,30,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[18],NIL,chr(0),NIL,0);
      Mi3[4]:=MenuItem(^Mi3[5],0,45,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[19],NIL,chr(0),NIL,0);
      Mi3[5]:=MenuItem(^Mi3[6],0,60,150,15,ITEMTEXT+HIGHCOMP+COMMSEQ,0,^MiT[21],NIL,'U',NIL,0);
      Mi3[6]:=MenuItem(^Mi3[7],0,78,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+CHECKIT+MENUTOGGLE,0,^MiT[22],NIL,chr(0),NIL,0);
      Mi3[7]:=MenuItem(^Mi3[8],0,93,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+CHECKIT+MENUTOGGLE,0,^MiT[23],NIL,chr(0),NIL,0);
      Mi3[8]:=MenuItem(NIL,0,108,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP+CHECKIT+MENUTOGGLE,0,^MiT[24],NIL,chr(0),NIL,0);
      for i:=1 to 3 do begin
         if Prefs.WinActive[i+1]=true then Mi3[i+5].Flags:=Mi3[i+5].Flags or CHECKED;
         MiT[21+i]:=IntuiText(2,1,0,18,0,^CustomTA,PText[317+i],NIL);
      end;

   SMi2[1]:=MenuItem(^SMi2[2],150,0,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[25],NIL,chr(0),NIL,0);
   SMi2[2]:=MenuItem(^SMi2[3],150,15,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[26],NIL,chr(0),NIL,0);
   SMi2[3]:=MenuItem(^SMi2[4],150,30,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[27],NIL,chr(0),NIL,0);
   SMi2[4]:=MenuItem(^SMi2[5],150,45,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[28],NIL,chr(0),NIL,0);
   SMi2[5]:=MenuItem(^SMi2[6],150,60,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[29],NIL,chr(0),NIL,0);
   SMi2[6]:=MenuItem(^SMi2[7],150,75,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[30],NIL,chr(0),NIL,0);
   l:=150; j:=75;
   for i:=7 to 30 do begin
      j:=j+15;
      if not (Prefs.ScrHeight>256) and (j+75>=256) then begin
         l:=l+150;
         j:=0;
      end;
      SMi2[i]:=MenuItem(^SMi2[i+1],l,j,150,15,ITEMTEXT+ITEMENABLED+HIGHCOMP,0,^MiT[i+24],NIL,chr(0),NIL,0);
   end;
   for i:=1 to 6 do MiT[i]:=IntuiText(2,1,0,5,1,^CustomTA,PText[i+121],NIL);
   MiT[3].NextText:=^SubMit;
   for i:=7 to 15 do MiT[i]:=IntuiText(2,1,0,5,1,^CustomTA,PText[i+122],NIL);
   for i:=16 to 19 do MiT[i]:=IntuiText(2,1,0,5,1,^CustomTA,PText[i+123],NIL);

   MiT[25]:=IntuiText(2,1,0,5,1,^CustomTA,'IFF-8SVX',NIL);
   MiT[26]:=IntuiText(2,1,0,5,1,^CustomTA,'(IFF-16SV)',NIL);
   MiT[27]:=IntuiText(2,1,0,5,1,^CustomTA,'IFF-16SX',NIL);
   MiT[28]:=IntuiText(2,1,0,5,1,^CustomTA,'IFF-24SX',NIL);
   MiT[29]:=IntuiText(2,1,0,5,1,^CustomTA,'RAW-Data',NIL);
   MiT[30]:=IntuiText(2,1,0,5,1,^CustomTA,'WTA-Format',^MiT[20]);

   MiT[20]:=IntuiText(2,2,0,0,9,^CustomTA,'-----------------',NIL);
   MiT[21]:=IntuiText(2,1,0,5,1,^CustomTA,PText[143],^MiT[20]);

   SubMiT:=Intuitext(2,1,0,140,0,^CustomTA,'',NIL);
   i:=1;
   inf:=ptr(XAllocMem(sizeOf(FileInfoBlock),0));
   if long(inf)<>0 then begin
      MyLock:=Lock('SAVER',-2);
      If MyLock<>0 then begin
         j:=Examine(MyLock,inf);
         If inf^.fib_DirEntryType>0 then begin
            j:=ExNext(MyLock,Inf);
            while (j<>0) and (i<25) do begin
               MenuName[i]:=inf^.fib_filename;
               if (copy(MenuName[i],length(MenuName[i])-1,2)<>'.p') and
               (copy(MenuName[i],length(MenuName[i])-6,7)<>'.backup') and
               (copy(MenuName[i],length(MenuName[i])-3,4)<>'.bak') and
               (copy(MenuName[i],length(MenuName[i])-1,2)<>'.c') and
               (copy(MenuName[i],length(MenuName[i])-1,2)<>'.o') and
               (copy(MenuName[i],length(MenuName[i])-1,2)<>'.s') and
               (copy(MenuName[i],length(MenuName[i])-4,5)<>'.mdbi') and
               (copy(MenuName[i],length(MenuName[i])-4,5)<>'.mdbg') then begin
                  MiT[i+30]:=IntuiText(2,1,0,5,1,^CustomTA,MenuName[i],NIL);
                  i:=i+1;
               end;
               j:=ExNext(MyLock,Inf);
            End;
         End
      End;
      XFreeMem(Long(inf),SizeOf(FileInfoBlock));
   end;
   SMi2[i+5].NextItem:=NIL;
   WTVersion:=WTVer;

   NeuScreen:=NewScreen(0,0,Prefs.ScrWidth,Prefs.ScrHeight,5,1,2,GENLOCK_VIDEO,CUSTOMSCREEN,^CustomTA,WTVersion,NIL,NIL);
   Pens:=PenArr(0,0,2,
                2,1,      {Window Light,Shadow}
                3,1,      {Active, WindowColor and -Text}
                0,        {Inactive, Windocolor}
                3,
                1,2,1,    {Screen Text, Block, Shadow}
                0);
   i:=0;
   repeat
      i:=i+1;
      Tags:=TagArr(SA_DisplayID,   Prefs.ScrID,
                   SA_Interleaved, _TRUE,
                   SA_Draggable,   _TRUE,
                   SA_AutoScroll,  _TRUE,
                   SA_PENS,        addr(Pens),
                   TAG_DONE,       0);
      MyScreen:=OpenScreenTagList(^NeuScreen,^Tags);
      if (MyScreen=NIL) and (Prefs.ScrID<>$29004) then Prefs.ScrID:=$29004
      else if MyScreen=NIL then begin
         MySReq:=rtAllocRequestA(RT_SCREENMODEREQ,NIL);
         if MySReq<>NIL then begin
            STags:=STagArr(RTSC_Flags,SCREQF_GUIMODES or SCREQF_SIZEGADS or SCREQF_NONSTDMODES,
                           0,0);
            if rtScreenModeRequestA(MySReq,PText[164],^STags) then begin
               Prefs.ScrID:=MySReq^.DisplayID;
               Prefs.ScrWidth:=MySReq^.DisplayWidth;
               if Prefs.ScrWidth<640 then Prefs.ScrWidth:=640;
               Prefs.ScrHeight:=MySReq^.DisplayHeight;
               if Prefs.ScrHeight<SETPREFSWINDOW+1 then Prefs.ScrHeight:=SETPREFSWINDOW+1;
            end;
            rtFreeRequest(MySReq);
         end;
      end;
   until (MyScreen<>NIL) or (i=3);
   if MyScreen=NIL then begin
      GAMEEXIT;
      OPENWTSCREEN:=false;
      exit;
   end;
   RealYPos:=MyScreen^.Height+MyScreen^.BarHeight-SCRDIFF;
   scr:=true;
   INITSTDCOLORS;
   NeuWindow:=NewWindow(0,0,MyScreen^.Width,MyScreen^.Height,2,1,RAWKEY or GADGETDOWN
                        or GADGETUP or MENUPICK or MOUSEBUTTONS,BORDERLESS or SMART_REFRESH
                        or BACKDROP,NIL,NIL,'',MyScreen,
                        NIL,MyScreen^.Width,MyScreen^.Height,MyScreen^.Width,MyScreen^.Height,CUSTOMSCREEN);
   MyWindow:=OpenWindow(^Neuwindow);
   If MyWindow=Nil Then begin
      GAMEEXIT;
      OPENWTSCREEN:=false;
      exit;
   end;
   process_ptr:=p_Process(FindTask(NIL));
   oldwindow_ptr:=process_ptr^.pr_WindowPtr;
   Process_ptr^.pr_WindowPtr:=MyWindow;
   SetMenuStrip(MyWindow,^MenuX[1]);
   if Prefs.WinActive[4] then if not OPENINTUIWINDOW4 then begin
      GAMEEXIT;
      OPENWTSCREEN:=false;
      exit;
   end;
   if Prefs.WinActive[2] then if not OPENINTUIWINDOW2 then begin
      GAMEEXIT;
      OPENWTSCREEN:=false;
      exit;
   end;
   if Prefs.WinActive[3] then if not OPENINTUIWINDOW3 then begin
      GAMEEXIT;
      OPENWTSCREEN:=false;
      exit;
   end;
   if not SampleEd then begin
      if not MAKEMAINSCREEN then begin
         GAMEEXIT;
         OPENWTSCREEN:=false;
         exit;
      end;
   end else if not MAKESAMPLEEDSCREEN then begin
      GAMEEXIT;
      OPENWTSCREEN:=false;
      exit;
   end;
   DRAWTIMEPATTERNLIST(false);
   RefreshGadgets(IntuiWindow1^.FirstGadget,IntuiWindow1,NIL);
   OPENWTSCREEN:=true;
end;



function SETPREFS:boolean;



type STagArr=array [1..4] of long;

var STags                       :STagArr;
var Langs,ActLang,ChBit         :byte;
var XRate                       :word;
var LanguageNames               :array[1..15] of string[70];
var MyVReq                      :^rtFileRequester;
var MySReq                      :^rtScreenModeRequester;
var OldTextMemA,OldTextMemL     :long;
var MySList1,MySList2,MySList3,
    MySList4,MySList5,MySList6,
    MySList7                    :SelectListGad;
var VWindow                     :^Window;
var OldPlayMethod               :byte;
var AudioChanged     :boolean;


function READLANGS:boolean;

var inf         :p_FileInfoBlock;
var MyLock      :BPTR;

Begin
   READLANGS:=true;
   Langs:=0;
   inf:=ptr(XAllocMem(sizeOf(FileInfoBlock),0));
   if long(inf)=0 then begin
      READLANGS:=false;
      exit;
   end;
   MyLock:=Lock('WTLocale',-2);
   If MyLock=0 Then READLANGS:=false Else Begin
      j:=Examine(MyLock,inf);
      If inf^.fib_DirEntryType<=0 Then READLANGS:=false Else Begin
         j:=ExNext(MyLock,Inf);
         While (j<>0) and (Langs<15) do begin
            Langs:=Langs+1;
            LanguageNames[Langs]:=inf^.fib_filename;
            j:=ExNext(MyLock,Inf)
         End;
      End
   End;
   XFreeMem(Long(inf),SizeOf(FileInfoBlock));
   if Langs=0 then READLANGS:=false;
End;



procedure DEFINEVMEM;

var DKnopf      :array [1..6] of Gadget;
var DTextGad    :Gadget;
var DTextInfo   :StringInfo;
var DBuffer     :string;

begin
   for i:=1 to 4  do DKnopf[i]:=Gadget(NIL,30,i*13+34,21,12,GADGHIMAGE+GADGIMAGE,
                                       RELVERIFY+TOGGLESELECT,BOOLGADGET,^ButtonImg[1],
                                       ^ButtonImg[2],NIL,0,Nil,i,0);
   WRITE(55,47,2,0,VWindow^,PText[335]); if Prefs.UNDOVMem   then DKnopf[1].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(55,60,2,0,VWindow^,PText[336]); {if Prefs.BufferVMem then} DKnopf[2].Flags:=GADGIMAGE+GADGHIMAGE+GADGDISABLED;
   WRITE(55,73,2,0,VWindow^,PText[337]); if Prefs.FunctVMem  then DKnopf[3].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(55,86,2,0,VWindow^,PText[338]); if Prefs.FrameCache then DKnopf[4].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   DKnopf[5]:=Gadget(NIL,500,40,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^OKKnopfTx,0,Nil,5,0);
   DKnopf[6]:=Gadget(NIL,18,108,43,21,GADGHIMAGE+GADGIMAGE,$1,BOOLGADGET,^GImg[3],^GImg[4],NIL,0,Nil,6,0);
   DTextGad:=Gadget(Nil,85,112,320,16,GADGHCOMP,STRINGCENTER,STRGADGET,NIL,Nil,Nil,0,^DTextInfo,0,0);
   DTextInfo:=StringInfo(^DBuffer,^DBuffer,0,100,0,0,0,0,0,0,Nil,0,Nil);
   DBuffer:=Prefs.VMemStr;
   MAKEBORDER(VWindow^,83,110,406,127,NEGATIVE);
   WRITE(410,113,2,0,VWindow^,PText[332]);

   for i:=1 to 6 do AddGadget(VWindow,^DKnopf[i],NIL);
   AddGadget(VWindow,^DTextGad,NIL);
   RefreshGadgets(VWindow^.FirstGadget,VWindow,NIL);
   repeat

      RawCode:=0; GadCode:=0;
      IMsg:=Wait_Port(VWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(VWindow^.UserPort);
         if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      end;

      if GadCode=6 then begin
         if DBuffer='' then DBuffer:='T:';
         FileFR:='';
         MyVReq:=rtAllocRequestA(RT_FILEREQ,NIL);
         if MyVReq<>NIL then begin
            FTags:=FTagArr(RTFI_Flags,FREQF_NOFILES,
                           RTFI_Dir,addr(DBuffer),
                           0,0);
            l:=rtChangeReqAttrA(MyVReq,^FTags);
            l:=rtFileRequestA(MyVReq,'',PText[232],^FTags);
            DBuffer:=MyVReq^.Dir;
            if not (DBuffer[length(DBuffer)] in [':','/']) then DBuffer:=DBuffer+'/';
            rtFreeRequest(MyVReq);
            RefreshGadgets(VWindow^.FirstGadget,VWindow,NIL);
         end else DisplayBeep(NIL);
      end;

   until (GadCode=5) or (RawCode=68);
   if RawCode=68 then begin
      DKnopf[5].flags:=DKnopf[5].flags+SELECTED;
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      delay(5);
   end;
   if not (DBuffer[length(DBuffer)] in [':','/']) then DBuffer:=DBuffer+'/';
   Prefs.VMemStr:=DBuffer;
   if not (DKnopf[1].flags and SELECTED=0) then Prefs.UNDOVMem:=true else Prefs.UNDOVMem:=false;
   if not (DKnopf[2].flags and SELECTED=0) then Prefs.BufferVMem:=true else Prefs.BufferVMem:=false;
   if not (DKnopf[3].flags and SELECTED=0) then Prefs.FunctVMem:=true else Prefs.FunctVMem:=false;
   if not (DKnopf[4].flags and SELECTED=0) then Prefs.FrameCache:=true else Prefs.FrameCache:=false;
   RawCode:=0; GadCode:=0;
   CloseWindow(VWindow);
end;



procedure SETCHGADS(s1,s2,First :boolean);

var i   :byte;

begin
   with Prefs do begin
      if PlayType1=3 then PlayType1:=1;
      if PlayType2=3 then PlayType2:=1;
      if not First then begin
         ChBit:=1;
         PlayCh1:=0; PlayCh2:=0;
         for i:=16 to 21 do begin
            if not (DKnopf[i].Flags and SELECTED=0) then PlayCh1:=PlayCh1+ChBit;
            if not (DKnopf[i+7].Flags and SELECTED=0) then PlayCh2:=PlayCh2+ChBit;
            ChBit:=ChBit*2;
         end;
         if ((PlayType1=1) and s1) or ((PlayType2=1) and s2) then begin
            PlayCh1:=$3F; PlayCh2:=0;
            PlayType1:=1; PlayType2:=1;
         end else if ((PlayType1=2) and s1) or ((PlayType2=2) and s2) then begin
            if not (PlayCh1 and CH_LEFT=0) then PlayCh1:=PlayCh1 or CH_RIGHT else PlayCh1:=PlayCh1 and not CH_RIGHT;
            if not (PlayCh1 and CH_SLEFT=0) then PlayCh1:=PlayCh1 or CH_SRIGHT  else PlayCh1:=PlayCh1 and not CH_SRIGHT;         
            PlayCh2:=PlayCh1 xor $3F;
            PlayType1:=2; PlayType2:=2;
         end else if (PlayType1=3) then PlayType1:=PlayType2
         else if (PlayType2=3) then PlayType2:=PlayType1;
      end;
      MySList5.SelectedGad:=PlayType1;
      MySList6.SelectedGad:=PlayType2;
      DKnopf[29].GadgetText:=^DKnopfTx[Langs+17+PlayType1]; DKnopf[29].GadgetText^.FrontPen:=2;
      DKnopf[30].GadgetText:=^DKnopfTx[Langs+17+PlayType2]; DKnopf[30].GadgetText^.FrontPen:=2;
      ChBit:=1;
      for i:=16 to 21 do begin
         if (PlayCh1 and ChBit=ChBit) then DKnopf[i].Flags:=DKnopf[i].Flags or SELECTED
          else DKnopf[i].Flags:=DKnopf[i].Flags and not SELECTED;
         if (PlayCh2 and ChBit=ChBit) then DKnopf[i+7].Flags:=DKnopf[i+7].Flags or SELECTED
          else DKnopf[i+7].Flags:=DKnopf[i+7].Flags and not SELECTED;
         if (PlayType1=1) and (PlayType2=1)
          then DKnopf[i].Flags:=DKnopf[i].Flags or GADGDISABLED
          else DKnopf[i].Flags:=DKnopf[i].Flags and not GADGDISABLED;
         if (PlayType1 in [1..2]) and (PlayType2 in [1..2])
          then DKnopf[i+7].Flags:=DKnopf[i+7].Flags or GADGDISABLED
          else DKnopf[i+7].Flags:=DKnopf[i+7].Flags and not GADGDISABLED;
         ChBit:=ChBit*2;
      end;
      if (PlayType1=2) and (PlayType2=2) then begin
         DKnopf[17].Flags:=DKnopf[17].Flags or GADGDISABLED;
         DKnopf[20].Flags:=DKnopf[20].Flags or GADGDISABLED;         
      end;
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
   end;
end;



begin
   SETPREFS:=false;
   AudioChanged:=FALSE;
   if not READLANGS then exit;
   if not OPENDWIN(SETPREFSWINDOW,1,DWindow,PText[160],0,0) then exit;
   XRate:=Prefs.SRate;
   OldPlayMethod:=Prefs.PlayMethod;
   for i:=1 to 4  do DKnopf[i]:=Gadget(NIL,30,i*13+34,21,12,GADGHIMAGE+GADGIMAGE,
                                       RELVERIFY+TOGGLESELECT,BOOLGADGET,^ButtonImg[1],
                                       ^ButtonImg[2],NIL,0,Nil,i,0);
   for i:=5 to 8  do DKnopf[i]:=Gadget(NIL,170,(i-4)*13+34,21,12,GADGHIMAGE+GADGIMAGE,
                                       RELVERIFY+TOGGLESELECT,BOOLGADGET,^ButtonImg[1],
                                       ^ButtonImg[2],NIL,0,Nil,i,0);

   WRITE(55,47,2,0,DWindow^,PText[165]);  if Prefs.Confirm  then DKnopf[1].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(55,60,2,0,DWindow^,PText[166]);  if Prefs.UseVMem  then DKnopf[2].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(55,73,2,0,DWindow^,PText[167]);  if Prefs.ShowData then DKnopf[3].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(55,86,2,0,DWindow^,PText[168]);  if Prefs.Cache    then DKnopf[4].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(196,47,2,0,DWindow^,PText[169]); if Prefs.AutoPlay then DKnopf[5].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(196,60,2,0,DWindow^,PText[170]); if Prefs.EffReq   then DKnopf[6].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(196,73,2,0,DWindow^,PText[171]); if Prefs.Raster   then DKnopf[7].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   WRITE(196,86,2,0,DWindow^,PText[172]); if Prefs.ImmediatRender then DKnopf[8].Flags:=GADGIMAGE+GADGHIMAGE+SELECTED;
   if Prefs.AutoPlay then DKnopf[8].Flags:=DKnopf[8].Flags or SELECTED or GADGDISABLED;
      { BUTTONS }
   DKnopf[9]:=Gadget(NIL,18,145,43,21,GADGHIMAGE+GADGIMAGE,$1,BOOLGADGET,^GImg[3],^GImg[4],NIL,0,Nil,9,0);
      { DISKS }
   for i:=1 to 2 do begin
      TextGad[i]:=Gadget(Nil,85,129+i*20,320,16,GADGHCOMP,STRINGCENTER,STRGADGET,NIL,Nil,Nil,0,^TextInfo[i],0,0);
      TextInfo[i]:=StringInfo(^Buffer[i],^Buffer[i],0,100,0,0,0,0,0,0,Nil,0,Nil);
      MAKEBORDER(DWindow^,83,127+i*20,406,144+i*20,NEGATIVE);
   end;
   Buffer[1]:=Prefs.SampleStr;      WRITE(415,150,2,0,DWindow^,PText[173]);
   Buffer[2]:=Prefs.CopyrightStr;   WRITE(415,170,2,0,DWindow^,'Sample-Copyright');

   for i:=16 to 21 do begin
      DKnopf[i]:=Gadget(NIL,i*21-318,195,21,12,GADGHIMAGE+GADGIMAGE,RELVERIFY+TOGGLESELECT,
                        BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,40,0);
      DKnopf[i+7]:=Gadget(NIL,i*21-318,224,21,12,GADGHIMAGE+GADGIMAGE,RELVERIFY+TOGGLESELECT,
                          BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,41,0);
   end;
   WRITE(24,210,2,0,DWindow^,CHANNELNAMES);
   WRITE(285,210,2,0,DWindow^,PText[235]);
   DKnopf[29]:=Gadget(NIL,150,195,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,^DKnopfTx[Langs+Prefs.PlayType1],0,Nil,29,0);
   DKnopf[30]:=Gadget(NIL,150,220,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,^DKnopfTx[Langs+Prefs.PlayType2],0,Nil,30,0);
   DKnopfTx[Langs+18]:=IntuiText(2,0,0,4,2,^CustomTA,'Amiga 16Bit',NIL);
   DKnopfTx[Langs+19]:=IntuiText(2,0,0,4,2,^CustomTA,'Amiga 8Bit AB/DC',NIL);
   DKnopfTx[Langs+20]:=IntuiText(2,0,0,4,2,^CustomTA,'PPC AHI-Device',NIL);
   MySList5:=SelectListGad(DWindow,^DKnopf[29],Prefs.PlayType1,0,0,0,
                           ITTArr(^DKnopfTx[Langs+18],^DKnopfTx[Langs+19],
                                  ^DKnopfTx[Langs+20],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));
   MySList6:=SelectListGad(DWindow,^DKnopf[30],Prefs.PlayType2,0,0,0,
                           ITTArr(^DKnopfTx[Langs+18],^DKnopfTx[Langs+19],
                                  ^DKnopfTx[Langs+20],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));

   if (Prefs.SubCFreq<20) then Prefs.SubCFreq:=20;
   if (Prefs.SubCFreq>80) then Prefs.SubCFreq:=80;
   WRITE(442,126,2,1,DWindow^,PText[176]);
   DKnopf[31]:=Gadget(NIL,312,124,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,^DKnopfTx[(Langs+20+(Prefs.SubCFreq div 20))],0,Nil,31,0);
   DKnopfTx[Langs+21]:=IntuiText(2,0,0,4,2,^CustomTA,'20 Hz',NIL);
   DKnopfTx[Langs+22]:=IntuiText(2,0,0,4,2,^CustomTA,'40 Hz',NIL);
   DKnopfTx[Langs+23]:=IntuiText(2,0,0,4,2,^CustomTA,'60 Hz',NIL);
   DKnopfTx[Langs+24]:=IntuiText(2,0,0,4,2,^CustomTA,'80 Hz',NIL);
   MySList7:=SelectListGad(DWindow,^DKnopf[31],Prefs.SubCFreq div 20,0,0,0,
                           ITTArr(^DKnopfTx[Langs+21],^DKnopfTx[Langs+22],
                                  ^DKnopfTx[Langs+23],^DKnopfTx[Langs+24],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));

   DKnopf[11]:=Gadget(NIL,500,40,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^OKKnopfTx,0,Nil,11,0);
   ActLang:=0;
   repeat
      ActLang:=ActLang+1;
   until (ActLang>=Langs) or (LanguageNames[ActLang]=Prefs.LocaleString);
   DKnopf[12]:=Gadget(NIL,312,44,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,^DKnopfTx[ActLang+1],0,NIL,12,0);

   MySList3:=SelectListGad(DWindow,^DKnopf[12],ActLang,0,0,0,ITTArr(NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));
   for i:=2 to Langs+1 do begin
      DKnopfTx[i]:=IntuiText(2,0,0,4,2,^CustomTA,LanguageNames[i-1],NIL);
      MySList3.ITextTag[pred(i)]:=^DKnopfTx[i];
   end;
   MySList3.ITextTag[15]:=NIL;

   DKnopf[13]:=Gadget(NIL,18,244,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[1],NIL,^DKnopfTx[Langs+2],0,NIL,13,0);
   DKnopfTx[Langs+2]:=IntuiText(2,0,0,4,2,^CustomTA,PText[162],NIL);
   DKnopfTx[Langs+2].LeftEdge:=64-IntuiTextLength(^DKnopfTx[Langs+2]) div 2;
   MAKEBORDER(DWindow^,150,244,406,258,NEGATIVE);
   s:=intstr(Prefs.ScrWidth)+' x '+intstr(Prefs.ScrHeight);
   WRITE(278,245,2,3,DWindow^,s);

   DKnopf[14]:=Gadget(NIL,312,64,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,^DKnopfTx[Langs+2+Prefs.SUnit],0,NIL,14,0);
   DKnopfTx[Langs+3]:=IntuiText(2,0,0,4,2,^CustomTA,'Samples',NIL);
   DKnopfTx[Langs+4]:=IntuiText(2,0,0,4,2,^CustomTA,'Sec',NIL);
   WRITE(442,66,2,1,DWindow^,PText[163]);
   MySList1:=SelectListGad(DWindow,^DKnopf[14],Prefs.SUnit,0,0,0,ITTArr(^DKnopfTx[Langs+3],
                             ^DKnopfTx[Langs+4],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));

   DKnopf[15]:=Gadget(NIL,312,84,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,^DKnopfTx[Langs+4+Prefs.Pegel],0,NIL,15,0);
   DKnopfTx[Langs+5]:=IntuiText(2,0,0,4,2,^CustomTA,'0',NIL);
   DKnopfTx[Langs+6]:=IntuiText(2,0,0,4,2,^CustomTA,'3 dB',NIL);
   DKnopfTx[Langs+7]:=IntuiText(2,0,0,4,2,^CustomTA,'6 dB',NIL);
   WRITE(442,86,2,1,DWindow^,PText[164]);
   MySList2:=SelectListGad(DWindow,^DKnopf[15],Prefs.Pegel,0,0,0,ITTArr(^DKnopfTx[Langs+5],
                           ^DKnopfTx[Langs+6],^DKnopfTx[Langs+7],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));

   DKnopf[22]:=Gadget(NIL,312,104,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],NIL,^DKnopfTx[Langs+7+Prefs.PlayMethod],0,NIL,22,0);
   DKnopfTx[Langs+8]:=IntuiText(2,0,0,4,2,^CustomTA,'Surround-Sound',NIL);
   DKnopfTx[Langs+9]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   1 - 1',NIL);
   DKnopfTx[Langs+10]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   1 - 2',NIL);
   DKnopfTx[Langs+11]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   1 - 3',NIL);
   DKnopfTx[Langs+12]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   2 - 1',NIL);
   DKnopfTx[Langs+13]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   2 - 2',NIL);
   DKnopfTx[Langs+14]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   2 - 3',NIL);
   DKnopfTx[Langs+15]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   3 - 1',NIL);
   DKnopfTx[Langs+16]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   3 - 2',NIL);
   DKnopfTx[Langs+17]:=IntuiText(2,0,0,4,2,^CustomTA,'SpectraFX   3 - 3',NIL);
   WRITE(442,106,2,1,DWindow^,PText[161]);
   MySList4:=SelectListGad(DWindow,^DKnopf[22],Prefs.PlayMethod,0,0,0,ITTArr(^DKnopfTx[Langs+8],
                           ^DKnopfTx[Langs +9],^DKnopfTx[Langs+10],^DKnopfTx[Langs+11],
                           ^DKnopfTx[Langs+12],^DKnopfTx[Langs+13],^DKnopfTx[Langs+14],
                           ^DKnopfTx[Langs+15],^DKnopfTx[Langs+16],^DKnopfTx[Langs+17],
                           NIL,NIL,NIL,NIL,NIL));

   for i:= 1 to  9 do AddGadget(DWindow,^DKnopf[i],NIL);
   for i:=11 to 31 do AddGadget(DWindow,^DKnopf[i],NIL);
   for i:= 1 to  2 do AddGadget(DWindow,^TextGad[i],NIL);
   SETCHGADS(TRUE,TRUE,TRUE);
   RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
   repeat

      RawCode:=0; GadCode:=0;
      IMsg:=Wait_Port(DWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(DWindow^.UserPort);
         if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      end;

      if (GadCode=2) and (DKnopf[2].Flags and SELECTED=SELECTED) then begin
         if OPENDWIN(138,32,VWindow,PText[331],0,0) then begin
            DEFINEVMEM;
            with Prefs do if not UNDOVMem and not BufferVMem
            and not FunctVMem and not FrameCache then
             DKnopf[2].Flags:=DKnopf[2].Flags and not SELECTED;
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
         end else DisplayBeep(NIL);
      end;

      if GadCode=5 then begin
         if not (DKnopf[5].Flags and SELECTED=0) then DKnopf[8].Flags:=DKnopf[8].Flags or SELECTED or GADGDISABLED;
         if (DKnopf[5].Flags and SELECTED=0) then DKnopf[8].Flags:=DKnopf[8].Flags and not GADGDISABLED;
         RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      end;

      if GadCode=13 then begin
         MySReq:=rtAllocRequestA(RT_SCREENMODEREQ,NIL);
         if MySReq<>NIL then begin
            STags:=STagArr(RTSC_Flags,SCREQF_GUIMODES or SCREQF_SIZEGADS or SCREQF_NONSTDMODES,
                           0,0);
            if rtScreenModeRequestA(MySReq,PText[164],^STags) then begin
               Prefs.ScrID:=MySReq^.DisplayID;
               Prefs.ScrWidth:=MySReq^.DisplayWidth;
               if Prefs.ScrWidth<640 then Prefs.ScrWidth:=640;
               Prefs.ScrHeight:=MySReq^.DisplayHeight;
               if Prefs.ScrHeight<SETPREFSWINDOW+1 then Prefs.ScrHeight:=SETPREFSWINDOW+1;
               SETPREFS:=true;
            end;
            rtFreeRequest(MySReq);
         end else GadCode:=0;
      end;

      if GadCode=14 then Prefs.SUnit:=DOSELECTLIST(^MySList1);
      if GadCode=15 then Prefs.Pegel:=DOSELECTLIST(^MySList2);
      if GadCode=22 then Prefs.PlayMethod:=DOSELECTLIST(^MySList4);
      if GadCode=29 then begin
         Prefs.PlayType1:=DOSELECTLIST(^MySList5);
         SETCHGADS(true,false,FALSE);
         AudioChanged:=TRUE;
      end;
      if GadCode=30 then begin
         Prefs.PlayType2:=DOSELECTLIST(^MySList6);
         SETCHGADS(false,true,FALSE);
         AudioChanged:=TRUE;
      end;
      if (GadCode=31) then Prefs.SubCFreq:=DOSELECTLIST(^MySList7)*20;
      if GadCode=40 then SETCHGADS(true,true,FALSE);
      if GadCode=41 then SETCHGADS(true,true,FALSE);

      if GadCode=12 then begin
         ActLang:=DOSELECTLIST(^MySList3);
         Prefs.LocaleString:=LanguageNames[ActLang];
         OldTextMemA:=TextMemA; TextMemA:=0;
         OldTextMemL:=TextMemL;
         if not INITLANG then begin
            TextMemA:=OldTextMemA;
            TextMemL:=OldTextMemL;
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
            DisplayBeep(NIL);
         end else begin
            XFreeMem(OldTextMemA,OldTextMemL);
            SETPREFS:=true;
            Gadcode:=13;
         end;
      end;

      if GadCode=9 then begin
         if Buffer[1]='' then Buffer[1]:='SAMPLES';
         FileFR:='';
         MyVReq:=rtAllocRequestA(RT_FILEREQ,NIL);
         if MyVReq<>NIL then begin
            FTags:=FTagArr(RTFI_Flags,FREQF_NOFILES,
                           RTFI_Dir,addr(Buffer[1]),
                           0,0);
            l:=rtChangeReqAttrA(MyVReq,^FTags);
            l:=rtFileRequestA(MyVReq,'',PText[232],^FTags);
            Buffer[1]:=MyVReq^.Dir;
            if not (Buffer[1][length(Buffer[1])] in [':','/']) then Buffer[1]:=Buffer[1]+'/';
            rtFreeRequest(MyVReq);
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
         end else DisplayBeep(NIL);
      end;

   Until (GadCode in [11,13]) or (RawCode=68);
   if RawCode=68 then begin
      DKnopf[11].flags:=DKnopf[11].flags+SELECTED;
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      delay(5);
   end;
   if not (DKnopf[1].flags and SELECTED=0) then Prefs.Confirm:=true else Prefs.Confirm:=false;
   if not (DKnopf[2].flags and SELECTED=0) then Prefs.UseVMem:=true else Prefs.UseVMem:=false;
   if not (DKnopf[3].flags and SELECTED=0) then Prefs.ShowData:=true else Prefs.ShowData:=false;
   if not (DKnopf[4].flags and SELECTED=0) then Prefs.Cache:=true else Prefs.Cache:=false;
   if not (DKnopf[5].flags and SELECTED=0) then Prefs.AutoPlay:=true else Prefs.AutoPlay:=false;
   if not (DKnopf[6].flags and SELECTED=0) then Prefs.EffReq:=true else Prefs.EffReq:=false;
   if not (DKnopf[7].flags and SELECTED=0) then Prefs.Raster:=true else Prefs.Raster:=false;
   if not (DKnopf[8].flags and SELECTED=0) then Prefs.ImmediatRender:=true else Prefs.ImmediatRender:=false;
   if Prefs.AutoPlay then Prefs.ImmediatRender:=true;
   Prefs.SampleStr:=Buffer[1];
   Prefs.CopyrightStr:=Buffer[2];
   ChBit:=1;
   Prefs.PlayCh1:=0;
   Prefs.PlayCh2:=0;
   for i:=16 to 21 do begin
      if not (DKnopf[i].Flags and SELECTED=0) then Prefs.PlayCh1:=Prefs.PlayCh1+ChBit;
      if not (DKnopf[i+7].Flags and SELECTED=0) then Prefs.PlayCh2:=Prefs.PlayCh2+ChBit;
      ChBit:=ChBit*2;
   end;
   while DWindow^.FirstGadget<>NIL do RemoveGadgets(DWindow,DWindow^.FirstGadget);
   CloseWindow(DWindow);
   Prefs.SRate:=XRate; GETNOTEPOS;
   if GadCode=13 then begin
      GETWINPOSITIONS;
      AnimPlay(-10);
      process_ptr^.pr_WindowPtr:=OldWindow_Ptr;
      if scr then begin
         while MyScreen^.FirstWindow<>NIL do begin
            while MyScreen^.FirstWindow^.FirstGadget<>NIL do
             RemoveGadgets(MyScreen^.FirstWindow,MyScreen^.FirstWindow^.FirstGadget);
             CloseWindow(MyScreen^.FirstWindow);
         end;
         CloseScreen(MyScreen);
         IntuiWindow1:=NIL;
         IntuiWindow2:=NIL;
         IntuiWindow3:=NIL;
         IntuiWindow4:=NIL;
         scr:=false;
      end;
      if not OPENWTSCREEN then DisplayBeep(NIL);
      if not Scr then SETPREFS:=false
   end;
   if Scr then begin
      if PlayDataValid and ((OldPlayMethod<>Prefs.PlayMethod) or (AudioChanged))
      and ((MemA24[0,1]<>0) or (MemA24[0,3]<>0)) then begin
         WORKINFO(NIL,1);
         WORKINFO(PText[179],7);
         CALCCHANNELS(0,PlayL24[0],UsedChans);
      end;
      PROCESSWAVE($8,true);
   end;
   GadCode:=0; RawCode:=0;
end;



procedure GETMARKOFFSET(var StartOffset,EndOffset :long);

begin
   StartOffset:=_WaveOp[OPos].WAreaA;
   EndOffset:=_WaveOp[OPos].WAreaE;
   if EndOffset=0 then EndOffset:=PlayL24[0];
   if EndOffset>MemL24[0] then EndOffset:=MemL24[0];
   if StartOffset>EndOffset then StartOffset:=EndOffset-4;
end;



function DEFINEEMPTY(UChannels :byte; WinTitle :str):short;

begin
   DEFINEEMPTY:=-1;
   if not OPENDWIN(80,0,DWindow,WinTitle,3,0) then exit;
   ACTIVECHANNELGADS(ActiveMode[0],UChannels);
   RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
   repeat

      RawCode:=0; GadCode:=0;
      IMsg:=Wait_Port(DWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(DWindow^.UserPort);
         if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      End;

   Until (GadCode in [1..2]) or (RawCode in [68,69]);
   if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEEMPTY:=GETACTIVECHANNELS(ActiveMode[0])
   else DEFINEEMPTY:=-1;
end;



function DOWAVE:boolean;

var Stepsize            :real;
var Steps,Periods       :long;
var DataS               :^string[5];
var Chunk               :string[5];
var ChID,ChBit,i        :byte;
var j                   :integer;


function MAKEWAVE(SAddr :long):boolean;

var i,j                                 :integer;
var Offset,Constant                     :real;
var Phase,stData                        :long;
var ChBit,CharID,CharCnt,BitsCnt,SaveID :byte;
var Bits                                :array [1..160] of byte;
var StartFound                          :boolean;


procedure GETCOPYRIGHT;

var CString             :string[25];
var ChCnt,BitValue      :byte;

begin
   CharID:=0;
   CString:='';
   CString[21]:=chr(0);
   for CharCnt:=1 to 20 do begin
      BitValue:=1;
      i:=0;
      for BitsCnt:=1 to 8 do begin
         CharID:=CharID+1;
         if Bits[CharID]>0 then i:=i or BitValue;
         BitValue:=BitValue*2;
      end;
      CString[CharCnt]:=chr(i);
   end;
   StartFound:=true;
   for i:=1 to 20 do if not (ord(CString[i]) in [32..127,161..255]) then StartFound:=false;
   if StartFound then l:=TASKREQUEST(CString,PText[223],NIL,PText[220],NIL);
end;



begin
   MAKEWAVE:=false;
   with _WaveOp[1] do begin
      Addr1:=SAddr;    Phase:=round(Operator[1]*Operator[3]/360);
      PlayL24[0]:=MemL24[0];
      case (OpType and not $80) of
         1: begin {*** SINUS ***}
               Stepsize:=6.2831852/Operator[1];
               Steps:=round((Operator[3]*6.283185307/360)/Stepsize);
               repeat
                  Data1:=ptr(Addr1); Addr1:=Addr1+4;
                  Data1^:=-round(8388000*sin(Stepsize*Steps));
                  Steps:=Steps+1;
               until Addr1>=SAddr+MemL24[0];
            end;
         2: begin {*** RECHTECK ***}
               Steps:=pred(Operator[1] div 2); if Steps<2 then Steps:=2;
               if Phase>0 then Periods:=Operator[2]+1 else Periods:=Operator[2];
               repeat
                  while (Phase<Steps) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=-8388000;
                  end;
                  while (Phase<Steps*2) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=8388000;
                  end;
                  Phase:=1; Periods:=Periods-1;
               until (Addr1>=SAddr+MemL24[0]) or (Periods=0);
               PlayL24[0]:=Addr1-SAddr
            end;
         3: begin {*** DREIECK ***}
               Steps:=pred(Operator[1] div 4); if Steps<2 then Steps:=2;
               Constant:=8388600/Steps;
               if Phase>0 then Periods:=Operator[2]+1 else Periods:=Operator[2];
               repeat
                  while (Phase<Steps) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=round(Constant*(-Phase));
                  end;
                  while (Phase<Steps*3) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=round(Constant*(Phase-Steps*2));
                  end;
                  while (Phase<Steps*4) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=-round(Constant*(Phase-Steps*4));
                  end;
                  Phase:=1; Periods:=Periods-1;
               until (Addr1>=SAddr+MemL24[0]) or (Periods=0);
               PlayL24[0]:=Addr1-SAddr;
            end;
         4: begin {*** d-FUNKTION ***}
               Steps:=pred(Operator[1] div 2); if Steps<2 then Steps:=2;
               if Phase>0 then Periods:=Operator[2]+1 else Periods:=Operator[2];
               repeat
                  while (Phase<Steps) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=round(8388000/Phase);
                  end;
                  while (Phase<Steps*2) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=-round(8388000/(Phase-Steps));
                  end;
                  Phase:=1; Periods:=Periods-1;
               until (Addr1>=SAddr+MemL24[0]) or (Periods=0);
               PlayL24[0]:=Addr1-SAddr;
            end;
         5: begin {*** e-FUNKTION ***}
               Steps:=pred(Operator[1] div 2); if Steps<2 then Steps:=2;
               if Phase>0 then Periods:=Operator[2]+1 else Periods:=Operator[2];
               repeat
                  while (Phase<Steps) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=8388000-round(8388000/Phase);
                  end;
                  while (Phase<Steps*2) and (Addr1<SAddr+MemL24[0]) do begin
                     Phase:=Phase+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=-8388000+round(8388000/(Phase-Steps));
                  end;
                  Phase:=1; Periods:=Periods-1;
               until (Addr1>=SAddr+MemL24[0]) or (Periods=0);
               PlayL24[0]:=Addr1-SAddr;
            end;
         6: begin {*** RAMPE AUF ***}
               l:=(Operator[1] div 2)-Phase; Constant:=16777200/Operator[1];
               repeat
                  repeat
                     l:=l-1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=round(Constant*l);
                  until (l<=-(Operator[1] div 2)) or (Addr1>=SAddr+MemL24[0]);
                  l:=Operator[1] div 2;
               until Addr1>=SAddr+MemL24[0];
            end;
         7: begin {*** RAMPE AB ***}
               l:=-(Operator[1] div 2)+Phase; Constant:=16777200/Operator[1];
               repeat
                  repeat
                     l:=l+1;
                     Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=round(Constant*l);
                  until (l>=Operator[1] div 2) or (Addr1>=SAddr+MemL24[0]);
                  l:=-(Operator[1] div 2);
               until Addr1>=SAddr+PlayL24[0];
            end;
         8: begin {*** WELLEN-MODUL ***}
               if MemAMod=0 then exit;
               FHandle:=DosOpen(OpString,MODE_OLDFILE);
               if FHandle=0 then begin
                  l:=TASKREQUEST(OpString,PText[184],NIL,PText[220],NIL);
                  exit;
               end;
               l:=DosRead(FHandle,ptr(MemAMod),MemLMod);
               DosClose(FHandle);
               ModMemInhalt:=1;
               Stepsize:=2500 / Operator[1];
               for i:=1 to Operator[2] do begin
                  Offset:=Stepsize;
                  repeat
                     Data16:=ptr(round(Offset)*2+MemAMod); Offset:=Offset+Stepsize;
                     Data1:=ptr(Addr1);                    Addr1:=Addr1+4;
                     Data1^:=(32767-Data16^)*255;
                  until (Offset>=2500);
               end;
            end;
         otherwise begin {*** 9/10:  LOADER/SAMPLE/SOFTMOD ***}
               Fhandle:=0;
               if (OpType and not $80)=9 then begin
                  FHandle:=DosOpen(OpString,MODE_OLDFILE);
                  if FHandle=0 then begin
                     l:=TASKREQUEST(OpString,PText[185],NIL,PText[220],NIL);
                     exit;
                  end;
               end;
               if (Flags=0) or ((OpType and not $80)=10) then begin
                  s:='LOADER/';
                  if (OpType and not $80)=9 then s:=s+Prefs.LoaderString
                  else if (OpType and not $80)=10 then s:=s+OpString;
                  MyWTStdMsg:=WTStdMsg(MyMsg,true,MDC_DOIT,VERSION_LOADER,MyScreen,MyWindow,Channels and ActiveChannels[0],ActiveMode[0],
                                        MemA16[0],MemA24[0],MemAUNDO[0],
                                        MemL24[0],PlayL24[0],Prefs.SRate,SAttack[0],SDecay[0],SSustain[0],SRelease[0],
                                        ^_WaveOp[1],1,OEnd,AreaA[0],AreaE[0],FHandle,
                                        ^MyWTImg,^EmptyMsgPrc,^ChSurround,^ChQuadro,^ChAC3,UsedChans,
                                        MemAAlpha[0],AlphaUNDO[0],
                                        $BADBAD,FirstPattern,FirstEntry,^MySDHeader[0],AnimPath,NIL,NIL,NIL,NIL,NIL,NIL);
                 l:=PORTCOMMUNICATION(PORT_LOADER,s,^MyWTStdMsg);
                  if l=-1 then begin
                     DosClose(FHandle);
                     exit;
                  end;
                  SETNEWWTSTATE;
                  if FHandle<>0 then DosClose(FHandle);
                  if l=MDE_ERROR then exit else if l=MDE_NOTMYFORMAT then begin
                     l:=TASKREQUEST(PText[186],PText[187],NIL,PText[220],NIL);
                     exit;
                  end;
               end else begin
                  l:=DosSeek(FHandle,0,OFFSET_BEGINNING);
                  ChBit:=1; SaveID:=0; StartFound:=false; BitsCnt:=1;
                  for i:=1 to 6 do begin
                     if not (Channels and ChBit=0) and (MemA24[0,i]<>0) then begin
                        case Flags of
                           FLAG_8:  MemLF:=Operator[1];
                           FLAG_16: MemLF:=Operator[1]*2;
                           FLAG_24: MemLF:=Operator[1]*4;
                        end;
                        if Flags<>FLAG_24 then l:=DosRead(FHandle,ptr(MemA24[0,i]+MemL24[0]-MemLF),MemLF)
                        else l:=DosRead(FHandle,ptr(MemA24[0,i]),MemLF);
                        Addr1:=MemA24[0,i];
                        l:=0;
                        case Flags of
                           FLAG_8:  begin
                                       Addr8:=MemA24[0,i]+MemL24[0]-MemLF;
                                       repeat
                                          Data8:=ptr(Addr8); Addr8:=Addr8+1;
                                          Data1:=ptr(Addr1); Addr1:=Addr1+4;
                                          Data1^:=Data8^*65530;
                                          if (SaveID=0) and (BitsCnt<161) then begin
                                             if StartFound then begin
                                                Bits[BitsCnt]:=Data8^ and $1;
                                                BitsCnt:=BitsCnt+1;
                                             end;
                                             if (Data8^ and 1=1) then StartFound:=true;
                                          end;
                                       until (Addr8>=MemA24[0,i]+MemL24[0]);
                                       MemLF:=MemLF*4;
                                    end;
                           FLAG_16: begin
                                       Addr16:=MemA24[0,i]+MemL24[0]-MemLF;
                                       repeat
                                          Data16:=ptr(Addr16); Addr16:=Addr16+2;
                                          Data1:=ptr(Addr1);   Addr1:=Addr1+4;
                                          Data1^:=Data16^*255;
                                          if (SaveID=0) and (BitsCnt<161) then begin
                                             if StartFound then begin
                                                Bits[BitsCnt]:=Data16^ and $1;
                                                BitsCnt:=BitsCnt+1;
                                             end;
                                             if (Data16^ and 1=1) then StartFound:=true;
                                          end;
                                       until (Addr16>=MemA24[0,i]+MemL24[0]);
                                       MemLF:=MemLF*2;
                                    end;
                           FLAG_24: begin
                                       Addr1:=MemA24[0,i];
                                       if SaveID=0 then repeat
                                          Data1:=ptr(Addr1); Addr1:=Addr1+4;
                                          if BitsCnt<161 then begin
                                             if StartFound then begin
                                                Bits[BitsCnt]:=Data1^ and $1;
                                                BitsCnt:=BitsCnt+1;
                                             end;
                                             if (Data1^ and 1=1) then StartFound:=true;
                                          end;
                                       until (Addr1>=MemA24[0,i]+MemLF) or (Addr1>MemA24[0,i]+672);
                                       Addr1:=MemLF+MemA24[0,i];
                                    end;
                        end;
                        SaveID:=SaveID+1;
                     end;
                     ChBit:=ChBit*2;
                  end;
                  GETCOPYRIGHT;
                  PlayL24[0]:=MemLF*Operator[2];
                  if FHandle<>0 then DosClose(FHandle);
               end;
            end;
      end;
      if (OpType and not $80) in [1..7] then WTVersion:=PText[(OpType and not $80)+1]
      else if (OpType and not $80) in [8..10] then WTVersion:=OpString;
      if (OpType and not $80) in [1,3,5] then begin
         Data1:=ptr(SAddr); stData:=Data1^;
         Addr1:=SAddr+MemL24[0];
         Data1:=ptr(Addr1);
         repeat
            Data1^:=0;
            Addr1:=Addr1-4; Data1:=ptr(Addr1);
         until (Data1^ in [stData-2000..stData+2000]) or (Addr1<=SAddr);
      end else if (OpType and not $80 in [9,10]) and (Operator[2]>1) then begin
         for j:=1 to pred(Operator[2]) do for i:=1 to 6 do if MemA24[0,i]<>0 then
          CopyMem(MemA24[0,i],MemA24[0,i]+(Operator[1]*4*j),Operator[1]*4);
         PlayL24[0]:=Operator[1]*Operator[2]*4;
      end;
   end;
   SInfo[0]:=WTVersion;
   WTVersion:=WTVer+WTVersion;
   MAKEWAVE:=true;
end;



begin
   DOWAVE:=false;
   FREEALPHA(0);
   FREESOUNDMEM(0,false);
   FREESDMEMORY(0);
   if AnimHandle<>0 then FREEOLDANIM;

   SAttack[0]:=0; SDecay[0]:=0; SSustain[0]:=0; SRelease[0]:=0;
   with _WaveOp[1] do begin
      ActiveChannels[0]:=GETCHANNELBITS(ActiveMode[0]);
      MemL24[0]:=Operator[1]*Operator[2]*4;
      if MemL24[0]<28 then MemL24[0]:=28;
      MemL24[0]:=(succ(MemL24[0] div 64)*64);
      if MemL24[0]>400000000 then MemL24[0]:=400000000;
      if not ALLOCSOUNDMEM(0,ActiveChannels[0],true,true) then exit;

      if (OpType and $80=$80) and ((MemAAlpha[0,1] or MemAAlpha[0,3])=0) then
       if not ALLOCALPHA(0) then begin
          FREESOUNDMEM(0,true); exit;
      end;

      PlayL24[0]:=Operator[1]*Operator[2]*4;
      PlayLUndo:=PlayL24[0];
      ALLOCUNDO(0);
      b:=false;
      WORKINFO(PText[102],1);

      if SoundMode=MD_MONO then begin
         ActiveChannels[0]:=Channels;
         case Channels of
            CH_LEFT:  begin
                         exchange(MemA24[0,1],MemA24[0,3]);
                         exchange(MemAAlpha[0,1],MemAAlpha[0,3]);
                      end;
            CH_RIGHT: begin
                         exchange(MemA24[0,2],MemA24[0,3]);
                         exchange(MemAAlpha[0,2],MemAAlpha[0,3]);
                      end;
            otherwise;
         end;
      end;

      ChID:=0; ChBit:=1;
      repeat
         ChID:=ChID+1;
         if (MemA24[0,ChID]<>0) and not (Channels and ChBit=0) then
          if not MAKEWAVE(MemA24[0,ChID]) then begin
            FREESOUNDMEM(0,true);
            if (MemAAlpha[0,1] or MemAAlpha[0,3])<>0 then FREEALPHA(0);
            exit;
         end;
         ChBit:=ChBit*2;
      until (ChID=6) or ((MemA24[0,ChID]<>0) and not (Channels and (ChBit div 2)=0));
      if ActiveMode[0]=MD_MONO then begin
         ActiveChannels[0]:=CH_CENTER;
         case Channels of
            CH_LEFT:  begin
                         exchange(MemA24[0,1],MemA24[0,3]);
                         exchange(MemAAlpha[0,1],MemAAlpha[0,3]);
                      end;
            CH_RIGHT: begin
                         exchange(MemA24[0,2],MemA24[0,3]);
                         exchange(MemAAlpha[0,2],MemAAlpha[0,3]);
                      end;
            otherwise;
         end;
      end;
      WORKINFO(PText[102],1);
      with _WaveOp[1] do begin
         if ((OpType and not $80)<9) and (ChID<6) then begin
            for i:=succ(ChID) to 6 do begin
               if (MemA24[0,i]<>0) and not (Channels and ChBit=0) then
                CopyMemQuick(MemA24[0,ChID],MemA24[0,i],PlayL24[0]);
               ChBit:=ChBit*2;
            end;
         end;
      end;
      ChBit:=1;
      for i:=19 to 24 do begin
         if not (ActiveChannels[0] and ChBit=0) then Knopf[i].Flags:=(Knopf[i].Flags or SELECTED) and not GADGDISABLED
          else Knopf[i].Flags:=(Knopf[i].Flags or GADGDISABLED) and not SELECTED;
         ChBit:=ChBit*2;
      end;
      Zoom[0]:=2000000000;
      DrawOffset[0]:=0;   AreaA[0]:=0;   AreaE[0]:=0;
      DOWAVE:=true;
   end;
   DoDoublesize:=true;
end;



procedure WRITELNAME;

begin
   SetAPen(DWindow^.RPort,0); RectFill(DWindow^.RPort,185,79,302,93);
   WRITE(243,81,2,3,DWindow^,Prefs.LoaderString);
end;



function ASKREADY(FName :str):boolean;

begin
   ASKREADY:=false;
   with _WaveOp[1] do begin
      ChunkSize:=WOP_NORM;
      s:='LOADER/'+FName;
      MyWTStdMsg:=WTStdMsg(MyMsg,true,MDC_ASKREADY,VERSION_LOADER,MyScreen,MyWindow,ActiveChannels[0],ActiveMode[0],
                           MemA16[0],MemA24[0],MemAUNDO[0],
                           MemL24[0],PlayL24[0],Prefs.SRate,SAttack[0],SDecay[0],SSustain[0],SRelease[0],
                           ^_WaveOp[1],1,OEnd,AreaA[0],AreaE[0],0,
                           ^MyWTImg,^EmptyMsgPrc,^ChSurround,^ChQuadro,^ChAC3,UsedChans,
                           MemAAlpha[0],AlphaUNDO[0],
                           $BADBAD,FirstPattern,FirstEntry,^MySDHeader[0],AnimPath,NIL,NIL,NIL,NIL,NIL,NIL);
     l:=PORTCOMMUNICATION(PORT_LOADER,s,^MyWTStdMsg);
      if (l in [MDE_READY,MDE_NICE_SOFTMOD]) and (l<>-1) then begin
         ASKREADY:=true;
         SETNEWWTSTATE;
         if l=MDE_NICE_SOFTMOD then begin
            ACTIVECHANNELGADS(SoundMode,Channels);
            OpType:=10;
            OpString:=Prefs.LoaderString;
            DKnopf[9].GadgetText:=^DKnopfTx[OpType];
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
         end else if (OpType=10) and (l=MDE_READY) then GadCode:=11;
      end else Prefs.LoaderString:='UNIVERSAL_IFF';
      WRITELNAME;
   end;
end;



function DEFINEWAVE(FreeWTA :boolean):boolean;

var ChID,ChBit          :byte;
var MySList1,MySList2   :SelectListGad;


procedure READSAMPLE;

type MString=text;

var MyMagicWord,DefinedMagic    :string;
var MagicFHandle                :MString;
var i                           :byte;

function DEFINEIT(FName :str):long;

begin
   with _WaveOp[1] do begin
      if FreeWTA then FREEWTAFILE(1,OEnd) else FREEWTAFILE(1,1);
      MyWTStdMsg:=WTStdMsg(MyMsg,true,MDC_DEFINEIT,VERSION_LOADER,MyScreen,MyWindow,ActiveChannels[0],ActiveMode[0],
                           MemA16[0],MemA24[0],MemAUNDO[0],
                           MemL24[0],PlayL24[0],Prefs.SRate,SAttack[0],SDecay[0],SSustain[0],SRelease[0],
                           ^_WaveOp[1],1,OEnd,AreaA[0],AreaE[0],FHandle,
                           ^MyWTImg,^EmptyMsgPrc,^ChSurround,^ChQuadro,^ChAC3,UsedChans,
                           MemAAlpha[0],AlphaUNDO[0],
                           $BADBAD,FirstPattern,FirstEntry,^MySDHeader[0],AnimPath,NIL,NIL,NIL,NIL,NIL,NIL);
      l:=PORTCOMMUNICATION(PORT_LOADER,FName,^MyWTStdMsg);
      DEFINEIT:=l;
      SETNEWWTSTATE;
      if (OpType and $80=$80) then DKnopf[20].Flags:=DKnopf[20].Flags or SELECTED;
      OpType:=OpType and not $80;
   end;
end;


begin
   with _WaveOp[1] do begin
      FRTit:=PText[237];
      if OpType=9 then PathFR:=OpString
      else if OpType in [10,11] then PathFR:=Prefs.SampleStr;
      FRShow:=''; b:=false;
      if FILEREQ then begin
         FHandle:=DosOpen(PathFR,MODE_OLDFILE);
         if FHandle=0 then begin
            l:=TASKREQUEST(PathFR,PText[189],NIL,PText[220],NIL);
            exit;
         end else begin
            s:='LOADER/'+Prefs.LoaderString;
            _WaveOp[1].OpString:=PathFR; {fr MPEG-Loader, da mpega.lib nur Filenamen akzeptiert}
            l:=DEFINEIT(s);
            if l=-1 then begin
               DosClose(FHandle);
               exit;
            end;
            if l=MDE_NOTMYFORMAT then begin
               l:=DosSeek(FHandle,0,OFFSET_BEGINNING);
               l:=DosRead(FHandle,^MyMagicWord,40);
               l:=DosSeek(FHandle,0,OFFSET_BEGINNING);
               reset(MagicFHandle,'LOADER/MagicWords.data');
               if IOResult=0 then begin
                  repeat
                     readln(MagicFHandle,DefinedMagic);
                     b:=true;
                     for i:=1 to length(DefinedMagic) do
                       if (DefinedMagic[i]<>'#') and (DefinedMagic[i]<>MyMagicWord[i]) then b:=false;
                     readln(MagicFHandle,DefinedMagic);
                  until b or eof(MagicFHandle);
                  close(MagicFHandle);
                  if b then begin
                     if ASKREADY(DefinedMagic) then begin
                        s:='LOADER/'+DefinedMagic;
                        l:=DEFINEIT(s);
                        if l=-1 then begin
                           DosClose(FHandle);
                           exit;
                        end;
                        Prefs.LoaderString:=DefinedMagic;
                        if l<>MDE_READY then b:=true else b:=false;
                     end else b:=true;
                  end else b:=true;
               end else b:=true;
            end else if l<>MDE_READY then begin
               if l=MDE_NICE_SOFTMOD then
                l:=TASKREQUEST(PText[222],PText[197],NIL,PText[219],NIL)
               else OpType:=1;
               exit;
            end;
            if not b then begin
               Channels:=MyWTStdMsg.ActiveChannels;
               if (MyWTStdMsg.ActiveMode<>SoundMode) and (MyWTStdMsg.ActiveMode>0) then begin
                  s:=PText[249]+' '+DKnopfTx[MyWTStdMsg.ActiveMode+11].IText;
                  l:=TASKREQUEST(s,PText[250],PText[220],NIL,PText[221]);
                  if l=1 then SoundMode:=MyWTStdMsg.ActiveMode
               end;
               ChBit:=1;
               for i:=1 to 6 do begin
                  if not (Channels and ChBit=0) then
                   DKnopf[i+2].flags:=DKnopf[i+2].Flags or SELECTED
                  else
                   DKnopf[i+2].flags:=DKnopf[i+2].Flags and not SELECTED;
                  ChBit:=ChBit*2;
               end;
               DKnopf[9].GadgetText:=^DKnopfTx[9];
               DKnopf[10].GadgetText:=^DKnopfTx[SoundMode+11];
               OpType:=9; OpString:=PathFR;
               Flags:=0;
            end;
         end;
         if b then begin
            l:=TASKREQUEST(PText[186],PText[188],PText[216],NIL,PText[221]);
            if l=1 then begin
               MemLF:=DosSeek(FHandle,0,OFFSET_END);
               MemLF:=DosSeek(FHandle,0,OFFSET_BEGINNING);
               m:=TASKREQUEST(PText[195],PText[196],PText[213],PText[214],PText[215]);
               Channels:=GETACTIVECHANNELS(SoundMode);
               Channels:=CHANNELREQUEST($3F,Channels,0,PText[244],l);
               ChID:=0;  ChBit:=1;
               for i:=1 to 6 do begin
                  if not (Channels and ChBit=0) then begin
                     DKnopf[i+2].flags:=DKnopf[i+2].Flags or SELECTED;
                     ChID:=ChID+1;
                  end else DKnopf[i+2].flags:=DKnopf[i+2].Flags and not SELECTED;
                  ChBit:=ChBit*2;
               end;
               if ChID=0 then ChID:=1;
               case m of
                  1: begin
                        Flags:=FLAG_8;  Operator[1]:=MemLF div ChID;
                     end;
                  2: begin
                        Flags:=FLAG_16; Operator[1]:=MemLF div 2 div ChID;
                     end;
                  3: begin
                        Flags:=FLAG_24; Operator[1]:=MemLF div 4 div ChID;
                     end;
               end;
               Channels:=CH_LEFT;
               OpType:=9;
               DKnopf[9].GadgetText:=^DKnopfTx[OpType];
               OpString:=PathFR;
            end else begin
               DosClose(FHandle); OpType:=1; exit;
            end;
         end;
         DosClose(FHandle);

         if Operator[1]>100000000 then Operator[1]:=100000000;
         if Operator[1]<4 then Operator[1]:=4;
         Operator[2]:=1;
         Operator[1]:=Operator[1] div 2;

         if Operator[1]<65536 then SchieberInfo[1].HorizPot:=Operator[1] else SchieberInfo[1].HorizPot:=65535;
         if Operator[2]<32768 then SchieberInfo[2].HorizPot:=Operator[2]*2 else SchieberInfo[2].HorizPot:=65535;
         SchieberInfo[3].HorizPot:=0;
         Buffer[1]:=intstr(Operator[1]*2);
         Buffer[2]:=intstr(Operator[2]);
         Buffer[3]:='0';
      end;
      for i:=3 to 8 do DKnopf[i].flags:=DKnopf[i].flags or GADGDISABLED;
      DKnopf[18].flags:=DKnopf[18].Flags or GADGDISABLED;
      DKnopf[19].flags:=DKnopf[19].Flags or GADGDISABLED;
      Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
      TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
   end;
   RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
end;


procedure WRITEFREQ;

var s   :string[100];

begin
   SetAPen(DWindow^.RPort,0); RectFill(DWindow^.RPort,454,107,630,120);
   SFreq:=round(10000000/(Prefs.SRate*2.79365));
   s:=PText[20]+' = '+realstr(SFreq/_WaveOp[1].Operator[1],2)+' Hz';
   WRITE(454,107,2,0,DWindow^,s);
end;


begin
   DEFINEWAVE:=false;
   if FreeWTA then FREEWTAFILE(2,OEnd);
   WTVersion:=WTVer;
   if not OPENDWIN(160,0,DWindow,PText[1],3,2) then exit;
   OPos:=1; OEnd:=1;
   _WaveOp[1].Operation:=1;
   with _WaveOp[1] do begin
      if OpType=10 then Prefs.LoaderString:=OpString;
      WAreaA:=0; WAreaE:=0;
      DKnopf[20]:=Gadget(NIL,337,81,21,12,GADGHIMAGE+GADGIMAGE,TOGGLESELECT+RELVERIFY,BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,0,0);
      WRITE(365,82,2,0,DWindow^,PText[23]);
      if (OpType and $80=$80) then DKnopf[20].Flags:=DKnopf[20].Flags or SELECTED;
      OpType:=OpType and not $80;
      MAKEBORDER(DWindow^,184,78,303,94,NEGATIVE); WRITELNAME;
      Operator[1]:=Operator[1] div 2;
      CREATEGADS(1,2,4);
      ACTIVECHANNELGADS(SoundMode,Channels);
      DKnopf[9].GadgetText:=^DKnopfTx[OpType];
      for i:=1 to 11 do DKnopfTx[i]:=IntuiText(2,0,0,4,2,^CustomTA,PText[i+1],NIL);
      MySList1:=SelectListGad(DWindow,^DKnopf[9],OpType,0,0,0,ITTArr(^DKnopfTx[1],
                              ^DKnopfTx[2],^DKnopfTx[3],^DKnopfTx[4],^DKnopfTx[5],
                              ^DKnopfTx[6],^DKnopfTx[7],NIL,NIL,NIL,NIL,
                              NIL,NIL,NIL,NIL));
      DKnopf[10].GadgetText:=^DKnopfTx[SoundMode+11];
      DKnopfTx[12]:=IntuiText(2,0,0,4,2,^CustomTA,'1.0  Mono',NIL);
      DKnopfTx[13]:=IntuiText(2,0,0,4,2,^CustomTA,'2.0  Stereo',NIL);
      DKnopfTx[14]:=IntuiText(2,0,0,4,2,^CustomTA,'3.0  3 Channel',NIL);
      DKnopfTx[15]:=IntuiText(2,0,0,4,2,^CustomTA,'4.0  Quadro',NIL);
      DKnopfTx[16]:=IntuiText(2,0,0,4,2,^CustomTA,'4.0  Surround',NIL);
      DKnopfTx[17]:=IntuiText(2,0,0,4,2,^CustomTA,'5.0',NIL);
      DKnopfTx[18]:=IntuiText(2,0,0,4,2,^CustomTA,'5.1',NIL);
      MySList2:=SelectListGad(DWindow,^DKnopf[10],SoundMode,0,0,0,ITTArr(^DKnopfTx[12],
                              ^DKnopfTx[13],^DKnopfTx[14],^DKnopfTx[15],^DKnopfTx[16],
                              ^DKnopfTx[17],^DKnopfTx[18],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));
         { SELECTLIST }
      if MemAMod=0 then DKnopf[5].flags:=GADGIMAGE+GADGDISABLED;
         { DISKGADGET  }
      DKnopf[14]:=Gadget(NIL,412,108,16,13,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^CalcImg,NIL,NIL,0,Nil,14,0);
      DKnopf[15]:=Gadget(NIL,428,108,16,13,GADGHCOMP,$1,BOOLGADGET,NIL,NIL,NIL,0,Nil,15,0);
      DKnopf[16]:=Gadget(NIL,412,125,16,13,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^CalcImg,NIL,NIL,0,Nil,16,0);
      DKnopf[17]:=Gadget(NIL,428,125,16,13,GADGHCOMP,$1,BOOLGADGET,NIL,NIL,NIL,0,Nil,17,0);
      DKnopf[18]:=Gadget(NIL,412,142,16,13,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^CalcImg,NIL,NIL,0,Nil,18,0);
      DKnopf[19]:=Gadget(NIL,428,142,16,13,GADGHCOMP,$1,BOOLGADGET,NIL,NIL,NIL,0,Nil,19,0);
         { CALCGADS }

      ChBit:=1;
      for i:=3 to 8 do begin
         if not (DKnopf[i].Flags and SELECTED=0) then
          DKnopf[i].Flags:=DKnopf[i].Flags-SELECTED;
         if (Channels and ChBit)>0 then
          DKnopf[i].Flags:=DKnopf[i].Flags or SELECTED;
         ChBit:=ChBit*2;
         if OpType=9 then DKnopf[i].flags:=DKnopf[i].flags or GADGDISABLED;
      end;
         { CHANNELGADS }
      for i:=1 to 2 do CREATEPROPGAD(10,90+(i*17),1,i,i,19,DWindow^);
      CREATEPROPGAD(10,141,Operator[3]*182,182,3,19,DWindow^);
      if Operator[1]<65536 then SchieberInfo[1].HorizPot:=Operator[1] else SchieberInfo[1].HorizPot:=65535;
      if Operator[2]<32768 then SchieberInfo[2].HorizPot:=Operator[2]*2 else SchieberInfo[2].HorizPot:=65535;
      Buffer[1]:=intstr(Operator[1]*2); Buffer[2]:=intstr(Operator[2]); Buffer[3]:=intstr(Operator[3]);

      WRITE(206,63,2,3,DWindow^,PText[10]);
      WRITE(282,63,2,3,DWindow^,PText[12]);
      WRITE(358,63,2,3,DWindow^,PText[9]);

      WRITEFREQ;
      WRITE(454,124,2,0,DWindow^,PText[21]);
      WRITE(454,141,2,0,DWindow^,PText[22]);
      if not (OpType in [1..7,10]) then begin
         DKnopf[18].flags:=DKnopf[18].Flags or GADGDISABLED;
         DKnopf[19].flags:=DKnopf[19].Flags or GADGDISABLED;
         Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
         TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
      end;
      for i:=1 to 3 do AddGadget(DWindow,^TextGad[i],NIL);
      for i:=1 to 3 do AddGadget(DWindow,^Schieber[i],NIL);
      for i:=9 to 20 do AddGadget(DWindow,^DKnopf[i],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0; b:=false;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if GadCode=9 then begin
            Channels:=GETACTIVECHANNELS(MD_AC3);
            OpType:=DOSELECTLIST(^MySList1);
            DKnopf[18].flags:=DKnopf[18].Flags and not GADGDISABLED;
            DKnopf[19].flags:=DKnopf[19].Flags and not GADGDISABLED;
            Schieber[3].flags:=Schieber[3].Flags and not GADGDISABLED;
            TextGad[3].flags:=TextGad[3].Flags and not GADGDISABLED;
            ACTIVECHANNELGADS(SoundMode,Channels);
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
            ChunkSize:=WOP_SMALL;
            if FreeWTA then FREEWTAFILE(1,OEnd) else FREEWTAFILE(1,1)
         end;

         if GadCode=10 then begin
            Channels:=GETACTIVECHANNELS(MD_AC3);
            SoundMode:=DOSELECTLIST(^MySList2);
            if OpType<>9 then ACTIVECHANNELGADS(SoundMode,Channels);
            RefreshGadgets(Dwindow^.FirstGadget,DWindow,NIL);
            if FreeWTA then FREEWTAFILE(1,OEnd) else FREEWTAFILE(1,1)
         end;


         if GadCode=12 then begin
            PathFR:='LOADER/'+Prefs.LoaderString; FRTit:=PText[236]; FRShow:='';
            if FILEREQ then begin
               FREESDMEMORY(0);
               Prefs.LoaderString:=FileFR;
               if FreeWTA then FREEWTAFILE(1,OEnd) else FREEWTAFILE(1,1);
               b:=ASKREADY(FileFR);
            end;
         end;

         if GadCode=11 then with _WaveOp[1] do begin
            FREESDMEMORY(0);
            ChunkSize:=WOP_NORM; READSAMPLE; WRITELNAME;
         end;

         if GadCode=13 then with _WaveOp[1] do begin
            PathFR:='WAVE'; FRTit:=PText[238]; FRShow:='';
            if FILEREQ then begin
               if FreeWTA then FREEWTAFILE(1,OEnd) else FREEWTAFILE(1,1);
               ChunkSize:=WOP_NORM; OpType:=8;
               Operator[1]:=1250;
               l:=50000000 div Operator[1];
               if l<Operator[2] then Operator[2]:=l;
               OpString:=PathFR;
               DKnopf[9].GadgetText:=^DKnopfTx[8];
               if Operator[1]<65536 then SchieberInfo[1].HorizPot:=Operator[1] else SchieberInfo[1].HorizPot:=65535;
               if Operator[2]<32768 then SchieberInfo[2].HorizPot:=Operator[2]*2 else SchieberInfo[2].HorizPot:=65535;
               Buffer[1]:=intstr(Operator[1]*2);
               Buffer[2]:=intstr(Operator[2]);
               for i:=14 to 17 do if not (DKnopf[i].flags and GADGDISABLED=0) then DKnopf[i].flags:=DKnopf[i].flags-GADGDISABLED;
               DKnopf[18].flags:=DKnopf[18].Flags or GADGDISABLED;
               DKnopf[19].flags:=DKnopf[19].Flags or GADGDISABLED;
               Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
               TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
               RefreshGadgets(Dwindow^.FirstGadget,DWindow,NIL);
            end;
         end;

         if (GadCode=14)  and (Operator[1]>2) then Buffer[1]:=intstr(Operator[1]);
         if (GadCode=15)  then if (Operator[1]<50000000) then Buffer[1]:=intstr(Operator[1] * 4) else Buffer[1]:='100000000';
         if (GadCode=16) and (Operator[2]>1) then Buffer[2]:=intstr(Operator[2] div 2);
         if (GadCode=17) then if (Operator[2]<25000000) then Buffer[2]:=intstr(Operator[2] * 2) else Buffer[2]:='25000000';
         if (GadCode=18) and (Operator[3]>0) then Buffer[3]:=intstr(Operator[3] div 2);
         if (GadCode=19) then if (Operator[3]<180) then Buffer[3]:=intstr(Operator[3] * 2) else Buffer[3]:='359';
         if GadCode in [14..15] then GadCode:=21;
         if GadCode in [16..17] then GadCode:=23;
         if GadCode in [18..19] then GadCode:=25;

         if (GadCode=20) or not (Schieber[1].Flags and SELECTED=0) then begin
            Operator[1]:=SchieberInfo[1].HorizPot;
            if Operator[1]<2 then Operator[1]:=2;
            if not (Operator[1]*Operator[2] in [2..50000000]) then Operator[1]:=50000000 div Operator[2];
            Buffer[1]:=intstr(Operator[1]*2);
            RefreshGadgets(^TextGad[1],DWindow,NIL);
            WRITEFREQ;
         end;
         if GadCode=21 then begin
            val(Buffer[1],Operator[1],i);
            Operator[1]:=Operator[1] div 2;
            if Operator[1]<2 then Operator[1]:=2;  if Operator[1]>50000000 then Operator[1]:=50000000;
            if not (Operator[1]*Operator[2] in [2..50000000]) then Operator[1]:=50000000 div Operator[2];
            Buffer[1]:=intstr(Operator[1]*2);
            if Operator[1]<65536 then SchieberInfo[1].HorizPot:=Operator[1] else SchieberInfo[1].HorizPot:=65535;
            RefreshGadgets(^Schieber[1],DWindow,NIL);
            WRITEFREQ;
         end;

         if (GadCode=22) or not (Schieber[2].flags and SELECTED=0) then begin
            Operator[2]:=SchieberInfo[2].HorizPot div 2;
            if Operator[2]<1 then Operator[2]:=1;
            if not (Operator[1]*Operator[2] in [2..50000000]) then Operator[2]:=50000000 div Operator[1];
            Buffer[2]:=intstr(Operator[2]);
            RefreshGadgets(^TextGad[2],DWindow,NIL);
            WRITEFREQ;
         end;
         if GadCode=23 then begin
            val(Buffer[2],Operator[2],i);
            if Operator[2]<1 then Operator[2]:=1;
            if Operator[2]>25000000 then Operator[2]:=25000000;
            if not (Operator[1]*Operator[2] in [2..50000000]) then Operator[2]:=50000000 div Operator[1];
            Buffer[2]:=intstr(Operator[2]);
            if Operator[2]<32768 then SchieberInfo[2].HorizPot:=Operator[2]*2 else SchieberInfo[2].HorizPot:=65535;
            RefreshGadgets(^Schieber[2],DWindow,NIL);
            WRITEFREQ;
         end;

         if (GadCode=24) or not (Schieber[3].flags and SELECTED=0) then begin
            Operator[3]:=SchieberInfo[3].HorizPot div 182;
            Buffer[3]:=intstr(Operator[3]);
            RefreshGadgets(^TextGad[3],DWindow,NIL);
         end;
         if GadCode=25 then begin
            val(Buffer[3],Operator[3],i);
            if Operator[3]<0 then Operator[3]:=0;  if Operator[3]>359 then Operator[3]:=359;
            Buffer[3]:=intstr(Operator[3]);
            SchieberInfo[3].HorizPot:=Operator[3]*182;
            RefreshGadgets(^Schieber[3],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if not (DKnopf[20].Flags and SELECTED=0) then OpType:=OpType or $80;
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEWAVE:=true;
      if Operator[1]<2 then Operator[1]:=2;
      Operator[1]:=Operator[1]*2;
      if Operator[2]<1 then Operator[2]:=1;
      Channels:=GETACTIVECHANNELS(SoundMode);
      if (Channels=0) and (SoundMode=MD_MONO) and (OpType and 9=9) then begin
         ChBit:=1;
         for i:=3 to 4 do begin
            if not (DKnopf[i].Flags and SELECTED=0) then Channels:=Channels+ChBit;
            ChBit:=ChBit*2;
         end;
      end;
      ActiveMode[0]:=SoundMode;
      if OpType in [1..7] then ChunkSize:=WOP_SMALL;
   end;
end;



function DOFREQ(SAddr,AlphaSAddr,StartOffset,EndOffset :long):long;

var Stepsize,Factor,Step,Constant,SSize,FreqValue,ACtrR :real;
var Offset,Steps,Addr1,Addr2,AddrA1,AddrA2,i            :long;
var ACtr1,ACtr2,Dir                                     :byte;
var DataA1,DataA2                                       :^byte;
var DataW                                               :^word;


procedure NORMALALPHA;

begin
   if ACtr1>=20 then begin
      ACtr1:=0;
      DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
      DataA2:=ptr(AddrA2);
      DataA1^:=DataA2^;
   end;
   if ACtr2>=20 then begin
      ACtr2:=0;
      DataA2:=ptr(AddrA2); AddrA2:=AddrA2+1;
      DataA1^:=DataA2^;
   end;
   ACtr1:=ACtr1+1; ACtr2:=ACtr2+Offset;
end;


begin
   with _WaveOp[OPos] do begin
      Addr1:=SAddr+StartOffset;              Addr2:=Addr1;
      AddrA1:=AlphaSAddr+StartOffset div 80; AddrA2:=AddrA1;
      ACtr1:=20;                             ACtr2:=ACtr1;
      ACtrR:=ACtr1;
      if  (OpType in [5..8]) and (Operator[2]=1) then exit;
      if (OpType in [1..4]) and (Operator[1]=Operator[2]) then begin
         repeat
            Addr1:=Addr1+4;               Data1:=ptr(Addr1);
            Addr2:=Addr2+(Operator[1]*4); Data2:=ptr(Addr2);
            Data1^:=Data2^;
            if AlphaSAddr<>0 then NORMALALPHA
         until (Addr2>=SAddr+EndOffset);
      
      end else if OpType=1 then begin {*** LINEAR ***}
         Steps:=(EndOffset-StartOffset) div abs(Operator[1]-Operator[2]);
         if Steps=0 then Steps:=1;
         Offset:=Operator[1];
         for i:=1 to abs(Operator[2]-Operator[1]) do begin
            repeat
               Addr1:=Addr1+4;        Data1:=ptr(Addr1);
               Addr2:=Addr2+(Offset*4); Data2:=ptr(Addr2);
               Data1^:=Data2^;
               if AlphaSAddr<>0 then NORMALALPHA
            until (Addr2>=SAddr+EndOffset) or (Addr2>=SAddr+StartOffset+Steps*i);
            if Operator[1]<Operator[2] then Offset:=Offset+1 else Offset:=Offset-1;
         end;

      end else if OpType=2 then begin {*** DOPPELT LINEAR ***};
         Steps:=(EndOffset-StartOffset) div 2 div abs(Operator[1]-Operator[2]);
         Offset:=Operator[1];
         i:=1; Dir:=1;
         repeat
            repeat
               Addr1:=Addr1+4;        Data1:=ptr(Addr1);
               Addr2:=Addr2+Offset*4; Data2:=ptr(addr2);
               Data1^:=Data2^;
               if AlphaSAddr<>0 then NORMALALPHA
            until (Addr2>=SAddr+EndOffset) or (Offset=0)
            or (Addr2>=SAddr+StartOffset+Steps*i);
            if Addr2>=SAddr+(StartOffset+EndOffset) div 2 then Dir:=2;
            if Dir=1 then if Operator[1]<Operator[2] then Offset:=Offset+1 else Offset:=Offset-1;
            if Dir=2 then if Operator[1]<Operator[2] then Offset:=Offset-1 else Offset:=Offset+1;
            i:=i+1;
         until (Offset=0) or (Addr2>=SAddr+EndOffset);

      end else if OpType=3 then begin {*** LINEAR SOFT ***}
         Factor:=(Operator[2]-Operator[1])/(EndOffset-StartOffset)*(Operator[1]+Operator[2])*2;
         Stepsize:=Operator[1];
         Step:=Operator[1];
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data2:=ptr(Addr2); Addr2:=SAddr+StartOffset+(round(Step)*4);
            Data1^:=Data2^;
            Step:=Step+abs(Stepsize);   Stepsize:=Stepsize+Factor;
            if AlphaSAddr<>0 then begin
               if ACtr1>=20 then begin
                  ACtr1:=0;
                  DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
                  DataA2:=ptr(AddrA2);
                  DataA1^:=DataA2^;
               end;
               if ACtrR>20 then begin
                  ACtrR:=ACtrR-20;
                  DataA2:=ptr(AddrA2); AddrA2:=AddrA2+1;
                  DataA1^:=DataA2^;
               end;
               ACtr1:=ACtr1+1; ACtrR:=ACtrR+Stepsize;
            end;
         until (Addr2>=SAddr+EndOffset) or (Addr1>=SAddr+EndOffset);

      end else if OpType=4 then begin {*** DOPPELT LINEAR SOFT ***}
         Factor:=-(Operator[1]-Operator[2])/(EndOffset-StartOffset)*(Operator[1]+Operator[2])*4;
         Stepsize:=Operator[1];
         Step:=Operator[1];
         l:=(EndOffset-StartOffset) div 2;
         Dir:=1;
         repeat
            repeat
               Data1:=ptr(Addr1); Addr1:=Addr1+4;
               Data2:=ptr(Addr2); Addr2:=SAddr+StartOffset+(round(Step)*4);
               Data1^:=Data2^;
               Step:=Step+Stepsize;   Stepsize:=Stepsize+Factor;
               if AlphaSAddr<>0 then begin
                  if ACtr1>=20 then begin
                     ACtr1:=ACtr1-20;
                     DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
                     DataA2:=ptr(AddrA2);
                     DataA1^:=DataA2^;
                  end;
                  if ACtrR>=20 then begin
                     ACtrR:=ACtrR-20;
                     DataA2:=ptr(AddrA2); AddrA2:=AddrA2+1;
                     DataA1^:=DataA2^;
                  end;
                  ACtr1:=ACtr1+1; ACtrR:=ACtrR+Stepsize;
               end;
            until (Dir=1) and ((Addr2>=SAddr+StartOffset+l) or (Addr1>SAddr+StartOffset+l))
               or (Dir=2) and ((Addr2>SAddr+EndOffset) or (Addr1>SAddr+EndOffset));
            Factor:=-Factor; Dir:=2;
         until (Addr2>=SAddr+EndOffset) or (Addr1>=SAddr+EndOffset);

      end else if OpType=5 then begin {*** SINUS-MODULATION ***}
         Stepsize:=6.2831852/Operator[3]; Steps:=1;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data2:=ptr(Addr2); Addr2:=Addr2+round((2+Operator[2]+(Operator[2]*sin(Stepsize*Steps)))/2)*4;
            Data1^:=Data2^;    Steps:=Steps+1;
            if AlphaSAddr<>0 then begin
               if ACtr1>=20 then begin
                  ACtr1:=ACtr1-20;
                  DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
                  DataA2:=ptr(AddrA2);
                  DataA1^:=DataA2^;
               end;
               if ACtr2>=20 then begin
                  ACtr2:=ACtr2-20;
                  DataA2:=ptr(AddrA2); AddrA2:=AddrA2+1;
                  DataA1^:=DataA2^;
               end;
               ACtr1:=ACtr1+1; ACtr2:=ACtr2+round((2+Operator[2]+(Operator[2]*sin(Stepsize*Steps)))/2);
            end;
         until (Addr2>=SAddr+EndOffset) or (Addr1>=SAddr+EndOffset);

      end else if OpType=6 then begin {*** DREIECK-MODULATION ***}
         Steps:=pred(Operator[3] div 2); if Steps<2 then Steps:=2;
         Constant:=succ(Operator[2])/Steps;
         repeat
            l:=1;
            while (l<Steps) and (Addr2<SAddr+EndOffset) do begin
               l:=l+1;
               Data1:=Ptr(Addr1); Addr1:=Addr1+4;
               Data2:=ptr(Addr2); Offset:=round(Constant*l); Addr2:=Addr2+Offset*4;
               Data1^:=Data2^;
               if AlphaSAddr<>0 then NORMALALPHA;
            end;
            while (l<Steps*2) and (Addr2<SAddr+EndOffset) do begin
               l:=l+1;
               Data1:=Ptr(Addr1); Addr1:=Addr1+4;
               Data2:=ptr(Addr2); Offset:=round(Constant*(Steps*2-l)); Addr2:=Addr2+Offset*4;
               Data1^:=Data2^;
               if AlphaSAddr<>0 then NORMALALPHA;
            end;
         until (Addr2>=SAddr+EndOffset) or (Addr1>=SAddr+EndOffset);

      end else if OpType=7 then begin {*** RAMPE-AUF-MODULATION ***}
         repeat
            l:=Operator[3]; Constant:=Operator[2]/Operator[3];
            repeat
               l:=l-1;
               Data1:=Ptr(Addr1); Addr1:=Addr1+4;
               Data2:=ptr(Addr2); Offset:=round(Constant*l); Addr2:=Addr2+Offset*4;
               Data1^:=Data2^;
               if AlphaSAddr<>0 then NORMALALPHA;
            until (l<=0) or (Addr2>=SAddr+EndOffset);
         until (Addr2>=SAddr+EndOffset) or (Addr1>=SAddr+EndOffset);

      end else if OpType=8 then begin {*** RAMPE-AB-MODULATION ***}
         repeat
            l:=0; Constant:=Operator[2]/Operator[3];
            repeat
               l:=l+1;
               Data1:=Ptr(Addr1); Addr1:=Addr1+4;
               Data2:=ptr(Addr2); Offset:=round(Constant*l); Addr2:=Addr2+Offset*4;
               Data1^:=Data2^;
               if AlphaSAddr<>0 then NORMALALPHA;
            until (l>=Operator[3]) or (Addr2>=SAddr+EndOffset);
         until (Addr2>=SAddr+EndOffset) or (Addr1>=SAddr+EndOffset);

      end  else if OpType=9 then begin {*** FREQ-MODUL ***}
         if MemAMod=0 then exit;
         if ModMemInhalt<>2 then begin
            FHandle:=DosOpen(OpString,MODE_OLDFILE);
            if FHandle=0 then begin
               l:=TASKREQUEST(OpString,PText[184],NIL,PText[220],NIL);
               exit;
            end;
            l:=DosRead(FHandle,ptr(MemAMod),5000);
            Addr16:=MemAMod; FreqValue:=0;
            repeat
               DataW:=ptr(Addr16); Addr16:=Addr16+2;
               FreqValue:=FreqValue+(DataW^/5957);
               DataW^:=DataW^ div 5957;
            until Addr16=MemAMod+5000;
            FreqValue:=FreqValue*6.1;
            DosClose(FHandle);
            ModMemInhalt:=2;
         end;

         SSize:=FreqValue/(EndOffset-StartOffset); Factor:=SSize;
         repeat
            DataW:=ptr(MemAMod+round(Factor)*2); Factor:=Factor+SSize;
            Addr1:=Addr1+4;                      Data1:=ptr(Addr1);
            Addr2:=Addr2+succ(DataW^)*4;         Data2:=ptr(Addr2);
            Data1^:=Data2^;
            if AlphaSAddr<>0 then begin
               if ACtr1>=20 then begin
                  ACtr1:=ACtr1-20;
                  DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
                  DataA2:=ptr(AddrA2);
                  DataA1^:=DataA2^;
               end;
               if ACtrR>=20 then begin
                  ACtrR:=ACtrR-20;
                  DataA2:=ptr(AddrA2); AddrA2:=AddrA2+1;
                  DataA1^:=DataA2^;
               end;
               ACtr1:=ACtr1+1; ACtrR:=ACtrR+DataW^+1
            end;
         until (Addr1>=SAddr+EndOffset) or (Addr2>=SAddr+EndOffset) or (Factor>=2500);
      end else DisplayBeep(NIL);
      if AreaE[0]<>0 then AreaE[0]:=Addr1-SAddr;

      DOFREQ:=Addr1-SAddr;
      if Addr1<SAddr+PlayL24[0] then begin
         CopyMemQuick(SAddr+EndOffset,Addr1,abs(PlayL24[0]-EndOffset));
         if AlphaSAddr<>0 then CopyMem(AlphaSAddr+EndOffset div 80,AddrA1,round(abs(PlayL24[0]-EndOffset)/80+0.5));
         Addr1:=Addr1+abs(PlayL24[0]-EndOffset);
         AddrA1:=AddrA1+abs(PlayL24[0]-EndOffset) div 80;
      end;
      while Addr1<SAddr+PlayL24[0] do begin
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         Data1^:=0;
      end;
      while (AlphaSAddr<>0) and (AddrA1<AlphaSAddr+round(MemL24[0]/80+0.5)) do begin
         DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
         DataA1^:=1;
      end;
   end;
   DoDoubleSize:=true;
end;



function DEFINEFREQ:boolean;

var s           :string[8];
var MySList     :SelectListGad;

procedure DRAWGRAPH;

const x=270;
const y=79;

var StepLength  :real;
var i,j,k,l,m   :integer;

begin
   with _WaveOp[OPos] do begin
      SetAPen(DWindow^.RPort,0);
      RectFill(DWindow^.RPort,x,y-38,x+160,y-6);
      if Optype in [1..2] then begin
         if Optype=1 then begin
            StepLength:=160/(abs(Operator[1]-Operator[2])+1); l:=1;
         end else begin
            StepLength:=80/(abs(Operator[1]-Operator[2])+1);    l:=2;
         end;
         i:=Operator[1]; if Operator[1]>Operator[2] then j:=-1 else j:=1;
         k:=1;
         for m:=1 to l do begin
            repeat
               DRAWLINE(DWindow^,x+round(pred(k)*StepLength),y-i*3-7,x+round(k*StepLength),y-i*3-7,3);
               if (i<>Operator[2]) and (l=1) then i:=i+j
               else if (l=2) then i:=i+j;
               k:=k+1;
            until (i in [Operator[1],Operator[2]]) or (Operator[1]=Operator[2]);
            j:=-j;
            if Operator[1]<>Operator[2] then begin
               DRAWLINE(DWindow^,x+round(pred(k)*StepLength),y-i*3-7,x+round(k*StepLength),y-i*3-7,3);
               k:=k+1;
            end else i:=i+j
         end;
      end else if OpType=3 then DRAWLINE(DWindow^,x,y-Operator[1]*3-7,x+160,y-Operator[2]*3-7,3)
      else if OpType=4 then begin
         DRAWLINE(DWindow^,x,y-Operator[1]*3-7,x+80,y-Operator[2]*3-7,3);
         DRAWLINE(DWindow^,x+80,y-Operator[2]*3-7,x+160,y-Operator[1]*3-7,3);
      end else if OpType in [5..8] then begin
         DrawImage(DWindow^.RPort,^GImg[6],320,42);
         s:=intstr(Operator[2])+"-fach";
         WRITE(350,63,2,3,DWindow^,s);
      end else if OpType=9 then DRAWIMAGE(DWindow^.RPort,^GImg[3],328,46);
   end;
end;


begin
   DEFINEFREQ:=false;
   if not OPENDWIN(147,0,DWindow,PText[26],3,1) then exit;
   _WaveOp[Opos].Operation:=2;
   with _WaveOp[OPos] do begin
      MAKEBORDER(DWINDOW^,268,40,432,74,NEGATIVE);
      CREATEGADS(1,1,1);
      ACTIVECHANNELGADS(ActiveMode[0],Channels);
      DKnopf[9].GadgetText:=^DKnopfTx[OpType];
         { SELECTLISTEN }
      if MemAMod=0 then DKnopf[2].flags:=GADGIMAGE+GADGDISABLED;
         { DISKGADGET  }
      for i:=1 to 2 do CREATEPROPGAD(10,77+(17*i),pred(Operator[i])*7281,6553,i,10,DWindow^);
      CREATEPROPGAD(10,128,Operator[3] div 2,1,3,10,DWindow^);
      Buffer[1]:=intstr(Operator[1]); Buffer[2]:=intstr(Operator[2]); Buffer[3]:=intstr(Operator[3]);

      for i:=1 to 8 do DKnopfTx[i]:=IntuiText(2,0,0,4,2,^CustomTA,PText[i+26],NIL);
      MySList:=SelectListGad(DWindow,^DKnopf[9],OpType,0,0,0,ITTArr(^DKnopfTx[1],
                             ^DKnopfTx[2],^DKnopfTx[3],^DKnopfTx[4],^DKnopfTx[5],
                             ^DKnopfTx[6],^DKnopfTx[7],^DKnopfTx[8],NIL,NIL,NIL,NIL,NIL,NIL,NIL));
      DKnopfTx[5].IText:=PText[2]; DKnopfTx[6].IText:=PText[4];
      DKnopfTx[7].IText:=PText[7]; DKnopfTx[8].IText:=PText[8];
      DKnopfTx[9]:=IntuiText(2,0,0,4,2,^CustomTA,PText[31],NIL);

      WRITE(206,63,2,3,DWindow^,PText[31]);
      WRITE(414,95,2,0,DWindow^,PText[32]);
      WRITE(414,113,2,0,DWindow^,PText[33]);
      WRITE(414,131,2,0,DWindow^,PText[34]);
      if OpType in [5..8] then begin
         Schieber[1].flags:=Schieber[1].Flags or GADGDISABLED;
         TextGad[1].flags:=TextGad[1].Flags or GADGDISABLED;
      end else begin
         Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
         TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
      end;
      for i:=1 to 3 do AddGadget(DWindow,^TextGad[i],NIL);
      for i:=1 to 3 do AddGadget(DWindow,^Schieber[i],NIL);
      for i:=9 to 10 do AddGadget(DWindow,^DKnopf[i],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      DRAWGRAPH;
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if GadCode=9 then begin
            OpType:=DOSELECTLIST(^MySList);
            if OpType in [5..8] then begin
               Schieber[1].flags:=Schieber[1].Flags or GADGDISABLED;
               TextGad[1].flags:=TextGad[1].Flags or GADGDISABLED;
               Schieber[3].flags:=Schieber[3].Flags and not GADGDISABLED;
               TextGad[3].flags:=TextGad[3].Flags and not GADGDISABLED;
            end else begin
               Schieber[1].flags:=Schieber[1].Flags and not GADGDISABLED;
               TextGad[1].flags:=TextGad[1].Flags and not GADGDISABLED;
               Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
               TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
            end;
            RefreshGadgets(Dwindow^.FirstGadget,DWindow,NIL);
            DRAWGRAPH;
         end;

         if GadCode=10 then with _WaveOp[OPos] do begin
            FRTit:=PText[238]; PathFR:='FREQ'; FRShow:='';
            if FILEREQ then begin
               ChunkSize:=WOP_NORM;
               OpString:=PathFR;
               OpType:=9;
               DKnopf[9].GadgetText:=^DKnopfTx[9];
               Schieber[1].flags:=Schieber[1].Flags and not GADGDISABLED;
               TextGad[1].flags:=TextGad[1].Flags and not GADGDISABLED;
               Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
               TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
            end;
            RefreshGadgets(Dwindow^.FirstGadget,DWindow,NIL);
            DRAWGRAPH;
         end;

         if (GadCode=11) or not (Schieber[1].flags and SELECTED=0) then begin
            Operator[1]:=succ(SchieberInfo[1].HorizPot div 7281);
            Buffer[1]:=intstr(Operator[1]);
            RefreshGadgets(^TextGad[1],DWindow,NIL);
            DRAWGRAPH;
         end;
         if GadCode=12 then begin
            val(Buffer[1],Operator[1],i);
            if Operator[1]<1 then Operator[1]:=1;
            if Operator[1]>10 then Operator[1]:=10;
            Buffer[1]:=intstr(Operator[1]);
            SchieberInfo[1].HorizPot:=pred(Operator[1])*7281;
            RefreshGadgets(^Schieber[1],DWindow,NIL);
            DRAWGRAPH;
         end;

         if (GadCode=13) or not (Schieber[2].flags and SELECTED=0) then begin
            Operator[2]:=succ(SchieberInfo[2].HorizPot div 7281);
            Buffer[2]:=intstr(Operator[2]);
            RefreshGadgets(^TextGad[2],DWindow,NIL);
            DRAWGRAPH;
         end;
         if GadCode=14 then begin
            val(Buffer[2],Operator[2],i);
            if Operator[2]<1 then Operator[2]:=1;
            if Operator[2]>10 then Operator[2]:=10;
            Buffer[2]:=intstr(Operator[2]);
            SchieberInfo[2].HorizPot:=pred(Operator[2])*7281;
            RefreshGadgets(^Schieber[2],DWindow,NIL);
            DRAWGRAPH;
         end;

         if (GadCode=15) or not (Schieber[3].flags and SELECTED=0) then begin
            Operator[3]:=SchieberInfo[3].HorizPot*2;
            if Operator[3]<1 then Operator[3]:=1; if Operator[3]>131068 then Operator[3]:=131068;
            Buffer[3]:=intstr(Operator[3]);
            RefreshGadgets(^TextGad[3],DWindow,NIL);
         end;
         if GadCode=16 then begin
            val(Buffer[3],Operator[3],i);
            if Operator[3]<1 then Operator[3]:=1; if Operator[3]>131068 then Operator[3]:=131068;
            Buffer[3]:=intstr(Operator[3]);
            SchieberInfo[3].HorizPot:=Operator[3] div 2;
            RefreshGadgets(^Schieber[3],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEFREQ:=true;
      Channels:=GETACTIVECHANNELS(ActiveMode[0]);
      SoundMode:=ActiveMode[0];
      if OpType in [1..8] then ChunkSize:=WOP_SMALL else ChunkSize:=WOP_NORM;
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure DOHKURVE(SAddr,AlphaSAddr,StartOffset,EndOffset :long);

var Stepsize,Factor,Constant    :real;
var Offset,Steps,Addr1,AddrA    :long;
var Data1                       :^long;
var DataA                       :^byte;

begin
   Addr1:=SAddr+StartOffset;
   AddrA:=AlphaSAddr+(StartOffset div 80);
   with _WaveOp[OPos] do begin
      Steps:=0;
      if (OpType=1) and (Operator[1]=Operator[2])
      or (OpType in [2..5]) and (Operator[2]=0) then exit;
      if OpType=1 then begin {*** LINEAR ***}
         Stepsize:=(Operator[2]-Operator[1])/(EndOffset-StartOffset)*4;
         Factor:=Operator[1];
         if AlphaSAddr=0 then repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data1^:=round(Data1^*Factor / 101);
            Factor:=Factor+Stepsize;
         until Addr1>SAddr+EndOffset
         else repeat
            DataA:=ptr(AddrA); AddrA:=AddrA+1; Addr1:=Addr1+80;
            DataA^:=round(DataA^*Factor/100);
            Factor:=Factor+(Stepsize*20);
         until Addr1>SAddr+EndOffset;

      end else if OpType=2 then begin {*** SINUS-MODULATION ***}
         Stepsize:=6.2831852/Operator[3]; Steps:=1;
         repeat
            if AlphaSAddr=0 then begin
               Data1:=ptr(Addr1); Addr1:=Addr1+4;
               Data1^:=round(Data1^*(100+(Operator[2]*sin(Stepsize*Steps)))/201);
               Steps:=Steps+1;
            end else begin
               DataA:=ptr(AddrA); AddrA:=AddrA+1; Addr1:=Addr1+80;
               DataA^:=round(DataA^*(100+(Operator[2]*sin(Stepsize*Steps)))/201);
               Steps:=Steps+20;
            end;
         until Addr1>SAddr+EndOffset;

      end else if OpType=3 then begin {*** DREIECK-MODULATION ***}
         Stepsize:=(Operator[2])/Operator[3]*2;
         repeat
            Factor:=100-Operator[2];
            if AlphaSAddr=0 then begin
               while (Factor<100) and (Addr1<=SAddr+EndOffset) do begin
                  Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                  Data1^:=round(Data1^*Factor/101); Factor:=Factor+Stepsize;
               end;
               while (Factor>100-Operator[2]) and (Addr1<=SAddr+EndOffset) do begin
                  if Factor>101 then Factor:=101;
                  Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                  Data1^:=round(Data1^*Factor/101); Factor:=Factor-Stepsize;
               end;
            end else begin
               while (Factor<100) and (Addr1<=SAddr+EndOffset) do begin
                  DataA:=Ptr(AddrA); AddrA:=AddrA+1; Addr1:=Addr1+80;
                  DataA^:=round(DataA^*Factor/101); Factor:=Factor+Stepsize*20;
               end;
               while (Factor>100-Operator[2]) and (Addr1<=SAddr+EndOffset) do begin
                  if Factor>101 then Factor:=101;
                  DataA:=Ptr(AddrA); AddrA:=AddrA+1; Addr1:=Addr1+80;
                  DataA^:=round(DataA^*Factor/101); Factor:=Factor-Stepsize*20;
               end;
            end;
         until Addr1>SAddr+EndOffset;

      end else if OpType=4 then begin {*** RAMPE-AUF-MODULATION ***}
         Stepsize:=(Operator[2])/Operator[3];
         repeat
            Factor:=100-Operator[2];
            if AlphaSAddr=0 then begin
               while (Factor<100) and (Addr1<=SAddr+EndOffset) do begin
                  Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                  Data1^:=round(Data1^*Factor/101); Factor:=Factor+Stepsize;
               end;
            end else begin
               while (Factor<100) and (Addr1<=SAddr+EndOffset) do begin
                  DataA:=Ptr(AddrA); AddrA:=AddrA+1; Addr1:=Addr1+80;
                  DataA^:=round(DataA^*Factor/101); Factor:=Factor+Stepsize*20;
               end;
            end;
         until Addr1>SAddr+EndOffset;

      end else if OpType=5 then begin {*** RAMPE-AB-MODULATION ***}
         Stepsize:=(Operator[2])/Operator[3];
         repeat
            Factor:=100;
            if AlphaSAddr=0 then begin
               while (Factor>100-Operator[2]) and (Addr1<=SAddr+EndOffset) do begin
                  Data1:=Ptr(Addr1); Addr1:=Addr1+4;
                  Data1^:=round(Data1^*Factor/101); Factor:=Factor-Stepsize;
               end;
            end else begin
               while (Factor>100-Operator[2]) and (Addr1<=SAddr+EndOffset) do begin
                  DataA:=Ptr(AddrA); AddrA:=AddrA+1; Addr1:=Addr1+80;
                  DataA^:=round(DataA^*Factor/101); Factor:=Factor-Stepsize*20;
               end;
            end;
         until Addr1>SAddr+EndOffset;

      end else if OpType=6 then begin {*** HLKV-MODUL ***}
         if MemAMod=0 then exit;
         if ModMemInhalt<>3 then begin
            FHandle:=DosOpen(OpString,MODE_OLDFILE);
            if FHandle=0 then begin
               l:=TASKREQUEST(OpString,PText[184],NIL,PText[220],NIL);
               exit;
            end;
            l:=DosRead(FHandle,ptr(MemAMod),5000);
            DosClose(FHandle);
            ModMemInhalt:=3;
         end;
         Stepsize:=10000/(EndOffset-StartOffset); Factor:=Stepsize;
         if AlphaSAddr=0 then begin
            repeat
               Data1:=Ptr(Addr1);  Addr1:=Addr1+4;
               DataW:=ptr(MemAMod+round(Factor)*2);
               Factor:=Factor+Stepsize;
               Data1^:=round(Data1^*(DataW^/65535));
            until (Addr1>SAddr+EndOffset) or (Factor>=2500);
         end else begin
            repeat
               DataA:=Ptr(AddrA); AddrA:=AddrA+1; Addr1:=Addr1+80;
               DataW:=ptr(MemAMod+round(Factor)*2);
               Factor:=Factor+Stepsize*20;
               DataA^:=round(DataA^*(DataW^/65535));
            until (Addr1>SAddr+EndOffset) or (Factor>=2500);
         end;
      end else DisplayBeep(NIL);
   end;
end;



function DEFINEHKURVE:boolean;

var s           :string[5];
var MySList     :SelectListGad;

procedure DRAWGRAPH;

begin
   with _WaveOp[OPos] do begin
      SetAPen(DWindow^.RPort,0); RectFill(DWindow^.RPort,270,41,430,73);
      if OpType=1 then DRAWLINE(DWindow^,270,round(69-Operator[1]/3.8),430,round(69-Operator[2]/3.8),3)
      else if OpType in [2..5] then begin
         DrawImage(DWindow^.RPort,^GImg[6],320,42);
         s:=intstr(Operator[2])+"%";
         WRITE(350,63,2,3,DWindow^,s);
      end else if OpType=6 then DRAWIMAGE(DWindow^.RPort,^GImg[3],328,46);
   end;
end;



begin
   DEFINEHKURVE:=false;
   if not OPENDWIN(147,0,DWindow,PText[38],3,1) then exit;
   _WaveOp[Opos].Operation:=3;
   with _WaveOp[OPos] do begin
      MAKEBORDER(DWindow^,268,40,432,74,NEGATIVE);
      CREATEGADS(1,1,1);
      ACTIVECHANNELGADS(ActiveMode[0],Channels);
      DKnopf[9].GadgetText:=^DKnopfTx[OpType];
      for i:=1 to 5 do DKnopfTx[i]:=IntuiText(2,0,0,4,2,^CustomTA,PText[i+38],NIL);
      MySList:=SelectListGad(DWindow,^DKnopf[9],OpType,0,0,0,ITTArr(^DKnopfTx[1],
                             ^DKnopfTx[2],^DKnopfTx[3],^DKnopfTx[4],^DKnopfTx[5],
                             NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));
         { SELECTLIST }
      if MemAMod=0 then DKnopf[10].flags:=GADGIMAGE+GADGDISABLED;
         { DISKGADGET  }
      for i:=1 to 2 do CREATEPROPGAD(10,77+(17*i),pred(Operator[i])*661,655,i,10,DWindow^);
      CREATEPROPGAD(10,128,Operator[3] div 2,1,3,10,DWindow^);
      Buffer[1]:=intstr(Operator[1]); Buffer[2]:=intstr(Operator[2]); Buffer[3]:=intstr(Operator[3]);

      DKnopfTx[2].IText:=PText[2]; DKnopfTx[3].IText:=PText[4];
      DKnopfTx[4].IText:=PText[7]; DKnopfTx[5].IText:=PText[8];
      DKnopfTx[6].IText:=PText[40];

      WRITE(206,63,2,3,DWindow^,PText[40]);
      WRITE(414,96,2,0,DWindow^,PText[41]);
      WRITE(414,114,2,0,DWindow^,PText[42]);
      WRITE(414,132,2,0,DWindow^,PText[34]);
      if OpType in [2..5] then begin
         Schieber[1].flags:=Schieber[1].Flags or GADGDISABLED;
         TextGad[1].flags:=TextGad[1].Flags or GADGDISABLED;
      end else begin
         Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
         TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
      end;
      for i:=1 to 3 do AddGadget(DWindow,^TextGad[i],NIL);
      for i:=1 to 3 do AddGadget(DWindow,^Schieber[i],NIL);
      for i:=9 to 10 do AddGadget(DWindow,^DKnopf[i],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      DRAWGRAPH;
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if GadCode=9 then begin
            OpType:=DOSELECTLIST(^MySList);
            if OpType in [2..5] then begin
               Schieber[1].flags:=Schieber[1].Flags or GADGDISABLED;
               TextGad[1].flags:=TextGad[1].Flags or GADGDISABLED;
               Schieber[3].flags:=Schieber[3].Flags and not GADGDISABLED;
               TextGad[3].flags:=TextGad[3].Flags and not GADGDISABLED;
            end else begin
               Schieber[1].flags:=Schieber[1].Flags and not GADGDISABLED;
               TextGad[1].flags:=TextGad[1].Flags and not GADGDISABLED;
               Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
               TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
            end;
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
            DRAWGRAPH;
         end;

         if GadCode=10 then with _WaveOp[OPos] do begin
            FRTit:=PText[238]; PathFR:='HLKV'; FRShow:='';
            if FILEREQ then begin
               ChunkSize:=WOP_NORM;
               OpString:=PathFR;
               OpType:=6;
               DKnopf[9].GadgetText:=^DKnopfTx[6];
            end;
            Schieber[1].flags:=Schieber[1].Flags and not GADGDISABLED;
            TextGad[1].flags:=TextGad[1].Flags and not GADGDISABLED;
            Schieber[3].flags:=Schieber[3].Flags or GADGDISABLED;
            TextGad[3].flags:=TextGad[3].Flags or GADGDISABLED;
            RefreshGadgets(Dwindow^.FirstGadget,DWindow,NIL);
            DRAWGRAPH;
         end;

         if (Gadcode=11) or not (Schieber[1].flags and SELECTED=0) then begin
            Operator[1]:=SchieberInfo[1].HorizPot div 655;
            if Operator[1]>100 then Operator[1]:=100;
            if Operator[1]<1 then Operator[1]:=1;
            Buffer[1]:=intstr(Operator[1]);
            RefreshGadgets(^TextGad[1],DWindow,NIL);
            DRAWGRAPH;
         end;
         if GadCode=12 then begin
            val(Buffer[1],Operator[1],i);
            if Operator[1]>100 then Operator[1]:=100;
            if Operator[1]<1 then Operator[1]:=1;
            Buffer[1]:=intstr(Operator[1]);
            SchieberInfo[1].HorizPot:=Operator[1]*655;
            RefreshGadgets(^Schieber[1],DWindow,NIL);
            DRAWGRAPH;
         end;

         if (GadCode=13) or not (Schieber[2].flags and SELECTED=0) then begin
            Operator[2]:=succ(SchieberInfo[2].HorizPot div 661);
            if Operator[2]>100 then Operator[2]:=100;
            if Operator[2]<1 then Operator[2]:=1;
            Buffer[2]:=intstr(Operator[2]);
            RefreshGadgets(^TextGad[2],DWindow,NIL);
            DRAWGRAPH;
         end;
         if GadCode=14 then begin
            val(Buffer[2],Operator[2],i);
            if Operator[2]>100 then Operator[2]:=100;
            if Operator[2]<1 then Operator[2]:=1;
            Buffer[2]:=intstr(Operator[2]);
            SchieberInfo[2].HorizPot:=pred(Operator[2])*661;
            RefreshGadgets(^Schieber[2],DWindow,NIL);
            DRAWGRAPH;
         end;

         if (GadCode=15) or not (Schieber[3].flags and SELECTED=0) then begin
            Operator[3]:=SchieberInfo[3].HorizPot*2;
            if Operator[3]<1 then Operator[3]:=1; if Operator[3]>131068 then Operator[3]:=131068;
            Buffer[3]:=intstr(Operator[3]);
            RefreshGadgets(^TextGad[3],DWindow,NIL);
         end;
         if GadCode=16 then begin
            val(Buffer[3],Operator[3],i);
            if Operator[3]<1 then Operator[3]:=1; if Operator[3]>131068 then Operator[3]:=131068;
            Buffer[3]:=intstr(Operator[3]);
            SchieberInfo[3].HorizPot:=Operator[3] div 2;
            RefreshGadgets(^Schieber[3],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEHKURVE:=true;
      Channels:=GETACTIVECHANNELS(ActiveMode[0]);
      SoundMode:=ActiveMode[0];
      if OpType in [1..5] then ChunkSize:=WOP_SMALL else ChunkSize:=WOP_NORM;
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure DODIFFERENCER(SAddr,StartOffset,EndOffset :long; ChID :byte);

begin
   Addr1:=SAddr+StartOffset;
   if ChID=6 then exit;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      Data2:=ptr(Addr1);
      Data1^:=Data1^-Data2^ div 2;
   until Addr1>=SAddr+EndOffset;
   Data1^:=0;
end;



function DEFINEDIFFERENCER:boolean;

var shx :short;

begin
   DEFINEDIFFERENCER:=false;
   with _WaveOp[Opos] do begin
      Operation:=4;
      shx:=DEFINEEMPTY(Channels,PText[44]);
      if shx=-1 then exit else Channels:=shx;
      WAreaA:=AreaA[0];
      WAreaE:=AreaE[0];
   end;
   DEFINEDIFFERENCER:=true;
end;



procedure DOINTEGRATER(SAddr,StartOffset,EndOffset :long);

var IntData             :long;

begin
   Addr1:=SAddr+StartOffset;
   IntData:=0;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      Data1^:=(IntData+Data1^) div 2;
      IntData:=Data1^;
   until Addr1>=SAddr+EndOffset;
end;



function DEFINEINTEGRATER:boolean;

var shx :short;

begin
   DEFINEINTEGRATER:=false;
   with _WaveOp[OPos] do begin
      Operation:=5;
      shx:=DEFINEEMPTY(Channels,PText[45]);
      if shx=-1 then exit else Channels:=shx;
      WAreaA:=AreaA[0];
      WAreaE:=AreaE[0];
   end;
   DEFINEINTEGRATER:=true;
end;



procedure DOANTIALIAS(SAddr,StartOffset,EndOffset :long; ChID :byte);

var DataBefore,Addr1    :long;

begin
   with _WaveOp[OPos] do begin
      if (Operator[ChID]<=1) or (SAddr=0) then exit;
      Addr1:=SAddr+StartOffset;
      DataBefore:=0;
      repeat
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         Data2:=ptr(Addr1);
         Data1^:=round( ((Data2^+DataBefore)*Operator[ChID] + Data1^*(51-Operator[ChID])) / 61);
         if Data1^>MAX24 then Data1^:=MAX24 else if Data1^<-MAX24 then Data1^:=-MAX24;
         DataBefore:=Data2^;
      until Addr1>=SAddr+EndOffset;
   end;
end;



procedure GETGAD(GadID :byte; Factor,Max :word);

var GadNum      :byte;

begin
   with _WaveOp[OPos] do begin
      GadNum:=GadID*2-1;
      if (GadCode=GadNum+2) or not (Schieber[GadID].flags and SELECTED=0) then begin
         Operator[GadID]:=succ(SchieberInfo[GadID].HorizPot div Factor);
         if Operator[GadID]>Max then Operator[GadID]:=Max;
         if Operator[GadID]<1 then Operator[GadID]:=1;
         Buffer[GadID]:=intstr(Operator[GadID]);
         RefreshGadgets(^Schieber[GadID],DWindow,NIL);
      end;
      if (GadCode=GadNum+3) then begin
         val(Buffer[GadID],Operator[GadID],i);
         if Operator[GadID]>Max then Operator[GadID]:=Max;
         if Operator[GadID]<1 then Operator[GadID]:=1;
         Buffer[GadID]:=intstr(Operator[GadID]);
         SchieberInfo[GadID].HorizPot:=pred(Operator[GadID])*Factor;
         RefreshGadgets(^Schieber[GadID],DWindow,NIL);
      end;
   end;
end;



procedure CREATEBOARDGADS(Factor1,Factor2,TextNum :word);

var ChBit,i     :byte;

begin
   with _WaveOp[OPos] do begin
      ChBit:=1;
      for i:=1 to 7 do begin
         if i<7 then begin
            if Operator[i]<1 then Operator[i]:=1;
            l:=Operator[i]
         end else l:=Operator[1];
         Buffer[i]:=intstr(l);
         CREATEPROPGAD(10,23+17*i,pred(l)*Factor1,Factor2,i,2,DWindow^);
         if (i<7) and (ActiveChannels[0] and ChBit=0) then begin
            Schieber[i].Flags:=Schieber[i].Flags or GADGDISABLED;
            TextGad[i].Flags:=TextGad[i].Flags or GADGDISABLED;
         end;
         case i of
            1: s:='L'
            2: s:='R'
            3: s:='C'
            4: s:='SL'
            5: s:='SR'
            6: s:='Sub'
            7: s:=PText[TextNum];
         end;
         WRITE(414,i*17+24,2,0,DWindow^,s);
         ChBit:=ChBit*2;
      end;
      for i:=1 to 7 do AddGadget(DWindow,^TextGad[i],NIL);
      for i:=1 to 7 do AddGadget(DWindow,^Schieber[i],NIL);
   end;
end;



function DEFINEANTIALIAS:boolean;

var s           :string;
var l           :long;
var ChBit       :byte;

begin
   DEFINEANTIALIAS:=false;
   if not OPENDWIN(162,0,DWindow,PText[46],1,0) then exit;
   with _WaveOp[OPos] do begin
      Operation:=6;
      CREATEBOARDGADS(1337,1310,47);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         for i:=1 to 6 do GETGAD(i,1337,50);

         if (GadCode=15) or not (Schieber[7].flags and SELECTED=0) then begin
            l:=succ(SchieberInfo[7].HorizPot div 1337);
            if l>50 then l:=50;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*1337;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;
         if (GadCode=16) then begin
            val(Buffer[7],l,i);
            if l>50 then l:=50;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*1337;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEANTIALIAS:=true;
      Channels:=ActiveChannels[0];
      SoundMode:=ActiveMode[0];
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



function MAKEDRUM(SAddr,Addr1,AlphaSAddr :long):long;

var MaxAmp      :long;

begin
   MAKEDRUM:=0;
   if PlayL24[0]<256 then exit;
   MaxAmp:=0;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      if abs(Data1^)>MaxAmp then MaxAmp:=abs(Data1^);
   until (abs(Data1^)<MaxAmp) or (Addr1>=SAddr+PlayL24[0]);
   if Addr1>=SAddr+PlayL24[0] then exit;
   MaxAmp:=Addr1-SAddr;
   if SAttack[0]<>0 then SAttack[0]:=SAttack[0]-MaxAmp;
   if SDecay[0]<>0 then SDecay[0]:=SDecay[0]-MaxAmp;
   if SSustain[0]<>0 then SSustain[0]:=SSustain[0]-MaxAmp;
   if SRelease[0]<>0 then SRelease[0]:=SRelease[0]-MaxAmp;
   CopyMemQuick(Addr1,SAddr,PlayL24[0]-MaxAmp);
   if AlphaSAddr<>0 then CopyMem(AlphaSAddr+(Addr1-SAddr) div 80,AlphaSAddr,round((PlayL24[0]-MaxAmp)/80+0.5));
   Addr1:=SAddr+PlayL24[0]-MaxAmp;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      Data1^:=0;
   until Addr1>=SAddr+PlayL24[0];
   MAKEDRUM:=MaxAmp;
   DoDoubleSize:=true;
end;



function DEFINEMAKEDRUM:boolean;

var shx :short;

begin
   DEFINEMAKEDRUM:=true;
   with _WaveOp[Opos] do begin
      Operation:=7;
      _WaveOp[OPos].Channels:=$3F;
      WAreaA:=AreaA[0];
      WAreaE:=AreaE[0];
   end;
end;



procedure DOECHO;

var SPos,TPos,ChBit,ChID,ACtr                   :byte;
var Steps,l,Offset,Volume,Length24,Addr1,Addr2,
    StartOffset,EndOffset                       :long;
var SAddr24                                     :array[1..8] of long;
var EStep                                       :real;



procedure MAKEECHO(SAddr,TAddr,ESAddr,ETAddr :long; Volume :byte);

var Addr1,Addr2         :long;
var Data1,Data2         :^long;
var EFactor,GFactor     :real;
var i                   :byte;

begin
   with _WaveOp[OPos] do begin
      if (ESAddr=0) or (ETAddr=0) then exit;
      EFactor:=(Operator[5]/100);
      EFactor:=EFactor+  (EStep* (TAddr-ETAddr-Operator[2]*4)/4);
      Addr1:=SAddr; Addr2:=TAddr;
      if (Operator[5]<>100) or (Operator[6]<>100) then begin
         while (Addr2<ETAddr+MemL24[0]) and (Addr1<ESAddr+Length24) do begin
            Data1:=ptr(Addr1);  Addr1:=Addr1+4;
            Data2:=ptr(Addr2);  Addr2:=Addr2+4;
            GFactor:=EFactor+Volume;
            Data2^:=round(((Data2^*Volume)-(Data1^*EFactor))/GFactor);
            EFactor:=EFactor+EStep;
         end;
      end else begin
         while (Addr2<ETAddr+MemL24[0]) and (Addr1<ESAddr+Length24) do begin
            Data1:=ptr(Addr1);  Addr1:=Addr1+4;
            Data2:=ptr(Addr2);  Addr2:=Addr2+4;
            Data2^:=(Data2^*Volume-Data1^) div succ(Volume);
         end;
      end;
   end;
end;



begin
   WORKINFO(PText[109],1);
   PlayL24[0]:=MemL24[0];
   GETMARKOFFSET(StartOffset,EndOffset);
   Length24:=EndOffset-StartOffset;
   if _WaveOp[OPos].Operator[2]<Length24 div 4 then with _WaveOp[OPos] do begin
      EStep:=(Operator[6]-Operator[5])/((MemL24[0]/4-StartOffset)-Operator[2])/100;
      RESTOREALPHA(CH_LEFT+CH_RIGHT+CH_CENTER+CH_SLEFT+CH_SRIGHT,StartOffset,EndOffset);
      if OpType=1 then begin
         m:=Operator[3];
         for i:=1 to 8 do begin
            if i=5 then m:=Operator[4];
            l:=m and $7F;
            case l of
               CH_LEFT:   SAddr24[i]:=MemA24[0,1];
               CH_RIGHT:  SAddr24[i]:=MemA24[0,2];
               CH_CENTER: SAddr24[i]:=MemA24[0,3];
               CH_SLEFT:  SAddr24[i]:=MemA24[0,4];
               CH_SRIGHT: SAddr24[i]:=MemA24[0,5];
               otherwise  SAddr24[i]:=0;
            end;
            if SAddr24[i]<>0 then SAddr24[i]:=SAddr24[i]+StartOffset;
            m:=(m-l) div 128;
         end;

         for i:=1 to 8 do if SAddr24[i]=0 then begin
            for j:=i to 7 do SAddr24[j]:=SAddr24[j+1];
            SAddr24[8]:=0;
         end;
         if SAddr24[1]=0 then exit;
         i:=1; SPos:=1; TPos:=2;
         repeat
            if SPos>8 then SPos:=1;          if TPos>8 then TPos:=1;
            if SAddr24[SPos]=0 then SPos:=1; if SAddr24[TPos]=0 then TPos:=1;
            Addr1:=SAddr24[SPos];            Addr2:=SAddr24[TPos]+(Operator[2]*4*i);
            MAKEECHO(Addr1,Addr2,SAddr24[SPos],SAddr24[TPos],2);
            SPos:=SPos+1; TPos:=TPos+1; i:=i+1;
         until i>Operator[1];
      end else begin
         ChBit:=1; ChID:=0;
         for i:=1 to 6 do begin
            if not (Channels and ChBit=0) then ChID:=i;
            SAddr24[i]:=MemA24[0,i]+StartOffset;
            if MemA24[0,i]=0 then SAddr24[i]:=0;
            ChBit:=ChBit*2;
         end;
         Steps:=1;
         if ChID=0 then exit;
         repeat
            Offset:=(Operator[2]*Steps)*4;
            MAKEECHO(SAddr24[ChID],SAddr24[ChID]+Offset,SAddr24[ChID],SAddr24[ChID],2);
            Steps:=Steps+1;
         until (Steps>=Operator[1]) or (Steps*Operator[2]*4>Length24);
         if ActiveMode[0]=MD_MONO then exit;
         if ActiveMode[0] in [MD_MONO,MD_STEREO,MD_3CH,MD_SURROUND] then begin
            for i:=1 to 4 do if (i<>ChID) and (MemA24[0,i]<>0) then with ChSurround do begin
               Volume:=round(SQRT(SQR(ChX[i]-ChX[ChID])+SQR(ChY[i]-ChY[ChID]))/10);
               Offset:=Volume*Operator[2]*4;
               MAKEECHO(SAddr24[ChID],SAddr24[i]+Offset,SAddr24[ChID],SAddr24[i],Volume);
            end;
         end else if ActiveMode[0]=MD_QUADRO then begin
            for i:=1 to 5 do if not (i in [ChID,3]) and (MemA24[0,i]<>0) then with ChQuadro do begin
               Volume:=round(SQRT(SQR(ChX[i]-ChX[ChID])+SQR(ChY[i]-ChY[ChID]))/10);
               Offset:=Volume*Operator[2]*4;
               MAKEECHO(SAddr24[ChID],SAddr24[i]+Offset,SAddr24[ChID],SAddr24[i],Volume);
            end;
         end else for i:=1 to 5 do if (i<>ChID) and (MemA24[0,i]<>0) then with ChAC3 do begin
            Volume:=round(SQRT(SQR(ChX[i]-ChX[ChID])+SQR(ChY[i]-ChY[ChID]))/10);
            Offset:=Volume*Operator[2]*4;
            MAKEECHO(SAddr24[ChID],SAddr24[i]+Offset,SAddr24[ChID],SAddr24[i],Volume);
         end
      end;
   end;
end;



function DEFINEECHO:boolean;

var Order       :array[1..8] of byte;
var MySList     :SelectListGad;

begin
   DEFINEECHO:=false;
   if not OPENDWIN(182,0,DWindow,PText[51],3,1) then exit;
   with _WaveOp[OPos] do begin
      Operation:=8;
      for i:=1 to 4 do begin
         Order[i]:=Operator[3] and $7F;
         if (Order[i] and ActiveChannels[0]=0) then Order[i]:=0;
         Operator[3]:=(Operator[3]-Order[i]) div 128;
      end;
      for i:=5 to 8 do begin
         Order[i]:=Operator[4] and $7F;
         if (Order[i] and ActiveChannels[0]=0) then Order[i]:=0;
         Operator[4]:=(Operator[3]-Order[i]) div 128;
      end;
      CREATEGADS(1,1,0);
      DKnopf[9].GadgetText:=^DKnopfTx[OpType];
      for i:=1 to 2 do DKnopfTx[i]:=IntuiText(2,0,0,4,2,^CustomTA,PText[i+51],NIL);
      MySList:=SelectListGad(DWindow,^DKnopf[9],OpType,0,0,0,ITTArr(^DKnopfTx[1],
                             ^DKnopfTx[2],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));
      for i:=10 to 17 do begin
         DKnopf[i]:=Gadget(NIL,i*28-270,85,21,12,GADGHCOMP+GADGIMAGE,$1,
                           BOOLGADGET,^ButtonImg[1],NIL,NIL,0,Nil,i,0);
         case Order[i-9] of
            CH_LEFT:   DKnopf[i].GadgetText:=^KnopfTx[1];
            CH_RIGHT:  DKnopf[i].GadgetText:=^KnopfTx[2];
            CH_CENTER: DKnopf[i].GadgetText:=^KnopfTx[3];
            CH_SLEFT:  DKnopf[i].GadgetText:=^KnopfTx[4];
            CH_SRIGHT: DKnopf[i].GadgetText:=^KnopfTx[5];
            otherwise  DKnopf[i].GadgetText:=^DKnopfTx[3];
         end;
      end;
      DKnopfTx[3]:=IntuiText(2,0,0,6,1,^CustomTA,'-',NIL);
      WRITE(141,60,2,0,DWindow^,PText[54]);
      WRITE(232,85,2,0,DWindow^,PText[55]);
      WRITE(17,97,2,0,DWindow^,'1 -> 2 -> 3 -> 4 -> 5 -> 6 -> 7 -> 8');
      ACTIVECHANNELGADS(ActiveMode[0],Channels);
      for i:=3 to 8 do begin
         DKnopf[i].Activation:=$1;
         DKnopf[i].SelectRender:=^ButtonImg[4];
      end;
      if OpType=1 then for i:=3 to 8 do DKnopf[i].Flags:=DKnopf[i].Flags or GADGDISABLED
      else for i:=10 to 17 do DKnopf[i].Flags:=DKnopf[i].Flags or GADGDISABLED;
      DKnopf[8].Flags:=(DKnopf[8].Flags and not SELECTED) or GADGDISABLED;
      for i:=1 to 4 do begin
         DKnopf[16+i*2]:=Gadget(NIL,412,95+i*17,16,13,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^CalcImg,NIL,NIL,0,Nil,16+i*2,0);
         DKnopf[17+i*2]:=Gadget(NIL,428,95+i*17,16,13,GADGHCOMP,$1,BOOLGADGET,NIL,NIL,NIL,0,Nil,17+i*2,0);
      end;
         { CALC }
      for i:=1 to 4 do CREATEPROPGAD(10,94+17*i,1,1,i,25,DWindow^);
      SchieberInfo[1]:=Propinfo(FREEHORIZ,pred(Operator[1])*1680,0,1638,0,0,0,0,0,0,0);
      SchieberInfo[2]:=Propinfo(FREEHORIZ,pred(Operator[2])*8,0,8,0,0,0,0,0,0,0);
      SchieberInfo[3]:=Propinfo(FREEHORIZ,pred(Operator[5])*131,0,131,0,0,0,0,0,0,0);
      SchieberInfo[4]:=Propinfo(FREEHORIZ,pred(Operator[6])*131,0,131,0,0,0,0,0,0,0);
      WRITE(454,112,2,0,DWindow^,PText[56]);   Buffer[1]:=intstr(Operator[1]);
      WRITE(454,129,2,0,DWindow^,PText[57]);   Buffer[2]:=intstr(Operator[2]);
      WRITE(454,146,2,0,DWindow^,PText[58]);   Buffer[3]:=intstr(Operator[5]);
      WRITE(454,163,2,0,DWindow^,PText[59]);   Buffer[4]:=intstr(Operator[6]);
      for i:=1 to 4 do AddGadget(DWindow,^TextGad[i],NIL);
      for i:=1 to 4 do AddGadget(DWindow,^Schieber[i],NIL);
      for i:=9 to 25 do AddGadget(DWindow,^DKnopf[i],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if GadCode in [3..8] then begin
            for i:=3 to 8 do DKnopf[i].Flags:=DKnopf[i].Flags and not SELECTED;
            DKnopf[GadCode].Flags:=DKnopf[GadCode].Flags or SELECTED;
            RefreshGadgets(^DKnopf[8],DWindow,NIL);
         end;

         if GadCode=9 then begin
            Channels:=GETACTIVECHANNELS(MD_AC3);
            OpType:=DOSELECTLIST(^MySList);
            if OpType=1 then begin
               for i:=3 to 8 do DKnopf[i].Flags:=DKnopf[i].Flags or GADGDISABLED;
               for i:=10 to 17 do DKnopf[i].Flags:=DKnopf[i].Flags and not GADGDISABLED;
            end else begin
               ACTIVECHANNELGADS(ActiveMode[0],Channels);
               DKnopf[8].Flags:=DKnopf[8].Flags or GADGDISABLED;
               for i:=10 to 17 do DKnopf[i].Flags:=DKnopf[i].Flags or GADGDISABLED;
            end;
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
         end;

         if GadCode in [10..17] then begin
            i:=GadCode-9;
            repeat
               Order[i]:=Order[i]*2;
               if Order[i]=0 then Order[i]:=CH_LEFT;
               if Order[i]>CH_SRIGHT then Order[i]:=0;
            until not (Order[i] and ActiveChannels[0]=0) or (Order[i]=0);
            case Order[i] of
               CH_LEFT:   DKnopf[GadCode].GadgetText:=^KnopfTx[1];
               CH_RIGHT:  DKnopf[GadCode].GadgetText:=^KnopfTx[2];
               CH_CENTER: DKnopf[GadCode].GadgetText:=^KnopfTx[3];
               CH_SLEFT:  DKnopf[GadCode].GadgetText:=^KnopfTx[4];
               CH_SRIGHT: DKnopf[GadCode].GadgetText:=^KnopfTx[5];
               otherwise  DKnopf[GadCode].GadgetText:=^DKnopfTx[3];
            end;
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
         end;
         if GadCode=18 then if Operator[1]>1 then Buffer[1]:=intstr(Operator[1] div 2);
         if GadCode=19 then if Operator[1]<20 then Buffer[1]:=intstr(Operator[1] * 2) else Buffer[1]:='40';
         if GadCode=20 then if Operator[2]>1 then Buffer[2]:=intstr(Operator[2] div 2);
         if GadCode=21 then if Operator[2]<4001 then Buffer[2]:=intstr(Operator[2] * 2) else Buffer[2]:='8000';
         if GadCode=22 then if Operator[5]>1 then Buffer[3]:=intstr(Operator[5] div 2);
         if GadCode=23 then if Operator[5]<250 then Buffer[3]:=intstr(Operator[5] * 2) else Buffer[3]:='500';
         if GadCode=24 then if Operator[6]>1 then Buffer[4]:=intstr(Operator[6] div 2);
         if GadCode=25 then if Operator[6]<250 then Buffer[4]:=intstr(Operator[6] * 2) else Buffer[4]:='500';
         if GadCode in [18..19] then GadCode:=27;
         if GadCode in [20..21] then GadCode:=29;
         if GadCode in [22..23] then GadCode:=32;
         if GadCode in [24..25] then GadCode:=33;

         if (GadCode=26) or not (Schieber[1].flags and SELECTED=0) then begin
            Operator[1]:=succ(SchieberInfo[1].HorizPot div 1680);
            if Operator[1]<1 then Operator[1]:=1;
            if Operator[1]>40 then Operator[1]:=40;
            Buffer[1]:=intstr(Operator[1]);
            RefreshGadgets(^TextGad[1],DWindow,NIL);
         end;
         if GadCode=27 then begin
            val(Buffer[1],Operator[1],i);
            if Operator[1]<1 then Operator[1]:=1;
            if Operator[1]>40 then Operator[1]:=40;
            Buffer[1]:=intstr(Operator[1]);
            SchieberInfo[1].HorizPot:=pred(Operator[1])*1680;
            RefreshGadgets(^Schieber[1],DWindow,NIL);
         end;

         if (GadCode=28) or not (Schieber[2].flags and SELECTED=0) then begin
            Operator[2]:=succ(SchieberInfo[2].HorizPot div 8);
            if Operator[2]<1 then Operator[2]:=1;
            if Operator[2]>8000 then Operator[2]:=8000;
            Buffer[2]:=intstr(Operator[2]);
            RefreshGadgets(^TextGad[2],DWindow,NIL);
         end;
         if GadCode=29 then begin
            val(Buffer[2],Operator[2],i);
            if Operator[2]<1 then Operator[2]:=1;
            if Operator[2]>8000 then Operator[2]:=8000;
            Buffer[2]:=intstr(Operator[2]);
            SchieberInfo[2].HorizPot:=pred(Operator[2])*8;
            RefreshGadgets(^Schieber[2],DWindow,NIL);
         end;

         if (GadCode=30) or not (Schieber[3].flags and SELECTED=0) then begin
            Operator[5]:=succ(SchieberInfo[3].HorizPot div 131);
            if Operator[5]<1 then Operator[5]:=1;
            if Operator[5]>500 then Operator[5]:=500;
            Buffer[3]:=intstr(Operator[5]);
            RefreshGadgets(^TextGad[3],DWindow,NIL);
         end;
         if GadCode=31 then begin
            val(Buffer[3],Operator[5],i);
            if Operator[5]<1 then Operator[5]:=1;
            if Operator[5]>500 then Operator[5]:=500;
            Buffer[3]:=intstr(Operator[5]);
            SchieberInfo[3].HorizPot:=pred(Operator[5])*131;
            RefreshGadgets(^Schieber[3],DWindow,NIL);
         end;

         if (GadCode=32) or not (Schieber[4].flags and SELECTED=0) then begin
            Operator[6]:=succ(SchieberInfo[4].HorizPot div 131);
            if Operator[6]<1 then Operator[6]:=1;
            if Operator[6]>500 then Operator[6]:=500;
            Buffer[4]:=intstr(Operator[6]);
            RefreshGadgets(^TextGad[4],DWindow,NIL);
         end;
         if GadCode=33 then begin
            val(Buffer[4],Operator[6],i);
            if Operator[6]<1 then Operator[6]:=1;
            if Operator[6]>500 then Operator[6]:=500;
            Buffer[4]:=intstr(Operator[6]);
            SchieberInfo[4].HorizPot:=pred(Operator[6])*131;
            RefreshGadgets(^Schieber[4],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEECHO:=true;
      Operator[3]:=0;
      Operator[4]:=0;
      for i:=8 downto 5 do begin
         Operator[4]:=Operator[4]+Order[i];
         if i<>5 then Operator[4]:=Operator[4]*128;
      end;
      for i:=5 downto 1 do begin
         Operator[3]:=Operator[3]+Order[i];
         if i<>1 then Operator[3]:=Operator[3]*128;
      end;
      Channels:=GETACTIVECHANNELS(ActiveMode[0]);
      SoundMode:=ActiveMode[0];
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure DOVOLUME(SAddr,AlphaSAddr,StartOffset,EndOffset :long; ChID :byte);

var Addr1,AddrA1,Check  :long;
var Data1               :^long;
var DataA1              :^byte;

begin
   with _WaveOp[OPos] do begin
      if Operator[ChID]=100 then exit;
      if ((MemAAlpha[0,1] or MemAAlpha[0,3])=0) or (OpType=0) then begin
         Addr1:=SAddr+StartOffset;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data1^:=Data1^ div 100 * Operator[ChID];
            if Data1^>MAX24 then Data1^:=MAX24 else if Data1^<-MAX24 then Data1^:=-MAX24
         until Addr1>=SAddr+EndOffset;
      end else begin
         AddrA1:=AlphaSAddr+StartOffset div 80;
         repeat
            DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
            Check:=DataA1^ * Operator[ChID] div 100;
            if Check>255 then Check:=255;
            DataA1^:=Check;
         until AddrA1>=AlphaSAddr+round((EndOffset/80+0.5));
      end;
   end;
end;



function DEFINEVOLUME:boolean;

var s           :string;
var l           :long;
var ChBit       :byte;

begin
   DEFINEVOLUME:=false;
   if not OPENDWIN(162,0,DWindow,PText[61],1,0) then exit;
   with _WaveOp[OPos] do begin
      Operation:=9;
      CREATEBOARDGADS(131,131,62);
      DKnopf[9]:=Gadget(NIL,DKnopf[1].LeftEdge+(DKnopf[1].Width-21) div 2,90,
                        21,12,GADGHIMAGE+GADGIMAGE,TOGGLESELECT+RELVERIFY,
                        BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,20,0);
      WRITE(DKnopf[1].LeftEdge+DKnopf[1].Width div 2,106,2,3,DWindow^,PText[23]);
      if (MemAAlpha[0,1] or MemAAlpha[0,3])=0 then DKnopf[9].Flags:=DKnopf[9].Flags or GADGDISABLED;
      if (OpType and $80=$80) then DKnopf[9].Flags:=DKnopf[9].Flags or SELECTED;
      AddGadget(DWindow,^DKnopf[9],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         for i:=1 to 6 do GETGAD(i,131,500);

         if (GadCode=15) or not (Schieber[7].flags and SELECTED=0) then begin
            l:=succ(SchieberInfo[7].HorizPot div 131);
            if l>500 then l:=500;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*131;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;
         if (GadCode=16) then begin
            val(Buffer[7],l,i);
            if l>500 then l:=500;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*131;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if not (DKnopf[9].Flags and SELECTED=0) then OpType:=$80 else OpType:=0;
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEVOLUME:=true;
      Channels:=ActiveChannels[0];
      SoundMode:=ActiveMode[0];
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure DOREVERSE(SAddr,AlphaSAddr,StartOffset,EndOffset :long; ChID :byte);

var Addr1,Addr2         :long;
var Data1,Data2         :^long;
var DataA1,DataA2       :^byte;

begin
   if SAddr<>0 then begin
      Addr1:=SAddr+StartOffset; Addr2:=SAddr+EndOffset-4;
      while Addr1<Addr2 do begin
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         Data2:=ptr(Addr2); Addr2:=Addr2-4;
         Exchange(Data1^,Data2^);
      end;
   end;
   if AlphaSAddr<>0 then begin
      Addr1:=AlphaSAddr+StartOffset div 80;
      Addr2:=AlphaSAddr+round((EndOffset-4)/80+0.5);
      while Addr1<Addr2 do begin
         DataA1:=ptr(Addr1); Addr1:=Addr1+1;
         DataA2:=ptr(Addr2); Addr2:=Addr2-1;
         Exchange(DataA1^,DataA2^);
      end;
   end;
   DoDoubleSize:=true;
end;



function DEFINEREVERSE:boolean;

begin
   _WaveOp[OPos].Operation:=10;
   _WaveOp[OPos].Channels:=$3F;
   _WaveOp[OPos].WAreaA:=AreaA[0];
   _WaveOp[OPos].WAreaE:=AreaE[0];
   DEFINEREVERSE:=true;
end;



procedure DOOVERCROSS(SAddr,StartOffset,EndOffset :long; ChID :byte);

var MemA24Bak           :long;

begin
   with _WaveOp[OPos] do begin
      if (Operator[ChID]=1) or (SAddr=0) then exit;
      MemA24Bak:=XAllocVec(EndOffset-StartOffset,MEMF_CLEAR);
      if MemA24Bak=0 then begin
         l:=TASKREQUEST(PText[112],PText[183],NIL,PText[220],NIL);
         exit;
      end;
      CopyMemQuick(SAddr+StartOffset,MemA24Bak,EndOffset-StartOffset);
      for i:=2 to Operator[ChID] do begin
         Addr1:=SAddr+StartOffset;
         Addr2:=MemA24Bak;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data2:=ptr(Addr2); Addr2:=Addr2+i*4;
            Data1^:=(Data2^+Data1^*i) div succ(i);
            if Addr2>=MemA24Bak+EndOffset-StartOffset then Addr2:=MemA24Bak;
         until (Addr1>=SAddr+EndOffset);
      end;
      XFreeVec(MemA24Bak);
   end;
end;



function DEFINEOVERCROSS:boolean;

var s           :string;
var l           :long;
var ChBit       :byte;

begin
   DEFINEOVERCROSS:=false;
   if not OPENDWIN(162,0,DWindow,PText[66],1,0) then exit;
   with _WaveOp[OPos] do begin
      Operation:=11;
      CREATEBOARDGADS(7281,6553,67);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         for i:=1 to 6 do GETGAD(i,7281,10);

         if (GadCode=15) or not (Schieber[7].flags and SELECTED=0) then begin
            l:=succ(SchieberInfo[7].HorizPot div 7281);
            if l>10 then l:=10;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*7281;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;
         if (GadCode=16) then begin
            val(Buffer[7],l,i);
            if l>10 then l:=10;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*7281;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEOVERCROSS:=true;
      Channels:=ActiveChannels[0];
      SoundMode:=ActiveMode[0];
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure DODIGITIZER(SAddr,StartOffset,EndOffset :long; ChID :byte);

var Divider,Bits                :long;

begin
   with _WaveOp[OPos] do begin
      if Operator[ChID]>=24 then exit;
      l:=Operator[ChID]+6; if l>24 then l:=24;
      for i:=l downto Operator[ChID] do begin
         s:='   '+PText[113]+' '+intstr(i)+' Bit ';
         WORKINFO(s,1);
         Bits:=24-i;
         Divider:=1;
         for j:=1 to Bits do Divider:=Divider*2;
         Addr1:=SAddr+StartOffset;
         repeat
            Data1:=Ptr(Addr1); Addr1:=Addr1+4;
            Data1^:=round(Data1^ / Divider)*Divider;
         until Addr1>=SAddr+EndOffset;
      end;
   end;
end;



function DEFINEDIGITIZER:boolean;

var s           :string;
var l           :long;
var ChBit       :byte;

begin
   DEFINEDIGITIZER:=false;
   if not OPENDWIN(162,0,DWindow,PText[71],1,0) then exit;
   with _WaveOp[OPos] do begin
      Operation:=12;
      CREATEBOARDGADS(2849,2730,72);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat
         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         for i:=1 to 6 do GETGAD(i,2849,24);

         if (GadCode=15) or not (Schieber[7].flags and SELECTED=0) then begin
            l:=succ(SchieberInfo[7].HorizPot div 2849);
            if l>24 then l:=24;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*2849;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;
         if (GadCode=16) then begin
            val(Buffer[7],l,i);
            if l>24 then l:=24;
            if l<1 then l:=1;
            for i:=1 to 7 do begin
               if i<7 then Operator[i]:=l;
               Buffer[i]:=intstr(l);
               SchieberInfo[i].HorizPot:=pred(l)*2849;
            end;
            RefreshGadgets(^Schieber[7],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEDIGITIZER:=true;
      Channels:=ActiveChannels[0];
      SoundMode:=ActiveMode[0];
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure DOCUTZERO(SAddr,AlphaSAddr,StartOffset,EndOffset :long);

var Addr1,Addr2,AddrA1,AddrA2   :long;
var Data1,Data2                 :^long;
var DataA1,DataA2               :^byte;
var ACtr1,ACtr2                 :byte;


procedure NORMALALPHA;

begin
   if ACtr1>=20 then begin
      ACtr1:=0;
      DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
      DataA2:=ptr(AddrA2);
      DataA1^:=DataA2^;
   end;
   if ACtr2>=20 then begin
      ACtr2:=0;
      DataA2:=ptr(AddrA2); AddrA2:=AddrA2+1;
      DataA1^:=DataA2^;
   end;
end;



begin
   if SAddr=0 then exit;
   Addr1:=SAddr+StartOffset;              Addr2:=Addr1;
   AddrA1:=AlphaSAddr+StartOffset div 80; AddrA2:=AddrA1;
   ACtr1:=20;                             ACtr2:=ACtr1;
   repeat
      Data2:=ptr(Addr2); Addr2:=Addr2+4;
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      if AlphaSAddr<>0 then NORMALALPHA;
      ACtr1:=ACtr1+1; ACtr2:=ACtr2+1;
      while (abs(Data2^) in [0..200]) and (Addr2<SAddr+EndOffset) do begin
         Data2:=ptr(Addr2); Addr2:=Addr2+4;
         if AlphaSAddr<>0 then NORMALALPHA;
         ACtr2:=ACtr2+1;
      end;
      Data1^:=Data2^;
   until Addr2>=SAddr+EndOffset;
   if Addr2<SAddr+PlayL24[0] then begin
      CopyMemQuick(Addr2,Addr1,SAddr+PlayL24[0]-Addr2);
      if AlphaSAddr<>0 then CopyMem(AddrA2,AddrA1,AlphaSAddr+round(PlayL24[0]/80+0.5)-AddrA2);
      Addr1:=Addr1+(SAddr+PlayL24[0]-Addr2);
      AddrA1:=AddrA1+(AlphaSAddr+PlayL24[0] div 80-AddrA2);
   end;
   while Addr1<SAddr+PlayL24[0] do begin
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      Data1^:=0;
   end;
   while (AddrA1<AlphaSAddr+round(PlayL24[0]/80+0.5)) and (AlphaSAddr<>0) do begin
      DataA1:=ptr(AddrA1); AddrA1:=AddrA1+1;
      DataA1^:=1;
   end;
   DoDoubleSize:=true;
end;



function DEFINECUTZERO:boolean;

begin
   _WaveOp[OPos].Operation:=13;
   _WaveOp[OPos].Channels:=$3F;
   _WaveOp[OPos].WAreaA:=AreaA[0];
   _WaveOp[OPos].WAreaE:=AreaE[0];
   DEFINECUTZERO:=true;
end;



procedure DOHEAVY(SAddr,AlphaSAddr,StartOffset,EndOffset :long);

var Stepsize,Factor             :real;
var Addr1,Steps,Ti,Op1,Op2      :long;
var Data1                       :^long;
var DataA                       :^byte;

begin
   Steps:=0;
   with _WaveOp[OPos] do begin
      if (AlphaSAddr<>0) and (OpType and $80<>0) then begin
         Op1:=round(Operator[1]/20);  Op2:=round(Operator[2]/20);
         Stepsize:=(Operator[4]-Operator[3])/(EndOffset-StartOffset)*80;
         Factor:=Operator[3];  Ti:=0;
         Ti:=Op1;
         Addr1:=AlphaSAddr+StartOffset div 80;
         repeat
            DataA:=ptr(Addr1); Addr1:=Addr1+1; Ti:=Ti+1;
            if Ti>=Op1 then begin
               Addr1:=Addr1+Op2;
               Factor:=Factor+(Stepsize*Op2);
               Ti:=0;
            end;
            DataA^:=round(DataA^/100*Factor);
            Factor:=Factor+Stepsize;
         until Addr1>=AlphaSAddr+round(EndOffset/80+0.5);
      end else begin
         Op1:=Operator[1]*4;  Op2:=Operator[2]*4;
         Stepsize:=(Operator[4]-Operator[3])/(EndOffset-StartOffset)*4;
         Factor:=Operator[3];  Ti:=0;
         Ti:=Op1;
         Addr1:=SAddr+StartOffset;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4; Ti:=Ti+1;
            if Ti>=Operator[1] then begin
               Addr1:=Addr1+Op2;
               Factor:=Factor+(Stepsize*Op2)/4;
               Ti:=0;
            end;
            Data1^:=round(Data1^/100*Factor);
            Factor:=Factor+Stepsize;
         until Addr1>=SAddr+EndOffset;
      end;
   end;
end;



function DEFINEHEAVY:boolean;


procedure DRAWGRAPH;

var Middle      :integer;

const x=240;
const y=68;

begin
   RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
   with _WaveOp[OPos] do begin
      SetAPen(DWindow^.RPort,0);
      RectFill(DWindow^.RPort,x,y-26,x+160,y);
      RectFill(DWindow^.RPort,x,y+8,x+160,y+20);
      s:=PText[81]+' Ti+Tp='+intstr(Operator[1]+Operator[2])+' Bytes';
      WRITE(x+2,y+7,2,0,DWindow^,s);
      Middle:=round((160*Operator[1]) div (Operator[1]+Operator[2]))+x;
      SetAPen(DWindow^.RPort,6);
      Move(DWindow^.RPort,x,y-26);   Draw(DWindow^.RPort,Middle,y-26);
      Draw(DWindow^.RPort,Middle,y); Draw(DWindow^.RPort,x+160,y);
      DRAWLINE(DWindow^,x,round(y-Operator[3]/3.8),x+160,round(y-Operator[4]/3.8),3)
   end;
end;


begin
   DEFINEHEAVY:=false;
   if not OPENDWIN(165,0,DWindow,PText[76],3,0) then exit;
   with _WaveOp[OPos] do begin
      Operation:=14;
      MAKEBORDER(DWindow^,238,40,402,70,NEGATIVE);
      MAKEBORDER(DWindow^,238,73,402,89,NEGATIVE);
      CREATEGADS(1,0,0);
      ACTIVECHANNELGADS(ActiveMode[0],Channels);
      for i:=1 to 4 do begin
         CREATEPROPGAD(10,77+17*i,pred(Operator[i])*65,65,i,8,DWindow^);
         Buffer[i]:=intstr(Operator[i]);
      end;
      SchieberInfo[3]:=Propinfo(FREEHORIZ,pred(Operator[3])*661,0,655,0,0,0,0,0,0,0);
      SchieberInfo[4]:=Propinfo(FREEHORIZ,pred(Operator[4])*661,0,655,0,0,0,0,0,0,0);

      WRITE(414,95,2,0,DWindow^,PText[77]);
      WRITE(414,112,2,0,DWindow^,PText[78]);
      WRITE(414,129,2,0,DWindow^,PText[79]);
      WRITE(414,146,2,0,DWindow^,PText[80]);

      DKnopf[9]:=Gadget(NIL,DKnopf[1].LeftEdge+(DKnopf[1].Width-21) div 2,90,
                        21,12,GADGHIMAGE+GADGIMAGE,TOGGLESELECT+RELVERIFY,
                        BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,20,0);
      WRITE(DKnopf[1].LeftEdge+DKnopf[1].Width div 2,106,2,3,DWindow^,PText[23]);
      if ((MemAAlpha[0,1] or MemAAlpha[0,3])=0) or (Operator[1]<20)
      or (Operator[2]<20) then DKnopf[9].Flags:=DKnopf[9].Flags or GADGDISABLED;
      if (OpType and $80=$80) then DKnopf[9].Flags:=DKnopf[9].Flags or SELECTED;
      AddGadget(DWindow,^DKnopf[9],NIL);
      for i:=1 to 4 do AddGadget(DWindow,^TextGad[i],NIL);
      for i:=1 to 4 do AddGadget(DWindow,^Schieber[i],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      DRAWGRAPH;
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;
         if (GadCode=9) or not (Schieber[1].flags and SELECTED=0) then begin
            Operator[1]:=succ(SchieberInfo[1].HorizPot div 65);
            if Operator[1]>1000 then Operator[1]:=1000;
            if Operator[1]<1 then Operator[1]:=1;
            Buffer[1]:=intstr(Operator[1]);
            DRAWGRAPH;
         end;
         if Gadcode=10 then begin
            val(Buffer[1],Operator[1],i);
            if Operator[1]>1000 then Operator[1]:=1000;
            if Operator[1]<1 then Operator[1]:=1;
            Buffer[1]:=intstr(Operator[1]);
            SchieberInfo[1].HorizPot:=pred(Operator[1])*65;
            DRAWGRAPH;
         end;

         if (GadCode=11) or not (Schieber[2].flags and SELECTED=0) then begin
            Operator[2]:=succ(SchieberInfo[2].HorizPot div 65);
            if Operator[2]>1000 then Operator[2]:=1000;
            if Operator[2]<1 then Operator[2]:=1;
            Buffer[2]:=intstr(Operator[2]);
            DRAWGRAPH;
         end;
         if GadCode=12 then begin
            val(Buffer[2],Operator[2],i);
            if Operator[2]>1000 then Operator[2]:=1000;
            if Operator[2]<1 then Operator[2]:=1;
            Buffer[2]:=intstr(Operator[2]);
            SchieberInfo[2].HorizPot:=pred(Operator[2])*65;
            DRAWGRAPH;
         end;

         if GadCode in [9..12] then begin
            if ((MemAAlpha[0,1] or MemAAlpha[0,3])<>0) and (Operator[1]>=20)
            and (Operator[2]>=20) then DKnopf[9].Flags:=DKnopf[9].Flags and not GADGDISABLED;
            if (Operator[1]<20) or (Operator[2]<20) then DKnopf[9].Flags:=DKnopf[9].Flags or GADGDISABLED;
         end;

         if (GadCode=13) or not (Schieber[3].flags and SELECTED=0) then begin
            Operator[3]:=succ(SchieberInfo[3].HorizPot div 661);
            if Operator[3]>100 then Operator[3]:=100;
            if Operator[3]<1 then Operator[3]:=1;
            Buffer[3]:=intstr(Operator[3]);
            DRAWGRAPH;
         end;
         if GadCode=14 then begin
            val(Buffer[3],Operator[3],i);
            if Operator[3]>100 then Operator[3]:=100;
            if Operator[3]<1 then Operator[3]:=1;
            Buffer[3]:=intstr(Operator[3]);
            SchieberInfo[3].HorizPot:=pred(Operator[3])*661;
            DRAWGRAPH;
         end;

         if (GadCode=15) or not (Schieber[4].flags and SELECTED=0) then begin
            Operator[4]:=succ(SchieberInfo[4].HorizPot div 661);
            if Operator[4]>100 then Operator[4]:=100;
            if Operator[4]<1 then Operator[4]:=1;
            Buffer[4]:=intstr(Operator[4]);
            DRAWGRAPH;
         end;
         if GadCode=16 then begin
            val(Buffer[4],Operator[4],i);
            if Operator[4]>100 then Operator[4]:=100;
            if Operator[4]<1 then Operator[4]:=1;
            Buffer[4]:=intstr(Operator[4]);
            SchieberInfo[4].HorizPot:=pred(Operator[4])*661;
            DRAWGRAPH;
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if not (DKnopf[9].Flags and SELECTED=0) and (DKnopf[9].Flags and GADGDISABLED=0)
      then _WaveOp[OPos].OpType:=$80 else _WaveOp[OPos].OpType:=0;
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINEHEAVY:=true;
      Channels:=GETACTIVECHANNELS(ActiveMode[0]);
      SoundMode:=ActiveMode[0];
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure DOMIXAROUND(SAddr,AlphaSAddr,StartOffset,EndOffset :long);

var Addr1,Addr2         :long;
var Data1,Data2         :^long;
var DataA1,DataA2       :^byte;

begin
   if SAddr<>0 then begin
      Addr1:=SAddr+StartOffset; Addr2:=SAddr+EndOffset;
      while Addr1<Addr2 do begin
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         Data2:=ptr(Addr2); Addr2:=Addr2-4;
         Data1^:=(Data1^+Data2^) div 2;
         Data2^:=Data1^;
      end;
   end;
   if AlphaSAddr<>0 then begin
      Addr1:=AlphaSAddr+StartOffset div 80;
      Addr2:=AlphaSAddr+round(EndOffset/80+0.5);
      while Addr1<Addr2 do begin
         DataA1:=ptr(Addr1); Addr1:=Addr1+1;
         DataA2:=ptr(Addr2); Addr2:=Addr2-1;
         DataA1^:=DataA1^ div 2 + DataA2^ div 2;
         DataA2^:=DataA1^;
      end;
   end;
end;



function DEFINEMIXAROUND:boolean;

begin
   _WaveOp[OPos].Operation:=15;
   _WaveOp[OPos].Channels:=$3F;
   _WaveOp[OPos].WAreaA:=AreaA[0];
   _WaveOp[OPos].WAreaE:=AreaE[0];
   DEFINEMIXAROUND:=true;
end;



procedure DOTRIAC(SAddr,StartOffset,EndOffset :long);

var NowKill,DataBefore  :long;
var Kill                :boolean;

begin
   with _WaveOp[OPos] do begin
      Kill:=false;
      NowKill:=round(Operator[1]*MAX24/90);
      if OpType=1 then begin
         Addr1:=SAddr+StartOffset+4;
         Data1:=ptr(SAddr); DataBefore:=Data1^;
         if abs(Data1^)<NowKill then Kill:=true;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            if abs(Data1^)>NowKill then Kill:=false;
            if (Data1^>0) and (DataBefore<0) or
               (Data1^<0) and (DataBefore>0) or
               (Data1^=0) or (DataBefore=0) then Kill:=true;
            DataBefore:=Data1^;
            if Kill then Data1^:=0;
         until Addr1>=SAddr+EndOffset;
      end else if OpType=2 then begin
         Addr1:=SAddr+StartOffset+4;
         Data1:=ptr(SAddr); DataBefore:=Data1^;
         if abs(Data1^)>NowKill then Kill:=true;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            if (abs(Data1^)<NowKill) and (DataBefore>NowKill) or
               (abs(Data1^)<NowKill) and (abs(DataBefore)>abs(Data1^))
               then Kill:=true;
            if (Data1^>0) and (DataBefore<0) or
               (Data1^<0) and (DataBefore>0) or
               (Data1^=0) then Kill:=false;
            DataBefore:=Data1^;
            if Kill then Data1^:=0;
         until Addr1>=SAddr+EndOffset;
      end;
   end;
end;



function DEFINETRIAC:boolean;

var MySList     :SelectListGad;

begin
   DEFINETRIAC:=false;
   if not OPENDWIN(106,0,DWindow,PText[86],3,1) then exit;
   with _WaveOp[OPos] do begin
      Operation:=16;
      CREATEGADS(1,1,0);
      ACTIVECHANNELGADS(ActiveMode[0],Channels);
      DKnopf[9].GadgetText:=^DKnopfTx[OpType];
      for i:=1 to 2 do DKnopfTx[i]:=IntuiText(2,0,0,4,2,^CustomTA,PText[i+86],NIL);
      MySList:=SelectListGad(DWindow,^DKnopf[9],OpType,0,0,0,ITTArr(^DKnopfTx[1],
                              ^DKnopfTx[2],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));
      CREATEPROPGAD(10,86,pred(Operator[1])*744,736,1,9,DWindow^);
      Buffer[1]:=intstr(Operator[1]);

      WRITE(414,87,2,0,DWindow^,PText[89]);
      AddGadget(DWindow,^TextGad[1],NIL);
      AddGadget(DWindow,^Schieber[1],NIL);
      AddGadget(DWindow,^DKnopf[9],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if GadCode=9 then OpType:=DOSELECTLIST(^MySList);

         if (GadCode=10) or not (Schieber[1].flags and SELECTED=0) then begin
            Operator[1]:=succ(SchieberInfo[1].HorizPot div 744);
            if Operator[1]<1 then Operator[1]:=1;
            if Operator[1]>89 then Operator[1]:=89;
            Buffer[1]:=intstr(Operator[1]);
            RefreshGadgets(^TextGad[1],DWindow,NIL);
         end;
         if Gadcode=11 then begin
            val(Buffer[1],Operator[1],i);
            if Operator[1]<1 then Operator[1]:=1;
            if Operator[1]>89 then Operator[1]:=89;
            Buffer[1]:=intstr(Operator[1]);
            SchieberInfo[1].HorizPot:=pred(Operator[1])*744;
            RefreshGadgets(^Schieber[1],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode in [68,69]);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINETRIAC:=true;
      Channels:=GETACTIVECHANNELS(ActiveMode[0]);
      SoundMode:=ActiveMode[0];
      WAreaA:=AreaA[0]; WAreaE:=AreaE[0];
   end;
end;



procedure INITKEYS;

begin
   Octave:=2;
   with Notes do KeyRates:=KeyArr(
      bn_PlayRate[5,5],bn_PlayRate[5,7],0,
      bn_PlayRate[5,10],bn_PlayRate[5,12],bn_PlayRate[6,2],0,
      bn_PlayRate[6,5],bn_PlayRate[6,7],0,
      bn_PlayRate[6,10],bn_PlayRate[6,12],0,0,

      bn_PlayRate[5,4],bn_PlayRate[5,6],bn_PlayRate[5,8],bn_PlayRate[5,9],bn_PlayRate[5,11],bn_PlayRate[6,1],bn_PlayRate[6,3],
      bn_PlayRate[6,4],bn_PlayRate[6,6],bn_PlayRate[6,8],bn_PlayRate[6,9],bn_PlayRate[6,11],0,0,0,0,0,

      bn_PlayRate[4,5],bn_PlayRate[4,7],0,
      bn_PlayRate[4,10],bn_PlayRate[4,12],bn_PlayRate[5,2],0,
      bn_PlayRate[5,5],bn_PlayRate[5,7],0,0,0,0,0,0,0,

      bn_PlayRate[4,4],bn_PlayRate[4,6],bn_PlayRate[4,8],bn_PlayRate[4,9],bn_PlayRate[4,11],bn_PlayRate[5,1],bn_PlayRate[5,3],
      bn_PlayRate[5,4],bn_PlayRate[5,6],bn_PlayRate[5,8]);
end;



procedure INITVARS;

type StrArr12 =array [1..12] of string;
type RealArr12=array [1..12] of real;
type LongArr6 =array [1..6]  of long;
type ShortArr6=array [1..6]  of short;

var Note_String :StrArr12;
var Note_Real   :RealArr12;
var Operators   :LongArr6;
var i           :byte;
var XChX,XChY   :ShortArr6;
var LoadAlert   :boolean;


procedure INITSETUP;

begin
   Operators:=LongArr6(-1,-1,-1,-1,-1,-1);
   for i:=1 to MAXOPS do _WaveOp[i]:=WaveOp(WOP_SMALL,2,0,0,CH_LEFT+CH_RIGHT,0,Operators,0,0,'',0,0);
   for i:=1 to FUNCTS do with LastSetup[i] do begin
      Operation:=i;
      OpType:=0;         Flags:=0;
      SoundMode:=MD_MONO;
      Channels:=CH_CENTER; OpString:=chr(0);
      for j:=1 to 6 do Operator[j]:=0;
   end;
   with LastSetup[1] do begin {*** GENERATOR ***}
      Operator[1]:=200; Operator[2]:=20;
      Operator[3]:=0;   Operator[4]:=2;
      OpType:=$1;       OpString:='';  Channels:=CH_CENTER;
   end;
   with LastSetup[2] do begin {*** FREQUENZ ***}
      Operator[1]:=5;   Operator[2]:=1;
      Operator[3]:=40;
      OpType:=1;      OpString:='';   Channels:=CH_CENTER;
   end;
   with LastSetup[3] do begin {*** AMPLITUDE ***}
      Operator[1]:=100; Operator[2]:=1;
      Operator[3]:=40;
      OpType:=1; OpString:=''; Channels:=CH_CENTER;
   end;
   LastSetup[4].ChunkSize:=WOP_SMALL; {*** DIFFERENCER ***}
   LastSetup[5].ChunkSize:=WOP_SMALL; {*** INTEGRATER ***}
   with LastSetup[6] do begin {*** ANTIALIAS ***}
      for i:=1 to 6 do Operator[i]:=25;
      ChunkSize:=WOP_SMALL;
   end;
   LastSetup[7].ChunkSize:=WOP_SMALL;  {*** MAKEDRUM ***}
   with LastSetup[8] do begin {*** ECHO ***}
      ChunkSize:=WOP_SMALL;
      Operator[1]:=14;        Operator[2]:=1000;
      Operator[3]:=CH_CENTER; Operator[4]:=0;
      Operator[5]:=130;
      Operator[6]:=50;
      OpType:=1;       Channels:=CH_LEFT;
   end;
   with LastSetup[9] do begin          {*** VOLUME ***}
       for i:=1 to 6 do Operator[i]:=25;
       OpType:=$80;
   end;
   LastSetup[10].ChunkSize:=WOP_SMALL; {*** REVERSE ***}
   with LastSetup[11] do {*** OVERCROSS ***}
    for i:=1 to 6 do Operator[i]:=3;
   with LastSetup[12] do               {*** AD-WANDLER ***}
    for i:=1 to 6 do Operator[i]:=7;
   LastSetup[13].ChunkSize:=WOP_SMALL;  {*** CUTZERO ***}
   with LastSetup[14] do begin {*** ZERHACKER ***}
      Operator[1]:=50;  Operator[2]:=50;
      Operator[3]:=100; Operator[4]:=1;
   end;
   LastSetup[15].ChunkSize:=WOP_SMALL; {*** MIXAROUND ***}
   with LastSetup[16] do begin {*** TRIAC ***}
      Operator[1]:=30;  OpType:=1;
   end;
   with LastSetup[17] do begin {*** CHANNELCONVERTER ***}
      OpType:=1;
      Operator[1]:=1; Operator[2]:=2;
   end;
   with LastSetup[18] do begin {*** SCALE ***}
      Operator[1]:=1;
      OpType:=2;
   end;
end;


begin   {*** INITVARS ***}
   SharePayed:=false;
   FRShow:='';   PathFR:=''; DirFR:=''; FileFR:='';
   AnimPath:='';
   AnimHandle:=0;
{   for i:=1 to 2 do AnimBMemA[i]:=0;}
   IMem:=0;           CalcMem:=0;      MemAMod:=0;     TextMemA:=0;
   MemAEff:=0;        PlayLUndo:=0;    PatternPos:=1;  SelPattern:=0;
   Patterns:=0;       Entries:=0;      EntryPos:=1;    SelEntry:=0;
   FirstPattern:=NIL; FirstEntry:=NIL;
   InfoWindow:=NIL;
   IntuiWindow1:=NIL;   IntuiWindow2:=NIL; IntuiWindow3:=NIL;
   IntuiWindow4:=NIL;
   ProcessOff:=false;   SampleEd:=false;     PlayEd:=false;
   DoDoubleSize:=false; TDeviceValid:=true;
   EmptyMsgPrc:=MsgPrc(0,'','','','','',0,0,0,0,0,NIL);
   for i:=0 to 5 do begin
      MySDHeader[i]:=NIL;
      SAttack[i]:=0;    SDecay[i]:=0; SSustain[i]:=0; SRelease[i]:=0;
      PlayL24[i]:=0;    MemL24[i]:=0;
      DrawOffset[i]:=0; Zoom[i]:=4;   AreaA[i]:=0;    AreaE[i]:=0;
      ActiveChannels[i]:=CH_LEFT;     ActiveMode[i]:=MD_MONO;
      SInfo[i]:='Buffer '+intstr(i);
      for j:=1 to 6 do begin
         MemA24[i,j]:=0;    MemA16[i,j]:=0;   MemA8[i,j]:=0;
         MemAAlpha[i,j]:=0; MemAUNDO[i,j]:=0; AlphaUNDO[i,j]:=0;
      end;
   end;
   for i:=1 to 4 do PlayMemA[i]:=0;

   for i:=1 to 70 do FName[i]:='';
   OPos:=0; OEnd:=0;
   scr:=false;     WTAChanged:=false; FirstUNDO:=0;

   Note_String:=StrArr12(' A','Bb',' B',' C','C#',' D','Eb',' E',
                         ' F','F#',' G','G#');

   Note_Real:=RealArr12(28160,29829,31677,33453,35441,37679,39772,42112,44744,
                        47727,50416,53426);
   for i:=1 to 12 do with Notes do begin
      bn_NoteName[6,i]:='6'+Note_String[i];
      bn_SampleFreq[6,i]:=Note_Real[i];
      bn_PlayRate[6,i]:=round(10000000/(bn_SampleFreq[6,i]*2.79365));
   end;
   for j:=5 downto 0 do for i:=1 to 12 do with Notes do begin
      if j<>0 then bn_NoteName[j,i]:=intstr(j)+Note_String[i] else bn_NoteName[j,i]:=' '+Note_String[i];
      bn_SampleFreq[j,i]:=bn_SampleFreq[j+1,i]/2;
      bn_PlayRate[j,i]:=round(10000000/(bn_SampleFreq[j,i]*2.79365))
   end;
   INITKEYS;

   XChX:=ShortArr6(-10, 10,  0,   0,   0,0);
   XChY:=ShortArr6(  0,  0,  0,  24,   0,0);
   ChSurround:=ChCoords(XChX,XChY);

   XChX:=ShortArr6(-10, 10,  0,-10, 10,0);
   XChY:=ShortArr6(  0,  0,  0, 26, 26,0);
   ChQuadro:=ChCoords(XChX,XChY);

   XChX:=ShortArr6(-10, 10,  0, -10, 10,  0);
   XChY:=ShortArr6(  0,  0,  0,  28, 28, 14);
   ChAC3:=ChCoords(XChX,XChY);
   INITSETUP;
   for i:=1 to 6 do GMem[i]:=0;
   for i:=1 to 6 do ButtonMem[i]:=0;
   KnobMem:=0;
   Prefs:=r_Prefs(true,false,true,false,true,false,false,true,
                  CH_LEFT,true,true,true,true,
                  'T:','SAMPLES','PLAYLISTS','','',$3F,0,190,'UNIVERSAL_IFF','deutsch','WaveTracer DS',$A9004,640,512,1,1,1,1,1,0,40,
                  IntArr5(0    ,32000, 0,32000,    0),
                  IntArr5(32000,32000,17,   17,32000),
                  BArr5(true,true,true,true,true),184,148);

   LoadAlert:=false;
   FHandle:=DosOpen(PREFFILE,MODE_OLDFILE);
   if FHandle<>0 then begin
      l:=DosRead(FHandle,^i,1);
      if i=PREFVERSION then begin
         l:=DosRead(FHandle,^Prefs,sizeof(r_Prefs));
         for i:=1 to FUNCTS do with LastSetup[i] do begin
            l:=DosRead(FHandle,^ChunkSize,1);
            l:=DosRead(FHandle,ptr(addr(LastSetup[i])+1),ChunkSize-1);
            if LastSetup[i].Operation<>i then LoadAlert:=true;
         end;
      end;
      DosClose(FHandle);
   end;
   If LoadAlert then INITSETUP;
   GETNOTEPOS;
end;



procedure PLAYKEYS(RawCode :byte, XWindow :p_Window, PlayTime :long);

var s           :string;
var i,j,k       :byte;

begin
   i:=SetTaskPri(FindTask(NIL),PLAYPRIORITY);
   if RawCode in [80..82] then begin
      INITKEYS;
      if RawCode=82 then for i:=2 to 58 do KeyRates[i]:=KeyRates[i] div 2;
      if RawCode=80 then for i:=2 to 58 do KeyRates[i]:=KeyRates[i] * 2;
      Octave:=RawCode-79;
      s:=PText[248]+' '+intstr(Octave);
      TASKMESSAGE(s);
   end else if RawCode=64 then RawCode:=STARTSOUND(Prefs.SRate,0,XWindow,0,64,64)
   else if RawCode=66 then RawCode:=STARTSOUND(Prefs.SRate,0,XWindow,2,64,64);
   while (RawCode in [2..58]) and (KeyRates[RawCode]<>0) do
     RawCode:=STARTSOUND(KeyRates[RawCode],PlayTime,XWindow,0,64,64);
   i:=SetTaskPri(FindTask(NIL),0);
end;



procedure MARKAREA;

var l   :long;
var i   :byte;

procedure CLIPIT(x,x2 :long);

begin
   MyWindow^.RPort^.Mask:=WINMASK;
   if x>x2 then exchange(x,x2);
   x:=(x-DrawOffset[0]) div Zoom[0];     if x<0 then x:=0;
   x2:=(x2-DrawOffset[0]) div Zoom[0];   if x2>pred(MyScreen^.Width) then x2:=pred(MyScreen^.Width);
   if x2>0 then begin
      SetAPen(MyWindow^.RPort,31);
      RectFill(MyWindow^.RPort,x,MyScreen^.BarHeight,x2,RealYPos);
   end;
   SetAPen(Mywindow^.RPort,0);
   if x2=0 then x:=1;
   if x>0 then RectFill(Mywindow^.RPort,0,MyScreen^.BarHeight,x-1,RealYPos);
   if x2<MyScreen^.Width then RectFill(Mywindow^.RPort,x2+1,MyScreen^.BarHeight,pred(MyScreen^.Width),RealYPos);
   MyWindow^.RPort^.Mask:=$FF;
   WRITETBWINDOW;
end;


procedure STEPLEFT;

begin
   l:=19*Zoom[0];
   if DrawOffset[0]<l then l:=DrawOffset[0];
   DrawOffset[0]:=DrawOffset[0]-l;
   DrawOffset[0]:=DrawOffset[0] div 4 * 4;
   ScrollRaster(MyWindow^.RPort,-l div Zoom[0],0,0,MyScreen^.BarHeight,pred(MyScreen^.Width),RealYPos);
   for i:=1 to 6 do DRAWWAVE(MemA24[0,i],MemAAlpha[0,i],i,1);
end;


procedure STEPRIGHT;

begin
   l:=19*Zoom[0];
   if l+DrawOffset[0]>PlayL24[0]-MyScreen^.Width*Zoom[0] then l:=PlayL24[0]-MyScreen^.Width*Zoom[0]-DrawOffset[0];
   DrawOffset[0]:=DrawOffset[0]+l;
   if DrawOffset[0]<0 then DrawOffset[0]:=0;
   DrawOffset[0]:=DrawOffset[0] div 4 * 4;
   ScrollRaster(MyWindow^.RPort,l div Zoom[0],0,0,MyScreen^.BarHeight,pred(MyScreen^.Width),RealYPos);
   for i:=1 to 6 do DRAWWAVE(MemA24[0,i],MemAAlpha[0,i],i,2);
end;


begin
   if (MemA24[0,1] or MemA24[0,3])=0 then exit;
   l:=MyScreen^.MouseX*Zoom[0]+DrawOffset[0];
   if (l<AreaA[0]) or (l>AreaE[0]) then begin
      AreaA[0]:=l;
      if AreaA[0]>PlayL24[0] then AreaA[0]:=PlayL24[0];
      AreaE[0]:=AreaA[0];
   end else begin
      repeat
         if MyScreen^.MouseX<5 then STEPLEFT;
         if MyScreen^.MouseX>MyScreen^.Width-5 then STEPRIGHT;
         CLIPIT(AreaA[0],AreaE[0]);
         l:=MyScreen^.MouseX*Zoom[0]+DrawOffset[0];
      until (l>AreaE[0]) or (l<AreaA[0]) or (Knopf[32].Flags and SELECTED=0);
      if l<AreaA[0] then exchange(AreaE[0],AreaA[0]);
   end;
   while not (Knopf[32].Flags and SELECTED=0) do begin
      while ((AreaE[0]<>MyScreen^.MouseX*Zoom[0]+DrawOffset[0]) or
       ((DrawOffset[0]>0) and (MyScreen^.MouseX<5)) or
       ((DrawOffset[0]<PlayL24[0]-MyScreen^.Width*Zoom[0]) and (MyScreen^.MouseX>MyScreen^.Width-5)))
       and not (Knopf[32].Flags and SELECTED=0) do begin
         if (MyScreen^.MouseX<5) and (MyScreen^.MouseX*Zoom[0]+DrawOffset[0]<PlayL24[0]) then STEPLEFT;
         if (MyScreen^.MouseX>MyScreen^.Width-5) and (MyScreen^.MouseX*Zoom[0]+DrawOffset[0]<PlayL24[0]) then STEPRIGHT;
         AreaE[0]:=MyScreen^.MouseX*Zoom[0]+DrawOffset[0];
         if AreaE[0]>PlayL24[0] then AreaE[0]:=PlayL24[0];
         CLIPIT(AreaA[0],AreaE[0]);
      end;
   end;
   if AreaA[0]>AreaE[0] then exchange(AreaA[0],AreaE[0]);
   if AreaE[0]=AreaA[0] then
    if AreaE[0]<PlayL24[0] then AreaE[0]:=AreaE[0]+4 else AreaA[0]:=AreaA[0]-4;
   CLIPIT(AreaA[0],AreaE[0]);
   PROCESSWAVE($8,true);
end;



procedure DRAWFREE(Mode :byte);

var X,predX,Y,predY,x1,x2,y1,y2,DrawX1,DrawX2   :integer;
var ChNum,ActCh,i,ChPos,Color                   :byte;
var Size,Size2,Offset,Divider                   :real;
var YTop,YBottom                                :word;


procedure CREATENEWDATA(SAddr,EAddr,VData1,VData2 :long; ActCh :byte);

var Step,Value  :real;
var Addr1       :long;
var Data1       :^long;

begin
   if (MemA24[0,ActCh]=0) or not (SAddr in [MemA24[0,ActCh]..MemA24[0,ActCh]+PlayL24[0]])
   or not (EAddr in [MemA24[0,ActCh]..MemA24[0,ActCh]+PlayL24[0]]) then exit;
   SAddr:=SAddr div 4 * 4;
   Step:=(VData2-VData1)/(EAddr-SAddr)*4;
   Addr1:=SAddr;
   Value:=VData1;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+4;
      Data1^:=round(Value);
      if Data1^>MAX24 then Data1^:=MAX24 else if Data1^<-MAX24 then Data1^:=-MAX24;
      Value:=Value+Step;
   until Addr1>=EAddr;
   EAddr:=EAddr+400;
   if EAddr>MemA24[0,ActCh]+PlayL24[0] then EAddr:=MemA24[0,ActCh]-PlayL24[0];
   CALCCHANNELS(SAddr-MemA24[0,ActCh],EAddr-MemA24[0,ActCh],UsedChans);
end;


begin
   if (MemAAlpha[0,1] or MemAAlpha[0,3])<>0 then Color:=25 else Color:=0;
   ChNum:=0;
   for i:=19 to 25 do if not (Knopf[i].Flags and SELECTED=0) then ChNum:=ChNum+1;
   if Prefs.ShowData then ChNum:=ChNum+1;
   if ChNum=0 then exit;
   repeat
      ActCh:=0;
      ChPos:=0;
      i:=1;
      repeat
         if not (Knopf[i+18].Flags and SELECTED=0) then begin
            ChPos:=ChPos+1;
            Size:=round((MyScreen^.Height-SCRDIFF-10)/ChNum);
            Size2:=(MyScreen^.Height-SCRDIFF-10)/ChNum/2;
            Divider:=18400000 / Size;
            Offset:=pred(ChPos)*Size+MyScreen^.BarHeight+(Size/2);
            if MyScreen^.MouseY in [round(Offset-Size2)..round(Offset+Size2)] then ActCh:=i;
         end;
         i:=i+1;
      until (i>6) or (ActCh>0);
   until (ActCh>0) or Prefs.ShowData;
   if ActCh=0 then exit;
   YTop:=round(Offset-MAX24 / Divider);
   YBottom:=round(Offset+MAX24 / Divider);
   if Mode=1 then begin
      predX:=-1;
      while not (Knopf[32].Flags and SELECTED=0) do begin
         X:=MyScreen^.MouseX;
         Y:=MyScreen^.MouseY;
         if Y>YBottom then Y:=YBottom;
         if Y<YTop then Y:=YTop;
         if X*Zoom[0]+DrawOffset[0]<PlayL24[0] then begin
            if (predX>-1) and (predX<>X) then begin
               x1:=X; x2:=predX;
               y1:=Y; y2:=predY;
               if x2<x1 then begin
                  exchange(x1,x2);
                  exchange(y1,y2);
               end;
               SetAPen(MyWindow^.RPort,Color);
               RectFill(MyWindow^.RPort,x1,YTop,x2,YBottom);
               SetAPen(MyWindow^.RPort,4);
               Move(MyWindow^.RPort,x1,y1);
               Draw(MyWindow^.RPort,x2,y2);
               x2:=x2+1;
               CREATENEWDATA(x1*Zoom[0]+DrawOffset[0]+MemA24[0,ActCh],x2*Zoom[0]+DrawOffset[0]+MemA24[0,ActCh],round((Y1-Offset)*Divider),round((Y2-Offset)*Divider),ActCh);
            end;
            predX:=X;
            predY:=Y;
         end;
      end;
   end else if Mode=2 then begin
      x1:=-1;
      while not (Knopf[32].Flags and SELECTED=0) do begin
         if x1=-1 then begin
            x1:=MyScreen^.MouseX;   x2:=x1;
            y1:=MyScreen^.MouseY;   y2:=y1;
         end else begin
            if DrawX2<DrawX1 then exchange(DrawX1,DrawX2);
            SetAPen(MyWindow^.RPort,Color);
            RectFill(MyWindow^.RPort,DrawX1,YTop,DrawX2,YBottom);
            x2:=MyScreen^.MouseX;
            y2:=MyScreen^.MouseY
         end;
         if x2*Zoom[0]+DrawOffset[0]<PlayL24[0] then begin
            DrawX1:=x1;   DrawX2:=x2;
            if y1<YTop then y1:=YTop;
            if y1>YBottom then y1:=YBottom;
            if y2<YTop then y2:=YTop;
            if y2>YBottom then y2:=YBottom;
            SetAPen(MyWindow^.RPort,4);
            Move(MyWindow^.RPort,x1,y1);
            Draw(MyWindow^.RPort,x2,y2);
         end;
      end;
      if x1>x2 then begin
         exchange(x1,x2);
         exchange(y1,y2);
      end;
      x2:=x2+1;
      CREATENEWDATA(x1*Zoom[0]+DrawOffset[0]+MemA24[0,ActCh],x2*Zoom[0]+DrawOffset[0]+MemA24[0,ActCh],round((Y1-Offset)*Divider),round((Y2-Offset)*Divider),ActCh);
   end;
   DRAWWAVE(MemA24[0,ActCh],MemAAlpha[0,ActCh],ActCh,0);
end;



procedure HANDLEMAININTUITION;

var i           :integer;


procedure FINDZERO(GadCode :byte);

var OldOffset,OffsetDiff,DataX  :long;
var Data1                       :^long;

begin
   if (GadCode=7) and (AreaA[0]=0) then exit;
   if (GadCode=12) and (AreaE[0]=PlayL24[0]) then exit;
   if GadCode in [7,8] then OldOffset:=AreaA[0] else OldOffset:=AreaE[0];
   OffsetDiff:=0;
   repeat
      DataX:=$1FFFFFFF;
      if GadCode in [7,11] then OffsetDiff:=OffsetDiff-4
       else OffsetDiff:=OffsetDiff+4;
      for i:=1 to 5 do if MemA24[0,i]<>0 then begin
         Data1:=ptr(MemA24[0,i]+OldOffset+OffsetDiff);
         if Data1^<DataX then DataX:=Data1^;
      end;
   until (DataX in [-10..10]) or ((OldOffset+OffsetDiff)>=PlayL24[0])
   or ((OldOffset+OffsetDiff)<=0) or (((OldOffset+OffsetDiff)=AreaA[0]))
   or (((OldOffset+OffsetDiff)=AreaE[0]));
   if GadCode in [7,8] then AreaA[0]:=AreaA[0]+OffsetDiff else AreaE[0]:=AreaE[0]+OffsetDiff;
end;


begin
   if IMsg<>NIL then begin
      if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
         GadHit:=IMsg^.Class;
         XGadget:=IMsg^.IAddress;
         GadCode:=XGadget^.GadgetID;
      end else if IMsg^.class=MENUPICK then begin
         Men:=(IMsg^.Code and $1F)+1;
         MenItem:=((IMsg^.Code and $7E0) div 32)+1;
         SItem:=((IMsg^.Code and $F800)  div 2048)+1;
      end else if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code
      else if IMsg^.Class=NEWSIZE then GadCode:=-NEWSIZE
      else if IMsg^.Class=_CLOSEWINDOW then GadCode:=-_CLOSEWINDOW;
      Reply_Msg(IMsg)
   end;

   case UsedWindow of
      0: PLAYKEYS(RawCode,MyWindow,0);
      1: PLAYKEYS(RawCode,IntuiWindow1,0);
      2: PLAYKEYS(RawCode,IntuiWindow2,0);
      4: PLAYKEYS(RawCode,IntuiWindow4,0);
      otherwise;
   end;

   if UsedWindow=0 then begin
      if (GadCode=32) and (GadHit=GADGETDOWN) then begin
         if not SampleEd or (SEdMode=1) then MARKAREA;
         if SampleEd and (SEdMode=2) then DRAWFREE(1);
         if SampleEd and (SEdMode=3) then DRAWFREE(2);
      end;
   end;
   if UsedWindow in [0,1] then begin
      if RawCode in [45,46,47,94,74,93] then case Rawcode of
         45: GadCode:=25;
         46: GadCode:=26;
         47: GadCode:=27;
         94: GadCode:=28;
         74: GadCode:=29;
         93: GadCode:=30;
      end;
      if GadCode=25 then begin
         AreaA[0]:=0; AreaE[0]:=4;
      end else if GadCode=27 then begin
         AreaA[0]:=PlayL24[0]-4;
         AreaE[0]:=PlayL24[0];
      end else if GadCode=26 then begin
         if (AreaA[0]=0) and (AreaE[0]=0) then AreaE[0]:=PlayL24[0] else begin
            AreaA[0]:=0; AreaE[0]:=0;
         end;
      end else if (GadCode=28) and (Zoom[0]>4) then begin
         if (AreaE[0]=0) or (Zoom[0]<MaxZoom) then Zoom[0]:=Zoom[0] div 8 * 4 else begin
            DrawOffset[0]:=AreaA[0];
            Zoom[0]:=succ((AreaE[0]-AreaA[0]) div (MyScreen^.Width*4)) * 4;
         end;
         if Zoom[0]<4 then Zoom[0]:=4;
         PROCESSWAVE($8,true);
      end else if (GadCode=29) and (Zoom[0]<MaxZoom) then begin
         Zoom[0]:=Zoom[0] * 2;
         if Zoom[0]>=MaxZoom then Zoom[0]:=MaxZoom;
         if MemL24[0]-MyScreen^.Width*Zoom[0]<DrawOffset[0] then DrawOffset[0]:=MemL24[0]-MyScreen^.Width*Zoom[0];
         if DrawOffset[0]<0 then DrawOffset[0]:=0;
         PROCESSWAVE($8,true);
      end else if GadCode=30 then begin
         Zoom[0]:=4;
         if MemL24[0]-MyScreen^.Width*Zoom[0]<DrawOffset[0] then DrawOffset[0]:=MemL24[0]-MyScreen^.Width*Zoom[0];
         if DrawOffset[0]<0 then DrawOffset[0]:=0;
      end else if GadCode=31 then begin
         Zoom[0]:=MaxZoom;
         DrawOffset[0]:=0;
      end;
      if GadCode in [19..27,30,31] then begin
         WRITETBWINDOW;
         PROCESSWAVE($8,true);
      end;

      if RawCode in [78,79] then begin
         l:=MSchieberInfo.HorizPot;
         if RawCode=78 then l:=l+succ(MSchieberInfo.HorizBody div 4)
         else l:=l-succ(MSchieberInfo.HorizBody div 4);
         if l>65535 then l:=65535;
         if l<0 then l:=0;
         MSchieberInfo.HorizPot:=l;
         Gadcode:=50;
      end;

      while (GadCode=50) or not (MSchieber.Flags and SELECTED=0) do begin
         l:=round((PlayL24[0]-MyScreen^.Width*Zoom[0]) / 65535 * MSchieberInfo.HorizPot) div 4 * 4;
         if l<>DrawOffset[0] then begin
            DrawOffset[0]:=l;
            if DrawOffset[0]>(PlayL24[0]-MyScreen^.Width*Zoom[0]) then DrawOffset[0]:=(PlayL24[0]-MyScreen^.Width*Zoom[0]);
            DrawOffset[0]:=(DrawOffset[0] div 4) * 4;
            if DrawOffset[0]<0 then DrawOffset[0]:=0;
            PROCESSWAVE($8,true);
         end;
         GadCode:=0;
      end;
   end else if UsedWindow=3 then begin
      if GadCode=-NEWSIZE then ANIMPLAY(-1);
      if GadCode=1 then begin
         l:=TASKREQUEST(AnimPath,AnimErrorTxt,NIL,PText[220],NIL);
         RemoveGadgets(IntuiWindow3,^E3Knopf);
         SetAPen(IntuiWindow3^.RPort,0);
         RectFill(IntuiWindow3^.RPort,5,17,IntuiWindow3^.Width-19,IntuiWindow3^.Height-3);
      end;
   end else if UsedWindow=4 then begin
      if GadCode=1 then val(TBBuffer[1],l,i)
      else if GadCode=2 then val(TBBuffer[2],l,i)
      else if GadCode=3 then begin
         val(TBBuffer[3],l,i);
         l:=l*4;
         if not (TBKnopf[11].Flags and SELECTED=0) then begin
            AreaA[0]:=AreaE[0]-l;
            if AreaA[0]<0 then AreaA[0]:=0;
         end else begin
            AreaE[0]:=AreaA[0]+l;
            if AreaE[0]>PlayL24[0] then AreaE[0]:=PlayL24[0];
         end;
      end else if GadCode=4 then AreaA[0]:=0
      else if (GadCode=5) and (AreaA[0]>0) then AreaA[0]:=AreaA[0]-4
      else if (GadCode=6) and (AreaA[0]<PlayL24[0]) then AreaA[0]:=AreaA[0]+4
      else if (GadCode=9) and (AreaE[0]>0) then AreaE[0]:=AreaE[0]-4
      else if (GadCode=10) and (AreaE[0]<PlayL24[0]) then AreaE[0]:=AreaE[0]+4
      else if (GadCode in [7,8,11,12]) then FINDZERO(GadCode)
      else if GadCode=13 then AreaE[0]:=PlayL24[0]
      else if GadCode=14 then begin
         TBKnopf[12].Flags:=TBKnopf[12].Flags and not SELECTED;
         RefreshGadgets(IntuiWindow4^.FirstGadget,IntuiWindow4,NIL);
      end else if GadCode=15 then begin
         TBKnopf[11].Flags:=TBKnopf[11].Flags and not SELECTED;
         RefreshGadgets(IntuiWindow4^.FirstGadget,IntuiWindow4,NIL);
      end;
      if GadCode in [1..2] then begin
         l:=l*4;
         if l<0 then l:=0;
         if l>PlayL24[0] then l:=PlayL24[0];
         if GadCode=1 then AreaA[0]:=l else AreaE[0]:=l;
      end;
      if GadCode in [1..13] then begin
         if AreaA[0]>AreaE[0] then exchange(AreaA[0],AreaE[0]);
         WRITETBWINDOW;
         if (AreaE[0]<4) and (PlayL24[0]>0) then AreaE[0]:=4;
         DRAWMARK(AreaA[0],AreaE[0],0)
      end;
   end;

   if (Men=3) or (GadCode=-_CLOSEWINDOW) then begin
      if (MenItem=6) or ((UsedWindow=2) and (GadCode=-_CLOSEWINDOW)) then begin
         if (UsedWindow=2) and (GadCode=-_CLOSEWINDOW)
          then Mi3[6].Flags:=Mi3[6].Flags and not CHECKED;
         if (Mi3[6].Flags and CHECKED=CHECKED) and (IntuiWindow2=NIL) then begin
            if not OPENINTUIWINDOW2 then DisplayBeep(NIL);
            if IntuiWindow2=NIL then Mi3[6].Flags:=Mi3[6].Flags and not CHECKED;
         end else if IntuiWindow2<>NIL then begin
            GETWINPOSITIONS;
            CloseWindow(IntuiWindow2);
            IntuiWindow2:=NIL;
         end;
      end;
      if (MenItem=7) or ((UsedWindow=3) and (GadCode=-_CLOSEWINDOW)) then begin
         if (UsedWindow=3) and (GadCode=-_CLOSEWINDOW)
          then Mi3[7].Flags:=Mi3[7].Flags and not CHECKED;
         if (Mi3[7].Flags and CHECKED=CHECKED) and (IntuiWindow3=NIL) then begin
            if not OPENINTUIWINDOW3 then DisplayBeep(NIL);
            if IntuiWindow3=NIL then Mi3[7].Flags:=Mi3[7].Flags and not CHECKED;
         end else if IntuiWindow3<>NIL then begin
            GETWINPOSITIONS;
            AnimPlay(-10);
            IntuiWindow3:=NIL;
         end;
      end;
      if (MenItem=8) or ((UsedWindow=4) and (GadCode=-_CLOSEWINDOW)) then begin
         if (UsedWindow=4) and (GadCode=-_CLOSEWINDOW)
          then Mi3[8].Flags:=Mi3[8].Flags and not CHECKED;
         if (Mi3[8].Flags and CHECKED=CHECKED) and (IntuiWindow4=NIL) then begin
            if not OPENINTUIWINDOW4 then DisplayBeep(NIL);
            if IntuiWindow4=NIL then Mi3[8].Flags:=Mi3[8].Flags and not CHECKED;
         end else if IntuiWindow4<>NIL then begin
            GETWINPOSITIONS;
            CloseWindow(IntuiWindow4);
            IntuiWindow4:=NIL;
         end;
      end;
   end;
end;



function HANDLETIMEPATTERNWINDOW:boolean;

var j           :long;
var ActPattern  :PlayListPattern;

begin
   HANDLETIMEPATTERNWINDOW:=false;
   if (Rawcode=76) and (SelPattern in [2..Patterns]) then begin
      SelPattern:=SelPattern-1;
      DRAWTIMEPATTERNLIST(false)
   end;
   if (RawCode=77) and (SelPattern in [1..pred(Patterns)]) then begin
      SelPattern:=SelPattern+1;
      DRAWTIMEPATTERNLIST(false)
   end;

   if GadCode in [8..14] then begin
      if PatternPos+GadCode-8<=Patterns then begin
         ActPattern:=FirstPattern;
         j:=PatternPos+GadCode-8;
         if j>0 then for i:=1 to j do ActPattern:=ActPattern^.NextPattern;
         ActPattern^.Name:=TPBuffer[GadCode-7];
      end;
      DRAWTIMEPATTERNLIST(false);
   end;

   if GadCode in [1..7] then begin
      l:=pred(GadCode)+PatternPos;
      if SelPattern=l then SelPattern:=0 else SelPattern:=l;
      DRAWTIMEPATTERNLIST(true);
   end;
   if GadCode=110 then begin
      INSERTNEWPATTERN;
      DRAWTIMEPATTERNLIST(false);
   end else if GadCode=111 then begin
      REMOVEOLDPATTERN;
      DRAWTIMEPATTERNLIST(false);
   end;
   if Patterns>0 then begin
      if (GadCode=108) and (PatternPos>1) then begin
         PatternPos:=PatternPos-1;
         DRAWTIMEPATTERNLIST(false);
      end;
      if (GadCode=109) and (PatternPos<Patterns) then begin
         PatternPos:=PatternPos+1;
         DRAWTIMEPATTERNLIST(false);
      end;
      while (Gadcode=100) or (TPSchieber.Flags and SELECTED=SELECTED)
      do begin
         l:=1+round(TPSchieberInfo.VertPot/(65535/Patterns));
         if l<1 then l:=1;
         if PatternPos<>l then begin
            PatternPos:=l;
            DRAWTIMEPATTERNLIST(false);
         end;
         GadCode:=0;
      end;
   end;
   if (Gadcode=113) then begin   {*** ALLES LSCHEN ***}
      if Prefs.Confirm then l:=TASKREQUEST(PText[262],PText[271],PText[220],NIL,PText[218]) else l:=1;
      if l=1 then begin
         FREEPLAYLIST;
         DRAWTIMEPATTERNLIST(false);
         HANDLETIMEPATTERNWINDOW:=true;
      end;
   end;
   if GadCode=114 then begin
      PathFR:=Prefs.PlaylistStr; FRTit:=PText[234]; FRShow:='';
      if FILEREQ then begin
         Prefs.PlayListStr:=PathFR;
         LOADPLL;
         DRAWTIMEPATTERNLIST(false);
         HANDLETIMEPATTERNWINDOW:=true;
      end;
   end;
   if Gadcode=115 then begin
      if Patterns=0 then l:=TASKREQUEST(PText[211],PText[212],NIL,PText[220],NIL) else begin
         PathFR:=Prefs.PlaylistStr; FRTit:=PText[241]; FRShow:='';
         if FILEREQ then begin
            CHECKSUFFIX('.PLL');
            Prefs.PlayListStr:=PathFR;
            SAVEPLL;
         end;
      end;
   end;
end;



procedure PLAYLISTED;

var i,l,m,InsertPos                     :long;
var ValInt                              :integer;
var TextGad                             :array [1..36] of Gadget;
var TextInfo                            :array [1..36] of StringInfo;
var Buffer,UndoBuffer                   :array [1..24] of string[5];
var LBuffer,LUndoBuffer                 :array [1..6] of string[30];
var SData                               :array [1..2,1..6] of integer;
var ActPattern                          :PlayListPattern;
var ActEntry                            :PlayListEntry;
var LEdge,TEdge                         :integer;


procedure DRAWENTRYLIST;

var MyEntry     :PlayListEntry;
var ECtr        :long;
var s           :string[5];

begin
   if EntryPos>Entries then EntryPos:=Entries;
   MyEntry:=FirstEntry;
   ActEntry:=FirstEntry;
   for i:=1 to EntryPos do MyEntry:=MyEntry^.NextEntry;
   ECtr:=EntryPos;
   if Entries>0 then begin
      repeat
         if ECtr in [EntryPos..EntryPos+5] then with MyEntry^ do begin
            if ECtr=SelEntry then begin
               SetAPen(DWindow^.RPort,3);
               if VolumeL=0 then DKnopf[13].Flags:=DKnopf[13].Flags and not SELECTED else DKnopf[13].Flags:=DKnopf[13].Flags or SELECTED;
               if VolumeR=0 then DKnopf[14].Flags:=DKnopf[14].Flags and not SELECTED else DKnopf[14].Flags:=DKnopf[14].Flags or SELECTED;
               RectFill(DWindow^.RPort,14,succ(ECtr-EntryPos)*15+23,42,succ(ECtr-EntryPos)*15+36);
            end else begin
               SetAPen(DWindow^.RPort,0);
               RectFill(DWindow^.RPort,14,succ(ECtr-EntryPos)*15+22,42,succ(ECtr-EntryPos)*15+36);
            end;
            s:=intstr(ECtr); while length(s)<4 do s:='0'+s; WRITE(40,succ(ECtr-EntryPos)*15+24,2,4,DWindow^,s);
            Buffer[ECtr-Entrypos+1]:=intstr(Loop);
            Buffer[ECtr-EntryPos+19]:=intstr(VolumeL);
            Buffer[ECtr-EntryPos+7]:=intstr(VolumeR);
            Buffer[ECtr-EntryPos+13]:=intstr(Rate);
            LBuffer[ECtr-EntryPos+1]:=Name;
         end;
         if ECtr=SelEntry then ActEntry:=MyEntry;
         MyEntry:=MyEntry^.NextEntry;
         ECtr:=ECtr+1;
      until (MyEntry=NIL) or (ECtr>Entries);
   end;
   while ECtr<=EntryPos+5 do begin
      Buffer[ECtr-Entrypos+1]:='';
      Buffer[ECtr-EntryPos+19]:='';
      Buffer[ECtr-EntryPos+7]:='';
      Buffer[ECtr-EntryPos+13]:='';
      LBuffer[ECtr-EntryPos+1]:='';
      SetAPen(DWindow^.RPort,0); RectFill(DWindow^.RPort,14,succ(ECtr-EntryPos)*15+22,42,succ(ECtr-EntryPos)*15+36);
      ECtr:=ECtr+1;
   end;
   if Entries=0 then begin
      SchieberInfo[1].VertBody:=$FFFF;
      SchieberInfo[1].VertPot:=$FFFF;
   end else begin
      l:=round(65535*5/(Entries+5));          if l<1 then l:=1; if l>65535 then l:=65535;
      SchieberInfo[1].VertBody:=l;
      l:=round(65535/Entries*pred(EntryPos)); if l<1 then l:=1; if l>65535 then l:=65535;
      SchieberInfo[1].VertPot:=l;
   end;
   if SelEntry>Entries then selEntry:=0;
   if ActEntry<>FirstEntry then begin
      AreaA[0]:=ActEntry^.BeginOffset;
      AreaE[0]:=ActEntry^.EndOffset;
      DRAWMARK(AreaA[0],AreaE[0],0);
   end else if (FirstEntry^.NextEntry<>NIL) and (AreaE[0]<>0) then begin
      AreaA[0]:=0;
      AreaE[0]:=0;
      PROCESSWAVE($8,false);
   end;
   WRITETBWINDOW;
   RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
end;



procedure INSERTENTRY(Position :long);

var i   :long;
var MyEntry     :PlayListEntry;

begin
   ActEntry:=FirstEntry;
   ActPattern:=FirstPattern;
   for i:=1 to SelPattern do if ActPattern^.NextPattern<>NIL then ActPattern:=ActPattern^.NextPattern;
   MyEntry:=ADDENTRY(Position);
   if MyEntry=NIL then exit;
   with MyEntry^ do begin
      Rate:=Prefs.SRate;   Delay:=0;      Time:=0;
      Loop:=1;             VolumeL:=64;   VolumeR:=64;
      Name:=ActPattern^.Name;
      BeginOffset:=ActPattern^.BeginOffset;
      EndOffset:=ActPattern^.EndOffset;
   end;
   EntryPos:=Position-4;
   if EntryPos>Entries then EntryPos:=Entries-4;
   if EntryPos<1 then EntryPos:=1;
   DRAWENTRYLIST;
end;



procedure SETACTENTRY(EPos :long);

begin
   ActEntry:=FirstEntry;
   if EPos>0 then for i:=1 to EPos do ActEntry:=ActEntry^.NextEntry;
end;



begin {PLAYLISTED}
   if Mi3[6].Flags and CHECKED<>CHECKED then begin
      if not OPENINTUIWINDOW2 then begin
         DisplayBeep(NIL);
         exit;
      end;
   end;
   Mi3[6].Flags:=Mi3[6].Flags or CHECKED;
   LEdge:=Prefs.WinXOffset[5]; if LEdge>MyScreen^.Width-458 then LEdge:=MyScreen^.Width-458;
   TEdge:=Prefs.WinYOffset[5]; if TEdge>MyScreen^.Height-148 then TEdge:=MyScreen^.Height-148;
   NeuWindow:=NewWindow(LEdge,TEdge,458,148,3,1,RAWKEY or GADGETDOWN
                        or GADGETUP or MOUSEMOVE,SMART_REFRESH or WINDOWDRAG or
                        _REPORTMOUSE or WINDOWDEPTH or ACTIVATE,Nil,NIL,WTVer,MyScreen,Nil,
                        458,148,480,158,CUSTOMSCREEN);
   DWindow:=OpenWindow(^NeuWindow);
   If DWindow=Nil Then begin
      DisplayBeep(NIL);
      exit;
   end;
   SelEntry:=0; EntryPos:=1; ActEntry:=FirstEntry;
   MAKEBORDER(DWindow^,10,35,290,128,POSITIVE);
   DKnopf[1]:=Gadget(NIL,320,19,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^OKKnopfTx,0,NIL,1,0);
   DKnopf[3]:=Gadget(NIL,294,35,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^ButtonImg[5],NIL,NIL,0,Nil,3,0);
   DKnopf[4]:=Gadget(NIL,294,116,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^ButtonImg[6],NIL,NIL,0,Nil,4,0);
   for i:=1 to 6 do begin
      DKnopf[i+6]:=Gadget(NIL,15,i*15+24,29,12,GADGHNONE,$1,BOOLGADGET,NIL,NIL,NIL,0,NIL,i+6,0);
      { Nummer }
      TextGad[i]:=Gadget(NIL,44,i*15+24,20,15,GADGHCOMP,_LONGINT+STRINGRIGHT+$1,STRGADGET,NIL,Nil,Nil,0,^TextInfo[i],30+i,0);
      TextInfo[i]:=StringInfo(^Buffer[i],^Undobuffer[i],0,3,0,0,3,0,0,0,Nil,0,Nil);
      Buffer[i]:='';
      { Loop }
      TextGad[i+30]:=Gadget(NIL,70,i*15+24,20,15,GADGHCOMP,_LONGINT+STRINGRIGHT+$1,STRGADGET,NIL,Nil,Nil,0,^TextInfo[i+30],60+i,0);
      TextInfo[i+30]:=StringInfo(^Buffer[i+18],^Undobuffer[i+18],0,3,0,0,3,0,0,0,Nil,0,Nil);
      Buffer[i+18]:='';
      TextGad[i+6]:=Gadget(NIL,96,i*15+24,20,15,GADGHCOMP,_LONGINT+STRINGRIGHT+$1,STRGADGET,NIL,Nil,Nil,0,^TextInfo[i+6],36+i,0);
      TextInfo[i+6]:=StringInfo(^Buffer[i+6],^Undobuffer[i+6],0,3,0,0,3,0,0,0,Nil,0,Nil);
      Buffer[i+6]:='';
      { Volume L/R }
      TextGad[i+12]:=Gadget(NIL,122,i*15+24,30,15,GADGHCOMP,STRINGRIGHT+$1,STRGADGET,NIL,Nil,Nil,0,^TextInfo[i+12],42+i,0);
      TextInfo[i+12]:=StringInfo(^Buffer[i+12],^Undobuffer[i+12],0,5,0,0,5,0,0,0,Nil,0,Nil);
      Buffer[i+12]:='';
      { Rate }
      TextGad[i+18]:=Gadget(NIL,158,i*15+24,125,15,GADGHCOMP,STRINGCENTER+$1,STRGADGET,NIL,Nil,Nil,0,^TextInfo[i+18],48+i,0);
      TextInfo[i+18]:=StringInfo(^LBuffer[i],^LUndobuffer[i],0,30,0,0,30,0,0,0,Nil,0,Nil);
      LBuffer[i]:='';
      { Name }
   end;
   for i:=1 to 18 do UndoBuffer[i]:=Buffer[i];
   WRITE(27,19,2,3,DWindow^,PText[301]);
   WRITE(55,19,2,3,DWindow^,PText[302]);
   s:='L '+PText[303]+' R'; WRITE(95,19,2,3,DWindow^,s);
   WRITE(139,19,2,3,DWindow^,PText[304]);
   WRITE(225,19,2,3,DWindow^,PText[305]);

   Schieber[1]:=Gadget(NIL,294,48,21,66,GADGHCOMP,$82,PROPGADGET,^SData[1],NIL,NIL,0,^SchieberInfo[1],101,0);
   SchieberInfo[1]:=Propinfo(FREEVERT+AUTOKNOB,0,$FFFF,0,$FFFF,0,0,0,0,0,0);
   DKnopf[13]:=Gadget(NIL,72,131,21,12,GADGHIMAGE+GADGIMAGE,$3+TOGGLESELECT,BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,108,0);
   DKnopf[14]:=Gadget(NIL,98,131,21,12,GADGHIMAGE+GADGIMAGE,$3+TOGGLESELECT,BOOLGADGET,^ButtonImg[1],^ButtonImg[2],NIL,0,Nil,109,0);
   DKnopf[31]:=Gadget(NIL,132,131,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^ButtonImg[3],NIL,NIL,0,Nil,103,0);
   DKnopf[32]:=Gadget(NIL,320,55,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[1],NIL,^DKnopfTx[1],0,NIL,104,0);
   DKnopfTx[1]:=IntuiText(2,1,0,1,2,^CustomTA,PText[306],NIL);
   DKnopfTx[1].LeftEdge:=64-IntuiTextLength(^DKnopfTx[1]) div 2;

   DKnopf[33]:=Gadget(NIL,320,37,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[1],NIL,^DKnopfTx[2],0,NIL,105,0);
   DKnopfTx[2]:=IntuiText(2,1,0,1,2,^CustomTA,PText[307],NIL);
   DKnopfTx[2].LeftEdge:=64-IntuiTextLength(^DKnopfTx[2]) div 2;

   DKnopf[2]:=Gadget(NIL,320,73,128,16,GADGHCOMP+GADGIMAGE,RELVERIFY+TOGGLESELECT,BOOLGADGET,^GImg[1],NIL,^DKnopfTx[3],0,NIL,2,0);
   DKnopfTx[3]:=IntuiText(2,1,0,1,2,^CustomTA,PText[310],NIL);
   DKnopfTx[3].LeftEdge:=64-IntuiTextLength(^DKnopfTx[3]) div 2;

   DKnopf[15]:=Gadget(NIL,320,91,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[1],NIL,^DKnopfTx[4],0,NIL,15,0);
   DKnopfTx[4]:=IntuiText(2,1,0,1,2,^CustomTA,PText[311],NIL);
   DKnopfTx[4].LeftEdge:=64-IntuiTextLength(^DKnopfTx[4]) div 2;

   for i:=1 to 4 do AddGadget(DWindow,^DKnopf[i],NIL);
   for i:=7 to 15 do AddGadget(DWindow,^DKnopf[i],NIL);
   for i:=31 to 33 do AddGadget(DWindow,^DKnopf[i],NIL);
   for i:=1 to 24 do AddGadget(DWindow,^TextGad[i],NIL);
   for i:=31 to 36 do AddGadget(DWindow,^TextGad[i],NIL);
   AddGadget(DWindow,^Schieber[1],NIL);
   DRAWTIMEPATTERNLIST(false);
   DRAWENTRYLIST;
   repeat
      RawCode:=0; GadCode:=0; GadHit:=0;
      IMsg:=NIL;  IMsg1:=NIL; IMsg2:=NIL; IMsg3:=NIL; IMsg4:=NIL;
      IMsg:=Get_Msg(MyWindow^.UserPort);
      IMsg1:=Get_Msg(IntuiWindow1^.UserPort);
      if IntuiWindow2<>NIL then IMsg2:=Get_Msg(IntuiWindow2^.UserPort);
      if IntuiWindow3<>NIL then IMsg3:=Get_Msg(IntuiWindow3^.UserPort);
      if IntuiWindow4<>NIL then IMsg4:=Get_Msg(IntuiWindow4^.UserPort);
      IMsg0:=Get_Msg(DWindow^.UserPort);
      if (IMsg=NIL) and (IMsg1=NIL) and (IMsg2=NIL) and (IMsg3=NIL)
      and (IMsg0=NIL) then begin
         l:=wait(-1);
         IMsg:=Get_Msg(MyWindow^.UserPort);
         IMsg1:=Get_Msg(IntuiWindow1^.UserPort);
         if IntuiWindow2<>NIL then IMsg2:=Get_Msg(IntuiWindow2^.UserPort);
         if IntuiWindow3<>NIL then IMsg3:=Get_Msg(IntuiWindow3^.UserPort);
         if IntuiWindow4<>NIL then IMsg4:=Get_Msg(IntuiWindow4^.UserPort);
         IMsg0:=Get_Msg(DWindow^.UserPort);
      end;
      if IMsg=NIL then begin
         if IMsg1<>NIL then begin
            IMsg:=IMsg1;
            UsedWindow:=1;
         end else if IMsg2<>NIL then begin
            IMsg:=IMsg2;
            UsedWindow:=2;
         end else if IMsg3<>NIL then begin
            IMsg:=IMsg3;
            UsedWindow:=3;
         end else if IMsg4<>NIL then begin
            IMsg:=IMsg4;
            UsedWindow:=4;
         end else if IMsg0<>NIL then begin
            IMsg:=IMsg0;
            UsedWindow:=100;
         end
      end else UsedWindow:=0;

      HANDLEMAININTUITION;
      PLAYKEYS(RawCode,DWindow,0);

      if UsedWindow=2 then begin
         if HANDLETIMEPATTERNWINDOW then DRAWENTRYLIST;
      end else if UsedWindow=100 then begin
         if (Rawcode=76) and (SelEntry in [2..Entries]) then begin
            SelEntry:=SelEntry-1;
            DRAWENTRYLIST
         end;
         if (RawCode=77) and (SelEntry in [1..pred(Entries)]) then begin
            SelEntry:=SelEntry+1;
            DRAWENTRYLIST
         end;

         if (SelPattern>0)
          and (DWindow^.MouseX in [14..42]) and (DWindow^.MouseY in [35..128]) then begin
            InsertPos:=(DWindow^.MouseY-24) div 15;
            if InsertPos<1 then InsertPos:=0;
            for i:=1 to 6 do begin
               if i<>InsertPos then SetAPen(DWindow^.RPort,0) else SetAPen(DWindow^.RPort,3);
               Move(DWindow^.RPort,14,i*15+22);   Draw(DWindow^.RPort,42,i*15+22);
            end;
            InsertPos:=pred(InsertPos+EntryPos);
         end else InsertPos:=0;

         if GadCode=2 then begin  {*** ABSPIELEN ***}
            ActEntry:=FirstEntry;
            j:=0;
            for i:=1 to SelEntry do begin
               ActEntry:=ActEntry^.NextEntry;
               j:=j+1;
            end;
            i:=SetTaskPri(FindTask(NIL),PLAYPRIORITY);
            while (DKnopf[2].Flags and SELECTED=SELECTED) and (ActEntry<>NIL)
            do with ActEntry^ do begin
               if (BeginOffset<PlayL24[0]) and (EndOffset<=PlayL24[0]) then
                for i:=1 to Loop do begin
                  AreaA[0]:=BeginOffset;   AreaE[0]:=EndOffset;
                  s:=intstr(j); while length(s)<4 do s:='0'+s;
                  WRITE(16,131,2,5,DWindow^,s);
                  l:=STARTSOUND(Rate,0,DWindow,2,VolumeL,VolumeR);
               end;
               ActEntry:=ActEntry^.NextEntry;
               j:=j+1;
            end;
            DKnopf[2].Flags:=DKnopf[2].Flags and not SELECTED;
            RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
            i:=SetTaskPri(FindTask(NIL),0);
         end;

         if (Gadcode=15) then begin   {*** ALLES LSCHEN ***}
            if Prefs.Confirm then l:=TASKREQUEST(PText[262],PText[271],PText[220],NIL,PText[218]) else l:=1;
            if l=1 then begin
               FREEPLAYLIST;
               DRAWTIMEPATTERNLIST(false);
               DRAWENTRYLIST;
            end;
         end;

         if (GadCode in [7..12]) then begin
            if InsertPos>0 then INSERTENTRY(pred(InsertPos)) else begin
               l:=GadCode-7+EntryPos;
               if SelEntry=l then SelEntry:=0 else SelEntry:=l;
               SelPattern:=0;
               InsertPos:=0;
               SetAPen(DWindow^.RPort,0);
               DRAWTIMEPATTERNLIST(false);
               DRAWENTRYLIST;
            end;
         end;

         if Entries>0 then begin
            if (GadCode=3) and (EntryPos>1) then begin
               EntryPos:=EntryPos-1;
               DRAWENTRYLIST;
            end;
            if (GadCode=4) and (EntryPos<Entries) then begin
               EntryPos:=EntryPos+1;
               DRAWENTRYLIST;
            end;
            while (Gadcode=101) or (Schieber[1].Flags and SELECTED=SELECTED)
            do begin
               l:=1+round(SchieberInfo[1].VertPot/(65535/Entries));
               if l<1 then l:=1;
               if EntryPos<>l then begin
                  EntryPos:=l;
                  DRAWENTRYLIST;
               end;
               GadCode:=0;
            end;
         end;

         if (Gadcode=104) and (SelEntry>0) then begin
            ActEntry:=FirstEntry;
            for i:=0 to pred(SelEntry) do ActEntry:=ActEntry^.NextEntry;
            ActEntry^.BeforeEntry^.NextEntry:=ActEntry^.NextEntry;
            if ActEntry^.NextEntry<>NIL then ActEntry^.NextEntry^.BeforeEntry:=ActEntry^.BeforeEntry;
            SelEntry:=0;
            XFreeMem(long(ActEntry),sizeof(r_PlayListEntry));
            Entries:=Entries-1;
            if EntryPos>Entries then EntryPos:=Entries;
            DRAWENTRYLIST;
         end else if (GadCode=104) and (SelEntry=0) then DisplayBeep(NIL);

         if GadCode=105 then begin
         {*** BERNEHMEN ***}
            if SelPattern in [1..Patterns] then INSERTENTRY($0FFFFFFF)
            else DisplayBeep(NIL);
         end;

         if GadCode in [31..36] then begin
            if EntryPos+GadCode-31<=Entries then begin
               SETACTENTRY(EntryPos+GadCode-31);
               val(Buffer[GadCode-30],ActEntry^.Loop,ValInt);
               if ActEntry^.Loop<1   then ActEntry^.Loop:=1;
               if ActEntry^.Loop>100 then ActEntry^.Loop:=100;
               Buffer[GadCode-30]:=intstr(ActEntry^.Loop);
            end;
            DRAWENTRYLIST;
         end;

         if (GadCode=108) and (SelEntry in [EntryPos..EntryPos+5]) then begin
            GadCode:=SelEntry-EntryPos+19;
            if DKnopf[13].Flags and SELECTED=0 then Buffer[GadCode]:='0' else Buffer[GadCode]:='64';
            GadCode:=42+GadCode;
         end;
         if GadCode in [61..66] then begin
            if EntryPos+GadCode-61<=Entries then begin
               SETACTENTRY(EntryPos+GadCode-61);
               val(Buffer[GadCode-42],ActEntry^.VolumeL,ValInt);
               if ActEntry^.VolumeL<0  then ActEntry^.VolumeL:=0;
               if ActEntry^.VolumeL>64 then ActEntry^.VolumeL:=64;
               Buffer[GadCode-42]:=intstr(ActEntry^.VolumeL);
            end;
            DRAWENTRYLIST;
         end;

         if (GadCode=109) and (SelEntry in [EntryPos..EntryPos+5]) then begin
            GadCode:=SelEntry-EntryPos+7;
            if DKnopf[14].Flags and SELECTED=0 then Buffer[GadCode]:='0' else Buffer[GadCode]:='64';
            GadCode:=30+GadCode;
         end;
         if GadCode in [37..42] then begin
            if EntryPos+GadCode-37<=Entries then begin
               SETACTENTRY(EntryPos+GadCode-37);
               val(Buffer[GadCode-30],ActEntry^.VolumeR,ValInt);
               if ActEntry^.VolumeR<0  then ActEntry^.VolumeR:=0;
               if ActEntry^.VolumeR>64 then ActEntry^.VolumeR:=64;
               Buffer[GadCode-30]:=intstr(ActEntry^.VolumeR);
            end;
            DRAWENTRYLIST;
         end;

         if (GadCode=103) and (SelEntry in [EntryPos..EntryPos+5]) then begin
            l:=GETNOTEFREQ(DWindow);
            GadCode:=SelEntry-EntryPos+13;
            with Notes do Buffer[GadCode]:=intstr(bn_PlayRate[bn_PosX,bn_PosY]);
            GadCode:=30+GadCode;
         end;
         if GadCode in [43..48] then begin
            if EntryPos+GadCode-43<=Entries then begin
               SETACTENTRY(EntryPos+GadCode-43);
               val(Buffer[GadCode-30],ActEntry^.Rate,ValInt);
               if ActEntry^.Rate<1     then ActEntry^.Rate:=1;
               if ActEntry^.Rate>60000 then ActEntry^.Rate:=60000;
               Buffer[GadCode-30]:=intstr(ActEntry^.Rate);
            end;
            DRAWENTRYLIST;
         end;

         if GadCode in [49..54] then begin
            if EntryPos+GadCode-49<=Entries then begin
               SETACTENTRY(EntryPos+GadCode-49);
               ActEntry^.Name:=LBuffer[GadCode-48];
            end;
            DRAWTIMEPATTERNLIST(false);
         end;
      end;

   Until (UsedWindow=100) and ((GadCode=1) or (RawCode=68));
   if LEAVEDEF(RawCode,GadCode,1,1,DWindow) then begin end;
   DRAWTIMEPATTERNLIST(false);
end;



function DOCHANNELC:boolean;

var Addr1,Addr2,Addr3,IntData,WaveMaxAmp,Check  :long;
var Data1,Data2,Data3                           :^long;
var DataA1,DataA2,DataA3                        :^byte;
var i,Div1,Div2,AlphaMaxAmp                     :byte;
var Divider                                     :real;


function GETDIVIDER(ChNum,ChID :byte):real;

var DivD :real;

begin
   DivD:=1;
   if ActiveMode[0] in [MD_MONO,MD_STEREO,MD_3CH,MD_SURROUND] then with ChSurround do begin
      if ChNum<5 then DivD:=SQRT(SQR(ChX[ChNum]-ChX[ChID])+SQR(ChY[ChNum]-ChY[ChID]))/10;
   end else if ActiveMode[0]=MD_QUADRO then with ChQuadro do begin
      if not ChNum in [3,5..6] then DivD:=SQRT(SQR(ChX[ChNum]-ChX[ChID])+SQR(ChY[ChNum]-ChY[ChID]))/10;
   end else with ChAC3 do DivD:=SQRT(SQR(ChX[ChNum]-ChX[ChID])+SQR(ChY[ChNum]-ChY[ChID]))/10;
   if abs(DivD)=0 then DivD:=1;
   GETDIVIDER:=DivD;
end;



procedure ADDCHANNELS(ChID :byte);

var i           :byte;

begin
   for i:=1 to 5 do if (i<>ChID) and (MemA24[0,i]<>0) then begin
      Divider:=GETDIVIDER(i,ChID);
      Addr1:=MemA24[0,ChID]+PlayL24[0];
      Addr2:=MemA24[0,i]+PlayL24[0];
      repeat
         Addr1:=Addr1-4; Data1:=ptr(Addr1);
         Addr2:=Addr2-4; Data2:=ptr(Addr2);
         Data1^:=round(Data1^+(Data2^/Divider));
      until Addr1<=MemA24[0,ChID];

      if (MemAAlpha[0,ChID]<>0) and (MemAAlpha[0,i]<>0) then begin
         Addr1:=MemAAlpha[0,ChID]+round(MemL24[0]/80+0.5);
         Addr2:=MemAAlpha[0,i]+round(MemL24[0]/80+0.5);
         repeat
            Addr1:=Addr1-1; DataA1:=ptr(Addr1);
            Addr2:=Addr2-1; DataA2:=ptr(Addr2);
            Check:=round(DataA1^+(DataA2^/Divider));
            if Check>255 then Check:=255; DataA1^:=Check;
         until Addr1<=MemAAlpha[0,ChID];
      end;
   end;
end;



procedure REMCHANNELS(ChID :byte);

var i           :byte;

begin
   for i:=1 to 5 do if (i<>ChID) and (MemA24[0,i]<>0) then begin
      Divider:=GETDIVIDER(i,ChID);
      Addr1:=MemA24[0,ChID]+PlayL24[0];
      Addr2:=MemA24[0,i]+PlayL24[0];
      repeat
         Addr1:=Addr1-4; Data1:=ptr(Addr1);
         Addr2:=Addr2-4; Data2:=ptr(Addr2);
         Data2^:=round(Data2^+(Data1^/Divider));
      until Addr1<=MemA24[0,ChID];
      if (MemAAlpha[0,ChID]<>0) and (MemAAlpha[0,i]<>0) then begin
         Addr1:=MemAAlpha[0,ChID]+round(MemL24[0]/80+0.5);
         Addr2:=MemAAlpha[0,i]+round(MemL24[0]/80+0.5);
         repeat
            Addr1:=Addr1-1; DataA1:=ptr(Addr1);
            Addr2:=Addr2-1; DataA2:=ptr(Addr2);
            Check:=round(DataA2^+(DataA1^/Divider));
            if Check>255 then Check:=255; DataA2^:=Check;
         until Addr1<=MemAAlpha[0,ChID];
      end;
   end;
   Addr1:=MemA24[0,ChID]+PlayL24[0];
   repeat
      Addr1:=Addr1-4; Data1:=ptr(Addr1);
      Data1^:=0;
   until Addr1<=MemA24[0,ChID];
end;



begin
   DOCHANNELC:=false;
   with _WaveOp[OPos] do begin
      WORKINFO(PText[118],1);
      case OpType of
         1: begin
               if (MemA24[0,Operator[1]]<>0) and (MemA24[0,Operator[2]]<>0) then CopyMemQuick(MemA24[0,Operator[1]],MemA24[0,Operator[2]],PlayL24[0]);
               if (MemAAlpha[0,Operator[1]]<>0) and (MemAAlpha[0,Operator[2]]<>0) then CopyMem(MemAAlpha[0,Operator[1]],MemAAlpha[0,Operator[2]],round(PlayL24[0]/80+0.5));
            end;
         2: begin
               if (MemA24[0,Operator[1]]<>0) and (MemA24[0,Operator[2]]<>0) then exchange(MemA24[0,Operator[1]],MemA24[0,Operator[2]]);
               if (MemAAlpha[0,Operator[1]]<>0) and (MemAAlpha[0,Operator[2]]<>0) then exchange(MemAAlpha[0,Operator[1]],MemAAlpha[0,Operator[2]])
            end;
         3: begin
               if (MemA24[0,Operator[1]]<>0) and (MemA24[0,Operator[2]]<>0) then begin
                  CopyMemQuick(MemA24[0,Operator[1]],MemA24[0,Operator[2]],PlayL24[0]);
                  Addr1:=MemA24[0,Operator[1]]+MemL24[0];
                  repeat
                     Addr1:=Addr1-4; Data1:=ptr(Addr1);
                     Data1^:=0;
                  until Addr1<=MemA24[0,Operator[1]];
               end;
               if (MemAAlpha[0,Operator[1]]<>0) and (MemAAlpha[0,Operator[2]]<>0) then begin
                  CopyMem(MemAAlpha[0,Operator[1]],MemAAlpha[0,Operator[2]],round(MemL24[0]/80+0.5));
                  Addr1:=MemAAlpha[0,Operator[1]]+round(MemL24[0]/80+0.5);
                  repeat
                     Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                     DataA1^:=255;
                  until Addr1<=MemAAlpha[0,Operator[1]];
               end;
            end;
         4: begin
               if (MemA24[0,Operator[1]]<>0) and (MemA24[0,Operator[2]]<>0) then begin
                  Addr1:=MemA24[0,Operator[1]]+PlayL24[0];
                  Addr2:=MemA24[0,Operator[2]]+PlayL24[0];
                  repeat
                     Addr1:=Addr1-4; Data1:=ptr(Addr1);
                     Addr2:=Addr2-4; Data2:=ptr(Addr2);
                     Data1^:=Data1^+Data2^;
                     Data2^:=Data1^;
                  until Addr1<=MemA24[0,Operator[1]];
               end;
               if (MemAAlpha[0,Operator[1]]<>0) and (MemAAlpha[0,Operator[2]]<>0) then begin
                  Addr1:=MemAAlpha[0,Operator[1]]+round(MemL24[0]/80+0.5);
                  Addr2:=MemAAlpha[0,Operator[2]]+round(MemL24[0]/80+0.5);
                  repeat
                     Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                     Addr2:=Addr2-1; DataA2:=ptr(Addr2);
                     DataA1^:=(DataA1^+DataA2^) div 2;
                     DataA2^:=DataA1^;
                  until Addr1<=MemAAlpha[0,Operator[1]];
               end;
            end;
         5: begin
               if MemA24[0,Operator[1]]<>0 then begin
                  Addr1:=MemA24[0,Operator[1]]+PlayL24[0];
                  repeat
                     Addr1:=Addr1-4; Data1:=ptr(Addr1);
                     Data1^:=0;
                  until Addr1<=MemA24[0,Operator[1]];
               end;
               if MemAAlpha[0,Operator[1]]<>0 then begin
                  Addr1:=MemAAlpha[0,Operator[1]]+round(MemL24[0]/80+0.5);
                  repeat
                     Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                     DataA1^:=255;
                  until Addr1<=MemAAlpha[0,Operator[1]];
               end;
            end;
         6: if MemA24[0,Operator[1]]<>0 then begin
               if Operator[1]=3 then begin
                  if (MemA24[0,1]<>0) and (MemA24[0,2]<>0) then begin
                     {CENTER}
                     Addr1:=MemA24[0,1]+PlayL24[0];
                     Addr2:=MemA24[0,2]+PlayL24[0];
                     Addr3:=MemA24[0,3]+PlayL24[0];
                     repeat
                        Addr1:=Addr1-4; Data1:=ptr(Addr1);
                        Addr2:=Addr2-4; Data2:=ptr(Addr2);
                        Addr3:=Addr3-4; Data3:=ptr(Addr3);
                        Data3^:=(Data1^+Data2^) div 2;
                        Data1^:=Data1^-Data3^;
                        Data2^:=Data2^-Data3^;
                     until Addr1<=MemA24[0,1];
                  end;
                  if (MemAAlpha[0,1]<>0) and (MemAAlpha[0,2]<>0)
                  and (MemAAlpha[0,3]<>0) then begin
                     Addr1:=MemAAlpha[0,1]+round(MemL24[0]/80+0.5);
                     Addr2:=MemAAlpha[0,2]+round(MemL24[0]/80+0.5);
                     Addr3:=MemAAlpha[0,3]+round(MemL24[0]/80+0.5);
                     repeat
                        Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                        Addr2:=Addr2-1; DataA2:=ptr(Addr2);
                        Addr3:=Addr3-1; DataA3:=ptr(Addr3);
                        DataA3^:=DataA1^ div 2 + DataA2^ div 2;
                     until Addr1<=MemAAlpha[0,1];
                  end;
               end else if Operator[1] in [4,5] then begin
                  {SURROUND}
                  Addr1:=MemA24[0,1]+PlayL24[0];
                  Addr2:=MemA24[0,2]+PlayL24[0];
                  Addr3:=MemA24[0,Operator[1]]+MemL24[0];
                  repeat
                     Addr1:=Addr1-4; Data1:=ptr(Addr1);
                     Addr2:=Addr2-4; Data2:=ptr(Addr2);
                     Addr3:=Addr3-4; Data3:=ptr(Addr3);
                     Data3^:=(Data1^-Data2^) div 2;
                     Data1^:=Data1^-Data3^;
                     Data2^:=Data2^-Data3^;
                  until Addr1<=MemA24[0,1];
                  if (MemAAlpha[0,1]<>0) and (MemAAlpha[0,2]<>0)
                  and (MemAAlpha[0,Operator[1]]<>0) then begin
                     Addr1:=MemAAlpha[0,1]+round(MemL24[0]/80+0.5);
                     Addr2:=MemAAlpha[0,2]+round(MemL24[0]/80+0.5);
                     Addr3:=MemAAlpha[0,Operator[1]]+round(MemL24[0]/80+0.5);
                     repeat
                        Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                        Addr2:=Addr2-1; DataA2:=ptr(Addr2);
                        Addr3:=Addr3-1; DataA3:=ptr(Addr3);
                        DataA3^:=DataA1^ div 2 + DataA2^ div 2;
                     until Addr1<=MemAAlpha[0,1];
                  end;
                  if ActiveMode[0] in [MD_AC3,MD_AC3_Sub] then ADDCHANNELS(Operator[1]);
                  SCANWAVE(MemA24[0,Operator[1]],MemAAlpha[0,Operator[1]],WaveMaxAmp,AlphaMaxAmp);
                  if not WaveMaxAmp in [MAX24-100..MAX24] then PUSHWAVE(MemA24[0,Operator[1]],WaveMaxAmp);
                  if AlphaMaxAmp<255 then PUSHALPHA(MemAAlpha[0,Operator[1]],AlphaMaxAmp);
               end else if Operator[1]=6 then begin
                  {SUBWOOFER}
                  Addr1:=MemA24[0,1]+PlayL24[0];
                  Addr2:=MemA24[0,6]+PlayL24[0];
                  IntData:=0;
                  repeat
                     Addr1:=Addr1-4; Data1:=ptr(Addr1);
                     Addr2:=Addr2-4; Data2:=ptr(Addr2);
                     IntData:=(Data1^+IntData) div 2;
                     Data2^:=IntData div 5;
                  until Addr1<=MemA24[0,1];
                  for i:=2 to 5 do begin
                     Addr1:=MemA24[0,i]+PlayL24[0];
                     Addr2:=MemA24[0,6]+PlayL24[0];
                     IntData:=0;
                     repeat
                        Addr1:=Addr1-4; Data1:=ptr(Addr1);
                        Addr2:=Addr2-4; Data2:=ptr(Addr2);
                        IntData:=(Data1^ + IntData) div 2;
                        Data2^:=Data2^+(IntData div 5);
                     until Addr1<=MemA24[0,i];
                  end;
                  Addr1:=MemA24[0,6];
                  IntData:=0;
                  repeat
                     Data1:=ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=(IntData+Data1^) div 2;
                     IntData:=Data1^;
                  until Addr1>=MemA24[0,6]+PlayL24[0];
                  if MemAAlpha[0,6]<>0 then begin
                     Addr1:=MemAAlpha[0,6]+round(MemL24[0]/80+0.5);
                     repeat
                        Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                        DataA1^:=255;
                     until Addr1<=MemAAlpha[0,6];
                  end;
               end else begin
                  ADDCHANNELS(Operator[1]);
                  SCANWAVE(MemA24[0,Operator[1]],MemAAlpha[0,Operator[1]],WaveMaxAmp,AlphaMaxAmp);
                  if not WaveMaxAmp in [MAX24-100..MAX24] then PUSHWAVE(MemA24[0,Operator[1]],WaveMaxAmp);
                  if not AlphaMaxAmp<255 then PUSHALPHA(MemAAlpha[0,Operator[1]],AlphaMaxAmp);
               end;
            end;
         7: if MemA24[0,Operator[1]]<>0 then begin
               if (Operator[1]=3) and (MemA24[0,1]<>0) and (MemA24[0,2]<>0) then begin
                  {CENTER}
                  Addr1:=MemA24[0,1]+PlayL24[0];
                  Addr2:=MemA24[0,2]+PlayL24[0];
                  Addr3:=MemA24[0,3]+PlayL24[0];
                  repeat
                     Addr1:=Addr1-4; Data1:=ptr(Addr1);
                     Addr2:=Addr2-4; Data2:=ptr(Addr2);
                     Addr3:=Addr3-4; Data3:=ptr(Addr3);
                     Data1^:=Data1^+Data3^ div 2;
                     Data2^:=Data2^+Data3^ div 2;
                     Data3^:=0;
                  until Addr1<=MemA24[0,1];
                  if (MemAAlpha[0,1]<>0) and (MemAAlpha[0,2]<>0) and (MemAAlpha[0,3]<>0) then begin
                     Addr1:=MemAAlpha[0,1]+round(MemL24[0]/80+0.5);
                     Addr2:=MemAAlpha[0,2]+round(MemL24[0]/80+0.5);
                     Addr3:=MemAAlpha[0,3]+round(MemL24[0]/80+0.5);
                     repeat
                        Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                        Addr2:=Addr2-1; DataA2:=ptr(Addr2);
                        Addr3:=Addr3-1; DataA3:=ptr(Addr3);
                        Check:=DataA1^+DataA3^ div 2;
                        if Check>255 then Check:=255; DataA1^:=Check;
                        Check:=DataA2^+DataA3^ div 2;
                        if Check>255 then Check:=255; DataA2^:=Check;
                     until Addr1<=MemAAlpha[0,1];
                  end;

               end else if Operator[1] in [4,5] then begin
                  {SURROUND}
                  PlayL24[0]:=MemL24[0];
                  case ActiveMode[0] of
                     MD_SURROUND: begin
                                     Addr1:=MemA24[0,1]+PlayL24[0];
                                     Addr2:=MemA24[0,2]+PlayL24[0];
                                     Addr3:=MemA24[0,4]+PlayL24[0];
                                     repeat
                                        Addr1:=Addr1-4; Data1:=ptr(Addr1);
                                        Addr2:=Addr2-4; Data2:=ptr(Addr2);
                                        Addr3:=Addr3-4; Data3:=ptr(Addr3);
                                        Data1^:=Data1^+Data3^ div 2;
                                        Data2^:=Data2^-Data3^ div 2;
                                        Data3^:=0;
                                     until Addr1<=MemA24[0,1];
                                     if (MemAAlpha[0,1]<>0) and (MemAAlpha[0,2]<>0)
                                     and (MemAAlpha[0,4]<>0) then begin
                                        Addr1:=MemAAlpha[0,1]+round(MemL24[0]/80+0.5);
                                        Addr2:=MemAAlpha[0,2]+round(MemL24[0]/80+0.5);
                                        Addr3:=MemAAlpha[0,4]+round(MemL24[0]/80+0.5);
                                        repeat
                                           Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                                           Addr2:=Addr2-1; DataA2:=ptr(Addr2);
                                           Addr3:=Addr3-1; DataA3:=ptr(Addr3);
                                           Check:=DataA1^+DataA3^ div 2;
                                           if Check>255 then Check:=255; DataA1^:=Check;
                                           Check:=DataA2^+DataA3^ div 2;
                                           if Check>255 then Check:=255; DataA2^:=Check;
                                        until Addr1<=MemAAlpha[0,1];
                                     end;
                                  end;
                     otherwise begin
                        Addr1:=MemA24[0,1]+PlayL24[0];
                        Addr2:=MemA24[0,2]+PlayL24[0];
                        Addr3:=MemA24[0,Operator[1]]+PlayL24[0];
                        Div1:=3; Div2:=3;
                        if Operator[1]=4 then Div1:=2 else Div2:=3;
                        repeat
                           Addr1:=Addr1-4; Data1:=ptr(Addr1);
                           Addr2:=Addr2-4; Data2:=ptr(Addr2);
                           Addr3:=Addr3-4; Data3:=ptr(Addr3);
                           Data1^:=Data1^+Data3^ div Div1;
                           Data2^:=Data2^-Data3^ div Div2;
                           Data3^:=0;
                        until Addr1<=MemA24[0,1];

                        if (MemAAlpha[0,1]<>0) and (MemAAlpha[0,2]<>0)
                        and (MemAAlpha[0,Operator[1]]<>0) then begin
                           Addr1:=MemAAlpha[0,1]+round(MemL24[0]/80+0.5);
                           Addr2:=MemAAlpha[0,2]+round(MemL24[0]/80+0.5);
                           Addr3:=MemAAlpha[0,Operator[1]]+round(MemL24[0]/80+0.5);
                           repeat
                              Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                              Addr2:=Addr2-1; DataA2:=ptr(Addr2);
                              Addr3:=Addr3-1; DataA3:=ptr(Addr3);
                              Check:=DataA1^+DataA3^ div Div1;
                              if Check>255 then Check:=255; DataA1^:=Check;
                              Check:=DataA2^+DataA3^ div Div2;
                              if Check>255 then Check:=255; DataA2^:=Check;
                           until Addr1<=MemAAlpha[0,1];
                        end;
                     end;
                  end;
               end else if Operator[1]=6 then begin
                  {SUBWOOFER}
                  for i:=1 to 5 do begin
                     Addr1:=MemA24[0,i]+MemL24[0];
                     Addr2:=MemA24[0,6]+MemL24[0];
                     repeat
                        Addr1:=Addr1-4; Data1:=ptr(Addr1);
                        Addr2:=Addr2-4; Data2:=ptr(Addr2);
                        Data1^:=Data1^+Data2^ div 5
                     until Addr1<=MemA24[0,i];
                  end;
                  Addr1:=MemA24[0,6];
                  repeat
                     Data1:=ptr(Addr1); Addr1:=Addr1+4;
                     Data1^:=0;
                  until Addr1>=MemA24[0,6]+PlayL24[0];
               end else REMCHANNELS(Operator[1]);
               if MemAAlpha[0,Operator[1]]<>0 then begin
                  Addr1:=MemAAlpha[0,Operator[1]]+round(MemL24[0]/80+0.5);
                  repeat
                     Addr1:=Addr1-1; DataA1:=ptr(Addr1);
                     DataA1^:=255;
                  until Addr1<=MemAAlpha[0,Operator[1]];
               end;
            end;
         otherwise DisplayBeep(NIL);
      end;
   end;
   DOCHANNELC:=true;
end;



function DEFINECHANNELC:boolean;

var ChBit,i     :byte;
var MySList     :SelectListGad;

procedure DRAWLINES;

begin
   with _WaveOp[OPos] do begin
      SetAPen(DWindow^.RPort,0); RectFill(DWindow^.RPort,223,45,418,120);
      SetAPen(Dwindow^.RPort,1);
      if OpType in [1..4] then begin
         Move(DWindow^.RPort,223,Operator[1]*15+30);
         Draw(DWindow^.RPort,418,Operator[2]*15+30);
      end else begin
         Move(DWindow^.RPort,223,Operator[1]*15+30);
         Draw(DWindow^.RPort,320,Operator[1]*15+30);
      end;
   end;
end;


begin
   DEFINECHANNELC:=false;
   if not OPENDWIN(131,0,DWindow,PText[91],1,0) then exit;
   with _WaveOp[OPos] do begin
      Operation:=17;
      CREATEGADS(0,1,0);
      for i:=1 to 7 do DKnopfTx[i]:=IntuiText(2,0,0,4,2,^CustomTA,PText[i+91],NIL);
      DKnopf[9].GadgetText:=^DKnopfTx[OpType];
      MySList:=SelectListGad(DWindow,^DKnopf[9],OpType,0,0,0,ITTArr(^DKnopfTx[1],
                             ^DKnopfTx[2],^DKnopfTx[3],^DKnopfTx[4],^DKnopfTx[5],
                             ^DKnopfTx[6],^DKnopfTx[7],NIL,NIL,NIL,NIL,
                             NIL,NIL,NIL,NIL));

      for i:=3 to 8 do begin
         DKnopf[i]:=  Gadget(NIL,200,i*15-5,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,
                             ^ButtonImg[1],NIL,^KnopfTx[i-2],0,Nil,i,0);
         DKnopf[i+7]:=Gadget(NIL,420,i*15-5,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,
                             ^ButtonImg[1],NIL,^KnopfTx[i-2],0,Nil,i+7,0);
      end;

      if ActiveMode[0]<7 then DKnopf[8].Flags:=DKnopf[8].Flags or GADGDISABLED;
      if ActiveMode[0]<6 then DKnopf[7].Flags:=DKnopf[7].Flags or GADGDISABLED;
      if ActiveMode[0]<4 then DKnopf[6].Flags:=DKnopf[6].Flags or GADGDISABLED;
      if ActiveMode[0]<3 then DKnopf[5].Flags:=DKnopf[5].Flags or GADGDISABLED;
      if ActiveMode[0]<2 then begin
         DKnopf[4].Flags:=DKnopf[4].Flags or GADGDISABLED;
         DKnopf[3].Flags:=DKnopf[3].Flags or GADGDISABLED;
         DKnopf[5].Flags:=DKnopf[5].Flags and not GADGDISABLED;
      end;
      if ActiveMode[0]=4 then begin
         DKnopf[5].Flags:=DKnopf[5].Flags or GADGDISABLED;
         DKnopf[7].Flags:=DKnopf[7].Flags and not GADGDISABLED;
      end;
      for i:=8 downto 3 do if not (DKnopf[i].Flags and GADGDISABLED=0) then
       DKnopf[i+7].Flags:=DKnopf[i+7].Flags or GADGDISABLED;

      if not (DKnopf[Operator[1]+2].Flags and GADGDISABLED=0) then
       for i:=8 downto 3 do if (DKnopf[i].Flags and GADGDISABLED=0) then Operator[1]:=i-2;

      if not (DKnopf[Operator[2]+9].Flags and GADGDISABLED=0) then
       for i:=15 downto 10 do if (DKnopf[i].Flags and GADGDISABLED=0) then Operator[2]:=i-9;

      if OpType>4 then for i:=10 to 15 do DKnopf[i].Flags:=DKnopf[i].Flags or GADGDISABLED;

      for i:=3 to 15 do AddGadget(DWindow,^DKnopf[i],NIL);
      DRAWLINES;
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat

         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;


         if GadCode=9 then begin
            OpType:=DOSELECTLIST(^MySList);
            if OpType in [1..4] then begin
               ChBit:=1;
               for i:=3 to 8 do begin
                  if (DKnopf[i].Flags and GADGDISABLED=0)
                  and not (ActiveChannels[0] and ChBit=0) then DKnopf[i+7].Flags:=DKnopf[i+7].Flags and not GADGDISABLED;
                  ChBit:=ChBit*2;
               end;
            end else for i:=10 to 15 do DKnopf[i].Flags:=DKnopf[i].Flags or GADGDISABLED;
            DRAWLINES;
            RefreshGadgets(Dwindow^.FirstGadget,DWindow,NIL);
         end;

         if GadCode in [3..8,10..15] then begin
            if GadCode in [3..8] then Operator[1]:=GadCode-2;
            if GadCode in [10..15] then Operator[2]:=GadCode-9;
            DRAWLINES;
         end;

      Until (GadCode in [1,2]) or (RawCode in [68,69]);
      if LEAVEDEF(RawCode,GadCode,1,2,DWindow) then DEFINECHANNELC:=true;
   end;
end;



function DOEFFECTMOD:boolean;

var ModType     :long;

begin
   DOEFFECTMOD:=false;
   with _WaveOp[OPos] do begin
      MyWTStdMsg:=WTStdMsg(MyMsg,true,MDC_DOIT,VERSION_EFFECTMOD,MyScreen,MyWindow,ActiveChannels[0],ActiveMode[0],
                            MemA16[0],MemA24[0],MemAUNDO[0],
                            MemL24[0],PlayL24[0],Prefs.SRate,SAttack[0],SDecay[0],SSustain[0],SRelease[0],
                            ^_WaveOp[OPos],OPos,OEnd,AreaA[0],AreaE[0],0,
                            ^MyWTImg,^EmptyMsgPrc,^ChSurround,^ChQuadro,^ChAC3,UsedChans,
                            MemAAlpha[0],AlphaUNDO[0],
                            $BADBAD,FirstPattern,FirstEntry,^MySDHeader[0],AnimPath,NIL,NIL,NIL,NIL,NIL,NIL);
      if PORTCOMMUNICATION(PORT_EFFECTMOD,OpString,^MyWTStdMsg)<>MDE_READY then exit;
      SETNEWWTSTATE;
      s:=OpString+'.data';
      FHandle:=DosOpen(s,MODE_OLDFILE);
      if Fhandle<>0 then begin
         l:=DosRead(FHandle,^ModType,4);
         DosClose(FHandle);
      end else ModType:=0;
      if not (ModType and EFF_NOCALC=0) then ProcessOff:=true else ProcessOff:=false;
   end;
   DOEFFECTMOD:=true;
end;



function DEFINEEFFECTMOD(Auto :boolean):boolean;

var ModType     :long;
var ModName     :string;


function READDIRECTORY:boolean;

var Data8       :^byte;
var x,y,ModPick :byte;
var FPos        :integer;
var inf         :p_FileInfoBlock;
var MyLock      :BPTR;

Begin
   READDIRECTORY:=true;
   if FName[1]<>'' then begin
      i:=1;
      repeat
         i:=i+1;
      until (FName[i]='') or (i=70);
      FPos:=pred(i);
   end else begin
      FPos:=1;
      inf:=ptr(XAllocMem(sizeOf(FileInfoBlock),0));
      if long(inf)=0 then begin
         READDIRECTORY:=false;
         exit;
      end;
      MyLock:=Lock('EFFECTS',-2);
      If MyLock=0 Then READDIRECTORY:=false Else Begin
         j:=Examine(MyLock,inf);
         If inf^.fib_DirEntryType<=0 Then READDIRECTORY:=false Else Begin
            j:=ExNext(MyLock,Inf);
            While j<>0 Do Begin
               FName[FPos]:=inf^.fib_filename;
               if copy(FName[FPos],length(FName[FPos])-4,5)='.data' then begin
                  FName[FPos]:=inf^.fib_filename;
                  FName[FPos]:=copy(FName[FPos],1,length(FName[FPos])-5);
                  FPos:=FPos+1;
               end;
               j:=ExNext(MyLock,Inf)
            End;
         End
      End;
      XFreeMem(Long(inf),SizeOf(FileInfoBlock));
      repeat
         b:=true;
         for i:=1 to pred(FPos-1) do begin
            if ord(FName[i,1])>ord(FName[succ(i),1]) then begin
               exchange(FName[i],FName[succ(i)]); i:=1; b:=false;
            end;
         end;
      until b;
   end;
   if FPos>1 then begin
      if (MemAEff=0) and Prefs.Cache then begin
         MemLEff:=FPos*576;
         MemAEff:=XAllocMem(MemLEff,MEMF_CLEAR);
         if MemAEff>0 then for i:=1 to pred(FPos) do begin
            s:='EFFECTS/'+FName[i]+'.data';
            FHandle:=DosOpen(s,MODE_OLDFILE);
            if FHandle<>0 then begin
               l:=DosRead(FHandle,^ModType,4);
               l:=DosRead(FHandle,ptr(MemAEff+pred(i)*576),576);
               DosClose(FHandle);
            end;
         end;
      end;


      if not OPENDWIN(succ(FPos div 11)*30+60,0,DWindow,PText[101],0,0) then begin
         READDIRECTORY:=false;
         exit;
      end;
      x:=1; y:=1; FHandle:=0;
      for i:=1 to pred(FPos) do begin
         for j:=0 to 191 do begin
            Data8:=ptr(MyBitMap.MemA+384+j);
            Data8^:=0;
         end;
         if MemAEff=0 then begin
            s:='EFFECTS/'+FName[i]+'.data';
            FHandle:=DosOpen(s,MODE_OLDFILE);
            if FHandle<>0 then begin
               l:=DosRead(FHandle,^ModType,4);
               l:=DosRead(FHandle,ptr(MyBitMap.MemA),576);
               DosClose(FHandle);
            end;
         end else CopyMemQuick(MemAEff+pred(i)*576,MyBitMap.MemA,576);
         if (FHandle<>0) or (MemAEff<>0) then BltBitMapRastPort(^MyBitMap,0,0,DWindow^.RPort,x*53-23,10+(y*30),53,24,192);
         EKnopf[i]:=Gadget(NIL,x*53-23,10+(y*30),53,24,GADGHCOMP,$1,BOOLGADGET,NIL,Nil,NIL,0,Nil,i,0);
         AddGadget(DWindow,^EKnopf[i],NIL);
         x:=x+1;
         if x>11 then begin
            x:=1; y:=y+1;
         end;
      end;
      EKnopf[FPos]:=Gadget(NIL,488,-20,128,16,GADGHCOMP+GADGIMAGE+GRELBOTTOM,$1,BOOLGADGET,^GImg[5],NIL,^CKnopfTx,0,Nil,FPos,0);
      MAKEBORDER(DWindow^,30,DWindow^.Height-21,468,DWindow^.Height-5,NEGATIVE);
      SetAPen(DWindow^.RPort,0); RectFill(DWindow^.RPort,32,DWindow^.Height-20,466,DWindow^.Height-6);
         {CANCEL }
      AddGadget(DWindow,^EKnopf[FPos],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      ModPick:=0;
      repeat
         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if (GadCode<>0) and (GadCode<>FPos) and (GadCode<>ModPick) then begin
            SetAPen(DWindow^.RPort,0);
            RectFill(DWindow^.RPort,32,DWindow^.Height-20,466,DWindow^.Height-6);
            WRITE(249,DWindow^.Height-19,2,3,DWindow^,FName[GadCode]);
            ModPick:=GadCode; GadCode:=0;
         end;

      until ((GadCode<>0) and (GadCode=ModPick)) or (Rawcode=69) or (GadCode=FPos);
      while DWindow^.FirstGadget<>NIL do RemoveGadgets(DWindow,DWindow^.FirstGadget);
      CloseWindow(DWindow);
      if GadCode in [1..FPos-1] then ModName:='EFFECTS/'+FName[GadCode] else READDIRECTORY:=false;
   end else begin
      TASKMESSAGE(PText[180]);
      READDIRECTORY:=false;
   end;
end;



begin
   DEFINEEFFECTMOD:=false;
   _WaveOp[OPos].Operation:=99;
   if not Auto then begin
      if Prefs.EffReq then begin
         PathFR:='EFFECTS';
         FRShow:='#?.eff';
         FRTit:=PText[101];
         if not FILEREQ then exit else ModName:=PathFR;
      end else if not READDIRECTORY then begin
         OPos:=OPos-1; OEnd:=OEnd-1; exit;
      end;
   end else ModName:=_WaveOp[OPos].OpString;
   with _WaveOp[OPos] do begin
      s:=ModName+'.data';
      FHandle:=DosOpen(s,MODE_OLDFILE);
      if FHandle<>0 then begin
         l:=DosRead(FHandle,^ModType,4);
         DosClose(FHandle);
      end else ModType:=0;
      with _WaveOp[OPos] do begin
         WAreaA:=AreaA[0];
         WAreaE:=AreaE[0];
      end;
      if not (ModType and EFF_DEFWIN=0) then begin
         MyWTStdMsg:=WTStdMsg(MyMsg,true,MDC_DEFINEIT,VERSION_EFFECTMOD,MyScreen,MyWindow,ActiveChannels[0],ActiveMode[0],
                               MemA16[0],MemA24[0],MemAUNDO[0],
                               MemL24[0],PlayL24[0],Prefs.SRate,SAttack[0],SDecay[0],SSustain[0],SRelease[0],
                               ^_WaveOp[OPos],OPos,OEnd,AreaA[0],AreaE[0],0,
                               ^MyWTImg,^EmptyMsgPrc,^ChSurround,^ChQuadro,^ChAC3,UsedChans,
                               MemAAlpha[0],AlphaUNDO[0],
                               $BADBAD,FirstPattern,FirstEntry,^MySDHeader[0],AnimPath,NIL,NIL,NIL,NIL,NIL,NIL);
         if PORTCOMMUNICATION(PORT_EFFECTMOD,ModName,^MyWTStdMsg)<>MDE_READY then begin
            OPos:=OPos-1;
            OEnd:=OEnd-1;
            exit;
         end else SETNEWWTSTATE;
         _WaveOp[OPos]:=MyWTStdMsg.ActWaveOp^;
      end;
      _WaveOp[OPos].OpString:=ModName;
   end;
   DEFINEEFFECTMOD:=true;
end;



function PORTCOMMUNICATION; {I}

var i                           :integer;
var PCLoop                      :boolean;
var Operation,l,GivenCommand    :long;
var CommPort                    :^MsgPort;
var s                           :string[150];
var FHandle2                    :BPTR;
var ActSDHeader                 :^SDHeader;
var MySDBodyShortText           :^SDBodyShortText;
var PortName,ModulName          :string;


begin
   PortName:=PName; ModulName:=MName;
   FHandle2:=DosOpen(ModulName,MODE_OLDFILE);
   if FHandle2=0 then begin
      PORTCOMMUNICATION:=-1;
      l:=TASKREQUEST(ModulName,PText[184],NIL,PText[220],NIL);
      exit;
   end else DosClose(FHandle2);
   if Debug then s:='run "'+ModulName+'"' else s:='run >NIL: "'+ModulName+'" >NIL:';
   i:=Execute(s,0,0);   i:=0;
   delay(5);
   repeat
     CommPort:=FindPort(PortName);
     i:=i+1; delay(1);
   until (CommPort<>NIL) or (i>=400);
   if CommPort=NIL then begin
      PORTCOMMUNICATION:=-1;
      l:=TASKREQUEST(PText[181],PText[182],NIL,PText[220],NIL);
      exit;
   end;
   PCLoop:=false;
   GivenCommand:=CommWTStdMsg^.Flags;
   CommWTStdMsg^.wt_Node:=Message(WTPort^.mp_Node,WTPort,sizeof(WTStdMsg));
   CommWTStdMsg^.wt_Node.mn_Node.ln_Type:=NT_FREEMSG;
   PutMsg(CommPort,^CommWTStdMsg^.wt_Node);
   repeat
      repeat
         CommWTStdMsg:=p_WTStdMsg(WaitPort(WTPort));
         CommWTStdMsg:=p_WTStdMsg(GetMsg(WTPort));
      until CommWTStdMsg<>NIL;

      if CommWTStdMsg^.Flags<>0 then with CommWTStdMsg^ do begin
         PORTCOMMUNICATION:=Flags;
         PCLoop:=true;
         if not (Flags in [MDE_READY,MDE_CANCELLED,MDE_NOTMYFORMAT,MDE_NICE_SOFTMOD,
                           MDE_FILEERROR]) then begin
            if Flags=MDE_WRONG_MODULEVERSION then l:=TASKREQUEST(PText[246],PText[247],NIL,PText[220],NIL);
            if Flags=MDE_NO_MEMORY then           l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
            if Flags=MDE_BREAK then               l:=TASKREQUEST(PText[231],NIL,NIL,PText[220],NIL);
            if FLags=MDE_CHANNELERROR then        l:=TASKREQUEST(PText[251],PText[252],NIL,PText[220],NIL);
            if Flags=MDE_FILEERROR then           l:=TASKREQUEST(PText[230],PText[231],NIL,PText[220],NIL);
            PORTCOMMUNICATION:=MDE_ERROR;
         end;
      end else with CommWTStdMsg^.WTMsgPrc^ do if PRC_Flags<>0 then begin
         case PRC_Flags of
            WTM_DRAWTIMEPATTERNLIST: DRAWTIMEPATTERNLIST(false);
            WTM_ADDANIMPATH:         begin
                                        if AnimPath<>PRC_Str1 then begin
                                           if AnimHandle<>0 then FREEOLDANIM;
                                           AnimPath:=PRC_Str1;
                                           ANIMPLAY(1);
                                        end;
                                        PRC_Long1:=0;
                                     end;
            WTM_ALLOCCHANNEL:        begin
                                        PRC_Long1:=XAllocMem(PRC_Long1+32,MEMF_CLEAR)+16;
                                        if PRC_Long1=16 then PRC_Long1:=0;
                                     end;
            WTM_FREECHANNEL:         XFreeMem(PRC_Long1-16,PRC_Long2+32);
            WTM_FREEPLAYLIST:        FREEPLAYLIST;
            WTM_ADDPATTERN:          PRC_NewPtr:=ADDPATTERN;
            WTM_ADDENTRY:            PRC_NewPtr:=ADDENTRY(PRC_Long1);
            WTM_GETCHANNELBITS:      PRC_Long1:=GETCHANNELBITS(Prc_Long1);
            WTM_GETSOUNDMODE:        PRC_Long1:=GETSOUNDMODE(PRC_Long1);
            WTM_DOSELECTLIST:        PRC_LONG1:=DOSELECTLIST(PRC_NewPtr);
            WTM_RESTOREALPHA:        RESTOREALPHA(PRC_Long1,PRC_Long2,PRC_Long3);
            WTM_ALLOCUNDO:           begin
                                        ALLOCUNDO(0);
                                        CommWTStdMsg^.MemAUNDO:=MemAUNDO[0];
                                     end;
            WTM_FREEUNDO:            begin
                                        FREEUNDO(0);
                                        CommWTStdMsg^.MemAUNDO:=MemAUNDO[0];
                                     end;
            WTM_GETMARKADDR:         begin
                                        TASKMESSAGE('Illegal Function-Call!!');
                                        DisplayBeep(NIL);
                                        PRC_Long1:=-1;
                                     end;
            WTM_GETMARKOFFSET:       GETMARKOFFSET(PRC_Long1,PRC_Long2);
            WTM_AUTODWIN:            PRC_Long1:=DEFINEEMPTY(PRC_Long1,PRC_Str1);
            WTM_HANDLEMOD:           begin
                                        PRC_Long1:=PORTCOMMUNICATION(PRC_Str1,PRC_Str2,ptr(Prc_Long1));
                                        PRC_Flags:=0;
                                     end;
            WTM_GETABORTINFO:         PRC_Long1:=0;
            WTM_SETCHANNELGADS:      ACTIVECHANNELGADS(PRC_Long1,PRC_Long2);
            WTM_GETCHANNELGADS:      Prc_Long1:=GETACTIVECHANNELS(ActiveMode[0]);
            WTM_WORKINFO:            WORKINFO(PRC_Str1,1);
            WTM_TASKREQ:             PRC_Long1:=TASKREQUEST(PRC_Str1,PRC_Str2,PRC_Str3,PRC_Str4,PRC_STR5)
            WTM_LONGREQ:             PRC_Long1:=LONGREQUEST(PRC_Str1,PRC_Str2,PRC_Str3,PRC_Str4,PRC_Long1,PRC_Long2,PRC_Long3,PRC_Long2)
            WTM_FILEREQ:             begin
                                        PathFR:=PRC_Str1; DirFR:=PRC_Str2; FileFR:=PRC_Str3;
                                        FRShow:=PRC_Str4; FRTit:=PRC_Str5;
                                        if FILEREQ then begin
                                           PRC_Str1:=PathFR; PRC_Str2:=DirFR; PRC_Str3:=FileFR;
                                           PRC_Long1:=0;
                                        end else PRC_Long1:=-1;
                                     end;
            WTM_TASKMSG:             begin
                                        TASKMESSAGE(PRC_Str1);
                                        PRC_Long1:=0;
                                     end;
            WTM_OPENDWIN:            if not OPENDWIN(PRC_Long1,PRC_Long2,PRC_NewPtr,PRC_Str1,PRC_Long3,PRC_Long4) then PRC_Long1:=-1;
            WTM_LEAVEWIN:            if LEAVEDEF(PRC_Long1,PRC_Long2,1,2,PRC_NewPtr) then PRC_Long1:=1 else PRC_Long2:=0;
            WTM_ALLOCALPHA:          if not ALLOCALPHA(0) then PRC_Long1:=-1 else CommWTStdMsg^.MemAAlpha:=MemAAlpha[0];
            WTM_PREFSPROCESS:        PROCESSWAVE(PRC_Long1,false);
            WTM_PLAYKEYS:            PLAYKEYS(PRC_Long1,PRC_NewPtr,PRC_Long2);
            WTM_PLAY:                begin
                                        i:=SetTaskPri(FindTask(NIL),PLAYPRIORITY);
                                        i:=STARTSOUND(PRC_Long1,PRC_Long2,PRC_NewPtr,0,64,64);
                                        i:=SetTaskPri(FindTask(NIL),0);
                                     end;
            WTM_CHANNELREQ:          PRC_Long1:=CHANNELREQUEST(PRC_Long1,PRC_Long2,PRC_Long3,PRC_Str1,PRC_Long2);
            WTM_GETNOTEFREQ:         PRC_Long1:=GETNOTEFREQ(PRC_NewPtr);
            WTM_CALCWAVE:            begin
                                        CALCCHANNELS(0,PlayL24[0],UsedChans);
                                        PRC_Long3:=1;
                                     end;
            WTM_ALLOC_SPECIAL_DATA:  begin
                                        case PRC_LONG1 of
                                           SD_ANIMINFO:   l:=XAllocMem(sizeof(SDBodyAnim),0);
                                           SD_SHORT_TEXT: l:=XAllocMem(sizeof(SDBodyShortText),0);
                                           SD_LOOP:       l:=XAllocMem(sizeof(SDBodyLoop),0);
                                           SD_SCENE:      l:=XAllocMem(sizeof(SDBodyScene),0);
                                           otherwise l:=0;
                                        end;
                                        PRC_NewPtr:=ptr(l);
                                     end;
            WTM_SPECIAL_DATA_FOUND:  if PRC_Long1=SD_ALPHA_CHANNEL then with _WaveOp[1] do OpType:=OpType or $80
                                      else if PRC_Long1 in [SD_SHORT_TEXT,SD_ANIMINFO,SD_SCENE,SD_LOOP] then begin
                                         ActSDHeader:=MySDHeader[0];
                                         if ActSDHeader<>NIL then begin
                                            while ActSDHeader^.NextSpecialData<>NIL do
                                             ActSDHeader:=ActSDHeader^.NextSpecialData;
                                            ActSDHeader^.NextSpecialData:=PRC_NewPtr;
                                         end else MySDHeader[0]:=PRC_NewPtr;
                                         if (GivenCommand=MDC_DEFINEIT) and (PRC_Long1=SD_SHORT_TEXT) then begin
                                            MySDBodyShortText:=r_SDBodyShortText(PRC_NewPtr);
                                            l:=TASKREQUEST(MySDBodyShortText^.sdb_TextString,NIL,NIL,PText[220],NIL);
                                         end;
                                      end else begin
                                         PRC_Long1:=-1;
                                         if PRC_NewPtr<>NIL then begin
                                            ActSDHeader:=PRC_NewPtr;
                                            XFreeMem(long(ActSDHeader),ActSDHeader^.sdh_Size);
                                         end;
                                      end;
            otherwise PRC_Long1:=-1;
         end;
         PRC_Flags:=0;
      end;
      Forbid;
      if CommWTStdMsg^.wt_Node.mn_ReplyPort^.mp_Node.ln_Name<>PortName
       then PCLoop:=false;
       {*** Verhindert Kollisionen zwischen Player- und anderen Modulen ***}
      CommPort:=FindPort(PortName);
      if CommPort<>NIL then begin
         CommWTStdMsg^.wt_Node:=Message(WTPort^.mp_Node,WTPort,sizeof(WTStdMsg));
         CommWTStdMsg^.wt_Node.mn_Node.ln_Type:=NT_FREEMSG;
         PutMsg(CommPort,^CommWTStdMsg^.wt_Node);
      end;
      Permit;
   until PCLoop;
   CommPort:=FindPort(PortName);
   while CommPort<>NIL do begin
      delay(1);
      CommPort:=FindPort(PortName);
   end;
   EmptyMsgPrc:=MsgPrc(0,'','','','','',0,0,0,0,0,NIL);
end;



procedure CALLFUNCTION(_Function,UsedChans:byte);

var l                           :long;
var ChBit,ChID,i                :byte;
var StartOffset,EndOffset       :long;

begin
   if _Function in [1,8] then exit;
   if _Function=7 then _WaveOp[OPos].Channels:=$3F;
   WORKINFO(PText[_Function+101],1);
   GETMARKOFFSET(StartOffset,EndOffset);
   l:=0; ChBit:=1;
   for ChID:=1 to 6 do begin
      if not ((UsedChans or CH_Sub) and ChBit=0) then begin
         if (MemA24[0,ChID]<>0) and (_WaveOp[OPos].Channels and ChBit=ChBit) then begin
            case _Function of
               2:  l:=DOFREQ(MemA24[0,ChID],MemAAlpha[0,ChID],StartOffset,EndOffset);
               3:  DOHKURVE(MemA24[0,ChID],MemAAlpha[0,ChID],StartOffset,EndOffset);
               4:  if ChID<>6 then DODIFFERENCER(MemA24[0,ChID],StartOffset,EndOffset,ChID);
               5:  DOINTEGRATER(MemA24[0,ChID],StartOffset,EndOffset);
               6:  DOANTIALIAS(MemA24[0,ChID],StartOffset,EndOffset,ChID);
               7:  l:=MAKEDRUM(MemA24[0,ChID],MemA24[0,ChID],MemAAlpha[0,ChID]);
               9:  DOVOLUME(MemA24[0,ChID],MemAAlpha[0,ChID],StartOffset,EndOffset,ChID);
               10: DOREVERSE(MemA24[0,ChID],MemAAlpha[0,ChID],StartOffset,EndOffset,ChID);
               11: DOOVERCROSS(MemA24[0,ChID],StartOffset,EndOffset,ChID);
               12: DODIGITIZER(MemA24[0,ChID],StartOffset,EndOffset,ChID);
               13: DOCUTZERO(MemA24[0,ChID],MemAAlpha[0,ChID],StartOffset,EndOffset);
               14: DOHEAVY(MemA24[0,ChID],MemAAlpha[0,ChID],StartOffset,EndOffset);
               15: DOMIXAROUND(MemA24[0,ChID],MemAAlpha[0,ChID],StartOffset,EndOffset);
               16: DOTRIAC(MemA24[0,ChID],StartOffset,EndOffset);
               otherwise;
            end;
         end;
      end;
      ChBit:=ChBit*2;
   end;;
   if (AreaE[0]>0) and (_Function=2) then AreaE[0]:=l;
   if (AreaE[0]>0) and (_Function=7) then begin
      AreaE[0]:=AreaE[0]-l; if AreaE[0]<0 then AreaE[0]:=0;
      AreaA[0]:=AreaA[0]-l; if AreaA[0]<0 then AreaA[0]:=0;
   end;
   CHECKMARK(OPos);
   ModMemInhalt:=0;
end;



function EDITOR:boolean;
forward;



function TRACEWTA(Mode :byte):boolean;
{Mode: WTA-File geladen = 1
       altes WTA-File geladen = 2}

var FunctLoop,FunctRepeat       :integer;
var EdUsed                      :boolean;
var i                           :long;

begin
   TRACEWTA:=false;
   for OPos:=1 to OEnd do with _WaveOp[OPos] do begin
      if (WAreaE>0) and (OPos>1) and (Operation<>1) then CHECKMARK(OPos)
      else begin
         AreaE[0]:=0;
         AreaA[0]:=0;
      end;
      PlayLUNDO:=PlayL24[0];
      WRITETBWINDOW;
      case Operation of
         1:  if not DOWAVE then exit;
         8:  DOECHO;
         17: if not DOCHANNELC then exit;
         18: if not DOSCALE then exit;
         99: if not DOEFFECTMOD then exit;
         otherwise begin
            if Operation in [4,5,7] then FunctRepeat:=_WaveOp[Opos].Operator[1] else FunctRepeat:=1;
            for FunctLoop:=1 to FunctRepeat do begin
               CALLFUNCTION(Operation,UsedChans);
               if FunctLoop<FunctRepeat then PROCESSWAVE(1,false);
               ModMemInhalt:=0;
            end;
         end;
      end;
      if Operation<>10 then PROCESSWAVE(1,false);
      if (Mode=2) and (PlayL24[0]*2<=MemL24[0]) then begin
         for i:=OEnd downto (OPos+1) do _WaveOp[i+1]:=_WaveOp[i];
         with _WaveOp[OPos+1] do begin
            Operation:=18;
            OpType:=1;
            Operator[1]:=PlayL24[0];
            while Operator[1]*2<=MemL24[0] do begin
               Operator[1]:=Operator[1]*2;
               if Prefs.SRate>1 then Prefs.SRate:=Prefs.SRate*2
            end;
            Operator[1]:=Operator[1] div 4;
         end;
         OEnd:=OEnd+1;
      end;
      if (OPos=1) and (Mode in [1,2]) then begin
         if Mode=2 then l:=TASKREQUEST(PText[275],PText[276],PText[277],NIL,PText[274])
         else if Mode=1 then l:=TASKREQUEST(PText[272],NIL,PText[273],NIL,PText[274]);
         if l=3 then begin
            EdUsed:=true;
            WORKINFO(NIL,8);
            OPos:=OEnd;
            PROCESSWAVE($8,true);
            while EDITOR do begin end;
            exit;
         end else EdUsed:=false;
      end;
   end;
   OPos:=OPos-1;
   if not EdUsed then PROCESSWAVE($1A,true);
   TRACEWTA:=true;
end;



function LOADWTA:boolean;

type r_OldWTA=record
   ChunkSize                            :byte;
   Operation,OpType,Channels,Flags      :integer;
   Operator                             :array [1..4] of long;
   OpString                             :string[81];
   MemLData,MemAData                    :long;
end;

var s                                   :string;
var ChBit,i                             :byte;
var _OldWaveOp                          :r_OldWTA;
var Order                               :array [1..8] of byte;
var ConvertWTA                          :boolean;

begin
   LOADWTA:=false;
   ConvertWTA:=false;
   FRShow:=''; PathFR:='WTA'; FRTit:=PText[239];
   if not FILEREQ then exit;
   WTVersion:=WTVer+FileFR;
   FHandle:=DosOpen(PathFR,MODE_OLDFILE);
   if FHandle=0 then begin
      l:=TASKREQUEST(PathFR,PText[189],NIL,PText[220],NIL);
      exit;
   end;
   s:=WTA_FILEID_NEW; i:=length(s);
   l:=DosRead(FHandle,^s,i);
   if s<>WTA_FILEID_NEW then begin
      if s=WTA_FILEID_OLD then ConvertWTA:=true else begin
         l:=TASKREQUEST(PathFR,PText[186],NIL,PText[220],NIL);
         DosClose(FHandle);
         exit;
      end;
   end;
   l:=DosRead(FHandle,^OEnd,4);
   l:=DosRead(FHandle,^Prefs.SRate,2);
   OPos:=1;
   repeat
      with _WaveOp[OPos] do begin
         l:=DosRead(FHandle,^ChunkSize,1);
         l:=l+DosRead(FHandle,ptr(addr(_WaveOp[OPos])+1),ChunkSize-1);
         if ConvertWTA then with _WaveOp[OPos] do
          if Operation=18 then Operation:=99;
         if (ChunkSize>=WOP_BIG) and (MemLData>0) then begin
            MemAData:=XAllocMem(MemLData,MEMF_CLEAR);
            if MemAData=0 then begin
               m:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
               FREEWTAFILE(1,OEnd);
               DosClose(FHandle); exit;
            end;
            l:=l+DosRead(FHandle,ptr(MemAData),MemLData);
         end else begin
            MemAData:=0; MemLData:=0;
         end;

         if l=ChunkSize+MemLData then OPos:=OPos+1 else begin
            m:=TASKREQUEST(PathFR,PText[192],PText[221],NIL,PText[220]);
            if m=3 then begin
               FREEWTAFILE(1,OEnd);
               DosClose(FHandle);
               exit;
            end else OEnd:=OPos-1;
         end;
      end;
   until OPos>OEnd;
   DosClose(FHandle);
    with _WaveOp[1] do begin
      ActiveMode[0]:=_WaveOp[1].SoundMode;
      ActiveChannels[0]:=GETCHANNELBITS(ActiveMode[0]);
   end;
   Opos:=OPos-1;
   OEnd:=OPos;
   if ConvertWTA then LOADWTA:=TRACEWTA(2) else LOADWTA:=TRACEWTA(1);
   OPos:=OEnd;
end;



procedure SAVESAMPLE;

type small=array[1..3] of byte;

var WData                                       :integer;
var SMemA,SMemL,l,Addr1,Addr2,Addr8,Addr16,
    Addr24,DataX,DataY,Divider,Result           :long;
var Data1                                       :^long;
var Data16                                      :^integer;
var Data8                                       :^short;
var DataS                                       :short;
var DataW                                       :integer;
var DataL                                       :long;
var Save8SVX,SaveReal,ChBit,ChID,ChCnt,FirstChn,
    SaveID,Answer,DataWrite                     :byte;
var DataBefore                                  :integer;
var s                                           :string;
var Data24,Crumple24                            :^Small;
var Quality                                     :array [0..12] of long;
var CharCnt,BitsCnt,BitValue,CharID,i           :byte;
var Bits                                        :array [1..168] of byte;
var WTText                                      :string;
var DoAlpha                                     :boolean;


function GETSAVEMEM:boolean;

begin
   GETSAVEMEM:=false;
   SMemL:=100032;
   SMemA:=XAllocVec(SMemL,MEMF_CLEAR);
   if SMemA=0 then begin
      SMemL:=AvailMem(MEMF_LARGEST)-640;
      if (SMemL>=640) then begin
         SMemA:=XAllocVec(SMemL,MEMF_CLEAR);
         if SMemA=0 then begin
            l:=TASKREQUEST(PText[183],PText[212],NIL,PText[220],NIL);
            exit;
         end;
      end else begin
         l:=TASKREQUEST(PText[183],PText[212],NIL,PText[220],NIL);
         exit;
      end;
   end;
   GETSAVEMEM:=true;
end;



procedure DISKFULL;

begin
   if SMemA<>0 then XFreeVec(SMemA); SMemA:=0;
   l:=TASKREQUEST(PText[191],PText[192],PText[253],NIL,PText[218]);
   DosClose(FHandle);
   if l=1 then l:=DeleteFile(PathFR);
end;



function SAVEDELTA:boolean;

begin
   SAVEDELTA:=false;
   l:=0;
   Addr1:=MemA24[0,ChID];
   Addr2:=MemA24[0,FirstChn];
   repeat
      Addr8:=SMemA;
      repeat
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         Data2:=ptr(Addr2); Addr2:=Addr2+4;
         Data8:=ptr(Addr8); Addr8:=Addr8+1;
         DataX:=Data1^-Data2^;
         Data8^:=round(SQRT(abs(DataX))/32.26);
         i:=Data8^ div 10;   Quality[i]:=Quality[i]+1;
         if DataX<0 then Data8^:=-Data8^;
      until (Addr1>=MemA24[0,ChID]+PlayL24[0]) or (Addr8>=SMemA+SMemL);
      m:=DosWrite(FHandle,ptr(SMemA),Addr8-SMemA);
      if m<Addr8-SMemA then begin
         DISKFULL;
         exit;
      end;
      l:=l+m;
   until l>=PlayL24[0] div 4;
   SAVEDELTA:=true;
end;



function SAVE16BIT:boolean;

begin
   SAVE16BIT:=false;
   Divider:=MAX24 div 32767;
   ChBit:=1; ChCnt:=0; SaveID:=0; CharID:=1;
   for ChID:=1 to 6 do begin
      if not (SaveReal and ChBit=0) then begin
         ChCnt:=ChCnt+1;
         if ((Result and COMPRESSION_DELTA=0) and (Result and COMPRESSION_DELTA_2=0))
         or (SaveID=0) then begin
            FirstChn:=ChID;
            l:=0; Addr1:=MemA24[0,ChID];
            repeat
               Addr16:=SMemA;
               repeat
                  Data1:=ptr(Addr1);   Addr1:=Addr1+4;
                  Data16:=ptr(Addr16); Addr16:=Addr16+2;
                  Data16^:=Data1^ div Divider;
                  if (SaveID=0) and (Result and $80=$80) and (CharID<169) then begin
                     DataW:=(Data16^ and not 1) or Bits[CharID];
                     CharID:=CharID+1;
                     if (DataW=0) and (Data16^=1) then DataW:=2;
                     Data16^:=DataW
                  end;
               until (Addr16>=SMemA+SMemL) or (Addr1>=MemA24[0,ChID]+PlayL24[0]);
               m:=DosWrite(FHandle,ptr(SMemA),Addr16-SMemA);
               if m<Addr16-SMemA then begin
                  DISKFULL;
                  exit;
               end;
               l:=l+m;
            until l>=PlayL24[0] div 2
         end else if not (Result and COMPRESSION_DELTA=0) then begin
            if not SAVEDELTA then exit;
         end; 
         SaveID:=SaveID+1;
      end;
      ChBit:=ChBit*2;
   end;
   SAVE16BIT:=true;
end;



procedure VIEWQUALITY;

var Reached,Maximum     :long;

begin
   Maximum:=0;
   for i:=0 to 12 do begin
      Maximum:=Maximum+Quality[i];
      Quality[i]:=Quality[i]*(12-i);
   end;
   Reached:=0;
   for i:=0 to 12 do Reached:=Reached+(Quality[i] div 12);
   s:=realstr(Reached/Maximum*100,2)+' %';
   l:=TASKREQUEST(PText[203],s,NIL,PText[220],NIL);
end;



function FIBONACCI(AlwaysSaved,SAddr,SMemL :long):long;

type FibArray=array[0..15] of short;

var l,m         :long;
var Addr1,Addr2 :long;
var Data1       :^short;
var Data2       :^byte;
var FibArr      :FibArray;


function GETFIB:short;

var D1,Diff     :integer;
var Fib,i       :short;

begin
   D1:=Data1^;
   Diff:=D1-DataBefore;
   if Diff<-27 then Fib:=$0 else if Diff>17 then Fib:=$F else begin
      i:=0;
      while (Diff>FibArr[i]) and (i<14) do i:=i+1;
      if FibArr[i]-Diff<FibArr[i+1]-Diff then Fib:=i else Fib:=i+1;
   end;

   if DataBefore+FibArr[Fib]>127 then Fib:=Fib-1;
   if DataBefore+FibArr[Fib]<-127 then Fib:=Fib+1;
   DataBefore:=DataBefore+FibArr[Fib];

   GETFIB:=Fib;
end;



begin
   FibArr:=FibArray(-34,-21,-13,-8,-5,-3,-2,-1,0,1,2,3,5,8,13,21);
   Addr1:=SAddr;
   Addr2:=SAddr;
   if AlwaysSaved=0 then begin
      DataBefore:=0;      m:=DosWrite(FHandle,^DataBefore,1);
      Data1:=ptr(Addr1);
      DataBefore:=Data1^; m:=m+DosWrite(FHandle,Data1,1);
   end;
   repeat
      Data1:=ptr(Addr1); Addr1:=Addr1+1;
      DataWrite:=GETFIB * 16;

      Data1:=ptr(Addr1); Addr1:=Addr1+1;
      DataWrite:=DataWrite or GETFIB;

      Data2:=ptr(Addr2); Addr2:=Addr2+1;
      Data2^:=DataWrite;

   until Addr1>=SAddr+SMemL;
   m:=DosWrite(FHandle,ptr(SAddr),SMemL div 2);
   if m*2>=SMemL then FIBONACCI:=SMemL;
end;



procedure SAVEALPHACHANNEL(Compress :byte);

var PadSize             :byte;

begin
   s:='ACHN';                    l:=DosWrite(FHandle,^s,4);
   l:=round(PlayL24[0]/80+0.5)*ChCnt;

   if l mod 4 <> 0 then begin
      PadSize:=4-(l mod 4);
      l:=succ(l div 4) * 4;
   end else PadSize:=0;          l:=DosWrite(FHandle,^l,4);
   ChBit:=1;
   for ChID:=1 to 6 do begin
      if not (SaveReal and ChBit=0) then begin
         l:=DosWrite(FHandle,ptr(MemAAlpha[0,ChID]),round(PlayL24[0]/80+0.5));
         if l<round(PlayL24[0]/80+0.5) then begin
            DISKFULL;
            exit;
         end;
      end;
      ChBit:=ChBit*2;
   end;
   l:=0;
   if PadSize<>0 then m:=DosWrite(FHandle,^l,PadSize);
end;



procedure SAVEADDITIONAL;

type DPANChunk=record
        Version,Frames          :word;
        FPS,pad1,pad2,pad3      :byte;
     end;

var MyDPAN              :DPANChunk;
var ActSDHeader         :^SDHeader;
var ActSDBodyAnim       :^SDBodyAnim;
var ActSDBodyScene      :^SDBodyScene;
var w                   :word;

begin
   ActSDHeader:=MySDHeader[0];
   if ActSDHeader<>NIL then begin
      if ActSDHeader^.sdh_Type=SD_ANIMINFO then begin
         s:='DPAN';            l:=DosWrite(FHandle,^s,4);
         l:=sizeof(DPANChunk); l:=DosWrite(FHandle,^l,4);
         ActSDBodyAnim:=r_SDBodyAnim(ActSDHeader);
         MyDPAN:=DPANChunk(3,ActSDBodyAnim^.sdb_Frames,ActSDBodyAnim^.sdb_FPS,0,0,0);
                               l:=DosWrite(FHandle,^MyDPAN,sizeof(DPANChunk));
      end else if ActSDHeader^.sdh_Type=SD_SCENE then begin
         s:='WTSZ';            l:=DosWrite(FHandle,^s,4);
         l:=208;               l:=DosWrite(FHandle,^l,4);
         ActSDBodyScene:=r_SDBodyScene(ActSDHeader);
         l:=DosWrite(FHandle,^ActSDBodyScene^.sdb_Name,208);
      end;
      ActSDHeader:=ActSDHeader^.NextSpecialData;
      if ActSDHeader=NIL then exit;
   end;
   if AnimPath<>'' then begin
      s:='ANIM';   l:=DosWrite(FHandle,^s,4);
      l:=200;      l:=DosWrite(FHandle,^l,4);
                   l:=DosWrite(FHandle,^AnimPath,200);
   end;
end;



begin
   { SAVESAMPLE }
   WTText:=('Sample created with '+WTVer);
   while length(WTText) mod 4<>0 do WTText:=WTText+' ';
   for i:=0 to 12 do Quality[i]:=1;
   SMemA:=0;
   if SItem<>6 then PathFR:=Prefs.SampleStr else PathFR:='WTA';
   FRShow:=''; FRTit:=PText[241];
   if not FILEREQ then exit;
   Prefs.SampleStr:=PathFR;
   WTVersion:=WTVer+FileFR;
   if (MemAAlpha[0,1] or MemAAlpha[0,3])<>0 then DoAlpha:=true else DoAlpha:=false;
   if SItem=6 then CHECKSUFFIX('.WTA');
   if SItem=1 then
    SaveReal:=CHANNELREQUEST(ActiveChannels[0],ActiveChannels[0],COMPRESSION_FIBONACCI_DELTA+$80,PText[243],Result)
   else if SItem in [2..4] then
    SaveReal:=CHANNELREQUEST(ActiveChannels[0],ActiveChannels[0],COMPRESSION_DELTA+COMPRESSION_DELTA_2+
    $80,PText[243],Result)
   else if SItem=5 then
    SaveReal:=CHANNELREQUEST(ActiveChannels[0],ActiveChannels[0],$80,PText[243],Result)
   else if SItem>6 then
    SaveReal:=CHANNELREQUEST(ActiveChannels[0],ActiveChannels[0],0,PText[243],Result);
   Save8SVX:=0; ChCnt:=0;
   if not (Result and $80=0) and (PlayL24[0]<680) then begin
      l:=TASKREQUEST(PText[224],PText[197],NIL,PText[220],NIL);
      Result:=Result and $7F;
   end;
   if not (Result and $80=0) then begin
      Prefs.CopyrightStr[21]:=chr(0);
      for i:=1 to 7 do Bits[i]:=0;
      Bits[8]:=1;
      CharID:=9;
      for CharCnt:=1 to 20 do begin
         BitValue:=1;
         i:=ord(Prefs.CopyrightStr[CharCnt]);
         if CharCnt>length(Prefs.CopyrightStr) then i:=32;
         for BitsCnt:=1 to 8 do begin
            if (i and BitValue=0) then Bits[CharID]:=0 else Bits[CharID]:=1;
            CharID:=CharID+1;
            BitValue:=BitValue*2;
         end;
      end;
   end;
   if not (SaveReal and CH_LEFT=0) then begin
      Save8SVX:=2; ChCnt:=1;
   end;
   if not (SaveReal and CH_RIGHT=0) then begin
      Save8SVX:=Save8SVX+4; ChCnt:=ChCnt+1;
   end;
   if not (SaveReal and CH_CENTER=0) then begin
      Save8SVX:=Save8SVX+8; ChCnt:=ChCnt+1;
   end;
   if not (SaveReal and CH_SLEFT=0) then begin
      Save8SVX:=Save8SVX+1; ChCnt:=ChCnt+1;
   end;
   if not (SaveReal and CH_SRIGHT=0) then begin
      Save8SVX:=Save8SVX+16; ChCnt:=ChCnt+1;
   end;
   if not (SaveReal and CH_SUB=0) then begin
      Save8SVX:=Save8SVX+32; ChCnt:=ChCnt+1;
   end;
   FHandle:=DosOpen(PathFR,MODE_OLDFILE);
   if FHandle<>0 then begin
      DosClose(FHandle);
      l:=TASKREQUEST(PathFR,PText[194],PText[217],NIL,PText[218]);
      if l=3 then exit;
   end;
   FHandle:=DosOpen(PathFR,MODE_NEWFILE);
   if FHandle=0 then begin
      l:=TASKREQUEST(PathFR,PText[190],NIL,PText[220],NIL);
      exit;
   end;
   PlayL24[0]:=PlayL24[0] div 8 * 8;
   WTAChanged:=false;
   if SItem in [1..4] then begin
      s:='FORM';     for i:=1 to 2 do l:=DosWrite(FHandle,^s,4);
   end;
   case SItem of
      1: begin
            SMemL:=PlayL24[0] div 4;
            if not GETSAVEMEM then begin
               DosClose(FHandle);
               exit;
            end;
            s:='8SVXVHDR'; l:=DosWrite(FHandle,^s,8);
            l:=20;         l:=DosWrite(FHandle,^l,4);

            if SSustain[0]<>0 then begin
               Addr1:=SSustain[0] div 4;
               Addr2:=PlayL24[0] div 4-Addr1;
            end else begin
               Addr1:=PlayL24[0] div 4;
               Addr2:=0;
            end;
            VHDR:=VoiceHeader(Addr1,Addr2,32,
                              round(10000000/(Prefs.SRate*2.79365)),1,Result and 1,0,1,Result and 1,0);
            l:=DosWrite(FHandle,^VHDR,20);

            s:='CHAN';     l:=DosWrite(FHandle,^s,4);
            l:=4;          l:=DosWrite(FHandle,^l,4);
            l:=Save8SVX;   l:=DosWrite(FHandle,^l,4);

            s:='ANNO';                l:=DosWrite(FHandle,^s,4);
            l:=length(WTText);        l:=DosWrite(FHandle,^l,4);
            s:=WTText;                l:=DosWrite(FHandle,^s,length(WTText));

            s:='ADSR';                l:=DosWrite(FHandle,^s,4);
            l:=16;                    l:=DosWrite(FHandle,^l,4);
            ADSR:=ADSRHeader(SAttack[0] div 4,SDecay[0] div 4,
                             SSustain[0] div 4,SRelease[0] div 4);
            l:=DosWrite(FHandle,^ADSR,16);

            if DoAlpha then SAVEALPHACHANNEL(VHDR.SCompression1);
            SAVEADDITIONAL;

            s:='BODY';                    l:=DosWrite(FHandle,^s,4);
            l:=PlayL24[0] div 4 * ChCnt;
            if VHDR.SCompression1=COMPRESSION_FIBONACCI_DELTA then
             l:=PlayL24[0] div 8 * ChCnt + ChCnt * 2;
                                          l:=DosWrite(FHandle,^l,4);
            Divider:=MAX24 div 127;
            ChBit:=1; SaveID:=0; CharID:=1;
            for ChID:=1 to 6 do begin
               if not (SaveReal and ChBit=0) then begin
                  l:=0; Addr1:=MemA24[0,ChID];
                  repeat
                     Addr8:=SMemA;
                     repeat
                        Data1:=ptr(Addr1); Addr1:=Addr1+4;
                        Data8:=ptr(Addr8); Addr8:=Addr8+1;
                        Data8^:=Data1^ div Divider;
                        if (SaveID=0) and (Result and $80=$80) and (CharID<169) then begin
                           DataS:=(Data8^ and not 1) or Bits[CharID];
                           CharID:=CharID+1;
                           if (DataS=0) and (Data8^=1) then DataS:=2;
                           Data8^:=DataS
                        end;
                     until (Addr8>=SMemA+SMemL) or (Addr1>=MemA24[0,ChID]+PlayL24[0]);
                     if not (Result and COMPRESSION_FIBONACCI_DELTA=0) then
                      m:=FIBONACCI(l,SMemA,Addr8-SMemA)
                     else
                      m:=DosWrite(FHandle,ptr(SMemA),Addr8-SMemA);
                     if m<Addr8-SMemA then begin
                        DISKFULL;
                        exit;
                     end;
                     l:=l+m;
                  until l>=PlayL24[0] div 4;
                  SaveID:=SaveID+1;
               end;
               ChBit:=ChBit*2;
            end;

            l:=DosSeek(FHandle,0,OFFSET_BEGINNING);
            l:=DosSeek(FHandle,0,OFFSET_END);
            l:=DosSeek(FHandle,4,OFFSET_BEGINNING);
            l:=l-8;
            l:=DosWrite(FHandle,^l,4);
         end;
      2: begin
            SMemL:=PlayL24[0] div 2;
            if not GETSAVEMEM then begin
               DosClose(FHandle);
               exit;
            end;
            s:='16SVVHDR'; l:=DosWrite(FHandle,^s,8);
            l:=20;         l:=DosWrite(FHandle,^l,4);

            if SSustain[0]<>0 then begin
               Addr1:=SSustain[0] div 4;
               Addr2:=(PlayL24[0] div 4)-Addr1;
            end else begin
               Addr1:=PlayL24[0] div 4;
               Addr2:=0;
            end;
            VHDR:=VoiceHeader(Addr1,Addr2,32,
                              round(10000000/(Prefs.SRate*2.79365)),1,0,0,1,0,0);
            VHDR.SCompression1:=VHDR.SCompression1 or (Result and $7F);
            VHDR.SCompression2:=VHDR.SCompression1;
            l:=DosWrite(FHandle,^VHDR,20);

            s:='CHAN';     l:=DosWrite(FHandle,^s,4);
            l:=4;          l:=DosWrite(FHandle,^l,4);
            l:=Save8SVX;   l:=DosWrite(FHandle,^l,4);

            s:='ANNO';                l:=DosWrite(FHandle,^s,4);
            l:=length(WTText);        l:=DosWrite(FHandle,^l,4);
            s:=WTText;                l:=DosWrite(FHandle,^s,length(WTText));

            s:='ADSR';                l:=DosWrite(FHandle,^s,4);
            l:=16;                    l:=DosWrite(FHandle,^l,4);
            ADSR:=ADSRHeader(SAttack[0] div 4,SDecay[0] div 4,
                             SSustain[0] div 4,SRelease[0] div 4);
            l:=DosWrite(FHandle,^ADSR,16);

            if DoAlpha then SAVEALPHACHANNEL(VHDR.SCompression1);
            SAVEADDITIONAL;

            s:='BODY';                l:=DosWrite(FHandle,^s,4);
            if (Result and COMPRESSION_DELTA=0) then l:=PlayL24[0] div 2 * ChCnt
            else l:=PlayL24[0] div 4 * ChCnt+1;
                                      l:=DosWrite(FHandle,^l,4);

            if not SAVE16BIT then exit;

            l:=DosSeek(FHandle,0,OFFSET_BEGINNING);
            l:=DosSeek(FHandle,0,OFFSET_END);
            l:=DosSeek(FHandle,4,OFFSET_BEGINNING);
            l:=l-8;
            l:=DosWrite(FHandle,^l,4);
         end;
      3: begin
            SMemL:=PlayL24[0] div 2;
            if not GETSAVEMEM then begin
               DosClose(FHandle);
               exit;
            end;
            s:='16SXSXHD';       l:=DosWrite(FHandle,^s,8);
            l:=sizeof(SXHeader); l:=DosWrite(FHandle,^l,4);
            SXHD:=SXHeader(16,64,PlayL24[0] div 2,Prefs.SRate,0,SaveReal and $3F,ActiveMode[0],round(10000000/(Prefs.SRate*2.79365)),0);
            SXHD.Flags:=SXHD.Flags or (Result and $7F);
            l:=DosWrite(FHandle,^SXHD,sizeof(SXHeader));

            s:='ANNO';                l:=DosWrite(FHandle,^s,4);
            l:=length(WTText);        l:=DosWrite(FHandle,^l,4);
            s:=WTText;                l:=DosWrite(FHandle,^s,length(WTText));

            s:='ADSR';                l:=DosWrite(FHandle,^s,4);
            l:=16;                    l:=DosWrite(FHandle,^l,4);
            ADSR:=ADSRHeader(SAttack[0] div 2,SDecay[0] div 2,
                             SSustain[0] div 2,SRelease[0] div 2);
            l:=DosWrite(FHandle,^ADSR,16);

            if DoAlpha then SAVEALPHACHANNEL(SXHD.Flags and $FF);
            SAVEADDITIONAL;

            s:='BODY';                l:=DosWrite(FHandle,^s,4);
            if (Result and COMPRESSION_DELTA=0) then l:=PlayL24[0] div 2 * ChCnt
            else l:=PlayL24[0] div 4 * ChCnt+1;
                                      l:=DosWrite(FHandle,^l,4);

            if not SAVE16BIT then exit;

            l:=DosSeek(FHandle,0,OFFSET_END);
            l:=DosSeek(FHandle,4,OFFSET_BEGINNING);
            l:=l-8;
            l:=DosWrite(FHandle,^l,4);
         end;
      4: begin
            SMemL:=PlayL24[0] div 4 * 3;
            if not GETSAVEMEM then begin
               DosClose(FHandle);
               exit;
            end;

            s:='24SXSXHD';          l:=DosWrite(FHandle,^s,8);
            l:=sizeof(SXHeader); l:=DosWrite(FHandle,^l,4);
            SXHD:=SXHeader(24,64,PlayL24[0],Prefs.SRate,COMPRESSION_3BYTE,SaveReal and $3F,ActiveMode[0],round(10000000/(Prefs.SRate*2.79365)),0);
            SXHD.Flags:=SXHD.Flags or (Result and $7F);
            l:=DosWrite(FHandle,^SXHD,sizeof(SXHeader));

            s:='ANNO';                l:=DosWrite(FHandle,^s,4);
            l:=length(WTText);        l:=DosWrite(FHandle,^l,4);
            s:=WTText;                l:=DosWrite(FHandle,^s,length(WTText));

            s:='ADSR';                l:=DosWrite(FHandle,^s,4);
            l:=16;                    l:=DosWrite(FHandle,^l,4);
            ADSR:=ADSRHeader(SAttack[0],SDecay[0],SSustain[0],SRelease[0]);
            l:=DosWrite(FHandle,^ADSR,16);

            if DoAlpha then SAVEALPHACHANNEL(SXHD.Flags and $FF);
            SAVEADDITIONAL;

            s:='BODY';          l:=DosWrite(FHandle,^s,4);
            l:=PlayL24[0] div 4 * 3 * ChCnt;
            if not (Result and COMPRESSION_DELTA=0) then l:=PlayL24[0] div 4 * ChCnt+2;
                                l:=DosWrite(FHandle,^l,4);
            FirstChn:=0; ChBit:=1; ChCnt:=0; Divider:=1; SaveID:=0; CharID:=1;
            if not (Result and COMPRESSION_DELTA_2=0) and
             not (SaveReal and CH_CENTER=0) then FirstChn:=3;
            for ChID:=1 to 6 do begin
               if not (SaveReal and ChBit=0) then begin
                  ChCnt:=ChCnt+1;
                  if ((Result and COMPRESSION_DELTA=0) and (Result and COMPRESSION_DELTA_2=0))
                  or ((SaveID=0) and (FirstChn=0)) or (FirstChn=ChID) then begin
                     if FirstChn=0 then FirstChn:=ChID;
                     l:=0; Addr1:=MemA24[0,ChID];
                     Crumple24:=ptr(addr(DataX)+1);
                     repeat
                        Addr24:=SMemA;
                        repeat
                           Data1:=ptr(Addr1);   Addr1:=Addr1+4;
                           if (FirstChn=ChID) and (Result and $80=$80) and (CharID<169) then begin
                              DataL:=(Data1^ and not 1) or Bits[CharID];
                              CharID:=CharID+1;
                              if (DataL=0) and (Data1^=1) then DataL:=2;
                              Data1^:=DataL
                           end;
                           Data24:=ptr(Addr24); Addr24:=Addr24+3;
                           DataX:=Data1^+MAX24;
                           Data24^:=Crumple24^;
                        until (Addr24>=SMemA+SMemL) or (Addr1>=MemA24[0,ChID]+PlayL24[0]);
                        m:=DosWrite(FHandle,ptr(SMemA),Addr24-SMemA);
                        if m<Addr24-SMemA then begin
                           DISKFULL;
                           exit;
                        end;
                        l:=l+m;
                     until l>=PlayL24[0] div 4 * 3;
                  end else if not (Result and COMPRESSION_DELTA=0) then begin
                     if not SAVEDELTA then exit
                  end;
                  SaveID:=SaveID+1;
               end;
               ChBit:=ChBit*2;
            end;
            l:=DosSeek(FHandle,0,OFFSET_END);
            l:=DosSeek(FHandle,4,OFFSET_BEGINNING);
            l:=l-8;
            l:=DosWrite(FHandle,^l,4);
         end;
      5: begin
            Answer:=TASKREQUEST(PathFR,PText[198],PText[213],PText[214],PText[215]);
            if Answer=1 then SMemL:=PlayL24[0] div 4
            else if Answer=2 then SMemL:=PlayL24[0] div 2;
            if Answer in [1,2] then if not GETSAVEMEM then begin
               DosClose(FHandle);
               exit;
            end;
            ChBit:=1; SaveID:=0; CharID:=1;
            for ChID:=1 to 6 do begin
               if not (SaveReal and ChBit=0) then begin
                  if (Answer=1) and (MemA24[0,ChID]<>0) then begin
                     Divider:=MAX24 div 127;
                     l:=0; Addr1:=MemA24[0,ChID];
                     repeat
                        Addr8:=SMemA;
                        repeat
                           Data1:=ptr(Addr1); Addr1:=Addr1+4;
                           Data8:=ptr(Addr8); Addr8:=Addr8+1;
                           Data8^:=Data1^ div Divider;
                           if (SaveID=0) and (Result and $80=$80) and (CharID<169) then begin
                              DataS:=(Data8^ and not 1) or Bits[CharID];
                              CharID:=CharID+1;
                              if (DataS=0) and (Data8^=1) then DataS:=2;
                              Data8^:=DataS
                           end;
                        until (Addr8>=SMemA+SMemL) or (Addr1>=MemA24[0,ChID]+PlayL24[0]);
                        m:=DosWrite(FHandle,ptr(SMemA),Addr8-SMemA);
                        if m<Addr8-SMemA then begin
                           DISKFULL;
                           exit;
                        end;
                        l:=l+m;
                     until l>=PlayL24[0] div 4
                  end else if (Answer=2) and (MemA24[0,ChID]<>0) then begin
                     Divider:=MAX24 div 32767;
                     l:=0; Addr1:=MemA24[0,ChID];
                     repeat
                        Addr16:=SMemA;
                        repeat
                           Data1:=ptr(Addr1);   Addr1:=Addr1+4;
                           Data16:=ptr(Addr16); Addr16:=Addr16+2;
                           Data16^:=Data1^ div Divider;
                           if (SaveID=0) and (Result and $80=$80) and (CharID<169) then begin
                              DataW:=(Data16^ and not 1) or Bits[CharID];
                              CharID:=CharID+1;
                              if (DataW=0) and (Data16^=1) then DataW:=2;
                              Data16^:=DataW
                           end;
                        until (Addr16>=SMemA+SMemL) or (Addr1>=MemA24[0,ChID]+PlayL24[0]);
                        m:=DosWrite(FHandle,ptr(SMemA),Addr16-SMemA);
                        if m<Addr16-SMemA then begin
                           DISKFULL;
                           exit;
                        end;
                        l:=l+m;
                     until l>=PlayL24[0] div 2
                  end else if (Answer=3) and (MemA24[0,ChID]<>0) then begin
                     if (SaveID=0) and (Result and $80=$80) then begin
                        Addr1:=MemA24[0,ChID];
                        repeat
                           Data1:=ptr(Addr1);   Addr1:=Addr1+4;
                           DataL:=(Data1^ and not 1) or Bits[CharID];
                           CharID:=CharID+1;
                           if (DataL=0) and (Data1^=1) then DataL:=2;
                           Data1^:=DataL
                        until (Addr1>=MemA24[0,ChID]+PlayL24[0]) or (Addr1>=MemA24[0,ChID]+672);
                     end;
                     m:=DosWrite(FHandle,ptr(MemA24[0,ChID]),PlayL24[0]);
                     if m<PlayL24[0] then begin
                        DISKFULL;
                        exit;
                     end;
                     l:=l+m;
                  end;
                  SaveID:=SaveID+1;
               end;
               ChBit:=ChBit*2;
            end;
         end;
      6: begin
            for i:=1 to OEnd do with _WaveOp[i] do begin
               if ChunkSize>WOP_NORM then begin
                  if (MemAData=0) or (MemLData=0) then begin
                     ChunkSize:=WOP_NORM; MemLData:=0; MemAData:=0;
                  end else ChunkSize:=WOP_BIG;
               end else MemLData:=0;
               if ChunkSize<WOP_SMALL then ChunkSize:=WOP_SMALL;
            end;
            s:=WTA_FILEID_NEW;
            l:=DosWrite(FHandle,^s,length(s));
            l:=DosWrite(FHandle,^OEnd,4);
            l:=DosWrite(FHandle,^Prefs.SRate,2);
            i:=1;
            repeat
               with _WaveOp[i] do begin
                  l:=DosWrite(FHandle,^_WaveOp[i],ChunkSize);
                  if ChunkSize>WOP_NORM then l:=l+DosWrite(FHandle,ptr(MemAData),MemLData);
                  if l=ChunkSize+MemLData then i:=i+1 else begin
                     l:=TASKREQUEST(PathFR,PText[191],NIL,PText[220],NIL);
                     DosClose(FHandle); exit;
                  end;
               end;
            until i>OEnd;
         end;
      otherwise begin
            PathFR:='SAVER/'+MenuName[SItem-6];
            MyWTStdMsg:=WTStdMsg(MyMsg,true,MDC_DOIT,VERSION_SAVER,^MyScreen,^MyWindow,SaveReal and $3F,ActiveMode[0],
                                  MemA16[0],MemA24[0],MemAUNDO[0],
                                  MemL24[0],PlayL24[0],Prefs.SRate,SAttack[0],SDecay[0],SSustain[0],SRelease[0],
                                  ^_WaveOp[OPos],OPos,OEnd,AreaA[0],AreaE[0],FHandle,
                                  ^MyWTImg,^EmptyMsgPrc,^ChSurround,^ChQuadro,^ChAC3,UsedChans,
                                  MemAAlpha[0],AlphaUNDO[0],
                                  $BADBAD,FirstPattern,FirstEntry,^MySDHeader[0],AnimPath,NIL,NIL,NIL,NIL,NIL,NIL);
            l:=PORTCOMMUNICATION(PORT_SAVER,PathFR,^MyWTStdMsg);
            if l=-1 then begin
               DosClose(FHandle);
               exit;
            end;
            SETNEWWTSTATE;
            if l=MDE_FILEERROR then begin
               DISKFULL;
               exit;
            end;
         end;
   end;
   if (SItem in [1..5]) and not (Result and COMPRESSION_DELTA=0) then VIEWQUALITY
   else if (SItem in [1..5]) and not (Result and COMPRESSION_DELTA_2=0) then begin
      Quality[0]:=Quality[0]*2;
      VIEWQUALITY;
   end;
   DosClose(FHandle);
   if SMemA<>0 then XFreeVec(SMemA);
   PROCESSWAVE(20,true);
end;



function EDITOR;

var i,j,k,GadOffset     :integer;
var TWindow             :^Window;
var ActMode             :byte;
var IMemA               :long;
var WinOpen,EdUsed      :boolean;
var MySList             :SelectListGad;


procedure DEFINENEW(Funct :byte);

var GoodDone    :boolean;
var i,j         :integer;


function REDEFINE:boolean;

var s   :string;

begin
   REDEFINE:=false;
   s:='';
   case _WaveOp[OPos].Operation of
      4: s:=PText[105];
      5: s:=PText[106];
      7: s:=PText[108];
      otherwise;
   end;
   s:=PText[148]+' '+s;
   if not OPENDWIN(90,0,DWindow,s,0,0) then exit;
   with _WaveOp[OPos] do begin
      DKnopf[1]:=Gadget(NIL,500,40,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^OKKnopfTx,0,Nil,1,0);
      DKnopf[2]:=Gadget(NIL,500,58,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^CKnopfTx,0,Nil,2,0);
         { OK / CANCEL }
      CREATEPROPGAD(10,50,pred(Operator[1])*661,655,1,2,DWindow^);
      Buffer[1]:=intstr(Operator[1]); ;

      WRITE(165,70,2,3,DWindow^,PText[147]);
      AddGadget(DWindow,^TextGad[1],NIL);
      AddGadget(DWindow,^Schieber[1],NIL);
      for i:=1 to 2 do AddGadget(DWindow,^DKnopf[i],NIL);
      RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
      repeat
         RawCode:=0; GadCode:=0;
         IMsg:=Wait_Port(DWindow^.UserPort);
         If IMsg<>Nil Then begin
            IMsg:=Get_Msg(DWindow^.UserPort);
            if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
               XGadget:=IMsg^.IAddress;
               GadCode:=XGadget^.GadgetID;
            end;
            if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
            Reply_Msg(IMsg)
         End;

         if (GadCode=3) or not (Schieber[1].flags and SELECTED=0) then begin
            Operator[1]:=succ(SchieberInfo[1].HorizPot div 661);
            if Operator[1]<1 then Operator[1]:=1;
            if Operator[1]>100 then Operator[1]:=100;
            Buffer[1]:=intstr(Operator[1]);
            RefreshGadgets(^TextGad[1],DWindow,NIL);
         end;
         if GadCode=4 then begin
            val(Buffer[1],Operator[1],i);
            if Operator[1]<1 then Operator[1]:=1;
            if Operator[1]>100 then Operator[1]:=100;
            Buffer[1]:=intstr(Operator[1]);
            SchieberInfo[1].HorizPot:=pred(Operator[1])*661;
            RefreshGadgets(^Schieber[1],DWindow,NIL);
         end;

      Until (GadCode in [1..2]) or (RawCode=68) or (RawCode=69);
      if LEAVEDEF(Rawcode,GadCode,1,2,DWindow) then REDEFINE:=true;
   end;
end;



begin
   OPos:=Funct;
   GoodDone:=false;   EdUsed:=true;
   if _WaveOp[Funct].Operation in [1..9,11,12,14,16..18,99] then begin
      GoodDone:=true;
      if ((AreaA[0]<>_WaveOp[Funct].WAreaA) or (AreaE[0]<>_WaveOp[Funct].WAreaE))
      and (Funct<>1) then begin
         CHECKMARK(Funct);
         PROCESSWAVE($8,true);
      end;
      case _WaveOp[Funct].Operation of
         1    : if DEFINEWAVE(false) then begin
                   if _WaveOp[1].OpType and $80=$80 then begin
                      if not ALLOCALPHA(0) then l:=TASKREQUEST(PText[183],PText[267],NIL,PText[220],NIL);
                   end else FREEALPHA(0);
                   ActiveChannels[0]:=GETCHANNELBITS(ActiveMode[0]);
                   PROCESSWAVE($8,true);
                end;
         2    : b:=DEFINEFREQ;
         3    : b:=DEFINEHKURVE;
         4    : b:=DEFINEDIFFERENCER;
         5    : b:=DEFINEINTEGRATER
         6    : b:=DEFINEANTIALIAS;
         7    : b:=REDEFINE;
         8    : b:=DEFINEECHO;
         9    : b:=DEFINEVOLUME;
         11   : b:=DEFINEOVERCROSS;
         12   : b:=DEFINEDIGITIZER;
         14   : b:=DEFINEHEAVY;
         16   : b:=DEFINETRIAC;
         17   : b:=DEFINECHANNELC;
         18   : b:=DEFINESCALE(true);
         99   : b:=DEFINEEFFECTMOD(true);
      end;
   end;
   if not GoodDone then l:=TASKREQUEST(PText[199],PText[200],NIL,PText[220],NIL);
end;



procedure RETRACE;

var JoMei,FunctRepeat,FunctLoop :integer;

begin
   while TWindow^.FirstGadget<>NIL do RemoveGadgets(TWindow,TWindow^.FirstGadget);
   CloseWindow(TWindow);
   WinOpen:=false;
   if OEnd>1 then begin
      b:=TRACEWTA(0);
      OPos:=OEnd;
      PROCESSWAVE($1A,true);
   end else DisplayBeep(NIL);
end;



procedure CANCELGADGET(GadNum :byte);

var x,y :integer;

begin
   if GadNum+GadOffset=1 then begin
      l:=TASKREQUEST(PText[201],PText[202],NIL,PText[220],NIL);
      exit;
   end else begin
      SetAPen(TWindow^.RPort,4);
      x:=EKnopf[GadNum+5].LeftEdge+3;
      y:=EKnopf[GadNum+5].TopEdge+2;
      Move(TWindow^.RPort,x,y);
      repeat
         y:=y+random(3);
         Draw(TWindow^.RPort,x+46,y);
         y:=y+random(3);
         Draw(TWindow^.RPort,x,y);
      until y>=EKnopf[GadNum+5].TopEdge+19;
      _WaveOp[GadNum+GadOffset].Flags:=FLAG_REMOVE;
   end;
end;



procedure CREATEEDLINE(y :byte);

var NextOp,x    :byte;

begin
   y:=y-1;
   x:=1;
   NextOp:=succ(y*9+GadOffset);
   while (x<=9) and (NextOp<=OPos) do with _WaveOp[NextOp] do begin
      if Operation<=12 then
       ClipBlit(IntuiWindow1^.RPort,Operation*53-51,IntuiWindow1^.BorderTop+15,TWindow^.RPort,x*53-43,y*28+25,53,24,192)
      else if Operation<=18 then
       ClipBlit(IntuiWindow1^.RPort,2+(Operation-13)*53,IntuiWindow1^.BorderTop+41,TWindow^.Rport,x*53-43,y*28+25,53,24,192)
      else if Operation=99 then begin
         IMemA:=XAllocMem(576,MEMF_CHIP+MEMF_CLEAR);
         if IMemA<>0 then begin
            Img:=Image(0,0,64,24,3,ptr(IMemA),7,1,NIL);
            s:=OpString+'.data';
            FHandle:=DosOpen(s,MODE_OLDFILE);
            if FHandle<>0 then begin
               l:=DosRead(FHandle,^l,4);
               l:=DosRead(FHandle,ptr(IMemA),576);
               DosClose(FHandle);
               DrawImage(TWindow^.RPort,^Img,x*53-43,y*28+25);
            end;
            XFreeMem(IMemA,576);
         end;
      end;
      if Flags=FLAG_REMOVE then CANCELGADGET(NextOp-GadOffset);
      NextOp:=NextOp+1;
      x:=x+1;
   end;
   RefreshGadgets(TWindow^.FirstGadget,TWindow,NIL);
end;



begin
   EDITOR:=false;   EdUsed:=false;
   if not OPENDWIN(116,0,TWindow,'',0,0) then exit;
   WinOpen:=true;
   EKnopf[1]:=Gadget(NIL,498,39,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[2],
                     NIL,^EKnopfTx[1],0,Nil,1,0);
   EKnopf[2]:=Gadget(NIL,498,57,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],
                     NIL,^EKnopfTx[3],0,Nil,2,0);
   EKnopf[3]:=Gadget(NIL,498,75,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],
                     NIL,^OKKnopfTx,0,Nil,3,0);
   EKnopf[4]:=Gadget(NIL,498,25,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^ButtonImg[5],
                     NIL,NIL,0,Nil,4,0);
   EKnopf[5]:=Gadget(NIL,498,93,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^ButtonImg[6],
                     NIL,NIL,0,Nil,5,0);
   EKnopfTx[1]:=IntuiText(2,0,0, 3,2,^CustomTA,PText[150],NIL);
   EKnopfTx[2]:=IntuiText(2,0,0, 3,2,^CustomTA,PText[151],NIL);
   EKnopfTx[3]:=IntuiText(3,0,0,30,2,^CustomTA,PText[152],NIL);
   ActMode:=1;
   MySList:=SelectListGad(TWindow,^EKnopf[1],ActMode,0,0,0,ITTArr(^EKnopfTx[1],
                          ^EKnopfTx[2],NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL));

   for i:=0 to 2 do for j:=1 to 9 do
      EKnopf[i*9+j+5]:=Gadget(NIL,j*53-43,i*28+25,53,24,GADGHCOMP,$1,BOOLGADGET,
                              NIL,NIL,NIL,0,Nil,i*9+j+5,0);
   for i:=1 to 32 do AddGadget(TWindow,^EKnopf[i],NIL);
   GadOffset:=0;
   for i:=1 to 3 do CREATEEDLINE(i);

   repeat
      RawCode:=0; GadCode:=0;
      IMsg:=Wait_Port(TWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(TWindow^.UserPort);
         if IMsg^.Class=GADGETUP then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      End;

      PLAYKEYS(RawCode,TWindow,0);

      if GadCode=1 then with EKnopf[1] do begin
         for i:=1 to 2 do DKnopfTx[i]:=EKnopfTx[i];
         DWindow:=TWindow;
         ActMode:=DOSELECTLIST(^MySList);
      end;

      if GadCode=2 then begin
         EdUsed:=false;
         for k:=1 to pred(MAXOPS) do begin
            for i:=1 to OEnd do if _WaveOp[i].Flags=FLAG_REMOVE then begin
               for j:=i to OEnd do _WaveOp[j]:=_WaveOp[j+1];
               OEnd:=OEnd-1; i:=1;
            end;
         end;
         GadCode:=3;
         EDITOR:=true;
         OPos:=OEnd;
         RETRACE;
      end;

      if (GadCode=4) and (GadOffset>0) then begin
         GadOffset:=GadOffset-9;
         for i:=1 to 14 do begin
            ScrollRaster(TWindow^.RPort,0,-2,10,25,486,105);
            WaitTOF;
         end;
         CREATEEDLINE(1);
      end;

      if (GadCode=5) and (GadOffset+27<OPos) then begin
         GadOffset:=GadOffset+9;
         for i:=1 to 14 do begin
            ScrollRaster(TWindow^.RPort,0,2,10,25,486,105);
            WaitTOF;
         end;
         CREATEEDLINE(3);
      end;

      if GadCode>5 then begin
         case ActMode of
            1: if OPos>=GadOffset+GadCode-5 then begin
                  i:=OPos; j:=OEnd;
                  DEFINENEW(GadOffset+GadCode-5);
                  OPos:=i; OEnd:=j;
                  GadCode:=0;
               end else DisplayBeep(NIL);
            2: CANCELGADGET(GadCode-5);
         end;
      end;

      if (Gadcode=3) and EdUsed and Prefs.Confirm then begin
         l:=TASKREQUEST(PText[268],PText[269],PText[219],NIL,PText[218]);
         if l=3 then GadCode:=0 else GadCode:=3;
      end;

   until GadCode=3;
   for i:=2 to OEnd do _WaveOp[i].Flags:=0;
   if WinOpen then begin
      while TWindow^.FirstGadget<>NIL do RemoveGadgets(TWindow,TWindow^.FirstGadget);
      CloseWindow(TWindow);
   end;
   GadCode:=0; RawCode:=0;
end;



procedure SETPLAYRATE;


procedure WRITENOTE;

begin
   SetAPen(DWindow^.RPort,0); RectFill(DWindow^.RPort,507,42,533,52);
   with Notes do
    if (bn_PosX>-1) and (bn_PosY>-1) then WRITE(520,41,1,3,DWindow^,bn_NoteName[bn_PosX,bn_PosY])
    else WRITE(520,41,1,3,DWindow^,'---')
end;


var HRate               :long;

begin
   if not OPENDWIN(80,0,DWindow,PText[153],0,0) then exit;
   DKnopf[1]:=Gadget(NIL,500,59,128,16,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,^GImg[5],NIL,^OKKnopfTx,0,Nil,1,0);
      { OK  }
   CREATEPROPGAD(10,40,Prefs.SRate,1,1,1,DWindow^);
   TextGad[2]:=Gadget(Nil,421,41,42,17,GADGHCOMP,_LONGINT+STRINGCENTER+$1,STRGADGET,NIL,Nil,Nil,0,^TextInfo[2],4,0);
   TextInfo[2]:=StringInfo(^Buffer[2],^Undobuffer[2],0,7,0,0,0,0,0,0,Nil,0,Nil);
   MAKEBORDER(DWindow^,418,40,464,54,NEGATIVE);
   Buffer[1]:=intstr(Prefs.SRate);
   Buffer[2]:=intstr(round(10000000/(Prefs.SRate*2.79365)));
   DKnopf[2]:=Gadget(NIL,477,40,21,12,GADGHCOMP+GADGIMAGE,$1,BOOLGADGET,
                     ^ButtonImg[3],NIL,NIL,0,Nil,5,0);
   MAKEBORDER(DWindow^,505,40,535,54,NEGATIVE);
   WRITENOTE;
   HRate:=Prefs.SRate;
   WRITE(165,56,2,3,DWindow^,PText[154]);
   WRITE(373,56,2,3,DWindow^,PText[155]);
   WRITE(441,56,2,3,DWindow^,PText[156]);
   for i:=1 to 2 do AddGadget(DWindow,^TextGad[i],NIL);
   AddGadget(DWindow,^Schieber[1],NIL);
   for i:=1 to 2 do AddGadget(DWindow,^DKnopf[i],NIL);
   RefreshGadgets(DWindow^.FirstGadget,DWindow,NIL);
   repeat

      RawCode:=0; GadCode:=0;
      IMsg:=Wait_Port(DWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(DWindow^.UserPort);
         if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      end;

      if GadCode=5 then begin
         l:=GETNOTEFREQ(DWindow);
         if l<>0 then begin
            Buffer[2]:=intstr(l);
            GadCode:=4;
         end;
         WRITENOTE;
      end;

      if (GadCode=2) or not (Schieber[1].flags and SELECTED=0) then begin
         HRate:=SchieberInfo[1].HorizPot;
         if HRate>65534 then HRate:=65534;
         if Hrate<1 then HRate:=1;
         SchieberInfo[1].HorizPot:=HRate;
         Buffer[1]:=intstr(HRate);
         Buffer[2]:=intstr(round(10000000/(HRate*2.79365)));
         RefreshGadgets(^TextGad[2],DWindow,NIL);
      end;
      if GadCode=3 then begin
         val(Buffer[1],HRate,i);
         if HRate>65534 then HRate:=65534;
         if Hrate<1 then HRate:=1;
         SchieberInfo[1].HorizPot:=HRate;
         Buffer[1]:=intstr(HRate);
         Buffer[2]:=intstr(round(10000000/(HRate*2.79365)));
         RefreshGadgets(^Schieber[1],DWindow,NIL);
      end;
      if GadCode=4 then begin
         val(Buffer[2],HRate,i);
         if HRate=0 then HRate:=1;
         HRate:=round(10000000/(HRate*2.79365));
         if HRate<1 then HRate:=1;
         if HRate>65534 then HRate:=65534;
         SchieberInfo[1].HorizPot:=HRate;
         Buffer[1]:=intstr(HRate);
         Buffer[2]:=intstr(round(10000000/(HRate*2.79365)));
         RefreshGadgets(^Schieber[1],DWindow,NIL);
      end;

      Prefs.SRate:=HRate;

      if GadCode in [2..4] then begin
         GETNOTEPOS; WRITENOTE;
      end;

      PLAYKEYS(RawCode,DWindow,0);

   Until (GadCode=1) or (RawCode=68);
   b:=LEAVEDEF(RawCode,GadCode,1,1,DWindow);
   PROCESSWAVE($8,true);
   RawCode:=0; GadCode:=0;
end;



procedure READOUT;

var CString                             :string[11];
var CharCnt,BitCnt,BitValue,CharID,i,j  :byte;
var Bits                                :array [1..80] of word;

begin
   for i:=6 downto 1 do if MemA24[0,i]<>0 then begin
      for j:=1 to 80 do Bits[j]:=0;
      Addr1:=MemA24[0,i];
      CharCnt:=1; CharID:=0;
      repeat
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         if (Data1^ and $FFFF>0) then
          Bits[CharCnt]:=Bits[CharCnt] + (Data1^ and $FFFF) div 10;
         CharCnt:=CharCnt+1;
         if CharCnt>80 then begin
            CharCnt:=1;
            CharID:=CharID+1;
         end;
      until (CharID=10) or (Addr1>=MemA24[0,i]+PlayL24[0]);
   end;
   CharID:=0;
   for CharCnt:=1 to 10 do begin
      BitValue:=1;
      i:=0;
      for BitCnt:=1 to 8 do begin
         CharID:=CharID+1;
         if Bits[CharID]>30000 then i:=i or BitValue;
         BitValue:=BitValue*2;
      end;
      CString[CharCnt]:=chr(i);
   end;
   CString[11]:=chr(0);
   s:='-'+CString+'-';
   l:=TASKREQUEST(s,'','','OK','');
end;



procedure SAMPLEEDIT(Mode :byte);

var Divider                                     :real;
var MemAAlphaNew                                :array [1..6] of long;
var ChCnt,ChID,i,ACtr                           :byte;
var MemLNew,MemANew,Addr1,Addr2,AddrA,CopyMemL,
    Value,Check,StartOffset,EndOffset           :long;
var MemA8New                                    :array [1..4] of long;
var Data1,Data2                                 :^long;
var DataA1,DataA2                               :^byte;
var DoAlpha,DoMarkedArea                        :boolean;



procedure UNDOINSERTMEM(MemType,ChPos :byte);

var ChID        :Byte;

begin
   l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
   if (MemType=2) and (ChPos>1) then begin
      MemANew:=0;
      while MemANew=0 do begin
         MemANew:=XAllocMem(MemL24[0] div 2,MEMF_CLEAR);
         if MemANew=0 then begin
            l:=TASKREQUEST(PText[260],PText[261],PText[219],NIL,PText[218]);
            if l=3 then begin
               FREESOUNDMEM(0,false);
               FREEWTAFILE(1,OEnd);
               exit;
            end;
         end;
      end;
      for i:=1 to 2 do CopyMemQuick(MemA8New[i],MemA8[0,i],PlayL24[0] div 4);
      exchange(MemA16[0,1],MemANew);
      MemA8[0,1]:=MemA16[0,1]; MemA8[0,2]:=MemA16[0,1]+MemL24[0] div 4;
      MemA8[0,3]:=MemA16[0,2]; MemA8[0,4]:=MemA16[0,2]+MemL24[0] div 4;
      XFreeMem(MemANew,MemLNew div 2);
   end;

   if MemType=2 then ChPos:=7;
   if ChPos>1 then for ChID:=pred(ChPos) downto 1 do
   if MemA24[0,ChID]<>0 then begin
      MemANew:=0;
      while MemANew=0 do begin
         MemANew:=XAllocMem(MemL24[0]+32,MEMF_CLEAR)+16;
         if MemANew=16 then begin
            l:=TASKREQUEST(PText[260],PText[261],PText[219],'',PText[218]);
            if l=3 then begin
               FREESOUNDMEM(0,false);
               FREEWTAFILE(1,OEnd);
               exit;
            end;
         end;
      end;
      if not (Knopf[ChID+18].Flags and SELECTED=0) then begin
         CopyMemQuick(MemA24[0,ChID],MemANew,AreaA[0]);
         CopyMemQuick(MemA24[0,ChID]+AreaA[0]+Value,MemANew+AreaA[0],PlayL24[0]-AreaA[0]);
      end else CopyMemQuick(MemANew,MemA24[0,ChID],PlayL24[0]);
      exchange(MemA24[0,ChID],MemANew);
      XFreeMem(MemANew-16,MemLNew+32);
   end;
   ALLOCUNDO(0);
end;



procedure GETBUFFEROFFSET(MemID :byte; var StartOffset,EndOffset :long);

begin
   StartOffset:=AreaA[MemID];
   EndOffset:=AreaE[MemID];
   if not (EndOffset in [4..MemL24[MemID]]) then EndOffset:=MemL24[MemID];
   if StartOffset>EndOffset then StartOffset:=EndOffset-4;
end;



function ALLOCSOUNDMEMSMOOTH(MemID,ActiveChannels :byte; Say,PlayMem :boolean):boolean;

var i,l         :byte;

begin
   ALLOCSOUNDMEMSMOOTH:=true;
   if not ALLOCSOUNDMEM(MemID,ActiveChannels,Say,PlayMem) then begin
      if Prefs.UseVMem and Prefs.UNDOVMem then for i:=5 downto 0 do begin
         HANDLEUNDO(MODE_MOVETODISK,i);
         if ALLOCSOUNDMEM(MemID,ActiveChannels,Say,PlayMem) then exit;
      end;
   end else exit;
   ALLOCSOUNDMEMSMOOTH:=false;
   MemL24[ActBuffer]:=0;
   l:=TASKREQUEST(PText[183],NIL,NIL,PText[220],NIL);
end;



function ALLOCALPHASMOOTH(MemID :byte):boolean;

var i   :byte;

begin
   ALLOCALPHASMOOTH:=true;
   if not ALLOCALPHA(MemID) then begin
      if Prefs.UseVMem and Prefs.UNDOVMem then for i:=5 downto 0 do begin
         HANDLEUNDO(MODE_MOVETODISK,i);
         if ALLOCALPHA(MemID) then exit;
      end;
   end else exit;
   ALLOCALPHASMOOTH:=false;
end;



begin   {*** SAMPLEEDIT ***}
   WORKINFO(PText[158],1);
   if (Mode in [4,5]) and ((MemA24[ActBuffer,1] or MemA24[ActBuffer,3])=0) then begin
      l:=TASKREQUEST(PText[259],PText[197],NIL,PText[220],NIL);
      exit;
   end;
   if (Mode in [4,5]) and (AreaE[ActBuffer]<>0) and (Prefs.Confirm) then begin
      l:=TASKREQUEST(PText[278],NIL,PText[220],NIL,PText[279]);
      if l=1 then DoMarkedArea:=true else DoMarkedArea:=false;
   end else DoMarkedArea:=true;
   DoAlpha:=true;
   if (Mode in [4,5]) and ((MemAAlpha[0,1] or MemAAlpha[0,3])=0) and
   ((MemAAlpha[ActBuffer,1] or MemAAlpha[ActBuffer,3])<>0) then
    if not ALLOCALPHA(0) then DoAlpha:=false;
   if (Mode in [4,5]) and ((MemAAlpha[0,1] or MemAAlpha[0,3])<>0) and
   ((MemAAlpha[ActBuffer,1] or MemAAlpha[ActBuffer,3])=0) then
    if not ALLOCALPHA(ActBuffer) then DoAlpha:=false;
   if not DoAlpha then begin
      l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
      exit;
   end;
   if (MemAAlpha[0,1] or MemAAlpha[0,3])<>0 then DoAlpha:=true else DoAlpha:=false;
   if Mode in [2..3] then begin  {*** SCHNEIDEN/KOPIEREN ***}
      if AreaE[0]-AreaA[0]<4 then begin
         l:=TASKREQUEST(PText[257],PText[197],NIL,PText[220],NIL);
         exit;
      end;
      FREESOUNDMEM(ActBuffer,false);
      FREEALPHA(ActBuffer);
      MemL24[ActBuffer]:=AreaE[0]-AreaA[0];
      PlayL24[ActBuffer]:=MemL24[ActBuffer];
      if not ALLOCSOUNDMEMSMOOTH(ActBuffer,ActiveChannels[0],false,false) then exit;
      for ChID:=1 to 6 do if not (Knopf[ChID+18].Flags and SELECTED=0) then
       CopyMemQuick(MemA24[0,ChID]+AreaA[0],MemA24[ActBuffer,ChID],MemL24[ActBuffer]);
      if DoAlpha then begin
         if not ALLOCALPHASMOOTH(ActBuffer) then exit;
         for ChID:=1 to 6 do if not (Knopf[ChID+18].Flags and SELECTED=0) then
          CopyMem(MemAAlpha[0,ChID]+AreaA[0] div 80,MemAAlpha[ActBuffer,ChID],round(MemL24[ActBuffer]/80+0.5));
      end;
      PlayRate[ActBuffer]:=Prefs.SRate;
      ActiveChannels[ActBuffer]:=ActiveChannels[0];
      ActiveMode[ActBuffer]:=ActiveMode[0];
      ALLOCUNDO(ActBuffer);
      if Mode=2 then begin
         for ChID:=1 to 6 do if not (Knopf[ChID+18].Flags and SELECTED=0) and (MemA24[0,ChID]<>0) then begin
            CopyMemQuick(MemA24[0,ChID]+AreaE[0],MemA24[0,ChID]+AreaA[0],MemL24[0]-AreaE[0]);
            Addr1:=MemA24[0,ChID]+MemL24[0]-AreaE[0]+AreaA[0];
            repeat
               Data1:=ptr(Addr1); Addr1:=Addr1+4;
               Data1^:=0;
            until Addr1>=MemA24[0,ChID]+MemL24[0];
            if DoAlpha then begin
               CopyMem(MemAAlpha[0,ChID]+AreaE[0] div 80,MemAAlpha[0,ChID]+AreaA[0] div 80,round((MemL24[0]-AreaE[0])/80+0.5));
               Addr1:=MemAAlpha[0,ChID]+(MemL24[0]-AreaE[0]+AreaA[0]) div 80;
               repeat
                  DataA1:=ptr(Addr1); Addr1:=Addr1+1;
                  DataA1^:=255;
               until Addr1>=MemAAlpha[0,ChID]+round(MemL24[0]/80+0.5);
            end;
         end;
         AreaA[0]:=0;   AreaE[0]:=0;
      end;
   end else if Mode=4 then begin {*** EINFGEN ***}
      if (Prefs.SRate<>PlayRate[ActBuffer]) and (Prefs.Confirm) then begin
         l:=TASKREQUEST(PText[258],NIL,PText[219],NIL,PText[218]);
         if l=3 then exit;
      end;
      if DoMarkedArea then GETBUFFEROFFSET(ActBuffer,StartOffset,EndOffset)
      else begin
         StartOffset:=0;
         EndOffset:=PlayL24[ActBuffer];
      end;
      CopyMemL:=PlayL24[0]-AreaA[0];
      if MemL24[0]-PlayL24[0]<EndOffset-StartOffset then CopyMemL:=CopyMemL-(EndOffset-StartOffset)+MemL24[0]-PlayL24[0];
      for ChID:=1 to 6 do if (MemA24[0,ChID]<>0) and (MemA24[ActBuffer,ChID]<>0)
      and not (Knopf[ChID+18].Flags and SELECTED=0) then begin
         Addr1:=MemA24[0,ChID]+AreaA[0]+CopyMemL;
         Addr2:=MemA24[0,ChID]+AreaA[0]+CopyMemL+(EndOffset-StartOffset);
         if Addr2>=MemA24[0,ChID]+MemL24[0] then begin
            l:=Addr2-(MemA24[0,ChID]+MemL24[0]);
            Addr1:=Addr1-l;
            Addr2:=Addr2-l;
         end;
         repeat
            Addr1:=Addr1-4; Data1:=ptr(Addr1);
            Addr2:=Addr2-4; Data2:=ptr(Addr2);
            Data2^:=Data1^;
         until Addr1<MemA24[0,ChID]+AreaA[0];
         if (AreaA[0]<SRelease[0]) and (SRelease[0]>0) then SRelease[0]:=SRelease[0]+(EndOffset-StartOffset);
         if (AreaA[0]<SSustain[0]) and (SSustain[0]>0) then SSustain[0]:=SSustain[0]+(EndOffset-StartOffset);
         CopyMemQuick(MemA24[ActBuffer,ChID]+StartOffset,MemA24[0,ChID]+AreaA[0],EndOffset-StartOffset);
         if DoAlpha then begin
            Addr1:=MemAAlpha[0,ChID]+round((AreaA[0]+CopyMemL)/80+0.5);
            Addr2:=MemAAlpha[0,ChID]+round((AreaA[0]+EndOffset-StartOffset+CopyMemL)/80+0.5);
            if Addr2>=MemAAlpha[0,ChID]+round(MemL24[0]/80+0.5) then begin
               l:=Addr2-(MemAAlpha[0,ChID]+round(MemL24[0]/80+0.5));
               Addr1:=Addr1-l;
               Addr2:=Addr2-l;
            end;
            repeat
               Addr1:=Addr1-1; DataA1:=ptr(Addr1);
               Addr2:=Addr2-1; DataA2:=ptr(Addr2);
               DataA2^:=DataA1^;
            until Addr1<MemAAlpha[0,ChID]+AreaA[0] div 80;
            CopyMem(MemAAlpha[ActBuffer,ChID]+round(StartOffset/80),MemAAlpha[0,ChID]+AreaA[0] div 80,round((EndOffset-StartOffset)/80+0.5))
         end;
      end;
      PlayL24[0]:=MemL24[0];
   end;                      {*** MISCHEN ***}
   if Mode=5 then begin
      if (Prefs.SRate<>PlayRate[ActBuffer]) and (Prefs.Confirm) then begin
         l:=TASKREQUEST(PText[258],NIL,PText[219],NIL,PText[218]);
         if l=3 then exit;
      end;
      l:=LONGREQUEST(PText[159],NIL,PText[220],NIL,100,1,500,Value);
      ACtr:=20;
      if DoMarkedArea then GETBUFFEROFFSET(ActBuffer,StartOffset,EndOffset)
      else begin
         StartOffset:=0;
         EndOffset:=PlayL24[ActBuffer];
      end;
      for ChID:=1 to 6 do if (MemA24[0,ChID]<>0) and (MemA24[ActBuffer,ChID]<>0)
      and not (Knopf[ChID+18].Flags and SELECTED=0) then begin
         Divider:=Value/100;
         AddrA:=MemAAlpha[ActBuffer,ChID];
         Addr1:=MemA24[0,ChID]+AreaA[0];
         Addr2:=MemA24[ActBuffer,ChID]+StartOffset;
         ACtr:=10;
         repeat
            Data1:=ptr(Addr1); Addr1:=Addr1+4;
            Data2:=ptr(Addr2); Addr2:=Addr2+4;
            if AddrA=0 then Data1^:=round(Data1^+(Data2^*Divider)) else begin
               if ACtr>=20 then begin
                  ACtr:=0;
                  DataA1:=ptr(AddrA); AddrA:=AddrA+1;
               end;
               ACtr:=ACtr+1;
               Data1^:=round(Data1^+((Data2^*Divider)/255*DataA1^))
            end;
         until (Addr1>=MemA24[0,ChID]+MemL24[0]) or (Addr2>=MemA24[ActBuffer,ChID]+EndOffset);
      end;
      PROCESSWAVE(1,true);
      PlayL24[0]:=MemL24[0];
   end;                      {*** LSCHEN ***}
   if Mode=6 then for ChID:=1 to 6 do if (MemA24[0,ChID]<>0)
   and not (Knopf[ChID+18].Flags and SELECTED=0) then begin
      Addr1:=MemA24[0,ChID]+AreaA[0];
      repeat
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         Data1^:=0;
      until Addr1>=MemA24[0,ChID]+AreaE[0];
   end;
   if Mode=7 then begin      {*** SPEICHER EINFGEN ***}
      ChCnt:=0;
      for ChID:=1 to 6 do if MemA24[0,ChID]<>0 then ChCnt:=ChCnt+1;
      l:=LONGREQUEST(PText[157],NIL,PText[220],NIL,(MemL24[0] div 40),1,MAXSIZE,Value);
      Value:=Value div 4 * 16;
      if Value<=40 then exit;
      FREEUNDO(0);
      FirstUNDO:=0;
      if AvailMem(0)<Value*ChCnt then begin
         l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
         ALLOCUNDO(0);
         exit;
      end;
      MemLNew:=Value+MemL24[0];

      if DoAlpha then begin
         for i:=1 to 6 do begin
            MemAAlphaNew[i]:=MemAAlpha[0,i];
            MemAAlpha[0,i]:=0;
         end;
         exchange(MemLNew,MemL24[0]);
         if not ALLOCALPHA(0) then begin
            l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
            for i:=1 to 6 do MemAAlpha[0,i]:=MemAAlphaNew[i];
            ALLOCUNDO(0);
            exit;
         end;
         exchange(MemLNew,MemL24[0]);
         for i:=1 to 6 do if MemAAlpha[0,i]<>0 then begin
            Addr1:=MemAAlpha[0,i]+round(MemLNew/80+0.5);
            repeat
               Addr1:=Addr1-1; DataA1:=ptr(Addr1);
               DataA1^:=1;
            until Addr1<=MemAAlpha[0,i];
         end;
         for ChID:=1 to 6 do if not (Knopf[ChID+18].Flags and SELECTED=0) then begin
            CopyMem(MemAAlphaNew[ChID],MemAAlpha[0,ChID],round(AreaA[0]/80+0.5));
            CopyMem(MemAAlphaNew[ChID]+AreaA[0] div 80,MemAAlpha[0,ChID]+(AreaA[0]+Value) div 80,round((PlayL24[0]-AreaA[0])/80+0.5));
         end else CopyMem(MemAAlphaNew[ChID],MemAAlpha[0,ChID],round(PlayL24[0]/80+0.5));
      end;

      for ChID:=1 to 6 do if MemA24[0,ChID]<>0 then begin
         MemANew:=XAllocMem(MemLNew+32,MEMF_CLEAR)+16;
         if MemANew=16 then begin
            UNDOINSERTMEM(1,ChID);
            exit;
         end;
         if not (Knopf[ChID+18].Flags and SELECTED=0) then begin
            CopyMemQuick(MemA24[0,ChID],MemANew,AreaA[0]);
            CopyMemQuick(MemA24[0,ChID]+AreaA[0],MemANew+AreaA[0]+Value,PlayL24[0]-AreaA[0]);
         end else CopyMemQuick(MemA24[0,ChID],MemANew,PlayL24[0]);
         exchange(MemA24[0,ChID],MemANew);
         XFreeMem(MemANew-16,MemL24[0]+32);
      end;

      for ChID:=1 to 2 do if MemA16[0,ChID]<>0 then begin
         MemANew:=XAllocMem(MemLNew div 2,MEMF_CLEAR);
         if MemANew=0 then begin
            UNDOINSERTMEM(2,ChID);
            exit;
         end;
         if ChID=1 then begin
            MemA8New[1]:=MemANew; MemA8New[2]:=MemANew+(MemLNew div 4);
            CopyMemQuick(MemA8[0,1],MemA8New[1],PlayL24[0] div 4);
            CopyMemQuick(MemA8[0,2],MemA8New[2],PlayL24[0] div 4);
         end else begin
            MemA8New[3]:=MemANew; MemA8New[4]:=MemANew+(MemLNew div 4);
            CopyMemQuick(MemA8[0,3],MemA8New[3],PlayL24[0] div 4);
            CopyMemQuick(MemA8[0,4],MemA8New[4],PlayL24[0] div 4);
         end;
         exchange(MemA16[0,ChID],MemANew);
         XFreeMem(MemANew,MemL24[0] div 2);
      end;
      if DoAlpha then begin
         for i:=1 to 6 do exchange(MemAAlpha[0,i],MemAAlphaNew[i]);
         FREEALPHA(0);
         for i:=1 to 6 do exchange(MemAAlpha[0,i],MemAAlphaNew[i]);
      end;
      for i:=1 to 4 do MemA8[0,i]:=MemA8New[i];
      MemL24[0]:=MemLNew;
      PlayL24[0]:=MemL24[0];
      if (AreaA[0]<SRelease[0]) and (SRelease[0]>0) then SRelease[0]:=SRelease[0]+Value;
      if (AreaA[0]<SSustain[0]) and (SSustain[0]>0) then SSustain[0]:=SSustain[0]+Value;
      SETSAMPLEGADS;
      ALLOCUNDO(0)
   end;
   if (Mode in [2,4,6,7]) and Prefs.ImmediatRender then begin
      WORKINFO(PText[179],7);
      CALCCHANNELS(AreaA[0] div 8 * 8,PlayL24[0],UsedChans);
   end else PlayDataValid:=false;
   WORKINFO('',8);
end;



procedure SWAPBUFFER;

var i,ChBit,MemAlloc    :byte;

begin
   MemAlloc:=$A;
   PlayDataValid:=false;
   if (MemA16[ActBuffer,1] and MemA16[ActBuffer,2])<>0 then MemAlloc:=$8 else begin
      for i:=1 to 2 do begin
         MemA16[ActBuffer,i]:=XAllocMem(MemL24[ActBuffer] div 2,MEMF_CLEAR);
         if MemA16[ActBuffer,i]=0 then begin
            l:=TASKREQUEST(PText[183],PText[197],NIL,PText[220],NIL);
            if i=1 then exit else begin
               XFreeMem(MemA16[ActBuffer,1],MemL24[ActBuffer] div 2);
               exit;
            end;
         end;
      end;
      MemA8[ActBuffer,1]:=MemA16[ActBuffer,1];
      MemA8[ActBuffer,2]:=MemA16[ActBuffer,1]+MemL24[ActBuffer] div 4;
      MemA8[ActBuffer,3]:=MemA16[ActBuffer,2];
      MemA8[ActBuffer,4]:=MemA16[ActBuffer,2]+MemL24[ActBuffer] div 4;
   end;
   for i:=1 to 6 do begin
      exchange(MemA24[0,i],MemA24[ActBuffer,i]);
      HANDLEUNDO(MODE_NAMEEXCHANGE,ActBuffer);
      exchange(MemAUNDO[0,i],MemAUNDO[ActBuffer,i]);
      exchange(AlphaUNDO[0,i],AlphaUNDO[ActBuffer,i]);
      exchange(MemA16[0,i],MemA16[ActBuffer,i]);
      exchange(MemAAlpha[0,i],MemAAlpha[ActBuffer,i]);
      exchange(MemA8[0,i],MemA8[ActBuffer,i]);
   end;
   exchange(MySDHeader[0],MySDHeader[ActBuffer]);
   exchange(ActiveMode[0],ActiveMode[ActBuffer]);
   exchange(ActiveChannels[0],ActiveChannels[ActBuffer]);
   exchange(Prefs.SRate,PlayRate[ActBuffer]);
   exchange(MemL24[0],MemL24[ActBuffer]);     exchange(PlayL24[0],PlayL24[ActBuffer]);
   exchange(DrawOffset[0],DrawOffset[ActBuffer]);
   exchange(Zoom[0],Zoom[ActBuffer]);
   exchange(AreaA[0],AreaA[ActBuffer]);       exchange(AreaE[0],AreaE[ActBuffer]);
   exchange(SInfo[0],SInfo[ActBuffer]);
   exchange(SAttack[0],SAttack[ActBuffer]);   exchange(SDecay[0],SDecay[ActBuffer]);
   exchange(SSustain[0],SSustain[ActBuffer]); exchange(SRelease[0],SRelease[ActBuffer]);
   WTVersion:=WTVer+SInfo[0];
   if Zoom[0]=0 then Zoom[0]:=succ(MemL24[0] div (MyScreen^.Width*4)) * 4;
   PlayL24[0]:=MemL24[0];
   SETSAMPLEGADS;
   ChBit:=1;
   for i:=19 to 24 do begin
      if not (ActiveChannels[0] and ChBit=0) then Knopf[i].Flags:=(Knopf[i].Flags or SELECTED) and not GADGDISABLED
       else Knopf[i].Flags:=(Knopf[i].Flags or GADGDISABLED) and not SELECTED;
      ChBit:=ChBit*2;
   end;
   WORKINFO('',1);
   PROCESSWAVE(MemAlloc,true);
end;



procedure INSERTDEMO;

var ChID        :byte;
var l,MemE      :long;


procedure FIBONACCI(Addr1,Addr2,MemLS :long);

type FibArray=array [0..15] of short;

var Data1       :^byte;
var Data2       :^byte;
var DataBefore  :byte;
var FibArr      :FibArray;

begin
   with MyWTStdMsg do begin
      FibArr:=FibArray(-34,-21,-13,-8,-5,-3,-2,-1,0,1,2,3,5,8,13,21);
      MemE:=Addr1+6002;
      DataBefore:=0;
      Data2:=ptr(Addr2); Addr2:=Addr2+1;
      Data2:=ptr(Addr2); Addr2:=Addr2+1;
      DataBefore:=Data2^;
      repeat
         Data2:=ptr(Addr2); Addr2:=Addr2+1;
         Data1:=ptr(Addr1); Addr1:=Addr1+1;
         DataBefore:=DataBefore+FibArr[(Data2^ and $F0) div 16];
         Data1^:=DataBefore;
         Data1:=ptr(Addr1); Addr1:=Addr1+1;
         DataBefore:=DataBefore+FibArr[Data2^ and $0F];
         Data1^:=DataBefore;
      until (Addr2>=MemE) or (Addr1>=Addr2);
   end;
end;


begin
   l:=TASKREQUEST('---==  D E M O V E R S I O N  ==---','Please read the manual! Bitte Bedienungsanleitung beachten!',NIL,PText[220],NIL);
   FHandle:=DosOpen('WT.data',MODE_OLDFILE);
   for ChID:=1 to 6 do if (MemA24[0,ChID]<>0) and (FHandle<>0) then begin
      l:=DosSeek(FHandle,IMAGE1+IMAGE2+IMAGE3,OFFSET_BEGINNING);
      l:=DosRead(FHandle,ptr(MemA24[0,ChID]+SAMPLE*7),SAMPLE);
      FIBONACCI(MemA24[0,ChID]+SAMPLE*6,MemA24[0,ChID]+SAMPLE*7,SAMPLE);
      Addr1:=MemA24[0,ChID];
      Addr8:=MemA24[0,ChID]+SAMPLE*6;
      MemE:=Addr8+SAMPLE*2;
      repeat
         Data1:=ptr(Addr1); Addr1:=Addr1+4;
         Data8:=ptr(Addr8); Addr8:=Addr8+1;
         Data1^:=Data8^*65535;
      until Addr8>=MemE
   end;
   DosClose(FHandle);
end;



procedure MEMINFO;

var s           :string;
var i,j,ChCnt   :byte;
var l           :long;

begin
   s:=WTVer+',  '+PText[137];
   if not OPENDWIN(245,0,DWindow,s,1,0) then exit;
   WRITE(320,45,2,3,DWindow^,PText[282]);
   s:=PText[283]+': '+intstr(AvailMem(MEMF_CHIP))+' Bytes,  '
     +PText[284]+': '+intstr(AvailMem(MEMF_FAST))+' Bytes';
   WRITE(320,60,2,3,DWindow^,s);

   WRITE(215,90,2,3,DWindow^,PText[286]);
   WRITE(370,90,2,3,DWindow^,PText[287]);
   WRITE(490,90,2,3,DWindow^,PText[288]);

   for i:=0 to 5 do begin
      if i=0 then WRITE(40,115,2,0,DWindow^,'Sample') else begin
         s:='Buffer '+intstr(i);
         WRITE(40,115+i*20,2,0,Dwindow^,s);
      end;
      ChCnt:=0; for j:=1 to 6 do if MemA24[i,j]<>0 then ChCnt:=ChCnt+1;
      s:=intstr(MemL24[i]*ChCnt)+' Bytes';
      if (MemAUNDO[i,1]<>0) or (MemAUNDO[i,3]<>0) then s:=s+', UNDO'
      else if (Prefs.UseVMem and Prefs.UNDOVMem)
      and ((MemA24[i,1]<>0) or (MemA24[i,3]<>0)) then s:=s+', VMem-UNDO';
                                           WRITE(215,115+i*20,2,3,DWindow^,s);
      if MemA16[0,1]>0 then s:=intstr(MemL24[i])+' Bytes' else s:='0';
                                           WRITE(370,115+i*20,2,3,DWindow^,s);
      if (MemAAlpha[i,1] or MemAAlpha[i,3])<>0 then l:=round(MemL24[i]/80+0.5) else l:=0;
      s:=intstr(l)+' Bytes';               WRITE(490,115+i*20,2,3,DWindow^,s);
   end;
   MAKEBORDER(DWindow^,120,105,550,235,NEGATIVE);

   repeat
      RawCode:=0; GadCode:=0;
      IMsg:=Wait_Port(DWindow^.UserPort);
      If IMsg<>Nil Then begin
         IMsg:=Get_Msg(DWindow^.UserPort);
         if IMsg^.Class in [GADGETDOWN,GADGETUP] then begin
            XGadget:=IMsg^.IAddress;
            GadCode:=XGadget^.GadgetID;
         end;
         if IMsg^.class=RAWKEY then RawCode:=IMsg^.Code;
         Reply_Msg(IMsg)
      end;

   Until (GadCode in [1,2]) or (RawCode in [68,69]);
   if LEAVEDEF(RawCode,1,1,2,DWindow) then begin end;
end;



procedure WAVETRACER;   {****** MAIN ******}
begin
   INITVARS;
   READKEYFILE;
   if PORTACTIVE(PORT_WT) then begin
      ERRORMSG('WaveTracer bereits aktiv!!','WaveTracer always active!!');
      exit;
   end;
   RexxPort:=CreatePort(PORT_REXX,0);
   if RexxPort=NIL then begin
      GAMEEXIT; exit;
   end;
   WTPort:=CreatePort(PORT_WT,0);
   if WTPort=NIL then begin
      GAMEEXIT; exit;
   end;
   with MyBitMap do begin
      MemL:=576; {64 x 24 x 3}
      MemA:=XAllocMem(MemL,MEMF_CHIP);
      if MemA=0 then begin
         GAMEEXIT; exit;
      end;
      MyBitMap:=WTBitMap(8,24,1,3,0,ptr(MemA),ptr(MemA+192),ptr(MemA+384),
                         NIL,NIL,NIL,NIL,NIL,MemA,MemL);
   end;
   MemLMod:=5000;
   MemAMod:=XAllocMem(MemLMod,MEMF_CLEAR);
   if MemAMod=0 then ModMemInhalt:=-1 else ModMemInhalt:=0;
   if not INITIMG then begin
      GAMEEXIT; exit;
   end;
   l:=XAllocMem(sizeof(r_PlayListPattern),MEMF_CLEAR);
   if l=0 then begin
      GAMEEXIT; exit;
   end else FirstPattern:=ptr(l);
   l:=XAllocMem(sizeof(r_PlayListEntry),MEMF_CLEAR);
   if l=0 then begin
      GAMEEXIT; exit;
   end else FirstEntry:=ptr(l);
   if not INITLANG then begin
      GAMEEXIT; exit;
   end;
   PlayMemL:=2000;
   for i:=1 to 4 do begin
      PlayMemA[i]:=XAllocMem(PlayMemL,MEMF_CHIP+MEMF_CLEAR);
      if PlayMemA[i]=0 then begin
         GAMEEXIT;
         exit;
      end;
   end;
   INITCHANNELS;
   if not OPENWTSCREEN then exit;
   PLAYKEYS(80,MyWindow,0);
   SetAPen(MyWindow^.RPort,0); RectFill(MyWindow^.RPort,MyScreen^.Width div 2-100,40,MyScreen^.Width div 2+100,58);
   WRITE(MyScreen^.Width div 2,30,2,3,MyWindow^,WTVer);
   WRITE(MyScreen^.Width div 2,54,2,3,MyWindow^,' 1993-1999 by OXYGENIC & Virtual Worlds Productions');
   WRITE(MyScreen^.Width div 2,68,2,3,MyWindow^,'Program is SHAREWARE, all rights reserved!');
   WRITE(MyScreen^.Width div 2,82,2,3,MyWindow^,'The very first Amiga-Soundtool supporting 4.0 Dolby-Surround-,');
   WRITE(MyScreen^.Width div 2,96,2,3,MyWindow^,'5.1 Dolby-AC-3-, 5.1 DTS-compatible sounds, SpectraFX and Audio-Alphachannels!');
   WRITE(MyScreen^.Width div 2,110,4,3,MyWindow^,'Konto-Nr.: 11 85 748   BLZ: 700 905 00 Sparda-Bank Mnchen eG');
   WRITETBWINDOW;
   if SharePayed then USERINFO;
   repeat
      if SampleEd then begin
         if AreaE[ActBuffer]<>0 then SetAPen(MyWindow^.RPort,24) else SetAPen(MyWindow^.Rport,0);
         RectFill(IntuiWindow1^.RPort,165,IntuiWindow1^.BorderTop+41,402,IntuiWindow1^.BorderTop+53);
         if Prefs.SUnit=1 then s:=intstr(MemL24[ActBuffer] div 4) else s:=realstr(MemL24[ActBuffer]/4/SFreq,4);
         s:=SInfo[ActBuffer]+': '+s;
         WRITE(284,IntuiWindow1^.BorderTop+41,2,235,IntuiWindow1^,s);
      end;
      if (MemAUNDO[0,1]<>0) or (MemAUNDO[0,3]<>0)
       or (Prefs.UseVMem and Prefs.UNDOVMem) then Mi3[5].Flags:=Mi3[5].Flags or ITEMENABLED
       else Mi3[5].Flags:=Mi3[5].Flags and not ITEMENABLED;
      RawCode:=0; GadCode:=0;   UsedWindow:=99;
      Men:=100;   MenItem:=100; SItem:=100;
      IMsg:=NIL;  IMsg1:=NIL;   IMsg2:=NIL; IMsg3:=NIL; IMsg4:=NIL;
      IMsg:=Get_Msg(MyWindow^.UserPort);
      IMsg1:=Get_Msg(IntuiWindow1^.UserPort);
      if IntuiWindow2<>NIL then IMsg2:=Get_Msg(IntuiWindow2^.UserPort);
      if IntuiWindow3<>NIL then IMsg3:=Get_Msg(IntuiWindow3^.UserPort);
      if IntuiWindow4<>NIL then IMsg4:=Get_Msg(IntuiWindow4^.UserPort);
      RxMsg:=p_RexxMsg(Get_Msg(RexxPort));
      if (IMsg=NIL) and (IMsg1=NIL) and
      (IMsg2=NIL) and (IMsg3=NIL) and
      (IMsg4=NIL) and (RxMsg=NIL) then begin
         l:=wait(-1);
         IMsg:=Get_Msg(MyWindow^.UserPort);
         IMsg1:=Get_Msg(IntuiWindow1^.UserPort);
         if IntuiWindow2<>NIL then IMsg2:=Get_Msg(IntuiWindow2^.UserPort);
         if IntuiWindow3<>NIL then IMsg3:=Get_Msg(IntuiWindow3^.UserPort);
         if IntuiWindow4<>NIL then IMsg4:=Get_Msg(IntuiWindow4^.UserPort);
         RxMsg:=p_RexxMsg(Get_Msg(RexxPort));
         if IMsg4=NIL then WRITETBWINDOW;
      end;
      if IMsg=NIL then begin
         UsedWindow:=1;
         if IMsg1<>NIL then IMsg:=IMsg1
         else if IMsg2<>NIL then begin
            IMsg:=IMsg2;
            UsedWindow:=2;
         end else if IMsg3<>NIL then begin
            IMsg:=IMsg3;
            UsedWindow:=3;
         end else if IMsg4<>NIL then begin
            IMsg:=IMsg4;
            UsedWindow:=4;
         end;
      end else UsedWindow:=0;

      HANDLEMAININTUITION;

      if RxMsg<>NIL then with RxMsg^ do begin
         rm_Result1:=0;
         rm_Result2:=NIL;
         REXXSHREDDER;
         if rm_Args[0]='KEYACTION' then begin
            val(rm_Args[1],l,i);
            RawCode:=l and $FF;
         end else if rm_Args[0]='SETPLAYRATE' then begin
            val(rm_Args[1],l,i);
            Prefs.SRate:=(l or $f) and $FFFF;
         end else if rm_Args[0]='SETPLAYFREQ' then begin
            val(rm_Args[1],l,i);
            SFreq:=(l or $F) and $FFFF;
            Prefs.SRate:=round(10000000/(SFreq*2.79365));
         end else if rm_Args[0]='MARKAREA' then begin
            val(rm_Args[1],l,i); AreaA[0]:=l*4;
            val(rm_Args[2],l,i); AreaE[0]:=l*4;
            PROCESSWAVE($8,true);
         end else if rm_Args[0]='GETSAMPLESIZE' then begin
            RxStr:=intstr(PlayL24[0] div 4);
            RxMsg^.rm_Result2:=CreateArgString(RxStr,length(RxStr));
         end else if rm_Args[0]='GETSOUNDMODE' then begin
            RxStr:=intstr(ActiveMode[0]);
            RxMsg^.rm_Result2:=CreateArgString(RxStr,length(RxStr))
         end else if rm_Args[0]='GETCHANNELS' then begin
            RxStr:=intstr(ActiveChannels[0]);
            RxMsg^.rm_Result2:=CreateArgString(RxStr,length(RxStr))
         end else if rm_Args[0]='GETCHANNELADDRESS' then begin
            val(rm_Args[1],l,i);
            if not (l in [1..6]) then RxStr:='0' else RxStr:=intstr(MemA24[0,l]);
            RxMsg^.rm_Result2:=CreateArgString(RxStr,length(RxStr))
         end else if rm_Args[0]='IMPORT' then begin
            IMPORTSAMPLE;
            WORKINFO('',1);
            PROCESSWAVE($1B,true);
         end else if (rm_Args[0]='CALLINTERNALEFFECT')
         and ((OPos in [1..MAXOPS]) or (rm_Args[1]='1')) then begin
            if rm_Args[1]='1' then begin
               OPos:=0; OEnd:=0;
            end;
            OPos:=OPos+1; OEnd:=OEnd+1;
            _WaveOp[OPos]:=WaveOp(WOP_NORM,ActiveMode[0],1,1,ActiveChannels[0],1,
                                  _WaveOp[1].Operator,AreaA[0],AreaE[0],'',0,0);
            with _WaveOp[OPos] do begin
               val(rm_Args[1],Operation,i);
               if not Operation in [1..18] then Operation:=1;
               val(rm_Args[2],OpType,i);
               val(rm_Args[3],Channels,i);
               for i:=1 to 6 do val(rm_Args[i+3],Operator[i],j);
               val(rm_Args[10],l,i); SoundMode:=l and $FF;
               if Operation=1 then begin
                  ActiveChannels[0]:=Channels;
                  ActiveMode[0]:=SoundMode;
                  if DOWAVE then PROCESSWAVE($1B,true);
               end else if Operation=8 then begin
                   DOECHO;   PROCESSWAVE($FF,true);
               end else if Operation=17 then begin
                   if DOCHANNELC then PROCESSWAVE($FF,true);
               end else if Operation=18 then begin
                   if DOSCALE then PROCESSWAVE($FF,true);
               end else begin
                  CALLFUNCTION(Operation,Channels);
                  PROCESSWAVE($FF,true);
               end;
            end;
         end else RxMsg^.rm_Result1:=-1;
         Reply_Msg(^RxMsg^.rm_Node);
      end;

      if Men=1 then begin
         if MenItem=1 then begin
            if (MemA24[0,1] or MemA24[0,3])=0 then begin
               l:=TASKREQUEST(PText[209],PText[210],PText[220],PText[123],PText[245]);
               if l=2 then begin
                  Men:=1; MenItem:=2;
               end else if l=3 then begin
                  GadCode:=1;
                  UsedWindow:=1;
               end;
            end else if MAKESAMPLEEDSCREEN then begin
               SampleEd:=true;
               PlayL24[0]:=MemL24[0];
               PROCESSWAVE($8,true);
            end;
         end;

         if MenItem=3 then if (MemA24[0,1] or MemA24[0,3])<>0 then SAVESAMPLE else
            l:=TASKREQUEST(PText[211],PText[212],NIL,PText[220],NIL);
         if MenItem=4 then while EDITOR do begin end;
         if menitem=5 then SETPLAYRATE;
      end;

      if Men=2 then begin
         if MenItem=1 then begin
            if not MAKEMAINSCREEN then begin
               GAMEEXIT;
               exit;
            end;
            SampleEd:=false;
            DRAWTIMEPATTERNLIST(false);
         end;
         if MenItem in [2..7] then begin
            if (MenItem in [2,3,5]) and (AreaE[0]=0) then
             l:=TASKREQUEST(PText[257],PText[197],NIL,PText[220],NIL) else begin
               PlayLUNDO:=MemL24[0];
               HANDLEUNDO(MODE_COPYNEW,0);
               FirstUNDO:=2;
               SAMPLEEDIT(MenItem);
               PROCESSWAVE($8,true);
            end;
         end;
         if MenItem=8 then if MemL24[ActBuffer]<>0 then SWAPBUFFER
         else l:=TASKREQUEST(PText[211],PText[197],NIL,PText[220],NIL);
         if MenItem=9 then MEMINFO;
      end;

      if Men=3 then begin
         if Menitem=1 then repeat until not SETPREFS;
         if MenItem=2 then begin
            FHandle:=DosOpen(PREFFILE,MODE_OLDFILE);
            if FHandle=0 then FHandle:=DosOpen(PREFFILE,MODE_NEWFILE);
            if FHandle=0 then l:=TASKREQUEST(PREFFILE,PText[190],NIL,PText[220],NIL)
            else begin
               Men:=PREFVERSION;
               l:=DosWrite(FHandle,^Men,1);
               l:=DosWrite(FHandle,^Prefs,sizeof(r_Prefs));
               DosClose(FHandle);
               Men:=3;
            end;
         end;
         if MenItem=3 then begin
            s:=WTVer+', Version 5.0';
            l:=TASKREQUEST(s,' 1993-1999 by Virtual Worlds Productions & OXYGENIC',NIL,PText[220],NIL);
         end;
         if MenItem=4 then USERINFO;
         if (MenItem=5) and ((OPos>1) or (FirstUNDO>1)) and not (FirstUNDO=0) then begin
            if not Prefs.ImmediatRender then PlayDataValid:=false;
            HANDLEUNDO(MODE_EXCHANGE,0);
            exchange(UndoAreaA,AreaA[0]);      exchange(UndoAreaE,AreaE[0]);
            exchange(PlayLUndo,PlayL24[0]);
            exchange(UndoAttack,SAttack[0]);   exchange(UndoDecay,SDecay[0]);
            exchange(UndoSustain,SSustain[0]); exchange(UndoRelease,SRelease[0]);

            l:=MaxZoom div Zoom[0];
            MaxZoom:=succ(MemL24[0] div (MyScreen^.Width*4)) * 4;
            Zoom[0]:=MaxZoom*l;
            if Zoom[0]>MaxZoom then Zoom[0]:=MaxZoom;
            if DrawOffset[0]>(PlayL24[0]-MyScreen^.Width*Zoom[0]) then DrawOffset[0]:=(PlayL24[0]-MyScreen^.Width*Zoom[0]);
            if DrawOffset[0]<4 then DrawOffset[0]:=0;
            if FirstUNDO mod 2=1 then begin
               OPos:=OPos-1; OEnd:=OEnd-1;
            end else begin
               OPos:=OPos+1; OEnd:=OEnd+1;
            end;
            FirstUNDO:=FirstUNDO+1;
            PROCESSWAVE($A,true);
         end;
      end;

      if UsedWindow=1 then begin {*** FUNCTION Window ***}
         if (GadCode in [1..9]) and SampleEd then begin
            if GadCode in [1..3] then begin
               if GadCode<>SEdMode then begin
                  Knopf[SEdMode].Flags:=Knopf[SEdMode].Flags or SELECTED;
                  Knopf[GadCode].Flags:=Knopf[GadCode].Flags or SELECTED;
               end;
               RefreshGadgets(^Knopf[3],IntuiWindow1,NIL);
               if GadCode<>SEdMode then begin
                  Knopf[SEdMode].Flags:=Knopf[SEdMode].Flags and not SELECTED;
                  Knopf[GadCode].Flags:=Knopf[GadCode].Flags and not SELECTED;
               end;
               SEdMode:=GadCode;
            end else if GadCode in [4..8] then begin
               for i:=4 to 9 do Knopf[i].Flags:=Knopf[i].Flags and not SELECTED;
               Knopf[GadCode].Flags:=Knopf[GadCode].Flags or SELECTED;
               ActBuffer:=GadCode-3;
            end;
            RefreshGadgets(^Knopf[9],IntuiWindow1,NIL);
         end;

         if (GadCode=10) and SampleEd then begin
            if Prefs.Confirm then l:=TASKREQUEST(PText[262],NIL,PText[219],NIL,PText[218]) else l:=1;
            if l=1 then begin
               for i:=1 to 6 do if MemA24[ActBuffer,i]<>0 then begin
                  FREESOUNDMEM(ActBuffer,false);
                  FREEUNDO(ActBuffer);
                  FREEALPHA(ActBuffer);
               end;
               MemL24[ActBuffer]:=0;
            end;
         end;

         if (GadCode=11) and SampleEd then begin
            if MemL24[ActBuffer]<>0 then begin
               SItem:=4;
               for i:=1 to 6 do exchange(MemA24[0,i],MemA24[ActBuffer,i]);
               exchange(PlayL24[0],PlayL24[ActBuffer]);
               exchange(MemL24[0],MemL24[ActBuffer]);
               SAVESAMPLE;
               for i:=1 to 6 do exchange(MemA24[0,i],MemA24[ActBuffer,i]);
               exchange(PlayL24[0],PlayL24[ActBuffer]);
               exchange(MemL24[0],MemL24[ActBuffer]);
            end else l:=TASKREQUEST(PText[211],PText[197],NIL,PText[220],NIL);
         end;

         if (GadCode=12) and SampleEd then MEMINFO;

         if (GadCode=13) and SampleEd then REALTIMEMIXER(0);

         if (GadCode=14) and SampleEd then PLAYLISTED;

         if (GadCode in [1..FUNCTS,99]) and not SampleEd then begin
            if (OPos=pred(MAXOPS)) and (GadCode<>1) then l:=TASKREQUEST(PText[204],PText[205],NIL,PText[220],NIL) else begin
               OPos:=OPos+1; OEnd:=OEnd+1; l:=0;
               if ((MemA24[0,1] or MemA24[0,3])=0) and (GadCode<>1) then begin
                  l:=TASKREQUEST(PText[209],PText[210],PText[220],PText[123],PText[245]);
                  if l=2 then begin
                     Men:=1; MenItem:=2;
                  end else if l=3 then GadCode:=1 else if l=1 then begin
                     OPos:=OPos-1;
                     OEnd:=OEnd-1;
                  end;
               end;
               if ((MemA24[0,1] or MemA24[0,3])<>0) or (GadCode=1) then begin
                  if not (SharePayed) and (random(5)=0) and (MemL24[0]>25000)
                   then INSERTDEMO;
                  UndoAreaA:=AreaA[0];      UndoAreaE:=AreaE[0];
                  PlayLUndo:=PlayL24[0];    FirstUNDO:=1;
                  UndoAttack:=SAttack[0];   UndoDecay:=SDecay[0];
                  UndoSustain:=SSustain[0]; UndoRelease:=SRelease[0];
                  HANDLEUNDO(MODE_COPYNEW,0);
                  if GadCode in [1..FUNCTS] then _WaveOp[OPos]:=LastSetup[GadCode];
                  if _WaveOp[OPos].ChunkSize<WOP_SMALL then _WaveOp[Opos].ChunkSize:=WOP_SMALL;
                  _WaveOp[OPos].Operation:=GadCode;
                  if GadCode in [4,5,7] then begin
                     if _WaveOp[OPos-1].Operation<>GadCode then _WaveOp[OPos].Operator[1]:=1;
                     if _WaveOp[OPos-1].Operation=GadCode then begin
                        OPos:=OPos-1; OEnd:=OEnd-1;
                        with _WaveOp[OPos] do Operator[1]:=Operator[1]+1;
                     end;
                  end;
                  FCode:=GadCode;
                  b:=false;
                  case FCode of
                     1:  begin
                            if WTAChanged and Prefs.Confirm then begin
                               l:=TASKREQUEST(PText[206],NIL,PText[219],NIL,PText[218]);
                               if l=3 then begin
                                  if OPos>1 then begin
                                     OPos:=OPos-1;
                                     OEnd:=OEnd-1;
                                  end;
                               end else if DEFINEWAVE(true) then if DOWAVE then PROCESSWAVE($1B,true);
                            end else if DEFINEWAVE(true) then if DOWAVE then PROCESSWAVE($1B,true);
                         end;
                     2:  b:=DEFINEFREQ
                     3:  b:=DEFINEHKURVE
                     4:  b:=DEFINEDIFFERENCER;
                     5:  b:=DEFINEINTEGRATER;
                     6:  b:=DEFINEANTIALIAS;
                     7:  b:=DEFINEMAKEDRUM;
                     8:  if DEFINEECHO then begin
                            DOECHO; PROCESSWAVE($1B,true);
                         end else begin
                            OPos:=Opos-1; OEnd:=OEnd-1;
                         end;
                     9:  b:=DEFINEVOLUME;
                     10: b:=DEFINEREVERSE;
                     11: b:=DEFINEOVERCROSS;
                     12: b:=DEFINEDIGITIZER
                     13: b:=DEFINECUTZERO;
                     14: b:=DEFINEHEAVY
                     15: b:=DEFINEMIXAROUND;
                     16: b:=DEFINETRIAC
                     17: if DEFINECHANNELC then begin
                            if DOCHANNELC then PROCESSWAVE($1B,true);
                         end else begin
                            OPos:=Opos-1; OEnd:=OEnd-1;
                         end;
                     18: if DEFINESCALE(false) then begin
                            if DOSCALE then PROCESSWAVE($1B,true);
                         end else begin
                            OPos:=Opos-1; OEnd:=OEnd-1;
                         end;
                     99: begin
                            for i:=1 to 6 do with _WaveOp[OPos] do Operator[i]:=-1;
                            _WaveOp[Opos].MemAData:=0;    _WaveOp[Opos].MemLData:=0;
                            _WaveOp[Opos].ChunkSize:=WOP_NORM;
                            if DEFINEEFFECTMOD(false) then begin
                               if not DOEFFECTMOD then begin
                                  OPos:=OPOs-1; OEnd:=OEnd-1;
                               end else PROCESSWAVE($1B,true);
                            end;
                            GadCode:=0;
                         end;
                     otherwise b:=true;
                  end;
                  if _WaveOp[OPos].Operation in [1..FUNCTS] then
                   LastSetup[_WaveOp[OPos].Operation]:=_WaveOp[OPos];
                  if FCode in [2..7,9..16] then begin
                     if b then begin
                        CALLFUNCTION(FCode,UsedChans);
                        PROCESSWAVE($1B,true);
                        ModMemInhalt:=0;
                     end else begin
                        OPos:=Opos-1; OEnd:=OEnd-1;
                     end;
                  end;
                  WTAChanged:=true;
               end;
            end;
         end;
      end else if UsedWindow=2 then if HANDLETIMEPATTERNWINDOW then begin end;
      if (Men=1) and (MenItem=2) then begin
         if WTAChanged and Prefs.Confirm then begin
            l:=TASKREQUEST(PText[206],PText[207],PText[216],NIL,PText[218]);
            if l=3 then begin end else b:=LOADWTA
         end else b:=LOADWTA;
      end;

      if (Men=1) and (MenItem=6) and WTAChanged and (Prefs.Confirm) then begin
         l:=TASKREQUEST(PText[206],PText[208],PText[219],NIL,PText[218]);
         if l=3 then MenITem:=100;
      end;

   until (Men=1) and (menitem=6) or not Scr;
   GETWINPOSITIONS;
   FHandle:=DosOpen(PREFFILE,MODE_NEWFILE);
   if FHandle<>0 then begin
      if LastSetup[1].ChunkSize>WOP_NORM then with LastSetup[1] do begin
         OpType:=1; ChunkSize:=WOP_SMALL;
      end;
      Men:=PREFVERSION;
      l:=DosWrite(FHandle,^Men,1);
      l:=DosWrite(FHandle,^Prefs,sizeof(r_Prefs));
      for i:=1 to FUNCTS-1 do begin
         LastSetup[i].MemAData:=0;
         LastSetup[i].MemLData:=0;
         l:=DosWrite(FHandle,^LastSetup[i],LastSetup[i].ChunkSize);
      end;
      DosClose(FHandle);
   end;
   process_ptr^.pr_WindowPtr:=OldWindow_Ptr;
   GAMEEXIT;
   LData:=ptr($BFE001);
   LData^:=LData^ and not 2;
End;



begin
   if length(parameterstr)>1 then Debug:=true else Debug:=false;
   OpenLib(DiskfontBase,'diskfont.library',0);
   CustomTA:=TextAttr('times.font',13,0,0);
   CustomFont:=OpenDiskFont(^CustomTA);
   if CustomFont=NIL then begin
      ERRORMSG('times.font 13 wird bentigt!','times.font 13 is needed!');
      error('');
   end;
   CloseLib(DiskfontBase);
   OpenLib(IntBase,'intuition.library',36);
   OpenLib(GfxBase,'graphics.library',39);
   OpenLib(DosBase,'dos.library',0);
   OpenLib(MTBase,'mathtrans.library',0);
   OpenLib(RTBase,'reqtools.library',38);
   OpenLib(RexxBase,'rexxsyslib.library',0);
   MyFReq:=rtAllocRequestA(RT_FILEREQ,NIL);
   if MyFReq<>NIL then begin
      WAVETRACER;
      rtFreeRequest(MyFReq)
   end else ERRORMSG('Kann ReqTools-Requester nicht allocieren!',
                     'Can`t allocate ReqTools-requester!');
   CloseLib(RexxBase);
   CloseLib(MTBase);
   CloseLib(DosBase);
   CloseLib(IntBase);
   CloseLib(GfxBase);
   CloseLib(RTBase);
{*** 13419 ***}
end.

